#include "CorrectEventRPMT.hh"
//////////////////////////////////////////////////////////
CorrectEventRPMT::
CorrectEventRPMT()
{
}
//////////////////////////////////////////////////////////
CorrectEventRPMT::
~CorrectEventRPMT()
{
}
//////////////////////////////////////////////////////////
bool CorrectEventRPMT::
SetTarget( string dataDir, UInt4 runNo, UInt4 daqId, UInt4 modNo, string instCode, string ext_code)
{
    DIR *dpath;
    if ((dpath=opendir(dataDir.c_str()))==NULL){
        cout << "SetTarget : not found dataDir= "+dataDir << endl;
        return false;
    }

    vector<string> _taragetFiles;
    _targetFiles.clear();
    struct dirent *dp;
    while((dp=readdir(dpath))!=NULL){
        string tmp( dp->d_name );
        cout << "file="+tmp << endl;
        char rootName_c[256];
        snprintf(rootName_c,sizeof(rootName_c),"%3s%06d_%02d_%03d", instCode.c_str(), runNo, daqId, modNo );
        string rootName(rootName_c);
        string::size_type ind1 = tmp.find( rootName );
        string::size_type ind2 = tmp.find( ext_code );
        if ((ind1!=string::npos)&&(ind2!=string::npos)&&(tmp.size()==24))
            _targetFiles.push_back(tmp);
    }

    if (_targetFiles.empty()){
        cout << "SetTarget : File not found"<<endl;
        _orgDataDir="";
        return false;
    }

    sort( _targetFiles.begin(), _targetFiles.end() );
    _orgDataDir=dataDir;
    
    return true;
}
//////////////////////////////////////////////////////////
bool CorrectEventRPMT::
Execute( string dataDir, UInt4 convRunNo, string instCode, string ext_code )
{
    if (_orgDataDir==""){
        return false;
    }

    vector<FILE*> fp_list( _targetFiles.size() );
    for (UInt4 i=0;i<_targetFiles.size();i++){
        string fname = _orgDataDir+"/"+_targetFiles[i];
        if (NULL==(fp_list[i]=fopen( fname.c_str(),"rb"))){
            cout << "Execute : can not open file="+fname << endl;
            return false;
        }
    }

    vector<string> _saveFiles( _targetFiles.size() );
    vector<FILE*> fo_list(_targetFiles.size() );
    for (UInt4 i=0; i<_saveFiles.size(); i++){
        char tmp_c[40];
        snprintf(tmp_c,sizeof(tmp_c),"%3s%06d%s.%s",instCode.c_str(),convRunNo,_targetFiles[i].substr(9,11).c_str(),ext_code.c_str());
        string tmp(tmp_c);
        string fname = dataDir+"/"+tmp;
        if (NULL==(fo_list[i]=fopen( fname.c_str(),"wb"))){
            cout << "Execute : can not open file="+fname << endl;
            return false;
        }
        _saveFiles[i] = fname;
    }
    for (UInt4 i=0; i<_saveFiles.size(); i++){
        cout << _orgDataDir+"/"+_targetFiles[i]+" -->> "+_saveFiles[i] <<endl;
    }

    UChar* buf1 = new UChar[4];
    UChar* buf2 = new UChar[4];
    UInt4 ind = 0;
    UInt4 i=0;
    bool isFileEnd=false;
    cout << _orgDataDir+"/"+_targetFiles[ind]+" -->> "+_saveFiles[ind] <<endl;
    UInt4 b7count=0;
    while(true){
        i=fread(buf1,4,1,fp_list[ind]);
        if (i!=1){
            if (ind==(fp_list.size()-1)){
                isFileEnd=true;
                break;
            }else{
                ind++;
                cout << _orgDataDir+"/"+_targetFiles[ind]+" -->> "+_saveFiles[ind] <<endl;
                i=fread(buf1,4,1,fp_list[ind]);
                if (i!=1){
                    isFileEnd=true;
                    break;
                }
            }
        }
        if (isFileEnd) break;
        
        if ((buf1[0]==0xb7)||(buf1[0]==0xb5)){
        }else{
            cout << "BUG FOUND" << endl;
            while(true){
                i=fread(buf1,4,1,fp_list[ind]);
                if (i!=1){
                    if (ind==(fp_list.size()-1)){
                        isFileEnd=true;
                        break;
                    }else{
                        ind++;
                        cout << _orgDataDir+"/"+_targetFiles[ind]+" -->> "+_saveFiles[ind] <<endl;
                        i=fread(buf1,4,1,fp_list[ind]);
                        if (i!=1){
                            isFileEnd=true;
                            break;
                        }
                    }
                }
                if ((buf1[0]==0xb7)||(buf1[0]==0xb5)) break;
            }
        
        }
        if (isFileEnd) break;
        
        i=fread(buf2,4,1,fp_list[ind]);
        if (i!=1){
            if (ind==(fp_list.size()-1)){
                isFileEnd=true;
                break;
            }else{
                ind++;
                cout << _orgDataDir+"/"+_targetFiles[ind]+" -->> "+_saveFiles[ind] <<endl;
                i=fread(buf2,4,1,fp_list[ind]);
                if (i!=1){
                    isFileEnd=true;
                    break;
                }
            }
        }else{
            if ((buf2[0]==0xb7)||(buf2[0]==0xb5)){
                cout << "BUG FOUND" << endl;
                memcpy(buf1,buf2,4);
                i=fread(buf2,4,1,fp_list[ind]);
                if (i!=1){
                    if (ind==(fp_list.size()-1)){
                        isFileEnd=true;
                        break;
                    }else{
                        ind++;
                        cout << _orgDataDir+"/"+_targetFiles[ind]+" -->> "+_saveFiles[ind] <<endl;
                        i=fread(buf2,4,1,fp_list[ind]);
                        if (i!=1){
                            isFileEnd=true;
                            break;
                        }
                    }
                }
            }
        }
        if (isFileEnd) break;
        if (buf1[0]==0xb7) b7count++;
        fwrite(buf1,1,4,fo_list[ind]);
        fwrite(buf2,1,4,fo_list[ind]);
    }

    for (UInt4 i=0;i<(fo_list.size());i++){
        fclose( fp_list[i] );
        fclose( fo_list[i] );
    }

    delete [] buf1;
    delete [] buf2;
    cout << "b7 count="<<b7count<<endl;
    return true;
}
