#include <string>
#include <cmath>
#include "ElementContainer.hh"
#include "ElementContainerArray.hh"
#include "ElementContainerMatrix.hh"

using namespace std;

class CalcPowder {
private:
	ElementContainerMatrix* m_ecm;
	double m_minQ;
	double m_maxQ;
	double m_elaMinQ;
	double m_elaMaxQ;
	
	unsigned int FindIndex(double xx, unsigned int size, vector<double>& bins, unsigned int previous);
	
protected:
        //static const double EPS = 1e-6;
        static const double EPS;
	
	void ToPowderBase(ElementContainerMatrix &ecm_res, double startQ, double endQ, double deltaQ);
	void ToPowderRectBase(ElementContainerMatrix &ecm_res, double startQ, double endQ, double deltaQ);
	void SetPolarAngle();
	
public:
	CalcPowder(ElementContainerMatrix* ecm);
	
	ElementContainerMatrix ToPowder(double startQ, double endQ, double deltaQ);
	ElementContainerMatrix ToPowderAutoBin(double deltaQ);
	
	ElementContainerMatrix ToPowderRect(double startQ, double endQ, double deltaQ);
};
