#include "HistogramBinToPointTk.hh"
#include "ElementContainerUtility.hh"
//////////////////////////////////////////////////////////
HistogramBinToPointTk::
HistogramBinToPointTk()
{
  Flag_convert = 0;
}

//////////////////////////////////////////////////////////
HistogramBinToPointTk::
HistogramBinToPointTk( ElementContainer *ec )
{
  Flag_convert = 0;
  SetTarget( ec );
  Convert();
}

//////////////////////////////////////////////////////////
HistogramBinToPointTk::
~HistogramBinToPointTk()
{

}
//////////////////////////////////////////////////////////
void HistogramBinToPointTk::
Convert()
{
  double binwidth = 0;
  
  ElementContainerUtility ecu;
  
  ElementContainer *ec = Put();
  vector<Double> orgX = ec->PutX();
  vector<Double> orgY = ec->PutY();
  vector<Double> orgE = ec->PutE();

  PointX.clear();
  PointY.clear();
  PointE.clear();
  PointS.clear();

  for (UInt4 i=0; i<(orgX.size()-1); i++){
    binwidth = orgX[i+1]-orgX[i];
    PointX.push_back((orgX[i]+orgX[i+1])/2.0);
    PointY.push_back( orgY[i]/binwidth );
    PointE.push_back( orgE[i]/binwidth );
  }
  
  if (ecu.ScalingExists(ec) == 0) {
    for (UInt4 i=0; i<(orgX.size()-1); i++){
      PointS.push_back( 1.0 );
    }
  } else {
    vector<Double> orgS = ecu.PutScaling(ec);
    
    for (UInt4 i=0; i<(orgX.size()-1); i++){
      PointS.push_back( orgS[i] * binwidth );
    }
  }

  Flag_convert = 1;

}

//////////////////////////////////////////////////////////
vector<Double> HistogramBinToPointTk::
PutX()
{
  if (Flag_convert==0){
    cout << "HistogramBinToPointTk >> Convert() is needed." << endl;
    vector<Double> ret;
    ret.push_back(0);
    return ret;
  }

  return PointX;

}

//////////////////////////////////////////////////////////
vector<Double> HistogramBinToPointTk::
PutY()
{
  if (Flag_convert==0){
    cout << "HistogramBinToPointTk >> Convert() is needed." << endl;
    vector<Double> ret;
    ret.push_back(0);
    return ret;
  }

  return PointY;

}

//////////////////////////////////////////////////////////
vector<Double> HistogramBinToPointTk::
PutE()
{
  if (Flag_convert==0){
    cout << "HistogramBinToPointTk >> Convert() is needed." << endl;
    vector<Double> ret;
    ret.push_back(0);
    return ret;
  }

  return PointE;

}

//////////////////////////////////////////////////////////
vector<Double> HistogramBinToPointTk::
PutS()
{
  if (Flag_convert==0){
    cout << "HistogramBinToPointTk >> Convert() is needed." << endl;
    vector<Double> ret;
    ret.push_back(0);
    return ret;
  }

  return PointS;

}

//////////////////////////////////////////////////////////
