#ifndef HISTOGRAMBINTOPOINTTK
#define HISTOGRAMBINTOPOINTTK

#include "Header.hh"
#include "ManipulatorBase.hh"
#include "ElementContainer.hh"
#include "ElementContainerArray.hh"
#include "ElementContainerMatrix.hh"
#include "HeaderBase.hh"
#include "CppToPython.hh"

//////////////////////////////////
// Histogram Bin to Point
/////////////////////////////////
//! Histogram format to points 
/*! 
 * 
 * 
 *  
 * 
 */
class HistogramBinToPointTk
    : public ManipulatorBase< ElementContainer >
{
private:
  vector<Double> PointX;
  vector<Double> PointY;
  vector<Double> PointE;
  vector<Double> PointS;
  int Flag_convert;

public:
  HistogramBinToPointTk();
  HistogramBinToPointTk( ElementContainer *ec );
  ~HistogramBinToPointTk();

  void Convert();
  vector<Double> PutXo(){ return Put()->PutX(); }
  vector<Double> PutX();
  vector<Double> PutY();
  vector<Double> PutE();
  vector<Double> PutS();
  PyObject *PutXList(){ return __gCppToPython.VectorDoubleToList( PutX() ); }
  /*!<Return the Python-List assigned to X-value. */

  PyObject *PutYList(){ return __gCppToPython.VectorDoubleToList( PutY() ); }
  /*!<Return the Python-List assigned to Y-value. */

  PyObject *PutEList(){ return __gCppToPython.VectorDoubleToList( PutE() );}
  /*!<Return the Python-List assigned to E-value. */

  PyObject *PutSList(){ return __gCppToPython.VectorDoubleToList( PutS() );}
  /*!<Return the Python-List assigned to E-value. */

};
#endif
