#include "SliceContainer.hh"

SliceContainer::SliceContainer(vector<double>& binsVec, vector<double>& ctVec, vector<double>& erVec, vector<double>& scVec, double fp, double mp, double ep)
//: XVector(binsVec), ScVector(scVec), Fp(fp), Mp(mp), Ep(ep)
: Fp(fp), Mp(mp), Ep(ep)
{
	SetCountData(binsVec, ctVec, erVec, scVec);
}

void SliceContainer::SetCountData(vector<double>& binsVec, vector<double>& ctVec, vector<double>& erVec, vector<double>& scVec)
{
	
	unsigned int num = ctVec.size();
	unsigned int ii;
	
	XVector.reserve(num);
	YVector.reserve(num);
	ErVector.reserve(num);
	ScVector.reserve(num);
	
	for (ii = 0; ii < num; ++ii) {
		XVector.push_back(binsVec[ii]);
		
		if (scVec[ii] > 0) {
			YVector.push_back(ctVec[ii] / scVec[ii]);
			ErVector.push_back(sqrt(erVec[ii]) / scVec[ii]);
		} else {
			//YVector.push_back(MASKVALUE());		// 2015.5.8 MASKVALUEp~
			YVector.push_back(0);
			ErVector.push_back(0);
		}
		
		ScVector.push_back(scVec[ii]);
	}
	XVector.push_back(binsVec[ii]);
}

