#ifndef SLICECONTAINER_HH
#define SLICECONTAINER_HH

#include "Header.hh"
#include <cstdlib>
#include <string>
#include <cmath>
#include <vector>
//#include <iostream>
//#include <Python.h>
#include "CppToPython.hh"

class SliceContainer
{
private:
	vector<double> XVector;
	vector<double> YVector;
	vector<double> ErVector;
	vector<double> ScVector;
	double Fp;
	double Mp;
	double Ep;
	
public:
	//static const double MASKVALUE(void) {return 1.0e15;};		// 2015.5.8 MASKVALUEp~
	
	SliceContainer() {};
	SliceContainer(vector<double>& binsVec, vector<double>& ctVec, vector<double>& erVec, vector<double>& scVec, double fp, double mp, double ep);
	~SliceContainer() {};
	
	void SetCountData(vector<double>& binsVec, vector<double>& ctVec, vector<double>& erVec, vector<double>& scVec);
	
	PyObject* PutXList() {return __gCppToPython.VectorDoubleToList(XVector);};
	PyObject* PutYList() {return __gCppToPython.VectorDoubleToList(YVector);};
	PyObject* PutErList() {return __gCppToPython.VectorDoubleToList(ErVector);};
	PyObject* PutScList() {return __gCppToPython.VectorDoubleToList(ScVector);};
	
	double PutFp() {return Fp;};
	double PutMp() {return Mp;};
	double PutEp() {return Ep;};
};

#endif
