# macos with AppleSilicon

AppleSiliconのmacOS上のHomebrew環境にて、万葉ライブラリのコンパイルに必要な最小限の環境を構築する方法を述べる。詳細はそれぞれのスクリプトを読め。

## 動作検証環境

- macOS Monterey 12.6.2
- AppleSiliconのみ
- 2022/12/18

## 準備
### Homebrewのインストール
詳細は略す。

### 必要なC++ライブラリのインストール
Homebrewからインストールできるものをインストールする。

```
$ ./00build_dep.sh
```

### 環境変数の設定
各種環境変数を設定するためにsetenv.shを環境に合わせて作成する。

この環境変数設定により、HomebrewでインストールしたPython3の場所、他のライブラリなどへのパス、インストール先（ */opt/mlfsoft* ）などが指定される。

setenv.shを自動的に作成するPythonスクリプトを準備している。このスクリプト( *create_setenv.py* )をインストール先を引数として実行すると、Homebrewから必要なライブラリなどのパスを取得しsetenv.shが作成される。下記のようにスクリプトを実行する。

```
$ python3 create_setup.py /Users/hoge/mlfsoft
```

ここでは、インストール先は */Users/hoge/mlfsoft* を指定している。万葉ライブラリのインストールパス（ *MANYO_PATH* ）は、*/Users/hoge/mlfsoft/manyo* となる。

作成された *setenv.sh* を用い、環境変数の設定を有効にする。

```
$ source setenv.sh
```

## コンパイル及びインストール
*01build_nexus.sh* , *02build_manyo.sh* , *03build_utsusemi.sh* をコピーして、以下のように配置する。

```
$ ls
01build_nexus.sh		03compile_utsusemi.sh		Utsusemi
02compile_manyo.sh		manyo
```


### NexusFormat
NexusFormatをインストールする。

```
$ ./01build_nexus.sh
```

### Manyoライブラリと空蟬C++コード
Manyoライブラリと空蟬のC++コードのインストールを行う。

```
$ ./02build_manyo.sh
$ ./03build_utsusemi.sh
```

## チェック

```
$ python3
>>> import Manyo
Manyo>>> import Manyo.Utsusemi
Manyo>>>
```