import os
import sys
import glob
import datetime

PYVERMAJ = sys.version_info.major
PYVERMIN = sys.version_info.minor
PYVERMIC = sys.version_info.micro

MLFSOFTPATH = sys.argv[1]

# search pypath
pypath_s = "/opt/homebrew/Cellar/python@{0}.{1}/{0}.{1}.{2}*".format(PYVERMAJ, PYVERMIN, PYVERMIC)
l = glob.glob(pypath_s)
if len(l) == 0:
    print("Not found python3")
    sys.exit(-1)
l.sort()
pypath = os.path.join(l[-1], "Frameworks/Python.framework/Versions/Current")

# search libomp version
l = glob.glob("/opt/homebrew/Cellar/libomp/*")
if len(l) == 0:
    print("Not found libomp")
    sys.exit(-1)
l.sort()
libomp_path = l[-1]

d = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
if os.path.exists(pypath):
    print("OK {}".format(pypath))
    cont = "# Created by create_setenv.py at {}\n".format(d)
    cont += "unset PREFIX\n"
    cont += "export MANYO_PATH={}/manyo\n".format(MLFSOFTPATH)
    cont += "\n"
    cont += ("BREWPYPATH="+pypath+"\n")
    cont += "BREWPYINCPATH=${BREWPYPATH}/include/python"
    cont += "{}.{}\n".format(PYVERMAJ, PYVERMIN)
    cont += "BREWPYLIBPATH=${BREWPYPATH}/lib\n"
    cont += "export LIBRARY_PATH=${MANYO_PATH}/lib:/opt/homebrew/lib:/opt/homebrew/opt/openssl/lib:/opt/homebrew/opt/zlib/lib:"
    cont += libomp_path+"/lib:${BREWPYLIBPATH}\n"
    cont += "export CPLUS_INCLUDE_PATH=/opt/homebrew/include/:/opt/homebrew/opt/openssl/include:"
    cont += libomp_path+"/include:${BREWPYINCPATH}:${MANYO_PATH}/include:${MANYO_PATH}/include/nexus\n"
    cont += "export DYLD_LIBRARY_PATH=${LIBRARY_PATH}\n"
    cont += "export INSTALL_PATH=${MANYO_PATH}\n"
    cont += "export PYTHONPATH=${MANYO_PATH}\n"
    cont += ("export PyVer=" + "{}.{}\n".format(PYVERMAJ, PYVERMIN))
    fo = open("setenv.sh", "w")
    fo.write(cont)
    fo.close()
else:
    print("FAILURE {}".format(pypath))

