%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')

%define srcname matplotlib
%define version 3.1.1
%define release 1.el7

%define mlfsoft_path /opt/mlfsoft
%define install_root %{mlfsoft_path}/python-utsusemi
%define with_py2 0

Summary: Python plotting package
Name:    utsusemi-deps-matplotlib
Version: %{version}
Release: %{release}
Source0: %{srcname}-%{version}.tar.gz
License: PSF
Group: Development/Libraries
Vendor: John D. Hunter, Michael Droettboom <matplotlib-users@python.org>
Url: https://matplotlib.org
BuildRequires: gcc gcc-c++ freetype-devel libpng-devel qhull-devel zlib-devel
Requires: dejavu-sans-fonts dvipng 

%description
Matplotlib strives to produce publication quality 2D graphics
for interactive graphing, scientific publishing, user interface
development and web application servers targeting multiple user
interfaces and hardcopy output formats.

%if %{with_py2}
%package -n utsusemi-deps-python2-matplotlib
Summary: %{summary}
BuildRequires: pycairo python-dateutil python-devel
BuildRequires: python-setuptools python-gobject numpy python-pillow pyparsing python-pytz
BuildRequires: utsusemi-deps-python2-cycler utsusemi-deps-python2-kiwisolver
Requires: pycairo python-dateutil numpy python-pillow pyparsing
Requires: utsusemi-deps-python-cycler utsusemi-deps-python-kiwisolver

%description -n utsusemi-deps-python2-matplotlib
%{description}
%endif

%package -n utsusemi-deps-python36-matplotlib
Summary: %{summary}
BuildRequires: python36-cairo python36-dateutil python3-devel
BuildRequires: python36-setuptools python36-gobject python36-numpy python36-pillow python36-pyparsing python36-pytz
BuildRequires: utsusemi-deps-python36-cycler utsusemi-deps-python36-kiwisolver
Requires: python36-cairo python36-dateutil python36-numpy python36-pillow python36-pyparsing
Requires: utsusemi-deps-python36-cycler utsusemi-deps-python36-kiwisolver

%description -n utsusemi-deps-python36-matplotlib
%{description}

%prep
%autosetup -n %{srcname}-%{version}

%build
%if %{with_py2}
%py2_build
%endif
%py3_build

%install
#py3_install -- --install-purelib %{install_root}/lib --install-platlib %{install_root}/lib
%if %{with_py2}
%py2_install -- --prefix %{install_root}
%endif
#%py3_install -- --prefix %{install_root}
%py3_install -- --install-purelib %{install_root} --install-platlib %{install_root}
pushd %{buildroot}%{install_root}
#mv lib64 lib
rm -rf lib64

%clean
rm -rf %{buildroot}

%if %{with_py2}
%files -n utsusemi-deps-python2-matplotlib
%defattr(-,root,root)
%dir %{mlfsoft_path}
%dir %{install_root}
%dir %{install_root}/lib
%dir %{install_root}/lib/python2.7
%dir %{install_root}/lib/python2.7/site-packages
%{install_root}/lib/python2.7/*
%endif

%files -n utsusemi-deps-python36-matplotlib
%defattr(-,root,root)
%dir %{mlfsoft_path}
%dir %{install_root}
%{install_root}/*
#%dir %{install_root}/lib
#%dir %{install_root}/lib/python3.6
#%dir %{install_root}/lib/python3.6/site-packages
#%{install_root}/lib/python3.6/*

%changelog
* Thu Nov 28 2019 Nobuo Okazaki - 3.1.1-1
- Initial SPEC for Utsusemi4

