%module  Utsusemi
%include "carrays.i"
%include "std_string.i"
%include "std_vector.i"
%include "std_pair.i"
%include "VectorDef.i"

%{
#include "Header.hh"
#include "MlfPhysicalConstants.hh"
#include "UtsusemiHeader.hh"
#include "BoostXmlParser.hh"
#include "MlfHeader.hh"
#include "AdvScatAbsoBodyManagerMLF.hh"
#include "MlfScatAbsoBodyManager.hh"
#include "MlfDetectorEfficiencyCorrection.hh"
#include "UtsusemiAnaEnvironReader.hh"
#include "T0TreatToolsBase.hh"
#include "T0TreatToolsNeunet.hh"
#include "EventDataMonitorBase.hh"
#include "DetectorInfoEditorBase.hh"
#include "DetectorInfoEditorNeunet.hh"
#include "DetectorInfoEditorReadout2d.hh"
#include "WiringInfoDataBase.hh"
#include "WiringInfoEditorBase.hh"
#include "WiringInfoEditorNeunet.hh"
#include "WiringInfoEditorReadout.hh"
#include "UtsusemiCheckDataProcess.hh"
#include "TofToEnergyTransfer.hh"
#include "HistogramBinToPoint.hh"
#include "TofToEnergyChoppers.hh"
#include "VanadiumToolsChoppers.hh"
#include "D4MatrixCalc.hh"
#include "UtsusemiSqeCalc.hh"
#include "UtsusemiSqeCalc2.hh"
#include "UtsusemiSqeCalcXtalParams.hh"
#include "CaseInfoReaderBase.hh"
#include "UtsusemiUnitConverter.hh"
#include "UtsusemiCalcContainers.hh"
#include "UtsusemiD4Matrix.hh"
#include "UtsusemiD4Matrix2.hh"
#include "UtsusemiCaseInfoReaderTrignet.hh"
#include "WiringInfoConversionDictionary.hh"
#include "UtsusemiTofOriginCorrection.hh"
#include "UtsusemiTrignetDictionary.hh"
#include "UtsusemiTrignetEventDecoderBase.hh"
#include "UtsusemiFilterBase.hh"
#include "UtsusemiFilterTrignet.hh"
#include "UtsusemiEventCasesDecoderBase.hh"
#include "UtsusemiEventCasesDecoderTemplate.hh"
#include "UtsusemiNeutronEventDecoderBase.hh"
#include "UtsusemiNeunetEventDecoderBase.hh"
#include "UtsusemiEventDataConverterTemplate.hh"
#include "UtsusemiEventDataConverterTemplateWithPH.hh"
#include "UtsusemiEventDataConverterTemplateWithPHDep.hh"
#include "UtsusemiEventDataConverterNeunet.hh"
#include "UtsusemiEventDataConverterNeunetWithPH.hh"
#include "UtsusemiEventDataConverterNeunetWithPHDep.hh"
#include "UtsusemiEventDataConverterSimpleNeunet.hh"
#include "UtsusemiEventDataConverterSample.hh"
#include "UtsusemiEventDataMonitorNeunet.hh"
#include "UtsusemiEventDataMonitorMWPC.hh"
#include "UtsusemiEventDataMonitorRPMT.hh"
#include "UtsusemiSetMask.hh"
#include "UtsusemiGetHistogramTemplate.hh"
#include "UtsusemiGetNeunetHistogram.hh"
#include "UtsusemiOneTrignetStorage.hh"
#include "UtsusemiWiringInfoEditorTemplate.hh"
#include "UtsusemiWiringInfoEditorBase.hh"
#include "UtsusemiWiringInfoEditorNeunet.hh"
#include "UtsusemiDetectorInfoEditorTemplate.hh"
#include "UtsusemiDetectorInfoEditorBase.hh"
#include "UtsusemiDetectorInfoEditorNeunet.hh"
#include "UtsusemiDetectorEfficiencyCorrection.hh"
#include "UtsusemiEventDataConverterReadoutTemplate.hh"
#include "T0TreatToolsReadout.hh"
#include "T0TreatToolsReadoutWLSF32.hh"
#include "UtsusemiReadoutRPMTEventDecoder.hh"
#include "UtsusemiReadoutMWPCEventDecoder.hh"
#include "UtsusemiReadoutWLSF32EventDecoder.hh"
#include "UtsusemiEventDataConverterReadoutWLSF32Template.hh"
#include "UtsusemiEventDataConverterWLSF32.hh"
#include "UtsusemiEventDataConverterRPMT.hh"
#include "UtsusemiEventDataConverterMWPC.hh"
#include "UtsusemiReadoutEventDecoderTemplate.hh"
#include "UtsusemiGetRPMTHistogram.hh"
#include "UtsusemiContainerTextConverter.hh"
#include "UtsusemiSubtractDarkBackground.hh"
#include "UtsusemiReductionCommon.hh"
#include "UtsusemiReductionInEla.hh"
#include "NxspeFileIO.hh"
#include "ShamotoDymPDF.hh"
#include "UtsusemiEventDataCreator.hh"
%}

%include "DoxySwig40.i"

%include "Header.hh"
%include "UtsusemiHeader.hh"
%import(module="Manyo.MLF") "MlfPhysicalConstants.hh"
%import(module="Manyo.MLF") "T0TreatToolsBase.hh"
%import(module="Manyo.MLF") "EventDataMonitorBase.hh"
%import(module="Manyo.MLF") "BoostXmlParser.hh"
%import(module="Manyo.MLF") "MlfHeader.hh"
%import(module="Manyo.MLF") "AdvScatAbsoBodyManagerMLF.hh"
%import(module="Manyo.MLF") "MlfScatAbsoBodyManager.hh"
%import(module="Manyo.MLF") "MlfDetectorEfficiencyCorrection.hh"


%include "CaseInfoReaderBase.hh"
%include "D4MatrixCalc.hh"
%include "DetectorInfoEditorBase.hh"
%include "DetectorInfoEditorNeunet.hh"
%include "DetectorInfoEditorReadout2d.hh"
%include "T0TreatToolsNeunet.hh"
%include "T0TreatToolsReadout.hh"
%include "T0TreatToolsReadoutWLSF32.hh"
%include "WiringInfoConversionDictionary.hh"
%include "WiringInfoDataBase.hh"
%include "WiringInfoEditorBase.hh"
%include "WiringInfoEditorNeunet.hh"
%include "WiringInfoEditorReadout.hh"
%include "VanadiumToolsChoppers.hh"

%include "UtsusemiAnaEnvironReader.hh"
%include "UtsusemiCheckDataProcess.hh"
%include "UtsusemiCaseInfoReaderTrignet.hh"
%include "UtsusemiCalcContainers.hh"
%include "UtsusemiD4Matrix.hh"
%include "UtsusemiD4Matrix2.hh"
%include "UtsusemiDetectorEfficiencyCorrection.hh"
%include "UtsusemiEventCasesDecoderBase.hh"
%include "UtsusemiFilterBase.hh"
%include "UtsusemiFilterTrignet.hh"
%include "UtsusemiNeutronEventDecoderBase.hh"
%include "UtsusemiNeunetEventDecoderBase.hh"
%include "UtsusemiOneTrignetStorage.hh"
%include "UtsusemiTofOriginCorrection.hh"
%include "UtsusemiTrignetDictionary.hh"
%include "UtsusemiTrignetEventDecoderBase.hh"
%include "UtsusemiUnitConverter.hh"
%include "NxspeFileIO.hh"

%include "TemplateDef.i"

%include "HistogramBinToPoint.hh"
%include "TofToEnergyChoppers.hh"
%include "TofToEnergyTransfer.hh"
%include "UtsusemiSetMask.hh"
%include "UtsusemiSqeCalc.hh"
%include "UtsusemiSqeCalc2.hh"
%include "UtsusemiSqeCalcXtalParams.hh"

%include "UtsusemiEventDataConverterWLSF32.hh"
%include "UtsusemiEventDataConverterRPMT.hh"
%include "UtsusemiEventDataConverterMWPC.hh"
%include "UtsusemiEventDataConverterNeunet.hh"
%include "UtsusemiEventDataConverterNeunetWithPH.hh"
%include "UtsusemiEventDataConverterNeunetWithPHDep.hh"
%include "UtsusemiEventDataConverterSample.hh"
%include "UtsusemiEventDataConverterSimpleNeunet.hh"
%include "UtsusemiEventDataMonitorNeunet.hh"
%include "UtsusemiEventDataMonitorMWPC.hh"
%include "UtsusemiEventDataMonitorRPMT.hh"

%include "UtsusemiWiringInfoEditorBase.hh"
%include "UtsusemiWiringInfoEditorNeunet.hh"
%include "UtsusemiDetectorInfoEditorBase.hh"
%include "UtsusemiDetectorInfoEditorNeunet.hh"

%include "UtsusemiReadoutRPMTEventDecoder.hh"
%include "UtsusemiReadoutMWPCEventDecoder.hh"
%include "UtsusemiReadoutWLSF32EventDecoder.hh"

%include "UtsusemiGetHistogramTemplate.hh"
%include "UtsusemiGetNeunetHistogram.hh"
%include "UtsusemiGetRPMTHistogram.hh"
%include "UtsusemiContainerTextConverter.hh"
%include "UtsusemiSubtractDarkBackground.hh"
%include "UtsusemiReductionCommon.hh"
%include "UtsusemiReductionInEla.hh"

%include "ShamotoDymPDF.hh"
%include "UtsusemiEventDataCreator.hh"
