#ifndef UTSUSEMITOFORIGINCORRECTION
#define UTSUSEMITOFORIGINCORRECTION

#include <algorithm>
#include "Header.hh"
#include "UtsusemiHeader.hh"

////////////////////////////////////////
// UtsusemiTofOriginCorrection
////////////////////////////////////////

//! Calculation of TOF origin Correction
/*! 
 *  
 *
 */
class UtsusemiTofOriginCorrection
{
private:
    void Initialize();
    UInt4 _TofOriginCorrType;
    Double (*PutTofShiftFunc)( Double lambda, vector<Double> *params );
    UInt4 (*PutTofShiftNumParams)();
    vector<Double> _DiscreteLambda;
    vector<Double> _DiscreteTofShift;
    static Double UtsusemiPutTofShiftFunc01( Double lambda, vector<Double> *params );
    static UInt4 UtsusemiPutTofShiftFunc01_NumOfParams();
    vector<Double> _Params;
    
public:
    UtsusemiTofOriginCorrection();
        //!< Constructor
        /*!<
         */
    ~UtsusemiTofOriginCorrection();
        //!< Destructor
        /*!<
         */
    bool SetTofOriginCorrectionType( UInt4 cType );
    bool SetTofOriginCorrectionType( UInt4 cType, vector<Double> params );
        //!< Sets type of Tof Origin Correction Function
        /*!< 
         *   @param type (UInt4) type number for a type of direct conversion
         *   @retval true
         *   @retval fales
         */
    Double TofOriginShiftByLambda( Double lambda );
    vector<Double> TofOriginShiftByLambda( vector<Double> vlambda );
    bool SetDiscreteData( vector<Double> lambda_list, vector<Double> tofshift_list );
    UInt4 PutNumOfParam();
};
#endif
