#ifndef WIRINGINFODATABASE
#define WIRINGINFODATABASE

#include "UtsusemiHeader.hh"

class WiringInfoTagDefineBase
{
public:
    WiringInfoTagDefineBase();
        //!< Constructor
        /*!<
         */
    ~WiringInfoTagDefineBase();
        //!< Destructor
        /*!<
         */
    static const string WINFO;
    static const string WINFO_AT_INST;
    static const string WINFO_AT_VER;
    static const string WINFO_AT_DATE;

    static const string WINFO_PIXELINFO;
    static const string WINFO_PIXELINFO_DAQ;
    static const string WINFO_PIXELINFO_DAQ_AT_ID;

    static const string WINFO_PIXELINFO_DAQ_MOD;
    static const string WINFO_PIXELINFO_DAQ_MOD_AT_NO;
    static const string WINFO_PIXELINFO_DAQ_MOD_AT_TYPE;
    static const string WINFO_PIXELINFO_DAQ_MOD_AT_TRIGINDEX;
    static const string WINFO_PIXELINFO_DAQ_MOD_AT_NUMBER_DET;
    
    static const string WINFO_PIXELINFO_DAQ_MOD_DET;
    static const string WINFO_PIXELINFO_DAQ_MOD_DET_AT_INDEX;
    static const string WINFO_PIXELINFO_DAQ_MOD_DET_AT_ID;
    static const string WINFO_PIXELINFO_DAQ_MOD_DET_AT_AXIS;
    static const string WINFO_PIXELINFO_DAQ_MOD_DET_AT_HEAD;
    static const string WINFO_PIXELINFO_DAQ_MOD_DET_AT_NUM;
    static const string WINFO_PIXELINFO_DAQ_MOD_DET_AXIS;
    static const string WINFO_PIXELINFO_DAQ_MOD_DET_AXIS_AT_SIZE;
    static const string WINFO_PIXELINFO_DAQ_MOD_DET_AXIS_AT_LABEL;
    static const string WINFO_PIXELINFO_DAQ_MOD_DET_AXIS_AT_START;

    static const string WINFO_TOFBININFO;
    static const string WINFO_TOFBININFO_TOFBIN;
    static const string WINFO_TOFBININFO_TOFBIN_AT_PAT;
    static const string WINFO_TOFBININFO_TOFBIN_AT_OFFSET;
    static const string WINFO_TOFBININFO_TOFBIN_AT_MASKID;
    static const string WINFO_TOFBINPATLIST;
    static const string WINFO_TOFBINPATLIST_PAT;
    static const string WINFO_TOFBINPATLIST_PAT_AT_ID;
    static const string WINFO_TOFBINPATLIST_PAT_AT_TYPE;
    static const string WINFO_TOFMASKPATLIST;
    static const string WINFO_TOFMASKPATLIST_PAT;
    static const string WINFO_TOFMASKPATLIST_PAT_AT_ID;
    
    static const string WINFO_TOFDOUBLEFRAME;
        
    static const string WINFO_FRAMEINFO;
    static const string WINFO_FRAMEINFO_AT_FRAMENO;
    static const string WINFO_FRAMEINFO_AT_BOUNDARY;
    static const string WINFO_FRAMEINFO_AT_TYPE; //[inamura 170410]
    
    static const string WINFO_TOFTIMEDEPNDBACKGROUND;       //[inamura 160809]
    static const string WINFO_TOFTIMEDEPNDBACKGROUND_REGION;//[inamura 160809]
};

class UtsusemiDetAxisInfo
{
public:
    UtsusemiDetAxisInfo();
        //!< Constructor
        /*!<
         */
    UtsusemiDetAxisInfo( const UtsusemiDetAxisInfo& obj );
        //!< Copy Constructor
        /*!<
         */
    ~UtsusemiDetAxisInfo();
        //!< Destructor
        /*!<
         */
    UInt4 size;
    string label;
    UInt4 start;

};
class UtsusemiDetInfo
{
public:
    UtsusemiDetInfo();
        //!< Constructor
        /*!<
         */
    UtsusemiDetInfo( const UtsusemiDetInfo& obj );
        //!< Copy Constructor
        /*!<
         */
    ~UtsusemiDetInfo();
        //!< Destructor
        /*!<
         */
    string detType;    /**< detector type PSD, SCIN2D, SCIN1D, TRIGNET  */
    bool isAlive;      /**< use or not */
    Int4 detId;
    Int4 headPixelId;
    Int4 numPixel;
    Int4 numAxis;
    //vector< pair<Int4,string> > multiAxes;/**< [numAxis]( pair.first:size, pair.second:label ) */
    vector< UtsusemiDetAxisInfo > multiAxes;
    
};
class UtsusemiModInfo
{
public:
    UtsusemiModInfo();
        //!< Constructor
        /*!<
         */
    UtsusemiModInfo( const UtsusemiModInfo& obj );
        //!< Copy Constructor
        /*!<
         */
    ~UtsusemiModInfo();
        //!< Destructor
        /*!<
         */
    void ClearList();
    vector<UInt4> PutAliveList();
        //!< Puts list of DetList index alived.
        /*!<
         *   @param None
         *   @return vector of index
         */
    bool isAlive;                        /**< use or not */
    string type;                         /**< Module type (PSD,TRIGNET,N2MON etc) */
    vector< UtsusemiDetInfo* > DetList;  /**< List of Detectors */
    vector< pair<string,string> > attributes;
};

class UtsusemiDaqInfo
{
public:
    UtsusemiDaqInfo();
        //!< Constructor
        /*!<
         */
    UtsusemiDaqInfo( const UtsusemiDaqInfo& obj );
        //!< Copy Constructor
        /*!<
         */
    ~UtsusemiDaqInfo();
        //!< Destructor
        /*!<
         */
    void ClearList();
    vector<UInt4> PutAliveList();
        //!< Puts list of ModList index alived.
        /*!<
         *   @param None
         *   @return vector of index
         */
    bool isAlive;                       /**< use or not */
    vector< UtsusemiModInfo* > ModList; /**< List of Modules */
};

class UtsusemiTofBinInfo
{
public:
    UtsusemiTofBinInfo();
        //!< Constructor
        /*!<
         */
    UtsusemiTofBinInfo( const UtsusemiTofBinInfo& obj );
        //!< Copy Constructor
        /*!<
         */
    ~UtsusemiTofBinInfo();
        //!< Destructor
        /*!<
         */
    UInt4 patternId;   /**< pattern ID  */
    Double offset;      /**< offset value  */
    Int4 maskPtnId;    /**<  mask pattern Id */
    string conts;      /**< parameters descriptions as text */
};

class UtsusemiTofBinPattern
{
public:
    UtsusemiTofBinPattern();
    UtsusemiTofBinPattern( const UtsusemiTofBinPattern& obj );
    ~UtsusemiTofBinPattern();
    UInt4 patternId;
    Int4 type;
    vector<Double>* PatternVect;
    
};

class UtsusemiTofMaskPattern
{
public:
    UtsusemiTofMaskPattern();
    UtsusemiTofMaskPattern( const UtsusemiTofMaskPattern& obj );
    ~UtsusemiTofMaskPattern();
    UInt4 patternId;
    vector< pair<Double,Double> > PatternVect;
    
};
class UtsusemiTimeDependBackGround
{
public:
    UtsusemiTimeDependBackGround();
    UtsusemiTimeDependBackGround( const UtsusemiTimeDependBackGround& obj );
    ~UtsusemiTimeDependBackGround();
    pair<Double,Double> TofRegion;
};
class UtsusemiFrameBoundaryInfo
{
public:
    UtsusemiFrameBoundaryInfo();
    UtsusemiFrameBoundaryInfo( const UtsusemiFrameBoundaryInfo& obj );
    ~UtsusemiFrameBoundaryInfo();
    UInt4 frameNo;
    Double boundaryValue;
    string boundaryType;
    static const string BOUNDARYTYPE_TOF;
    static const string BOUNDARYTYPE_ENERGY;
    static const string BOUNDARYTYPE_LAMBDA;
    static const string BOUNDARYTYPE_EI;
    bool SetParams( UInt4 fn, Double bv=0.0, string bt="" );
};
#endif
