#ifndef ACQUIRENEUTRONSOURCEIMAGEINFORMATION
#define ACQUIRENEUTRONSOURCEIMAGEINFORMATION

#define HOST_NAME    "www-cont.j-parc.jp"
//#define HOST_PROTCOL http
//#define HOST_PORT    80
//#define USER_AGENT   "target Information API/1.00"

/* File path and File name of Signal Keys */
#define IMAGE_PATH           "/MLF/Image/"
#define BEAM_POWER_FNAME     "BP.png"
#define CT_01_FNAME          "CT01.png"
#define MODERATOR_FNAME      "H2.png"
#define JPARC_STATUS_FNAME   "JP.png"
#define SHUTTER_STATUS_FNAME "ST.png"
#define CT_3HOUR_FNAME       "CT3H.png"
#define CT_1DAY_FNAME        "CT01LD.png"

#define CT_PATH              "/MLF/cgi/image/"
#define CT_FNAME             "CT.jpg"
#define MODERATOR_TMP_PATH   "/MLF/cgi/image/"
#define MODERATOR_TMP_FNAME  "H2tmp.jpg"

//#include <iostream>                                    /* for cout */
//#include <sstream>                                     /* for ostringstream */
//#include <fstream>                                     /* for ofstream */
//#include <iomanip>                                     /* manipulator */
#include "AcquireNeutronSourceInformationControlBase.hh"
//////////////////////////////////////////////////
class AcquireNeutronSourceImageInformation
  : public AcquireNeutronSourceInformationControlBase
{
private:
    string FileSavePath;        /* Image save path */
//  UInt2  Port;                /* The port number to connect */
    Bool   DebugFlag;           /* Debug mode OFF = false or 0; ON = true or not zero */
protected:
public:
    AcquireNeutronSourceImageInformation();
        //!< Constructor
        /*!<
         */
    AcquireNeutronSourceImageInformation( string host_name, Bool debug_flag = false );
        //!< Constructor
        /*!<
         *   @param host_name    The server name which is the information Web page of neutron source.
         *   @param debug_flag   The flag to show some parameters under running.
         *                       ( OFF:false/0, ON:true/1 )
         */
    AcquireNeutronSourceImageInformation( Bool debug_flag );
        //!< Constructor
        /*!<
         *   @param debug_flag   The flag to show some parameters under running.
         *                       ( OFF:false/0, ON:true/1 )
         */
    virtual ~AcquireNeutronSourceImageInformation();
        //!< Destructor
        /*!< 
         */

    Int4 SetSavePath( const string save_path );

    void GetImageInformation( const string Key );
    void GetImageInformation( const string Key, const string Start );
    void GetImageInformation( const string Key, const string Start, const string End );

    string PutImagePath( const string Key );
    string PutImagePath( const string Key, const UInt4 year, const UInt4 month, const UInt4 day, const UInt4 hour );

    string PutImageFilename( const string Key );
    string PutImageFilename( const string Key, const UInt4 year, const UInt4 month, const UInt4 day, const UInt4 hour );
};

#endif
