#ifndef ACQUIRENEUTRONSOURCEINFORMATIONBASE
#define ACQUIRENEUTRONSOURCEINFORMATIONBASE

#define BUFSIZE 4096

//#include <stdio>
//#include <stdlib>
#include <unistd.h>           /* getopt, optarg, sleep */
#include <netdb.h>            /* gethostbyname() */

#include <sys/types.h>        /* protocol family, opendir */
#include <sys/socket.h>       /* socket system call */
#include <sys/select.h>       /* select system call */
#include <sys/param.h>
#include <sys/stat.h>         /* mkdir */

#include <netinet/in.h>       /* struct sockaddr_in */
#include <arpa/inet.h>        /* inet_aton() */
#include <dirent.h>           /* opendir */

//#include <iostream>
#include <sstream>
//#include <string>           /* strncpy() */

#include "Header.hh"
#include "MlfHeader.hh"

#include <openssl/ssl.h>
#include <openssl/err.h>      /* for ERR_free_strings */

//////////////////////////////////////////////////
class AcquireNeutronSourceInformationBase
{
private:
protected:
    string HostName;                /* host name */
    string HostProtocol;            /* host protocol (http/https) */
    string FilePath;                /* file path */

    struct sockaddr_in sin;         /* The structure for socket */
//  struct hostent *ServHost;       /* The structure for host name and IP address */
//  struct servent *Service;        /* The structure for service */
    Int4 SocketDescriptor;          /* Socket descriptor */

    SSL_CTX *ctx;
    SSL *ssl;

public:
    AcquireNeutronSourceInformationBase();
        //!< Constructor
        /*!<
         */
    AcquireNeutronSourceInformationBase( string host_name );
        //!< Constructor
        /*!<
         *   @param host_name    The server name which is the information Web page of neutron source.
         */
    virtual ~AcquireNeutronSourceInformationBase();
        //!< Destructor
        /*!< 
         */

    void SetHostName( const string host_name );
    void SetHostProtocol( const string host_protocol );
    void SetFilePath( const string file_path );
    string PutHostName();
    string PutFilePath();

    Int4 InitializeSockaddrIn ();
    Int4 CreateSocket ();
    Int4 ServerConnect ();
    void SocketClose ();

    Int4 SendRequest (string& request);
    Int4 SendRequestHTTP(string& request);
    Int4 SendRequestHTTPS(string& request);
    Int4 RecvReply (string& recv_data);
    Int4 SplitBodyData (string& recv_data, string& body_data);
    //Int4 SplitBodyData (const string Mode, string& recv_data, string& body_data);
};

#endif
