#include "Header.hh"
#include "BinDataFileSectionReader.hh"

#ifndef EVENTDATAMONITOR
#define EVENTDATAMONITOR

class EventDataMonitorBase
{

private:
  


protected:
  size_t ElementSize;
  string WireingFile;
  string DetectorInfoFile;

  //UInt4 CurrentPosition;

  vector<string> TargetT0EvnetFileSet;
  vector<string> TargetEventFileSet;
  vector<UInt4>  DaqIdSet;
  vector<UInt8>  CurrentPosition;

  virtual Int8 Read( string TargetBinFile,
		     Int8 FromBegin, Int8 SizeOfData, void *buf );
  virtual Int8 Read( string TargetBinFile,
		     vector<UInt8> table, UChar *buf );
  virtual Int8 Read( vector<string> TargetBinFiles,
		     vector<UInt8> table, UChar *buf );
  
public:

  EventDataMonitorBase( size_t _ElementSize=8 );
  // Constructor

 ~EventDataMonitorBase();
  // Destructor

 

  virtual void ParameterSet( string _WireingFile,
			     string _DetectorInfoFile );

  /*
  virtual void Increment( string TargetT0EventFilePath,
			  string TargetEventDataPath,
                          UInt4 daqID )=0;
  */

  void AddDataFiles( string TargetT0EventFilePath,
		     string TargetEventDataFilePath,
		     UInt4 DaqID );

  void AddDataFiles( vector<string> TargetT0EventFilePath,
		     vector<string> TargetEventDatafilePath,
		     vector<UInt4> DaqID );


  virtual void Increment( UInt4 index )=0;
  // putSlicedToIndexEvents()
  // Read(), preIncrement(), 

  virtual void Output( string OutputFileName )=0;

  virtual void Clear()=0;
  virtual void ClearDataFileSets();
  
};

#endif
