/*
$Id: OnLineGnuPlot.hh 2284 2011-07-16 11:54:52Z jisuzuki $
 */

#ifndef ONLINEGNUPLOT
#define ONLINEGNUPLOT

#include "Header.hh"
#include "GslHistogram.hh"
#include "GnuplotInterface.hh"
#include "StringTools.hh"

class OnLineGnuPlot {

private:
  GnuplotInterface *gi;
  //vector< vector< GslHistogram* > * > *dat;
  void mplot();
  void splot();
  StringTools *st;

protected:
  vector< vector< GslHistogram* > * > *dat;

public:
  OnLineGnuPlot( string command="gnuplot" );
 ~OnLineGnuPlot();

  void e( string command ){ gi->e( command ); }
  void SetGrayColor();
  void SetDataObj( vector<GslHistogram*> *data, 
		   vector< vector< UInt4 > > dim );
  void SetDataObj( vector<GslHistogram*> *data, 
		   UInt4 x, UInt4 y );

  void MapPlot();
  void SurfacePlot();

  void MapPlot( UInt4 tof );
  void SurfacePlot( UInt4 tof );

  void TofVsCounts( UInt4 Psd );
};
 
#endif

/*
// the following is a sample code with this class.

EventDataToHistogramSample *eh = 
  new EventDataToHistogramSample( 40, 100 );

// Set parameters and input event data


OnLineGnuPlot *olg = new OnLineGnuPlot();
vector< vector< UInt4 > > vvu;
vector<UInt4> v0;
vector<UInt4> v1;
vector<UInt4> v2;
for( UInt4 i=0; i<10; i++ ){
  v0.push_back( i );
  v1.push_back( i+10 );
  v2.push_back( i+20 );
}
vvu.push_back(v0);
vvu.push_back(v1);
vvu.push_back(v2);

vector<GslHistogram*> * vh = eh->PutGslHistogramVec();
olg->SetDataObj( eh->PutGslHistogramVec(), vvu );
olg -> SurfacePlot();

// input event data

olg -> SurfacePlot(); // show summed data
olg -> SurfacePlot( 20 ); // show tof data

delete olg;
*/
