
// File: classASIO__local.xml
%feature("docstring") ASIO_local "

local side of the Boost ASIO netowrk connection

C++ includes: SerialNeutronExchanger.hh ";

%feature("docstring")  ASIO_local::ASIO_local "ASIO_local::ASIO_local(const std::string &host, const std::string &port) ";

%feature("docstring")  ASIO_local::~ASIO_local "ASIO_local::~ASIO_local() ";

%feature("docstring")  ASIO_local::stat "bool ASIO_local::stat(void)

return the status of Boost ASIO's tcp::iostream


Returns:
---------------

false for bad (not connected) ";


// File: classASIO__remote.xml
%feature("docstring") ASIO_remote "

remote side of the Boost ASIO netowrk connection

C++ includes: SerialNeutronExchanger.hh ";

%feature("docstring")  ASIO_remote::ASIO_remote "ASIO_remote::ASIO_remote(const UInt4 port) ";

%feature("docstring")  ASIO_remote::start_accept "void ASIO_remote::start_accept() ";

%feature("docstring")  ASIO_remote::~ASIO_remote "ASIO_remote::~ASIO_remote() ";

%feature("docstring")  ASIO_remote::from_host "std::string ASIO_remote::from_host(void) const ";


// File: classBinConverter.xml
%feature("docstring") BinConverter "C++ includes: ElementContainer.hh ";

%feature("docstring")  BinConverter::BinConverter "BinConverter::BinConverter(vector< Double > &LX, vector< Double > &LY, vector< Double > &LE, const vector< Double > *RX, const vector< Double > *RY, const vector< Double > *RE) ";

%feature("docstring")  BinConverter::~BinConverter "BinConverter::~BinConverter() ";

%feature("docstring")  BinConverter::prepare "Int4 BinConverter::prepare() ";

// File: classCollectArchitecture.xml

%feature("docstring") CollectArchitecture "

    Collect machine architecture.
    This class collects machine architecture parameters by using C-language struct of \"utsname\". You can get system name, node name, the version of OS, release information and machine architecture from this class object.
    \"PutEndian()\" will return a string, \"little\" or \"big\". The framework can judge automatically which the class of SwapBytes should be used or not from the return value of the method.
    C++ includes: CollectArchitecture.hh 

";
%feature("docstring") CollectArchitecture::CollectArchitecture "CollectArchitecture::CollectArchitecture() 

";
%feature("docstring") CollectArchitecture::~CollectArchitecture "CollectArchitecture::~CollectArchitecture() 

";
%feature("docstring") CollectArchitecture::PutEndian "string CollectArchitecture::PutEndian()
========================================
    <returns machine architecture. return a string, \"little\" or \"big\". See the manual of this class. If you receive warning messages from this method, this method cannot detect your machine architecture and return a \"big-endian flag\" as a default flag. 

";
// File: classCppToPython.xml

%feature("docstring") CppToPython "

    Connector between Python and C++ environment.
    This class is applied to data-converter between Python and C++ environment. \"PyObject*\", Python-list, tuple, double, int etc, can be accessed on C++ environment. The access speed to Python-Object in C++ environment is faster than that in Python environment. If you want to pass large Python-object from C++ to Python, it should be manipulated in C++ environment with this class.
    C++ includes: CppToPython.hh 

";
%feature("docstring") CppToPython::CppToPython "CppToPython::CppToPython()
===========================
    Constructor. 

";
%feature("docstring") CppToPython::~CppToPython "CppToPython::~CppToPython()
============================
    Destructor. 

";
%feature("docstring") CppToPython::MakeIntList "PyObject* CppToPython::MakeIntList(UInt4 size=0)
=================================================
    Returns a python list object, and its each value is integer. 

";
%feature("docstring") CppToPython::VectorUInt4ToList "PyObject* CppToPython::VectorUInt4ToList(vector< UInt4 > v)
============================================================
    This method converts from a vector<UInt4> object into a python list object. 

";
%feature("docstring") CppToPython::ListToUInt4Vector "vector<UInt4> CppToPython::ListToUInt4Vector(PyObject *List)
=============================================================
    This method converts from a python list object into a vector<UInt4> object. 

";
%feature("docstring") CppToPython::ListToUInt4VectorP "vector<UInt4>* CppToPython::ListToUInt4VectorP(PyObject *List)
===============================================================
    This method converts from a python list object into a vector<UInt4> dynamically-object. 

";
%feature("docstring") CppToPython::VectorInt4ToList "PyObject* CppToPython::VectorInt4ToList(vector< Int4 > v)
==========================================================
    This method converts from a vector<Int4> object into a python list object. 

";
%feature("docstring") CppToPython::ListToInt4Vector "vector<Int4> CppToPython::ListToInt4Vector(PyObject *List)
===========================================================
    This method converts from a python list object into a vector<Int4> object. 

";
%feature("docstring") CppToPython::ListToInt4VectorP "vector<Int4>* CppToPython::ListToInt4VectorP(PyObject *List)
=============================================================
    This method converts from a python list object into a vector<UInt4> dynamically-object. 

";
%feature("docstring") CppToPython::VectorStringToList "PyObject* CppToPython::VectorStringToList(vector< string > v)
==============================================================
    This method converts from a vector<string> object into a python list object. 

";
%feature("docstring") CppToPython::ListToStringVector "vector<string> CppToPython::ListToStringVector(PyObject *List)
===============================================================
    This method converts from a python list object into a vector<string> object. 

";
%feature("docstring") CppToPython::ListToStringVectorP "vector<string>* CppToPython::ListToStringVectorP(PyObject *List)
=================================================================
    This method converts from a python list object into a vector<string> dynamically-object. 

";
%feature("docstring") CppToPython::VectorToList "PyObject* CppToPython::VectorToList(vector< UInt4 > v)
=======================================================
    Alias of VectorUInt4ToList(v). 

    
PyObject* CppToPython::VectorToList(vector< Int4 > v)
======================================================
    Alias of VectorInt4ToList(v). 
    
PyObject* CppToPython::VectorToList(vector< Double > v)
========================================================
    Alias of VectorDoubleToList(v). 
";
%feature("docstring") CppToPython::MakeDoubleList "PyObject* CppToPython::MakeDoubleList(UInt4 size=0)
====================================================
    This method returns a Python-List whose element data-type is double. The argument of the integer is the size of the Python-list produced in this method. The value of each element is set as zero. 

";
%feature("docstring") CppToPython::VectorDoubleToList "PyObject* CppToPython::VectorDoubleToList(vector< Double > v)
==============================================================
    Converts from a STL-vector to a Python-List. The data-type of the vector- and list-elements are \"Double\". 

";
%feature("docstring") CppToPython::ListToDoubleVector "vector<Double> CppToPython::ListToDoubleVector(PyObject *List)
===============================================================
    This method returns \"vector<Double>\" converted from the argument of a Python-List. The type of the argument of this method is PyObject*. If the type of it is not Python-list, the warning message is sent to the standard-output, and a STL-vector whose size is zero will be returned to avoid problems. 

";
%feature("docstring") CppToPython::ListToDoubleVectorP "vector<Double>* CppToPython::ListToDoubleVectorP(PyObject *List)
=================================================================
    This method returns \"vector<Double>*\" converted from the argument of a Python-List. The type of the argument of this method is PyObject*. If the type of it is not Python-list, the warning message is sent to the standard-output, and a STL-vector whose size is zero will be returned to avoid problems. 

";
%feature("docstring") CppToPython::ListToInt4VectorVector "vector< vector<Int4> > CppToPython::ListToInt4VectorVector(PyObject *List) 

";
// File: classDoubleBinArrange.xml

%feature("docstring") DoubleBinArrange "

    Converter of bin width of one-dimensional histograms.
    This class is a converter of bin width of one-dimensional histogram stored. This class will be called in ElementContainer. Only four steps are required to convert it. 1, constructor. 2, SetHist(). 3, Binning() or Averaging(). 4, PutResultValue() and PutResultError(). If you use the method of \"Binning()\" in the procedure, this class will calculate simple addition concerning with its errors. If you use \"Averaging()\", simple averaging will be done.
    C++ includes: DoubleBinArrange.hh 

";
%feature("docstring") DoubleBinArrange::DoubleBinArrange "DoubleBinArrange::DoubleBinArrange(UInt4 SourceBinNumber, UInt4 ResultBinNumber)
=================================================================================
    Constructor.

    Args:
        SourceBinNumber is the number of bins of input histogram.
        ResultBinNumber is the number of bins of output histogram. 

";
%feature("docstring") DoubleBinArrange::~DoubleBinArrange "DoubleBinArrange::~DoubleBinArrange() 

";
%feature("docstring") DoubleBinArrange::SetHist "void DoubleBinArrange::SetHist(const vector< Double > &SourceBinBoundary, const vector< Double > &SourceValue, const vector< Double > &SourceError, const vector< Double > &ResultBinBoundary)
===============================================================================================================================================================================================

    Args:
        SourceBinBoundary is the boundary values of bins of input histogram.
        SourceValue is the hights of each bin of input histogram.
        SourceError is the error values of each bin of input histogram.
        ResultBinBoundary is the boundary values of bins of output histogram.
        The size of vectors of the arguments should be have the following relationship, SourceValue.size() = SourceError.size() = SourceBinBoundary.size()-1. 

";
%feature("docstring") DoubleBinArrange::PutResultBinMin "vector< Double > & DoubleBinArrange::PutResultBinMin()
=======================================================

    Returns:
        the lower boundary values of bins of output histogram. 

";
%feature("docstring") DoubleBinArrange::PutResultBinMax "vector< Double > & DoubleBinArrange::PutResultBinMax()
=======================================================

    Returns:
        the upper boundary values of bins of output histogram. 

";
%feature("docstring") DoubleBinArrange::PutResultBin "vector< Double > DoubleBinArrange::PutResultBin()
==================================================

    Returns:
        the center of each bin of the output histogram. 

";
%feature("docstring") DoubleBinArrange::PutResultBinVector "vector< Double > DoubleBinArrange::PutResultBinVector()
========================================================

    Returns:
        the values of bin boundaries of the output histogram. The values in the returned vector is the same as those in \"ResultBinBoundary\". 

";
%feature("docstring") DoubleBinArrange::PutResultValue "vector< Double > & DoubleBinArrange::PutResultValue()
======================================================

    Returns:
        result histogram values converted in this class. 

";
%feature("docstring") DoubleBinArrange::PutResultError "vector< Double > & DoubleBinArrange::PutResultError()
======================================================

    Returns:
        result histogram error values converted in this class. 

";
%feature("docstring") DoubleBinArrange::Binning "void DoubleBinArrange::Binning(Int4 DefaultErrorValue=0)
=========================================================
    Execute simple binning, see the manual of this class. 

";
%feature("docstring") DoubleBinArrange::Averaging "void DoubleBinArrange::Averaging()
===================================
    Execute simple averaging, see the manual of this class. 

";
// File: classElementContainer.xml

%feature("docstring") ElementContainer "

    vector<Double> container with their name tag.
    This class is used as a data container. The STL vectors, \"vector<Double>\", and each its name tag are stored in this class object.
    Comparing with NeutronVectorS, this class has some methods which is convenient to use vector<Double>. Since this class can not store array-objects, this class is more effective than \"NeutronVectorS\". This class is also designed to use this class from Python environment. Array objects of C++ are not convenient to use, because special functions on the Python are needed to access C++ arrays. But STL-vector of C++ is a little easy to use on the Python environment, because STL-vector can be converted to Python-list object easily, and in some cases, STL-vector can be accessed directly on the Python with SWIG-interface.
    \"Key\" is the name tag assigned to each vector<Double>. Each vector<Double> stored in this class object can be extracted with the \"Key\" or \"IndexNumber\". If you want to know their names registered in this storage, use \"DumpName()\" and you can see their names on the standard-output.
    When the destructor of this class is called, all data containers and a header object installed in this class will deleted completely. Copy constructor of this class can also work completely on Python.
    C++ includes: ElementContainer.hh 

";
%feature("docstring") ElementContainer::ElementContainer "ElementContainer::ElementContainer()
=====================================
    Constructor.
    If the header object is not required, use this method. 

    
ElementContainer::ElementContainer(const HeaderBase &Header)
=============================================================
    Constructor.
    The header object is received and held in this storage. 
    
ElementContainer::ElementContainer(const ElementContainer &ob)
===============================================================
    Override the copy constructor. 
";
%feature("docstring") ElementContainer::~ElementContainer "ElementContainer::~ElementContainer()
======================================
    Destructor. Delete all objects stored in this storage. 

";
%feature("docstring") ElementContainer::MaskedPlus "ElementContainer & ElementContainer::MaskedPlus(const ElementContainer &r) 

";
%feature("docstring") ElementContainer::MaskedSub "ElementContainer & ElementContainer::MaskedSub(const ElementContainer &r) 

";
%feature("docstring") ElementContainer::MaskedMul "ElementContainer & ElementContainer::MaskedMul(const ElementContainer &r) 

";
%feature("docstring") ElementContainer::MaskedDiv "ElementContainer & ElementContainer::MaskedDiv(const ElementContainer &r) 

";
%feature("docstring") ElementContainer::isHist "bool ElementContainer::isHist() 

";
%feature("docstring") ElementContainer::HistToScat "void ElementContainer::HistToScat() 

";
%feature("docstring") ElementContainer::ScatToHist "void ElementContainer::ScatToHist() 

";
%feature("docstring") ElementContainer::ReBin "ElementContainer ElementContainer::ReBin(ElementContainer &E, string &Key)
===========================================================================
    The number of bin and its width of the histogram are modified.
    The bin properties are set by the vector extracted from the arguments. The returned container has only three columns which have specified as x, y, and ye. The original data-container, \"*this\" is not changed, and the returned ElementContainer should delete in your codes. 

    
ElementContainer ElementContainer::ReBin(const vector< Double > &v)
====================================================================
    Core of Rebin() method. (averaging mode) See the comment of \"ReBin(ElementContainer*, string)\".
    You can define the bin propertis of the histogram directory.

    Args:
        v reference to a reference vector

    Returns:
        new ElementContainer with a X vector same with specified reference vector, Y and E vector re-binned from this ElementContainer. 
    
ElementContainer ElementContainer::ReBin(UInt4 n) 
";
%feature("docstring") ElementContainer::Binning "ElementContainer ElementContainer::Binning(UInt4 n) 

    
ElementContainer ElementContainer::Binning(const vector< Double > &v)
======================================================================
    Core of Binning() method. (binning mode)

    Args:
        v reference to a reference vector

    Returns:
        new ElementContainer with a X vector same with specified reference vector, Y and E vector re-binned from this ElementContainer. 
    
ElementContainer ElementContainer::Binning(ElementContainer &E, string &Key) 
";
%feature("docstring") ElementContainer::Averaging "ElementContainer ElementContainer::Averaging(UInt4 n) 

    
ElementContainer ElementContainer::Averaging(const vector< Double > &v)
========================================================================
    Core of Binning() method. (binning mode)

    Args:
        v reference to a reference vector

    Returns:
        new ElementContainer with a X vector same with specified reference vector, Y and E vector re-binned from this ElementContainer. 
    
ElementContainer ElementContainer::Averaging(ElementContainer &E, string &Key) 
";
%feature("docstring") ElementContainer::MergeWithWeight "ElementContainer ElementContainer::MergeWithWeight(ElementContainer &e) 

";
%feature("docstring") ElementContainer::PrepareXbin "vector< Double > ElementContainer::PrepareXbin(UInt4 n) 

";
%feature("docstring") ElementContainer::SetKeys "bool ElementContainer::SetKeys(const string &X, const string &Y, const string &E)
==================================================================================
    Set keys, they are key-names.
    \"X\" is assigned to the x-value column name, and \"Y\" is assigned to the y-value column name, \"E\" is assigned to the y-value-error column name. The x, y and error column with their key should be installed by the methods of \"Add(...)\" before this method is called. The keys, \"X\", \"Y\" and \"E\" were set as \"None\" in the constructor. 

";
%feature("docstring") ElementContainer::PutXKey "const string& ElementContainer::PutXKey() const
================================================
    Return X-key in string. 

";
%feature("docstring") ElementContainer::PutYKey "const string& ElementContainer::PutYKey() const
================================================
    Return Y-key in string. 

";
%feature("docstring") ElementContainer::PutEKey "const string& ElementContainer::PutEKey() const
================================================
    Return Y-Error-key in string. 

";
%feature("docstring") ElementContainer::PutX "vector< Double > ElementContainer::PutX()
==========================================
    Return the vector assigned to X-value. 

";
%feature("docstring") ElementContainer::PutY "vector< Double > ElementContainer::PutY()
==========================================
    Return the vector assigned to Y-value. 

";
%feature("docstring") ElementContainer::PutE "vector< Double > ElementContainer::PutE()
==========================================
    Return the vector assigned to the error of Y-value. 

";
%feature("docstring") ElementContainer::PutXList "PyObject* ElementContainer::PutXList()
=======================================
    Return the Python-List assigned to X-value. 

";
%feature("docstring") ElementContainer::PutYList "PyObject* ElementContainer::PutYList()
=======================================
    Return the Python-List assigned to Y-value. 

";
%feature("docstring") ElementContainer::PutEList "PyObject* ElementContainer::PutEList()
=======================================
    Return the Python-List assigned to E-value. 

";
%feature("docstring") ElementContainer::PutHistKeyList "PyObject * ElementContainer::PutHistKeyList() 

";
%feature("docstring") ElementContainer::PutTableSize "UInt4 ElementContainer::PutTableSize() const
=============================================
    Returns the number of vectors stored in this storage. 

";
%feature("docstring") ElementContainer::PutSize "UInt4 ElementContainer::PutSize() const
========================================
    Arias of UInt4 PutTableSize(). 

    
UInt4 ElementContainer::PutSize(UInt4 IndexNumber) const
=========================================================
    Returns the size of vectors assigned to the IndexNumber. 
    
UInt4 ElementContainer::PutSize(const string &Key) const
=========================================================
    Returns the size of vectors assigned to the \"Key\".
    This method is left for keeping the compatibility with the old version frameworks. 
";
%feature("docstring") ElementContainer::PutIndexNumber "Int8 ElementContainer::PutIndexNumber(const string &Key)
=========================================================
    Returns the IndexNumber assigned to the \"Key\".
    This method will be return -1, when \"Key\" has not been registored. The type of the return value is Int8, because negative values should be returned. 

";
%feature("docstring") ElementContainer::PutName "string ElementContainer::PutName(UInt4 IndexNumber) 

";
%feature("docstring") ElementContainer::PutKeys "vector< string > ElementContainer::PutKeys()
=============================================
    Returns the \"key\" assigned to the \"IndexNumber\".
    < 

";
%feature("docstring") ElementContainer::PutKeysList "PyObject * ElementContainer::PutKeysList() 

";
%feature("docstring") ElementContainer::PutUnitHeader "HeaderBase ElementContainer::PutUnitHeader() 

";
%feature("docstring") ElementContainer::PutHeader "HeaderBase ElementContainer::PutHeader()
=========================================
    Returns the object of \"HeaderBase\" stored in this container.
    This method will duplicate the original object, and return it. If you want to access the method of the object installed in this class, use PutHeaderPointer(). 

";
%feature("docstring") ElementContainer::PutHeaderPointer "HeaderBase* ElementContainer::PutHeaderPointer() 

";
%feature("docstring") ElementContainer::PutUnitHeaderPointer "HeaderBase* ElementContainer::PutUnitHeaderPointer() 

";
%feature("docstring") ElementContainer::InputUnitHeader "void ElementContainer::InputUnitHeader(const HeaderBase &uHeader) 

";
%feature("docstring") ElementContainer::InputHeader "void ElementContainer::InputHeader(const HeaderBase &Header)
=============================================================
    Input header-object.
    If the header object has installed already, the object is deleted, and the given header-object will be duplicated and its copy object will be installed. 

";
%feature("docstring") ElementContainer::ReSetUnit "void ElementContainer::ReSetUnit(string key, string unit) 

";
%feature("docstring") ElementContainer::DumpKey "void ElementContainer::DumpKey()
=================================
    Dump Key-name(s) with index-number(s) in table format to the standard-output. 

";
%feature("docstring") ElementContainer::Add "void ElementContainer::Add(const string &Key, vector< Double > value, const string &Unit=\"None\")
===================================================================================================
    Append and install a vector object with \"Key\".
    If the type of second argument is not vector<Double>, the data object will be converted into vector<Double> in this method. 

    
void ElementContainer::Add(const string &Key, vector< Float > value, const string &Unit=\"None\")
==================================================================================================
    Append and install a vector object with \"Key\".
    If the type of second argument is not vector<Double>, the data object will be converted into vector<Double> in this method. 
    
void ElementContainer::Add(const string &Key, vector< UInt4 > value, const string &Unit=\"None\")
==================================================================================================
    Append and install a vector object with \"Key\".
    If the type of second argument is not vector<Double>, the data object will be converted into vector<Double> in this method. 
    
void ElementContainer::Add(const string &Key, vector< UInt2 > value, const string &Unit=\"None\")
==================================================================================================
    Append and install a vector object with \"Key\".
    If the type of second argument is not vector<Double>, the data object will be converted into vector<Double> in this method. 
    
void ElementContainer::Add(const string &Key, PyObject *value, const string &Unit=\"None\")
============================================================================================
    Append and install a Python-List object with \"Key\".
    If the type of \"value\" is not \"Python-List\", the error message will be shown by CppToPython. 
    
void ElementContainer::Add(const string &Key, Double *&Array, UInt4 ArraySize, const string &Unit=\"None\")
============================================================================================================
    Append and install an array object with \"Key\".
    The array object will be converted into a vector<Double> in this method. 
    
void ElementContainer::Add(const string &Key, Float *&Array, UInt4 ArraySize, const string &Unit=\"None\")
===========================================================================================================
    Append and install an array object with \"Key\".
    The array object will be converted into a vector<Double> in this method. 
    
void ElementContainer::Add(const string &Key, UInt4 *&Array, UInt4 ArraySize, const string &Unit=\"None\")
===========================================================================================================
    Append and install an array object with \"Key\".
    The array object will be converted into a vector<Double> in this method. 
    
void ElementContainer::Add(const string &Key, UInt2 *&Array, UInt4 ArraySize, const string &Unit=\"None\")
===========================================================================================================
    Append and install an array object with \"Key\".
    The array object will be converted into a vector<Double> in this method. 
";
%feature("docstring") ElementContainer::AddBlankVector "void ElementContainer::AddBlankVector(const string &Key, UInt4 Size=0, const string &Unit=\"None\")
====================================================================================================
    Append a vector<Double> with its Key.
    The size of the vector is \"Size\", and its default size is zero. A vector object is created in this method, and appended to the container with \"Key\". This method is very useful for manipulating this class from the Python environment. 

";
%feature("docstring") ElementContainer::Find "vector<Double> ElementContainer::Find(const string &Key)
=========================================================
    Returns the pointer of the vector-object assigned to \"Key\". 

    
vector<Double> ElementContainer::Find(UInt4 IndexNumber)
=========================================================
    Returns the pointer of the vector-object assigned to \"IndexNumber\". 
    
Double ElementContainer::Find(const string &Key, UInt4 Index)
==============================================================
    Returns Index-th Double value extracted from the vector named as \"Key\". 
";
%feature("docstring") ElementContainer::Put "vector<Double> ElementContainer::Put(UInt4 IndexNumber)
========================================================
    Alias of Find(IndexNumber), returns a vector object. 

    
vector<Double> ElementContainer::Put(const string &Key)
========================================================
    Alias of Find(Key), returns a vector object. 
    
Double ElementContainer::Put(const string &Key, UInt4 Index)
=============================================================
    Alias of Find(string,UInt4). 
";
%feature("docstring") ElementContainer::PutUnit "string ElementContainer::PutUnit(const string &Key) const 

";
%feature("docstring") ElementContainer::SetUnit "void ElementContainer::SetUnit(const string &Key, const string &NewUnit) 

";
%feature("docstring") ElementContainer::PutList "PyObject* ElementContainer::PutList(const string &Key)
=======================================================
    Returns the Python-List object which is converted vector<Double>.
    The each element of the Python-List is equal to the vector returned by Put( Key ). This method is written on C++, the speed of converting from STL-vector object to Python-List object in this method is faster than that in Python environment. 

";
%feature("docstring") ElementContainer::ReduceColumn "vector< Double > ElementContainer::ReduceColumn(const string &Key) 

";
%feature("docstring") ElementContainer::ReduceColumnList "PyObject* ElementContainer::ReduceColumnList(const string &Key) 

";
%feature("docstring") ElementContainer::CheckKey "UInt4 ElementContainer::CheckKey(const string &Key)
====================================================
    This method returns zero, if the vector whose name is \"Key\" is not contained in the storage.
    The integer returned by this method expresses the number of the vectors assigned to \"Key\". But the value is not 0 or 1, the serious problems may occur in this class. 

";
%feature("docstring") ElementContainer::RenameKey "bool ElementContainer::RenameKey(const string &OldKey, const string &NewKey) 

";
%feature("docstring") ElementContainer::Copy "void ElementContainer::Copy(const string &Old, const string &New)
==================================================================
    Copy the vector object. The new vector object is created named as \"x\". Each value is copied from the \"vector-Old\" to the \"vector-New\". 

";
%feature("docstring") ElementContainer::Remove "void ElementContainer::Remove(const string &Key)
=================================================
    Remove a vector object whose name is \"Key\". 

";
%feature("docstring") ElementContainer::Replace "void ElementContainer::Replace(const string &Key, const vector< Double > &value) 

    
void ElementContainer::Replace(const string &Key, PyObject *value)
===================================================================
    Replace the vector assigned to Key. 
";
%feature("docstring") ElementContainer::AppendValue "void ElementContainer::AppendValue(const string &Key, Double value)
====================================================================
    This method appends \"value\" to the target vector specified by \"Key\".
    The class method of STL-vector, append(Double), is used in this method. 

    
void ElementContainer::AppendValue(const string &Key, const vector< Double > &value)
=====================================================================================
    This method appends \"vector<Double> value\" to the vector assigned to \"Key\".
    The vector \"value\" is connected to the end of the vector. 
";
%feature("docstring") ElementContainer::SetValue "void ElementContainer::SetValue(const string &Key, UInt4 Number, Double value)
===============================================================================
    This method can change the \"Number\"-th value of the target vector. The vector is extracted with \"Key\".
    If the value of the second argument, \"Number\", is larger than the size of target vector, a warning message will be shown. 

";
%feature("docstring") ElementContainer::Transform "void ElementContainer::Transform(const std::string &Key, T F, const std::string &newunit=\"None\")
===================================================================================================
    performs std::transform() to a vector with specified key and function object

    Args:
        Key a key which specifies the target vector
        F() a function object
        newunit new unit 

";
%feature("docstring") ElementContainer::Reverse "void ElementContainer::Reverse(void)
=====================================
    reverse all std::vector 

";
%feature("docstring") ElementContainer::Dump "void ElementContainer::Dump()
==============================
    Dump all information stored in this container to the standard output.
    If you want to convert this output into vector<string>, the vector object can be input into \"ReceiveString(vector<string>)\". 

    
void ElementContainer::Dump(UInt4 size)
========================================
    The method of \"Dump()\" will dump whole information stored in this container.
    If the size of vectors are huge, \"Dump()\" will completely fill up your console with data. This method will shorten the size of vector shown in your console. 
";
%feature("docstring") ElementContainer::PyDump "PyObject * ElementContainer::PyDump() 

";
%feature("docstring") ElementContainer::dump "void ElementContainer::dump() 

";
%feature("docstring") ElementContainer::DumpValue "void ElementContainer::DumpValue() 

    
void ElementContainer::DumpValue(UInt4 size) 
";
%feature("docstring") ElementContainer::DumpFromVectorContainer "void ElementContainer::DumpFromVectorContainer() 

    
void ElementContainer::DumpFromVectorContainer(UInt4 size) 
";
%feature("docstring") ElementContainer::PutXYEKeys "string ElementContainer::PutXYEKeys() 

";
%feature("docstring") ElementContainer::PutMergedKey "string ElementContainer::PutMergedKey() 

";
%feature("docstring") ElementContainer::PutSizeVector "vector< UInt4 > ElementContainer::PutSizeVector() 

";
%feature("docstring") ElementContainer::PutMergedDataVector "vector< Double > ElementContainer::PutMergedDataVector() 

";
%feature("docstring") ElementContainer::BuildElementContainer "void ElementContainer::BuildElementContainer(string XYEKeys, string MergedKey, vector< UInt4 > SizeVector, vector< Double > MergedDataVector, HeaderBase h, HeaderBase uh)
===========================================================================================================================================================================
    Build a new ElementContainer instance from long vector Mergedkey and MergedDataVector.
    The object of HeaderBase, the fifth argument, will be deleted in this function. If the object extracted with \"PutHeader()\" is installed with this function, you should copy it before use this function. 

";
%feature("docstring") ElementContainer::PutP "vector<Double>* ElementContainer::PutP(const string &Key) 

";
%feature("docstring") ElementContainer::AddToHeader "void ElementContainer::AddToHeader(const string &Key, Int4 value)
==================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 

    
void ElementContainer::AddToHeader(const string &Key, Double value)
====================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
    
void ElementContainer::AddToHeader(const string &Key, string value)
====================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
    
void ElementContainer::AddToHeader(const string &Key, vector< Int4 > value)
============================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
    
void ElementContainer::AddToHeader(const string &Key, vector< Double > value)
==============================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
    
void ElementContainer::AddToHeader(const string &Key, vector< string > value)
==============================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
";
%feature("docstring") ElementContainer::Sum "Double ElementContainer::Sum(const string &key, const UInt4 i0, const UInt4 i1) const
======================================================================================
    Returns the sum of each element of the target vector within the specified range [i0, i1). 

    
Double ElementContainer::Sum(const string &key) const
======================================================
    Returns the sum of each element of the target vector. The argument of this method is the key of the target vector. 
    
Double ElementContainer::Sum(void) const
=========================================
    Returns the sum of each element of the target vector. Ykey is selected as a target. 
    
std::pair< Double, Double > ElementContainer::Sum(const string &key, const string &err_key, UInt4 i0, UInt4 i1) const
======================================================================================================================
    Returns Sum(key, err_key) within the range [i0, i1) 
    
std::pair< Double, Double > ElementContainer::Sum(const string &key, const string &err_key) const
==================================================================================================
    Returns the sum of each element of the target vector and its error.
    The type of the rerurn value is std::pair<Double, Double>. The first element of the vector is the sum, and the second one is the its error. To calculate the sum and its error, this method requires you to input two keys. The first value of the return vector is equal to the return value of Sum(string). 
    
std::pair< Double, Double > ElementContainer::Sum(Double ini, Double fin) const
================================================================================
    Returns the sum of values of \"Ykey\" in the range between ini and fin of \"Xkey\" with errors.
    The type of the rerurn value is std::pair<Double, Double>. The first element of the vector is the sum, and the second one is the its error. To calculate the sum and its error, this method requires you to input two keys. ... arranged by Y.I. 
";
%feature("docstring") ElementContainer::Sum2 "std::pair< Double, Double > ElementContainer::Sum2(void) const
===============================================================
    Returns Sum( Ykey, Ekey ) 

";
%feature("docstring") ElementContainer::Ave "Double ElementContainer::Ave(const string &key)
================================================
    Returns the average value of the target vector. The average value will be obtained without its error. 

    
Double ElementContainer::Ave(const string &key, const string &err)
===================================================================
    Returns the average value of the target vector. The average value will be obtained with its error. 
";
%feature("docstring") ElementContainer::Min "Double ElementContainer::Min(const string &key)
================================================
    Returns the minimal value contained in the target vector. 

";
%feature("docstring") ElementContainer::Max "Double ElementContainer::Max(const string &key)
================================================
    Returns the maximum value contained in the target vector. 

";
%feature("docstring") ElementContainer::Integrate "std::pair< Double, Double > ElementContainer::Integrate()
==========================================================
    This method obtains the area of the histogram defined with \"Xkey\", \"Ykey\" and \"Ekey\".
    The first element of the return vector is the area integrated in this method, and the second argument is its error value. Before calling this method, you should set \"Xkey\", \"Ykey\" and \"Ekey\" with \"SetKeys(string,string,string)\". arranged by Y.I. 

    
std::pair< Double, Double > ElementContainer::Integrate(Double ini, Double fin)
================================================================================
    This method obtains the area of the histogram defined with \"Xkey\", \"Ykey\" and \"Ekey\".
    <
    The first element of the return vector is the area integrated in this method, and the second argument is its error value. Before calling this method, you should set \"Xkey\", \"Ykey\" and \"Ekey\" with \"SetKeys(string,string,string)\". The arguments of this methods are the start and end index of the histogram. When the size of Y-vector is S, the indices should be set from zero to (S-1). 
";
%feature("docstring") ElementContainer::SaveToBinFile "void ElementContainer::SaveToBinFile(string key, string FileName)
==================================================================
    histogram data whose name is \"key\" is saved to a binary file named as \"FileName\". 

";
%feature("docstring") ElementContainer::ReadBinFile "void ElementContainer::ReadBinFile(string FileName, string key)
================================================================
    A binary file stored by \"SaveToBinFile(string,string)\" is read by this method.
    The format of the target file is a dump file of double type C-language array. The target file data will be stored into ElementContainer with \"key\". 

";
%feature("docstring") ElementContainer::SaveTextFile "void ElementContainer::SaveTextFile(string FileName) 

    
void ElementContainer::SaveTextFile(string FileName, Int4 prec) 
    
void ElementContainer::SaveTextFile(string FileName, Char deli) 
    
void ElementContainer::SaveTextFile(string FileName, Int4 prec, Char deli) 
";
%feature("docstring") ElementContainer::SaveHistTextFile "void ElementContainer::SaveHistTextFile(string FileName) 

    
void ElementContainer::SaveHistTextFile(string FileName, Int4 prec) 
    
void ElementContainer::SaveHistTextFile(string FileName, Char deli) 
    
void ElementContainer::SaveHistTextFile(string FileName, Int4 prec, Char deli)
===============================================================================
    This method saves Histogram data defined by \"keys\" on a TEXT file named \"FileName\". by Y.I. and modified by T.I. 
";
%feature("docstring") ElementContainer::LoadTextFile "void ElementContainer::LoadTextFile(string FileName)
=====================================================
    This method saves Histogram data defined by \"keys\" on a TEXT file named \"FileName\". by Y.I. 

";
%feature("docstring") ElementContainer::Mul "ElementContainer ElementContainer::Mul(Double d) 

    
ElementContainer ElementContainer::Mul(Double d, Double e) 
    
ElementContainer ElementContainer::Mul(pair< Double, Double > &d) 
";
%feature("docstring") ElementContainer::MulMySelf "ElementContainer & ElementContainer::MulMySelf(Double d) 

    
ElementContainer & ElementContainer::MulMySelf(Double d, Double e) 
    
ElementContainer& ElementContainer::MulMySelf(pair< Double, Double > &d) 
";
%feature("docstring") ElementContainer::Plus "ElementContainer ElementContainer::Plus(Double d) 

    
ElementContainer ElementContainer::Plus(Double d, Double e) 
    
ElementContainer ElementContainer::Plus(pair< Double, Double > &d) 
";
%feature("docstring") ElementContainer::PlusMySelf "ElementContainer & ElementContainer::PlusMySelf(Double d) 

    
ElementContainer & ElementContainer::PlusMySelf(Double d, Double e) 
    
ElementContainer& ElementContainer::PlusMySelf(pair< Double, Double > &d) 
";
// File: classElementContainerAppendError.xml

%feature("docstring") ElementContainerAppendError "

    Append an error column to ElementContainer.
    The base-class of ElementContainerAppendError is ManipulatorBase< ElementContainer >. The output of \"ElementContainer\" is identical to the input data-object, because the base class of this class is ManipulatorBase. Please see the manual of it.
    The following is the procedure how to use this class, 1) Construct the class-instance of this class, 2) Use ManipulatorBase< ElementContainer >:: SetTarget(ElementContainer*), 3) Call Append(). 4) If you want to manipulate another containers, use ManipulatorBase< ElementContainer >::Clear(), and return 2).
    C++ includes: ElementContainerAppendError.hh 

";
%feature("docstring") ElementContainerAppendError::ElementContainerAppendError "ElementContainerAppendError::ElementContainerAppendError(Double ErrorValue=1.0)
================================================================================
    Constructor. The first argument is error value, and its default value is 1.0. If the counts-value is zero, the first argument will be used instead of sqrt(0.0). 

";
%feature("docstring") ElementContainerAppendError::~ElementContainerAppendError "ElementContainerAppendError::~ElementContainerAppendError()
============================================================
    Destructor. 

";
%feature("docstring") ElementContainerAppendError::Append "void ElementContainerAppendError::Append(ElementContainer *target, string CountsKey, string ErrorKey)
======================================================================================================
    The first argument is the key-name assigned to the values of Counts. The second argument is the key-name of the error-value, which will be appended to the input data-object.
    See the manual of this class. If the key-name of counts given in the constructor does not exist in the target container, this method will output the warning messages to the standard-output. 

";
// File: classElementContainerArray.xml

%feature("docstring") ElementContainerArray "

    Data container for a set of ElementContainer-s and HeaderBase.
    This class is inherited from the template class, NeutronVector<ElementContainer,HeaderBase>. This class is a Data-container class for storeing a set of ElementContainer-s and HeaderBase. See the manuals of the template class of NeutronVector<T,H>.
    C++ includes: ElementContainerArray.hh 

";
%feature("docstring") ElementContainerArray::ElementContainerArray "ElementContainerArray::ElementContainerArray()
===============================================
    Constructor.
    This method only calls the constructor of the base class. 

    
ElementContainerArray::ElementContainerArray(HeaderBase pheader)
=================================================================
    Constructor.
    This method only calls the constructor of the base class. 
    
ElementContainerArray::ElementContainerArray(const NeutronVector< ElementContainer, HeaderBase > &ob) 
    
ElementContainerArray::ElementContainerArray(const ElementContainerArray &ob) 
";
%feature("docstring") ElementContainerArray::SaveToBinFile "vector< UInt4 > ElementContainerArray::SaveToBinFile(string key, string FileName)
==================================================================================
    Histogram data stored in this class are saved as a file in binary data format.
    Histogram data are extracted from each ElementContainer with \"key\", and the dimension of ElementContainerArray is written in the type of vector<UInt4> and returned by this method. The return value will be used as the second argument of ReadBinFile(string,vector<UInt4>,string). 

";
%feature("docstring") ElementContainerArray::SaveToBinFilePy "PyObject * ElementContainerArray::SaveToBinFilePy(string key, string FileName)
===============================================================================
    This method has the same functionality as \"SaveToBinFile(string,string)\".
    The return value can be recognized by python-environment directory. 

";
%feature("docstring") ElementContainerArray::ReadBinFile "void ElementContainerArray::ReadBinFile(string FileName, vector< UInt4 > dimensions, string key)
=================================================================================================
    Histogram data stored by SaveToBinFile(string,string) is read with this method, and rebuild ElementContainerArray.
    This method should be called just after constructing this class method. The binary data will be stored in each ElementContainer with \"key\". 

    
void ElementContainerArray::ReadBinFile(string FileName, PyObject *dimensions, string key)
===========================================================================================
    This method has the same functionality as \"ReadBinFile(string,PyObject*,string)\".
    The second argument should be the return value of \"SaveToBinFilePy(string,string)\". 
";
%feature("docstring") ElementContainerArray::AppendErr "void ElementContainerArray::AppendErr(string Counts, string Error, Double ErrorValue=0.0)
==========================================================================================
    This method appends a vector<Double> into each object of ElementContainer.
    The first argument is the key-name of neutron-counts, and the second is the key-name of its error-value created and appended by this method. The third argument is passed to the constructor of \"ElementContainerAppendError\", please see the manual of it. 

";
%feature("docstring") ElementContainerArray::Mul "ElementContainerArray ElementContainerArray::Mul(Double d) 

    
ElementContainerArray ElementContainerArray::Mul(Double d, Double e) 
    
ElementContainerArray ElementContainerArray::Mul(pair< Double, Double > &p) 
";
%feature("docstring") ElementContainerArray::MulMySelf "ElementContainerArray & ElementContainerArray::MulMySelf(Double d) 

    
ElementContainerArray & ElementContainerArray::MulMySelf(Double d, Double e) 
    
ElementContainerArray& ElementContainerArray::MulMySelf(pair< Double, Double > &p) 
";
%feature("docstring") ElementContainerArray::Plus "ElementContainerArray ElementContainerArray::Plus(Double d) 

    
ElementContainerArray ElementContainerArray::Plus(Double d, Double e) 
    
ElementContainerArray ElementContainerArray::Plus(pair< Double, Double > &p) 
";
%feature("docstring") ElementContainerArray::PlusMySelf "ElementContainerArray & ElementContainerArray::PlusMySelf(Double d) 

    
ElementContainerArray & ElementContainerArray::PlusMySelf(Double d, Double e) 
    
ElementContainerArray& ElementContainerArray::PlusMySelf(pair< Double, Double > &p) 
";
%feature("docstring") ElementContainerArray::MergeWithWeight "ElementContainerArray ElementContainerArray::MergeWithWeight(ElementContainerArray &eca) 

";
// File: classElementContainerMatrix.xml

%feature("docstring") ElementContainerMatrix "

    Data container for a set of ElementContainerArray-s and HeaderBase.
    This class is inherited from the template class, NeutronVector<ElementContainerArray,HeaderBase>. This class is a Data-container class for storeing a set of ElementContainerArray-s and HeaderBase. See the manuals of the template class of NeutronVector<T,H>.
    C++ includes: ElementContainerMatrix.hh 

";
%feature("docstring") ElementContainerMatrix::ElementContainerMatrix "ElementContainerMatrix::ElementContainerMatrix()
=================================================
    Constructor.
    This method only calls the constructor of the base class. 

    
ElementContainerMatrix::ElementContainerMatrix(HeaderBase pheader)
===================================================================
    Constructor.
    This method only calls the constructor of the base class. 
    
ElementContainerMatrix::ElementContainerMatrix(const NeutronVector< ElementContainerArray, HeaderBase > &ob)
=============================================================================================================
    This copy constructor is very important from operators in NeutronVector. 
    
ElementContainerMatrix::ElementContainerMatrix(const ElementContainerMatrix &ob) 
";
%feature("docstring") ElementContainerMatrix::SaveToBinFile "vector< UInt4 > ElementContainerMatrix::SaveToBinFile(string key, string FileName)
===================================================================================
    Histogram data stored in this class are saved as a file in binary data format.
    Histogram data are extracted from each ElementContainer with \"key\", and the dimension of ElementContainerArray is written in the type of vector<UInt4> and returned by this method. The return value will be used as the second argument of ReadBinFile(string,vector<UInt4>,string). 

";
%feature("docstring") ElementContainerMatrix::SaveToBinFilePy "PyObject * ElementContainerMatrix::SaveToBinFilePy(string key, string FileName)
================================================================================
    This method has the same functionality as \"SaveToBinFile(string,string)\".
    The return value can be recognized by python-environment directory. 

";
%feature("docstring") ElementContainerMatrix::ReadBinFile "void ElementContainerMatrix::ReadBinFile(string FileName, vector< UInt4 > dimensions, string key)
==================================================================================================
    Histogram data stored by SaveToBinFile(string,string) is read with this method, and rebuild ElementContainerMatrix.
    This method should be called just after constructing this class method. The binary data will be stored in each ElementContainer with \"key\". 

    
void ElementContainerMatrix::ReadBinFile(string FileName, PyObject *dimensions, string key)
============================================================================================
    This method has the same functionality as \"ReadBinFile(string,PyObject*,string)\".
    The second argument should be the return value of \"SaveToBinFilePy(string,string)\". 
";
%feature("docstring") ElementContainerMatrix::AppendErr "void ElementContainerMatrix::AppendErr(string Counts, string Error, Double ErrorValue=0.0)
===========================================================================================
    This method appends a vector<Double> into each object of ElementContainer.
    The first argument is the key-name of neutron-counts, and the second is the key-name of its error-value created and appended by this method. The third argument is passed to the constructor of \"ElementContainerAppendError\", please see the manual of it. 

";
%feature("docstring") ElementContainerMatrix::AllSum "void ElementContainerMatrix::AllSum(ElementContainer &res)
===========================================================
    accumulation of all ElementContainers (for S(Q) merging) 

";
%feature("docstring") ElementContainerMatrix::Transpose "ElementContainerMatrix ElementContainerMatrix::Transpose()
===========================================================
    This method returns a transposed element container matrix. If a shape of the element container matrix is not rectangular, this method returns non-transposed one. 

";
%feature("docstring") ElementContainerMatrix::Mul "ElementContainerMatrix ElementContainerMatrix::Mul(Double d) 

    
ElementContainerMatrix ElementContainerMatrix::Mul(Double d, Double e) 
    
ElementContainerMatrix ElementContainerMatrix::Mul(pair< Double, Double > &p) 
";
%feature("docstring") ElementContainerMatrix::MulMySelf "ElementContainerMatrix & ElementContainerMatrix::MulMySelf(Double d) 

    
ElementContainerMatrix & ElementContainerMatrix::MulMySelf(Double d, Double e) 
    
ElementContainerMatrix& ElementContainerMatrix::MulMySelf(pair< Double, Double > &p) 
";
%feature("docstring") ElementContainerMatrix::Plus "ElementContainerMatrix ElementContainerMatrix::Plus(Double d) 

    
ElementContainerMatrix ElementContainerMatrix::Plus(Double d, Double e) 
    
ElementContainerMatrix ElementContainerMatrix::Plus(pair< Double, Double > &p) 
";
%feature("docstring") ElementContainerMatrix::PlusMySelf "ElementContainerMatrix & ElementContainerMatrix::PlusMySelf(Double d) 

    
ElementContainerMatrix & ElementContainerMatrix::PlusMySelf(Double d, Double e) 
    
ElementContainerMatrix& ElementContainerMatrix::PlusMySelf(pair< Double, Double > &p) 
";
%feature("docstring") ElementContainerMatrix::MergeWithWeight "ElementContainerMatrix ElementContainerMatrix::MergeWithWeight(ElementContainerMatrix &ecm) 

";
// File: classGaussianEventData.xml

%feature("docstring") GaussianEventData "

    Event data generator with Gaussian function.
    This class generate event data generator with Gaussian function and the class of GslRandGenerator.
    C++ includes: GaussianEventData.hh 

";
%feature("docstring") GaussianEventData::GaussianEventData "GaussianEventData::GaussianEventData(Double Average, Double Sigma, Int4 Ini, Int4 Fin)
=======================================================================================
    Constructor. The shape of Gaussian function is set with the arguments of this method. The minimum and maximum return value of the generator are Ini and Max. Average and Sigma are the expected value and the standard deviation. 

";
%feature("docstring") GaussianEventData::~GaussianEventData "GaussianEventData::~GaussianEventData() 

";
%feature("docstring") GaussianEventData::Next "Int4 GaussianEventData::Next()
===============================
    This method returns an integer. If you create the histogram filled with the return values, you will get a Gaussian distributed histogram. 

";
%feature("docstring") GaussianEventData::Generate "vector< Int4 > GaussianEventData::Generate(UInt4 size)
=======================================================
    This method returns a vector<Int4> vector object whose size is \"size\". The vector is filled the values obtained with \"Next()\". 

";
// File: classGslHistogram.xml

%feature("docstring") GslHistogram "

    converter from event type data to histogram in 1d
    This class is a converter from a set of event data to a histogram data.
    The procedure of conversion is following,
    (1) The boundary of the histogram bin is set with the constructor of this class. (2) The event data is filled into the histogram bins with \"Increment(Double,Double)\" or \"Increment(vector<Double>)\". (3) The result of the conversion is obtained with \"PutHistogram()\".
    C++ includes: GslHistogram.hh 

";
%feature("docstring") GslHistogram::GslHistogram "GslHistogram::GslHistogram(Double *Bin, UInt4 Size, UInt4 _NumOfMulTh=1)
=========================================================================
    Constructor. The bins of the histogram will be set with the arguments. The each value of the array is the boundary of the bins. 

";
%feature("docstring") GslHistogram::~GslHistogram "GslHistogram::~GslHistogram()
==============================
    Destructor 

";
%feature("docstring") GslHistogram::PutHistSize "UInt4 GslHistogram::PutHistSize()
==================================
    Returns the number of bins. 

";
%feature("docstring") GslHistogram::PutHistogramList "PyObject* GslHistogram::PutHistogramList()
===========================================
    This method returns a vector object. The vector object has the contents of each bin of the histogram. 

";
%feature("docstring") GslHistogram::PutHistogram "vector< Double > GslHistogram::PutHistogram()
==============================================
    This method returns a vector object. The vector object has the contents of each bin of the histogram. 

";
%feature("docstring") GslHistogram::PutHistogramErr "vector< Double > GslHistogram::PutHistogramErr()
=================================================
    This method returns a vector object. The vector object has the error values corresponding with the vector returned by \"PutHistogram()\". 

";
%feature("docstring") GslHistogram::PutHistogramErrList "PyObject* GslHistogram::PutHistogramErrList()
==============================================
    This method returns a vector object. The vector object has the error values corresponding with the vector returned by \"PutHistogram()\". 

";
%feature("docstring") GslHistogram::Increment "Int4 GslHistogram::Increment(Double x, UInt4 ThNum=0, Double Weight=1.0)
=========================================================================
    The second argument is ommitted, this method updates the histogram by adding 1.0 to the bin whose range contains the value of \"x\". The second value is not ommitted, this method increase the value by the number of \"Weight\". 

    
void GslHistogram::Increment(vector< Double > x, UInt4 ThNum=0)
================================================================
    Each value of x is filled into the histogram. \"Increment(Double,1.0)\" is executed in this method. 
    
void GslHistogram::Increment(vector< Int4 > x, UInt4 ThNum=0)
==============================================================
    Each value of x is filled into the histogram. \"Increment(Double,1.0)\" is executed in this method. 
";
%feature("docstring") GslHistogram::Dump "void GslHistogram::Dump()
==========================
    This method dumps All data stored in this class to stdout. 

";
%feature("docstring") GslHistogram::Reset "void GslHistogram::Reset()
===========================
    This method clears all data stored with \"Increment(double,double)\". 

";
%feature("docstring") GslHistogram::PutHistPointer "gsl_histogram* GslHistogram::PutHistPointer(UInt4 ThNum=0)
===========================================================
    The return value of this method is the pointer of \"gsl_histogram\". You can use all functions prepared in the gsl-library with the pointer. 

";
%feature("docstring") GslHistogram::PutBin "vector< Double > GslHistogram::PutBin()
========================================
    Returns bin boundaries. The size of returnd vector is PutHistSize()+1. 

";
%feature("docstring") GslHistogram::PutBinList "PyObject* GslHistogram::PutBinList()
=====================================
    Returns bin boundaries. The size of returnd list is PutHistSize()+1. 

";
%feature("docstring") GslHistogram::PutHistogramSum "Double GslHistogram::PutHistogramSum()
=======================================
    Returns the sum of all bin values. 

";
// File: classGslRandGenerator.xml

%feature("docstring") GslRandGenerator "

    Random number generator.
    This class generates random numbers. The type of the random numbers is \"unsigned long\", and The type of long and int is the same on current Linux systems.
    C++ includes: GslRandGenerator.hh 

";
%feature("docstring") GslRandGenerator::GslRandGenerator "GslRandGenerator::GslRandGenerator()
=====================================
    Constructor. EPOC time, Unix time is used as a random seed in this method. Don't construct this class method in a second. If you want to construct this class method in the same second, use the other constructor. 

    
GslRandGenerator::GslRandGenerator(unsigned long seed)
=======================================================
    Constructor. This method can receive random seed. The seed will be obtained from PutNextSeed() belonging had been constructed class objects. 
";
%feature("docstring") GslRandGenerator::~GslRandGenerator "GslRandGenerator::~GslRandGenerator()
======================================
    Destructor 

";
%feature("docstring") GslRandGenerator::PutMin "unsigned long GslRandGenerator::PutMin()
=========================================
    Returns minimum number of the candidates returned by PutRand(). 

";
%feature("docstring") GslRandGenerator::PutMax "unsigned long GslRandGenerator::PutMax()
=========================================
    Returns maximum number of the candidates returned by PutRand(). 

";
%feature("docstring") GslRandGenerator::PutRand "unsigned long GslRandGenerator::PutRand()
==========================================
    Returns a random number generated in this class. 

    
unsigned long GslRandGenerator::PutRand(UInt4 Max)
===================================================
    Returns a rundom number generated in this class. The range of the return value is 0 to Max, and the maximum value is Max. 
";
%feature("docstring") GslRandGenerator::PutNextSeed "unsigned long GslRandGenerator::PutNextSeed()
==============================================
    Returns a random number generated in this class. The return value will be used in the next constructor. See the manual of the constructor. 

";
%feature("docstring") GslRandGenerator::PutDouble "Double GslRandGenerator::PutDouble()
=====================================
    Returns a random number in double type. The value of the return number will be 0.0-1.0, but it is generated by PutRand()/PutMax(). 

";
// File: classHeaderBase.xml

%feature("docstring") HeaderBase "

    Data container for various data type with name-tag.
    This class is improved in its functionarities from \"HeaderBase\". \"vector<Int4>\", \"vector<Double>\" and vector<string> can be stored into this container, and \"Int4\", \"Double\" and \"string\" can be also kept in it with its names.
    To keep the convenience for storing various types of objects, \"HeaderBase\" is not more efficient than \"ElementContainer\" and \"NeutronVectorS\", and this class should not be used as containers for experimental numerical data sets. This class is applied to keep header information in \"ElementContainer\". Please see the data structure of it.
    To keep compatibility with the old-version of \"HeaderBase\", some methods are added in this class. This class object has six class objects as protected member, \"Map<Int4>\", \"Map<Double>\", \"Map<string>\", \"Map<vector<Int4> >\", \"Map<vector<Double> >\" and \"Map<vector<string> >\". If you want to append the other functionarities to this class, the protected methods are manipulated from your sub-class and see the manuals of \"Map\".
    You cannot register the data object with the same key-name as the already used key-name over the six categories. To avoid the duplication, the addition process is checked in the methods of \"Add(...)\" If you want to know the key-names registered in this storage, use \"Search(string)\" or \"Dump()\".
    Delimiter in this class is \",\" don't forget this rule. Comma(s) should not be contained in strings appending to this storage.
    \"DumpToString()\" and \"InputString()\" is used exchanging the all information between servers. All information can be converted into a string object by \"DumpToString()\", and re-builded with the string object to \"HeaderBase\" by \"InputString(string)\".
    All information including vector-objects stored in this class will be deleted in the destructor. If data-objects extracted from \"HeaderBase\" are installed into other containers, the objects should be copied in your application before executing this destructor.
    Because both \"Erase(Key)\" and Add(Key,Value) is executed in the method of \"OverWrite(Key,Value)\", the type of Value can be changed by \"OverWrite(Key,Value)\".
    C++ includes: HeaderBase.hh 

";
%feature("docstring") HeaderBase::HeaderBase "HeaderBase::HeaderBase()
=========================
    Constructor. 

    
HeaderBase::HeaderBase(const HeaderBase &ob)
=============================================
    Copy constructor. 
";
%feature("docstring") HeaderBase::~HeaderBase "HeaderBase::~HeaderBase()
==========================
    Destructor.
    All information stored in this class will be deleted in this method. 

";
%feature("docstring") HeaderBase::Add "void HeaderBase::Add(string Key, Int4 value)
=============================================
    Add a new value with its key. 

    
void HeaderBase::Add(string Key, Double value)
===============================================
    Add a new value with its key. 
    
void HeaderBase::Add(string Key, string value)
===============================================
    Add a new value with its key. 
    
void HeaderBase::Add(string Key, vector< Int4 > value)
=======================================================
    Add a new value with its key. 
    
void HeaderBase::Add(string Key, vector< Double > value)
=========================================================
    Add a new value with its key. 
    
void HeaderBase::Add(string Key, vector< string > value)
=========================================================
    Add a new value with its key. 
";
%feature("docstring") HeaderBase::AddHeader "void HeaderBase::AddHeader(string Key, Int4 value)
===================================================
    Alias of Add(Key,value) 

    
void HeaderBase::AddHeader(string Key, Double value)
=====================================================
    Alias of Add(Key,value) 
    
void HeaderBase::AddHeader(string Key, string value)
=====================================================
    Alias of Add(Key,value) 
    
void HeaderBase::AddHeader(string Key, vector< Int4 > value)
=============================================================
    Alias of Add(Key,value) 
    
void HeaderBase::AddHeader(string Key, vector< Double > value)
===============================================================
    Alias of Add(Key,value) 
    
void HeaderBase::AddHeader(string Key, vector< string > value)
===============================================================
    Alias of Add(Key,value) 
";
%feature("docstring") HeaderBase::add "void HeaderBase::add(string Key, Int4 value)
=============================================
    Alias of Add(Key,value) 

    
void HeaderBase::add(string Key, Double value)
===============================================
    Alias of Add(Key,value) 
    
void HeaderBase::add(string Key, string value)
===============================================
    Alias of Add(Key,value) 
    
void HeaderBase::add(string Key, vector< Int4 > value)
=======================================================
    Alias of Add(Key,value) 
    
void HeaderBase::add(string Key, vector< Double > value)
=========================================================
    Alias of Add(Key,value) 
    
void HeaderBase::add(string Key, vector< string > value)
=========================================================
    Alias of Add(Key,value) 
";
%feature("docstring") HeaderBase::AddInt4List "void HeaderBase::AddInt4List(string Key, PyObject *List) 

";
%feature("docstring") HeaderBase::AddDoubleList "void HeaderBase::AddDoubleList(string Key, PyObject *List) 

";
%feature("docstring") HeaderBase::AddStringList "void HeaderBase::AddStringList(string Key, PyObject *List) 

";
%feature("docstring") HeaderBase::Empty "bool HeaderBase::Empty(void) 

";
%feature("docstring") HeaderBase::Erase "void HeaderBase::Erase(string Key)
===================================
    Remove a value and its name-tag from the storage.
    This method searches the six-Maps for \"Key\". If the \"Key\" cannot be found in the storage, warning messages will be output to the STD-out. 

";
%feature("docstring") HeaderBase::erase "void HeaderBase::erase(string Key)
===================================
    Alias of \"Erase(Key)\". 

";
%feature("docstring") HeaderBase::clear "void HeaderBase::clear()
=========================
    Clear completely entire information stored in this class. 

";
%feature("docstring") HeaderBase::Clear "void HeaderBase::Clear()
=========================
    Alias of \"clear()\". 

";
%feature("docstring") HeaderBase::OverWrite "void HeaderBase::OverWrite(string Key, Int4 value)
===================================================
    Changes the value assigned to \"Key\". 

    
void HeaderBase::OverWrite(string Key, Double value)
=====================================================
    Changes the value assigned to \"Key\". 
    
void HeaderBase::OverWrite(string Key, string value)
=====================================================
    Changes the value assigned to \"Key\". 
    
void HeaderBase::OverWrite(string Key, vector< Int4 > value)
=============================================================
    Changes the value assigned to \"Key\". 
    
void HeaderBase::OverWrite(string Key, vector< Double > value)
===============================================================
    Changes the value assigned to \"Key\". 
    
void HeaderBase::OverWrite(string Key, vector< string > value)
===============================================================
    Changes the value assigned to \"Key\". 
";
%feature("docstring") HeaderBase::Dump "void HeaderBase::Dump()
========================
    Dump all information in user-frendly format to the STD-out. 

";
%feature("docstring") HeaderBase::PyDump "PyObject * HeaderBase::PyDump()
================================
    This method returns a Python-list object whose content equal strings shown by \"void Dump()\". 

";
%feature("docstring") HeaderBase::dump "void HeaderBase::dump()
========================
    Alias of \"Dump()\". 

";
%feature("docstring") HeaderBase::DumpHeader "void HeaderBase::DumpHeader() 

";
%feature("docstring") HeaderBase::Search "void HeaderBase::Search(string Key)
====================================
    Searchs the six Maps for \"Key\".
    The name of map contained the \"Key\" returns to the STD-out. 

";
%feature("docstring") HeaderBase::CheckKey "UInt4 HeaderBase::CheckKey(string Key)
=======================================
    Returns the number of \"Key\".
    If \"Key\" has been entered, this method will return 1. Under normal conditions, this method returns 1 or 0. 

";
%feature("docstring") HeaderBase::PutInt4 "Int4 HeaderBase::PutInt4(string Key)
=====================================
    Returns an integer type value assigned to \"Key\". 

    
Int4 HeaderBase::PutInt4(UInt4 Index) 
";
%feature("docstring") HeaderBase::PutDouble "Double HeaderBase::PutDouble(string Key)
=========================================
    Returns an double type value assigned to \"Key\". 

    
Double HeaderBase::PutDouble(UInt4 Index) 
";
%feature("docstring") HeaderBase::PutString "string HeaderBase::PutString(string Key)
=========================================
    Returns an string type value assigned to \"Key\". 

    
string HeaderBase::PutString(UInt4 Index) 
";
%feature("docstring") HeaderBase::PutInt4Vector "vector< Int4 > HeaderBase::PutInt4Vector(string Key)
=====================================================
    Returns an pointer of vector<Int4> assigned to \"Key\". 

    
vector<Int4> HeaderBase::PutInt4Vector(UInt4 Index) 
";
%feature("docstring") HeaderBase::PutDoubleVector "vector< Double > HeaderBase::PutDoubleVector(string Key)
=========================================================
    Returns an pointer of vector<Double> assigned to \"Key\". 

    
vector<Double> HeaderBase::PutDoubleVector(UInt4 Index) 
";
%feature("docstring") HeaderBase::PutStringVector "vector< string > HeaderBase::PutStringVector(string Key)
=========================================================
    Returns an pointer of vector<string> assigned to \"Key\". 

    
vector<string> HeaderBase::PutStringVector(UInt4 Index) 
";
%feature("docstring") HeaderBase::DumpToString "string HeaderBase::DumpToString()
==================================
    Convert all information stored in this class to a string.
    All information can be rebuild from the string by inputting it into \"InputString(string)\". 

";
%feature("docstring") HeaderBase::InputString "void HeaderBase::InputString(string s)
=======================================
    Receives a string generated by \"DumpToString()\" and re-build the information. 

";
%feature("docstring") HeaderBase::InputFile "void HeaderBase::InputFile(string FileName) 

";
%feature("docstring") HeaderBase::i "Int4 HeaderBase::i(string Key)
===============================
    This method is leaved keeping compatibility with \"HeaderBase\". 

";
%feature("docstring") HeaderBase::d "Double HeaderBase::d(string Key)
=================================
    This method is leaved keeping compatibility with \"HeaderBase\". 

";
%feature("docstring") HeaderBase::f "Float HeaderBase::f(string Key)
================================
    This method is leaved keeping compatibility with \"HeaderBase\". 

";
%feature("docstring") HeaderBase::s "string HeaderBase::s(string Key)
=================================
    This method is leaved keeping compatibility with \"HeaderBase\". 

";
%feature("docstring") HeaderBase::iv "vector<Int4> HeaderBase::iv(string Key)
========================================
    Alias of PuInt4Vector(string). 

";
%feature("docstring") HeaderBase::dv "vector<Double> HeaderBase::dv(string Key)
==========================================
    Alias of PutDoubleVector(string). 

";
%feature("docstring") HeaderBase::sv "vector<string> HeaderBase::sv(string Key)
==========================================
    Alias of PutStringVector(string). 

";
%feature("docstring") HeaderBase::PutKeyLocation "UInt4 HeaderBase::PutKeyLocation(string Key) 

";

// File: classKahanSum.xml
%feature("docstring") KahanSum "

function class to calculate summation with Kahan's algorithmhttp://en.wikipedia.org/wiki/Kahan_summation_algorithm ";

%feature("docstring")  KahanSum::KahanSum "KahanSum::KahanSum() ";

// File: classManipulatorBase.xml

%feature("docstring") ManipulatorBase "

    Manipulator for the data-object.
    This class is one of the base-class for constructing analysis operators. The functionality of the operator produced with this class is that the input data-object is operated some procedures in the derived class of this base-class and the pointer of input object is passed as output-object to the next operator. The dynamical data-object assigned to a result-object is not produced in the derived class.
    If you want to construct analysis operators whose functions are, (1) the type of input-object is not identical to the output-object, (2) the number of input or output objects is more than two, (3) the output object should be deleted by the destructor of the operator.
    See the manual of \"OperatorBase\".
    C++ includes: ManipulatorBase.hh 

";
%feature("docstring") ManipulatorBase::ManipulatorBase "ManipulatorBase< T >::ManipulatorBase()
========================================
    Constructor 

";
%feature("docstring") ManipulatorBase::~ManipulatorBase "ManipulatorBase< T >::~ManipulatorBase()
=========================================
    Destructor. This method will delete the entry of the target object, but the target object will not delete. 

";
%feature("docstring") ManipulatorBase::SetTarget "void ManipulatorBase< T >::SetTarget(T *target)
================================================
    Set the pointer of the target data object. The pointer will be returned as output object by \"T *Put()\" after calculating. 

";
%feature("docstring") ManipulatorBase::Put "T* ManipulatorBase< T >::Put()
===============================
    Return the target object operated in the derived class. The value of the pointer is identical to the value input by \"void SetTarget( T* )\". See the comments of \"T *Duplicate()\". 

";
%feature("docstring") ManipulatorBase::Duplicate "T * ManipulatorBase< T >::Duplicate()
======================================
    Return the calculated data-object. The contents of the object is identical with the object returned by \"T* Put()\". The returned dynamical data-object is constructed and copied in this method. The returned object should be deleted in your application. 

";
%feature("docstring") ManipulatorBase::Clear "void ManipulatorBase< T >::Clear()
===================================
    This method will delete the entry of the target object, but the target object will not delete. You can reuse the operator after calling this method. 

";
// File: classManyoDataIO.xml

%feature("docstring") ManyoDataIO "C++ includes: ManyoDataIO.hh 

";
%feature("docstring") ManyoDataIO::ManyoDataIO "ManyoDataIO::ManyoDataIO() 

";
%feature("docstring") ManyoDataIO::~ManyoDataIO "ManyoDataIO::~ManyoDataIO() 

";
%feature("docstring") ManyoDataIO::Write "void ManyoDataIO::Write(ElementContainer *E, const string &FileName, const string &UserName) 

    
void ManyoDataIO::Write(ElementContainerArray *A, const string &FileName, const string &UserName) 
    
void ManyoDataIO::Write(ElementContainerMatrix *M, const string &FileName, const string &UserName) 
";
%feature("docstring") ManyoDataIO::ReadElementContainer "ElementContainer * ManyoDataIO::ReadElementContainer(const string &FileName) 

";
%feature("docstring") ManyoDataIO::ReadElementContainerArray "ElementContainerArray * ManyoDataIO::ReadElementContainerArray(const string &FileName) 

";
%feature("docstring") ManyoDataIO::ReadElementContainerMatrix "ElementContainerMatrix * ManyoDataIO::ReadElementContainerMatrix(const string &FileName) 

";
%feature("docstring") ManyoDataIO::Read "bool ManyoDataIO::Read(ElementContainer *E, const string &FileName) 

    
bool ManyoDataIO::Read(ElementContainerArray *A, const string &FileName) 
    
bool ManyoDataIO::Read(ElementContainerMatrix *M, const string &FileName) 
";
%feature("docstring") ManyoDataIO::PutDataType "string ManyoDataIO::PutDataType(const string &FileName)
========================================================
    Return a data type.

    Args:
        FileName (string) filename @returnValue (string) ElementContainer/ElementContainerArray/ElementContainerMatrix/Unknown 

";
// File: classMap.xml

%feature("docstring") Map "

    General container like STL Map.
    This class is a general container class like STL-map. Because the STL-map applied to template classes cannot be used with the swig, this class will be utilized instead of the STL-map.
    If this class is used from the Python environment, you should use concrete class names, MapInt4, MapDoubleVector, etc. These definitions are written in \"analysis/Template.i\" which is the interface file of SWIG.
    The type of T can be set as not only int, double.... but also various pointers, *vector<Double> and class objects. Any objects can be stored in this class object.
    This class is not include a copy constructor. If you want to copy the class object of this class, you should copy each element in your application.
    C++ includes: Map.hh 

";
%feature("docstring") Map::Map "Map< T >::Map()
================
    Constructor. 

    
Map< T >::Map(const Map< T > &ob)
==================================
    copy constructor 
";
%feature("docstring") Map::~Map "Map< T >::~Map()
=================
    Destructor. 

";
%feature("docstring") Map::Empty "bool Map< T >::Empty()
=======================
    Returns empty or no. 

";
%feature("docstring") Map::Size "UInt4 Map< T >::Size() const
=============================
    Returns the size of vector. 

";
%feature("docstring") Map::PutTableSize "UInt4 Map< T >::PutTableSize() const
=====================================
    Alias of Size(). 

";
%feature("docstring") Map::PutIndexNumber "UInt4 Map< T >::PutIndexNumber(string key)
===========================================
    Returns \"IndexNumber\" assigned to \"key\". 

";
%feature("docstring") Map::Add "void Map< T >::Add(string key, T value)
========================================
    Input a pair of information.
    The first argument is a key-word whose type is string. The second argument is a value whose type is T. This class checks the name of \"key\" not to register doubly. If the installing key name is already installed in the storage, you will receive an warning message and this addition procedure will be rejected. 

";
%feature("docstring") Map::Find "T Map< T >::Find(string key)
=============================
    Returns an data element whose name is \"key\". 

";
%feature("docstring") Map::Put "T Map< T >::Put(string key)
============================
    Returns an data element whose name is \"key\". This is an alias of \"Find(string)\". 

    
T Map< T >::Put(UInt4 index) 
";
%feature("docstring") Map::PutKey "string Map< T >::PutKey(UInt4 index) 

";
%feature("docstring") Map::Clear "void Map< T >::Clear()
=======================
    Delete all information stored in this class. 

";
%feature("docstring") Map::Remove "void Map< T >::Remove(UInt4 IndexNumber)
=========================================
    Remove a data element whose index number is \"IndexNumber\". 

    
void Map< T >::Remove(string key)
==================================
    Remove a data element whose name is \"key\". 
";
%feature("docstring") Map::Dump "void Map< T >::Dump()
======================
    Dump all information to standard-output with index numbers and keys.
    If the type of T is pointer, the address of the pointer will be displayed. 

";
%feature("docstring") Map::Check "UInt4 Map< T >::Check(string Key)
==================================
    Check the existence of the \"Key\" included in this storage.
    If the \"Key\" is in this storage, returns 1. If the \"Key\" is not found in it, returns 0. 

";
// File: classNeXusFileIO.xml

%feature("docstring") NeXusFileIO "

    NeXus file interface.
    Data containers defined in Manyo Library can be stored in NeXus format with this class. This class is a wrapper of ReadNeXusFile and WriteNeXusFile.
    C++ includes: NeXusFileIO.hh 

";
%feature("docstring") NeXusFileIO::Write "void NeXusFileIO::Write(ElementContainerMatrix M, string FileName, string UserName, UInt4 CompMode=1)
======================================================================================================
    An data object of ElementContainerMatrix is stored in NeXus format. The input data object will be copied in this method. If you want to avoid it, use WriteP( ElementContainerMatrix *M, string FileName, string UserName, UInt4 CompMode=1).

    Args:
        M input data container
        FileName output file name
        UserName Your name will be recorded in the output file.
        CompMode The default value is 1, but the speed of data writing is very slow with the default value. We recommend that CompMode=0 is set and compress it with tar or zip command after writing the file. 

    
void NeXusFileIO::Write(ElementContainerArray A, string FileName, string UserName, UInt4 CompMode=1)
=====================================================================================================
    An data object of ElementContainerArray is stored in NeXus format. The input data object will be copied in this method. If you want to avoid it, use WriteP( ElementContainerArray *A, string FileName, string UserName, UInt4 CompMode=1).

    Args:
        A input data container
        FileName output file name
        UserName Your name will be recorded in the output file.
        CompMode The default value is 1, but the speed of data writing is very slow with the default value. We recommend that CompMode=0 is set and compress it with tar or zip command after writing the file. 
    
void NeXusFileIO::Write(ElementContainer C, string FileName, string UserName, UInt4 CompMode=1)
================================================================================================
    An data object of ElementContainer is stored in NeXus format. The input data object will be copied in this method. If you want to avoid it, use WriteP( ElementContainer *C, string FileName, string UserName, UInt4 CompMode=1).

    Args:
        C input data container
        FileName output file name
        UserName Your name will be recorded in the output file.
        CompMode The default value is 1, but the speed of data writing is very slow with the default value. We recommend that CompMode=0 is set and compress it with tar or zip command after writing the file. 
";
%feature("docstring") NeXusFileIO::ReadElementContainerMatrix "ElementContainerMatrix NeXusFileIO::ReadElementContainerMatrix(string FileName)
================================================================================
    ElementContainerMatrix in NeXus file is obtained in this method. This method can be read NeXus files produced with both of CompMode=1 and 0.

    Args:
        FileName Data file name read in this method. 

";
%feature("docstring") NeXusFileIO::ReadElementContainerArray "ElementContainerArray NeXusFileIO::ReadElementContainerArray(string FileName)
==============================================================================
    ElementContainerArray in NeXus file is obtained in this method. This method can be read NeXus files produced with both of CompMode=1 and 0. 

";
%feature("docstring") NeXusFileIO::ReadElementContainer "ElementContainer NeXusFileIO::ReadElementContainer(string FileName)
====================================================================
    ElementContainer in NeXus file is obtained in this method. This method can be read NeXus files produced with both of CompMode=1 and 0. 

";
%feature("docstring") NeXusFileIO::ReadElementContainerP "ElementContainer * NeXusFileIO::ReadElementContainerP(string FileName)
=======================================================================
    ElementContainer in NeXus file is obtained in this method. This method can be read NeXus files produced with both of CompMode=1 and 0.

    Returns:
        a pointer of ElmentContainer read in this method. 

";
%feature("docstring") NeXusFileIO::ReadElementContainerArrayP "ElementContainerArray * NeXusFileIO::ReadElementContainerArrayP(string FileName)
=================================================================================
    ElementContainerArray in NeXus file is obtained in this method. This method can be read NeXus files produced with both of CompMode=1 and 0.

    Returns:
        a pointer of ElmentContainerArray read in this method. 

";
%feature("docstring") NeXusFileIO::ReadElementContainerMatrixP "ElementContainerMatrix * NeXusFileIO::ReadElementContainerMatrixP(string FileName)
===================================================================================
    ElementContainerMatrix in NeXus file is obtained in this method. This method can be read NeXus files produced with both of CompMode=1 and 0.

    Returns:
        a pointer of ElmentContainerMatrix read in this method. 

";
%feature("docstring") NeXusFileIO::WriteP "void NeXusFileIO::WriteP(ElementContainerMatrix *M, string FileName, string UserName, UInt4 CompMode=1)
========================================================================================================
    An data object of ElementContainerMatrix is stored in NeXus format.

    Args:
        M input data container
        FileName output file name
        UserName Your name will be recorded in the output file.
        CompMode The default value is 1, but the speed of data writing is very slow with the default value. We recommend that CompMode=0 is set and compress it with tar or zip command after writing the file. 

    
void NeXusFileIO::WriteP(ElementContainerArray *A, string FileName, string UserName, UInt4 CompMode=1)
=======================================================================================================
    An data object of ElementContainerArray is stored in NeXus format.

    Args:
        A input data container
        FileName output file name
        UserName Your name will be recorded in the output file.
        CompMode The default value is 1, but the speed of data writing is very slow with the default value. We recommend that CompMode=0 is set and compress it with tar or zip command after writing the file. 
    
void NeXusFileIO::WriteP(ElementContainer *E, string FileName, string UserName, UInt4 CompMode=1)
==================================================================================================
    An data object of ElementContainer is stored in NeXus format.

    Args:
        E input data container
        FileName output file name
        UserName Your name will be recorded in the output file.
        CompMode The default value is 1, but the speed of data writing is very slow with the default value. We recommend that CompMode=0 is set and compress it with tar or zip command after writing the file. 
";
// File: classNeutronReadBinaryData.xml

%feature("docstring") NeutronReadBinaryData "

    Read a binary data file.
    This template class reads a binary data file, and provide its data as a array and vector. The dimensions of the reading binary file is not required to read, it is obtained from the data type and the size of the target file.
    Because this template is designed to read the whole of file, if the size of target file is large, the reading procedure is rather slow. If you want to read the section of the target file, you can use \"NeutronReadBinaryDataSection\".
    C++ includes: NeutronReadBinaryData.hh 

";
%feature("docstring") NeutronReadBinaryData::NeutronReadBinaryData "NeutronReadBinaryData< T >::NeutronReadBinaryData(string _SwapFlag=\"None\")
=============================================================================
    The mean of the argument is swap-flag. The argument should be selected from \"NoSwap\", \"Swap\", \"big\" and \"little\", and its default value is \"None\".
    If you selected \"Swap\", the byte-order of the target binary file is changed in this class. When the argument is \"NoSwap\", the byte-order of it is not changed.
    If the byte-order of the target file is \"little-endian\", you must set the argument as \"little\". The architecture of the computer running \"Manyo-Lib\" is obtained in this constructor, and the argument is compared with the architecture. This method will decide whether the byte-order should be changed or not.
    When the byte-order of the target file is \"big-endian\", you must set the argument as \"big\". 

";
%feature("docstring") NeutronReadBinaryData::ReadData "vector< T > NeutronReadBinaryData< T >::ReadData(string Filename)
==================================================================
    The \"FileName\" is the name of the target binary file. The data length of \"FileName\" is checked and obtained automatically using the data type of \"T\" and the file size. 

    
UInt8 NeutronReadBinaryData< T >::ReadData(string FileName, T *&array)
=======================================================================
    The \"FileName\" is the name of the target binary file. The data length of \"FileName\" is checked automatically using the data type of \"T\" and its file size. The second argument is the pointer of the array whose value should be NULL. The pointer will be assigned to the pointer of the array obtained and produced by this method. The returned value of this method is the size of the array. 
";
%feature("docstring") NeutronReadBinaryData::PrintData "void NeutronReadBinaryData< T >::PrintData(string FileName)
============================================================
    The content of \"FileName\" is dumped to the standard-output. 

";
%feature("docstring") NeutronReadBinaryData::PutUInt4Vector "vector< UInt4 > NeutronReadBinaryData< T >::PutUInt4Vector(string Filename)
============================================================================
    Returns a vector<UInt4>. The content of the vector is the same as the vector returned by the method of \"vector<T> ReadData(Char*)\". 

";
%feature("docstring") NeutronReadBinaryData::PutDoubleVector "vector< Double > NeutronReadBinaryData< T >::PutDoubleVector(string Filename)
==============================================================================
    Returns a vector<Double>. The content of the vector is the same as the vector returned by the method of \"vector<T> ReadData(Char*)\". 

";
%feature("docstring") NeutronReadBinaryData::PutDoubleList "PyObject * NeutronReadBinaryData< T >::PutDoubleList(string FileName)
======================================================================
    Returns a python list object. The content of the return object is the same as the PutDoubleVector(string). 

";
%feature("docstring") NeutronReadBinaryData::PutUInt4List "PyObject * NeutronReadBinaryData< T >::PutUInt4List(string FileName)
=====================================================================
    Returns a python list object. The content of the return object is the same as the PutUInt4Vector(string). 

";
// File: classNeutronVector.xml

%feature("docstring") NeutronVector "

    Data container template.
    This class is a container class. If you want to put objects, for example NeutronVector, into this class, it must be set 1 (default value).
    The STL vector is used as a data object storage in this template, you can add data objects at any time by using \"add( T* )\". When you call the destructor of this class, Not only the pointer entry in the vector, but also the substance of the data objects and header object will be deleted completely.
    The example are given in following,
    C++ includes: NeutronVector.hh 

";
%feature("docstring") NeutronVector::NeutronVector "NeutronVector< T, H >::NeutronVector()
=======================================
    Constructor. 

    
NeutronVector< T, H >::NeutronVector(H pheader)
================================================
    Constructor. 
    
NeutronVector< T, H >::NeutronVector(const NeutronVector &ob) 
";
%feature("docstring") NeutronVector::~NeutronVector "NeutronVector< T, H >::~NeutronVector()
========================================
    Destructor. 

";
%feature("docstring") NeutronVector::Allocate "void NeutronVector< T, H >::Allocate(UInt4 size)
=================================================
    All of data stored in this container are deleted, and created a new vector whose sise is specified by the argument. 

";
%feature("docstring") NeutronVector::Set "void NeutronVector< T, H >::Set(UInt4 index, T *value) 

";
%feature("docstring") NeutronVector::AddPointer "UInt4 NeutronVector< T, H >::AddPointer(T *value)
==================================================
    \"T*\" is the each array element pointer.
    Each T is stored into the STL vector object, you can use this method at any time.
    CAUTION: stored pointer still be pointing external object 

";
%feature("docstring") NeutronVector::Add "UInt4 NeutronVector< T, H >::Add(T value)
==========================================
    \"T value\" is the data object, and each object is copied to a dynamical object.
    The dynamical object will be stored into the container. Each T is stored into the STL vector object, you can use this method at any time. 

    
UInt4 NeutronVector< T, H >::Add(NeutronVector< T, H > &value) 
";
%feature("docstring") NeutronVector::Put "T NeutronVector< T, H >::Put(UInt4 index=0) 

";
%feature("docstring") NeutronVector::PutPointer "T * NeutronVector< T, H >::PutPointer(UInt4 index=0) 

";
%feature("docstring") NeutronVector::ref "T& NeutronVector< T, H >::ref(UInt4 index)
===========================================
    ref() reference implementation of the operator[] 

    
const T& NeutronVector< T, H >::ref(UInt4 index) const
=======================================================
    ref() reference implementation of the operator[] 
";
%feature("docstring") NeutronVector::InputHeader "void NeutronVector< T, H >::InputHeader(H pheader)
===================================================
    input header object.
    If the object have existed already, the old one will be deleted. 

";
%feature("docstring") NeutronVector::PutHeader "H NeutronVector< T, H >::PutHeader() 

";
%feature("docstring") NeutronVector::PutHeaderPointer "H* NeutronVector< T, H >::PutHeaderPointer() const
===================================================
    Returns the pointer of the header object. 

";
%feature("docstring") NeutronVector::reset "void NeutronVector< T, H >::reset()
====================================
    Reset the data storage in this class.
    Data storage is erased competely. 

";
%feature("docstring") NeutronVector::PutTableSize "UInt4 NeutronVector< T, H >::PutTableSize() const
==================================================
    alias of getTableSize() 

";
%feature("docstring") NeutronVector::EraseElement "UInt4 NeutronVector< T, H >::EraseElement(UInt4 i)
===================================================
    Delete the i-th data in the vector, the vector size decreases by 1.
    Not only the pointer entry in the vector but also the substance of the i-th data object will be deleted by this method. 

";
%feature("docstring") NeutronVector::PutSize "UInt4 NeutronVector< T, H >::PutSize() const
=============================================
    alias of PutTableSize() 

";
%feature("docstring") NeutronVector::ClearElement "UInt4 NeutronVector< T, H >::ClearElement(UInt4 i)
===================================================
    Clear the i-th element in the vector.
    The size of vector is not changed. The i-th value in the vector is set as NULL. 

";
%feature("docstring") NeutronVector::copy "UInt4 NeutronVector< T, H >::copy(UInt4 i)
===========================================
    Copy and add a T-type object from the i-th object to the end of the vector-container.
    A return value of this method is the number of vector size added in this method. 

";
%feature("docstring") NeutronVector::AddToHeader "void NeutronVector< T, H >::AddToHeader(string Key, Int4 value)
================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 

    
void NeutronVector< T, H >::AddToHeader(string Key, Double value)
==================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
    
void NeutronVector< T, H >::AddToHeader(string Key, string value)
==================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
    
void NeutronVector< T, H >::AddToHeader(string Key, vector< Int4 > value)
==========================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
    
void NeutronVector< T, H >::AddToHeader(string Key, vector< Double > value)
============================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
    
void NeutronVector< T, H >::AddToHeader(string Key, vector< string > value)
============================================================================
    Data objects can be installed into the header-object with its name-tag.
    The method of the header-object is executed in this method. See the manual of HeaderBase. 
";
%feature("docstring") NeutronVector::Transform "void NeutronVector< T, H >::Transform(const std::string &Key, std::vector< Func > F, const std::string &newunit=\"None\")
==========================================================================================================================
    performs std::transform() to a vector with specified key and function object

    Args:
        Key a key which specifies the target vector
        F a std vector of function object (or a vector of vector of ... of function object)
        newunit new unit 

";
%feature("docstring") NeutronVector::Reverse "void NeutronVector< T, H >::Reverse(void)
==========================================
    reverse all std::vector 

";
%feature("docstring") NeutronVector::Resize "void NeutronVector< T, H >::Resize(UInt4 newsize)
==================================================
    resize its vector
    if newsize is smaller than current size (shrink), objects pointed from vector v are remove. new size is larger, new pointers in vector point created new objects

    Args:
        newsize size of vector v to become 

";
// File: classNeutronWriteBinaryData.xml

%feature("docstring") NeutronWriteBinaryData "C++ includes: NeutronWriteBinaryData.hh 

";
%feature("docstring") NeutronWriteBinaryData::NeutronWriteBinaryData "NeutronWriteBinaryData< T >::NeutronWriteBinaryData() 

";
%feature("docstring") NeutronWriteBinaryData::~NeutronWriteBinaryData "NeutronWriteBinaryData< T >::~NeutronWriteBinaryData() 

";
%feature("docstring") NeutronWriteBinaryData::Write "void NeutronWriteBinaryData< T >::Write(T *array, UInt4 size, string FileName) 

    
void NeutronWriteBinaryData< T >::Write(vector< T > v, string FileName) 
";
// File: classOperatorBase.xml

%feature("docstring") OperatorBase "

    The base class for constructing calculating operators.
    This class is the template base class for constructing calculating operators. The child class of this class should only have functionalities of some procedures for data-converter, analysis etc.
    Some source data-objects are inputed into \"InputVec\" with SetInput( T1 ). Input source data-objects will be deleted by the destructor of this class. The contents of input source data-objects are extracted and analyzed by the child class of this class. The output object should be constructed in the child class and the output objects are installed into \"OutputVec\" with \"SetOutput(T2*)\". The output objects will be deleted by the destructor, but you should see the following comments.
    The results of the operation can be obtained from \"T2 Put(UInt4)\". \"Put(UInt4)\" will return a data object, and the return objects can install data containers and the other operators. The original data objects held by OutputVec will be deleted by the destructor of this class, but \"T2 Put(UInt4)\" returns the copy of the results.
    C++ includes: OperatorBase.hh 

";
%feature("docstring") OperatorBase::OperatorBase "OperatorBase< T1, T2 >::OperatorBase()
=======================================
    Constructor. 

";
%feature("docstring") OperatorBase::~OperatorBase "OperatorBase< T1, T2 >::~OperatorBase()
========================================
    Destructor. Delete all data objects, output objects. See the comments of \"Put(Int4)\" and \"Duplicate(Int4)\". 

";
%feature("docstring") OperatorBase::SetInput "void OperatorBase< T1, T2 >::SetInput(T1 InputObj) 

";
%feature("docstring") OperatorBase::SetInputP "void OperatorBase< T1, T2 >::SetInputP(T1 *InputObj)
=====================================================
    Set input object. The index number is given automatically. The input data objects will be copied to dynamical data objects and the copy will be installed to the data storage. The objects will be deleted by the destructor. 

";
%feature("docstring") OperatorBase::Put "T2 OperatorBase< T1, T2 >::Put(UInt4 index=0)
==============================================
    Return the result data-object assigned to \"index\". If T2-type data container is not installed with \"SetOutput(T2*)\", a T2-type data container will be constructed in this method and returned. If the value of the argument is too large, this method will be return a T2-type data container whose content is empty. 

";
%feature("docstring") OperatorBase::InputObjNumber "UInt4 OperatorBase< T1, T2 >::InputObjNumber()
===============================================
    Returns the size of InputVec. The return integer express the number of input objects. 

";
%feature("docstring") OperatorBase::OutputObjNumber "UInt4 OperatorBase< T1, T2 >::OutputObjNumber()
================================================
    Returns the size of OutputVec. The return integer express the number of output objects. 

";
%feature("docstring") OperatorBase::Clear "void OperatorBase< T1, T2 >::Clear()
=====================================
    Clear the two data storage completely. All output-objects and the copies of input-objects are deleted. 

";
%feature("docstring") OperatorBase::ClearOutput "void OperatorBase< T1, T2 >::ClearOutput()
===========================================
    Clear the output data storage completely. All output-objects re deleted. 

";
// File: classPyRunOnCPP.xml

%feature("docstring") PyRunOnCPP "

    Execute Python script. This class must not be called from Python.
    This class must not be called from Python !!
    This class executes python scripts with C-library provided by Python development tools. Because this class uses the library of python development environment, python scripts are executed in the same process of this class.
    C++ includes: PyRunOnCPP.hh 

";
%feature("docstring") PyRunOnCPP::PyRunOnCPP "PyRunOnCPP::PyRunOnCPP()
=========================
    Constructor 

";
%feature("docstring") PyRunOnCPP::~PyRunOnCPP "PyRunOnCPP::~PyRunOnCPP()
==========================
    Destructor. This method terminates the python process connected in this class. 

";
%feature("docstring") PyRunOnCPP::PyRun "Int4 PyRunOnCPP::PyRun(vector< string > script)
================================================
    Python script, the argument, is passed to the python called by the constructor. 

    
Int4 PyRunOnCPP::PyRun(string script)
======================================
    Python script, the argument, is passed to the python called by the constructor. The argument should not contain indents. If you want to input \"for-loop\" or \"if\", you should use \"PyRun(vector<string>)\". 
";
// File: classReadNeXusFile.xml

%feature("docstring") ReadNeXusFile "

    Read NeXus binary file.
    NeXus binary files can be read with this class. and NeXus C-API is utilized in this class. \"ElementContainer\" and the other data-container in Manyo-Lib will be constructed from NeXus file with this class. The sample codes for the Python environment is attached at the end of this file, \"ReadNeXusFile.hh\".
    C++ includes: ReadNeXusFile.hh 

";
%feature("docstring") ReadNeXusFile::ReadNeXusFile "ReadNeXusFile::ReadNeXusFile(const string &FileName) 

    
ReadNeXusFile::ReadNeXusFile(NXhandle w_handle) 
";
%feature("docstring") ReadNeXusFile::~ReadNeXusFile "ReadNeXusFile::~ReadNeXusFile() 

";
%feature("docstring") ReadNeXusFile::PutHandle "NXhandle ReadNeXusFile::PutHandle() 

";
%feature("docstring") ReadNeXusFile::GetGroupInfo "vector< string > ReadNeXusFile::GetGroupInfo()
===============================================
    Returns vector<string>, and set CurrentNumber. The size of the vector is two. \"NXgetgroupinfo(....)\" is executed in this method. The first element of the vector is GroupName, and that of second element is GroupClass. The second argument of \"NXgetgroupinfo(....)\" can extract with \"PutCurrentNumber()\". 

";
%feature("docstring") ReadNeXusFile::GetNextEntry "vector< string > ReadNeXusFile::GetNextEntry()
===============================================
    Returns vector<string>, and set CurrentNumber. The size of the vector is two. \"NXgetnextentry(......)\" is executed in this method. The first and second elements of the vector are \"GroupName\" and \"GroupClass\". The second argument of \"NXgetnextentry(.....)\" is set into CurrentNumber, and its value is obtained with \"PutCurrentNumber()\". 

";
%feature("docstring") ReadNeXusFile::GetInfo "vector< Int4 > ReadNeXusFile::GetInfo() 

";
%feature("docstring") ReadNeXusFile::PutCurrentNumber "Int4 ReadNeXusFile::PutCurrentNumber() 

";
%feature("docstring") ReadNeXusFile::OpenGroup "void ReadNeXusFile::OpenGroup(const string &GroupName, const string &GroupClass)
=================================================================================
    Returns vector<Int4> and set CurrentNumber. The size of the vector is two. \"NXgetinfo(.....)\" is executed in this method. The first and second elements of the vector are Dimension and DataType. The Current number is \"Rank\", which is the third argument value of \"NXgetinfo(.....)\". \"CurrentNumber\" is obtained with \"PutCurrentNumber()\". Open groups. The first and second argument of this method will be obtained with \"GetNextEntry()\". The first and second element of the vector obtained with \"GetNextEntry()\" are set into the first and second argument of this method. 

";
%feature("docstring") ReadNeXusFile::CloseGroup "void ReadNeXusFile::CloseGroup()
=================================
    Close group. 

";
%feature("docstring") ReadNeXusFile::OpenData "void ReadNeXusFile::OpenData(const string &DataSetName)
========================================================
    Open data directories. The argument, \"DataSetName\" is obtained with \"GetNextEntry()\" is the name of each value. 

";
%feature("docstring") ReadNeXusFile::CloseData "void ReadNeXusFile::CloseData()
================================
    Close data directory which is opened by \"OpenData(string)\". 

";
%feature("docstring") ReadNeXusFile::ReadData "void ReadNeXusFile::ReadData(const string &Name, UInt4 &i) 

    
void ReadNeXusFile::ReadData(const string &Name, Int4 &i) 
    
void ReadNeXusFile::ReadData(const string &Name, Double &d) 
    
void ReadNeXusFile::ReadData(const string &Name, string &s) 
    
void ReadNeXusFile::ReadData(const string &Name, vector< UInt4 > &vi) 
    
void ReadNeXusFile::ReadData(const string &Name, vector< Int4 > &vi) 
    
void ReadNeXusFile::ReadData(const string &Name, vector< Double > &vd) 
    
void ReadNeXusFile::ReadData(const string &Name, vector< string > &vs) 
    
void ReadNeXusFile::ReadData(const string &Name, vector< vector< Double > > &vvd) 
    
void ReadNeXusFile::ReadData(const string &Name, bool &f) 
    
void ReadNeXusFile::ReadData(const string &Name, T &t)
=======================================================
    proxy class to read NeXus file by using ReadData2() or ReadData1() for \"version\" = 2 or unversioned

    Args:
        Name name of data written in NeXus file. If this Name is \"\" the element name will be set automatically as \"ManyoLibData\".
        t reference to the object whose class has NXread(), be to resized and overwritten 
    
void ReadNeXusFile::ReadData(const string &Name, std::map< string, T > &t)
===========================================================================
    template method to read a stl map of any classes
    It is used to read data in Manyo's StlMapDouble (map< string, vector<Double> > M) and HeaderBase (std::map<string, int> _keymap)

    Args:
        t reference to the stl map (overwritten) 
    
void ReadNeXusFile::ReadData(const string &Name, std::vector< T * > &t)
========================================================================
    template method to read a stl vector of pointers directly.
    It is used to read data in NeutronVector (vector< T* > v).

    Args:
        t reference to the stl vector, all data pointed by t[] should be written 
";
%feature("docstring") ReadNeXusFile::GetInfo2d "vector< Int4 > ReadNeXusFile::GetInfo2d() 

";
%feature("docstring") ReadNeXusFile::ReadDataUInt4 "UInt4 ReadNeXusFile::ReadDataUInt4(const string &Name)
=======================================================
    Read data. The data-directory is opened and closed in this method. 

";
%feature("docstring") ReadNeXusFile::ReadDataInt4 "Int4 ReadNeXusFile::ReadDataInt4(const string &Name)
=====================================================
    Read data. The data-directory is opened and closed in this method. 

";
%feature("docstring") ReadNeXusFile::ReadDataDouble "Double ReadNeXusFile::ReadDataDouble(const string &Name)
=========================================================
    Read data. The data-directory is opened and closed in this method. 

";
%feature("docstring") ReadNeXusFile::ReadDataString "string ReadNeXusFile::ReadDataString(const string &Name)
=========================================================
    Read data. The data-directory is opened and closed in this method. 

";
%feature("docstring") ReadNeXusFile::ReadDoubleVector "vector<Double> ReadNeXusFile::ReadDoubleVector(const string &Name)
===================================================================
    Read data. The data-directory is opened and closed in this method. 

";
%feature("docstring") ReadNeXusFile::ReadInt4Vector "vector<Int4> ReadNeXusFile::ReadInt4Vector(const string &Name)
===============================================================
    Read data. The data-directory is opened and closed in this method. 

";
%feature("docstring") ReadNeXusFile::ReadUInt4Vector "vector<UInt4> ReadNeXusFile::ReadUInt4Vector(const string &Name)
=================================================================
    Read data. The data-directory is opened and closed in this method. 

";
%feature("docstring") ReadNeXusFile::ReadStringVector "vector<string> ReadNeXusFile::ReadStringVector(const string &Name)
===================================================================
    Read data. The data-directory is opened and closed in this method. 

";
%feature("docstring") ReadNeXusFile::ReadHeaderBase "HeaderBase ReadNeXusFile::ReadHeaderBase(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadElementContainer "ElementContainer ReadNeXusFile::ReadElementContainer(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadElementContainerP "ElementContainer* ReadNeXusFile::ReadElementContainerP(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadElementContainerArray "ElementContainerArray ReadNeXusFile::ReadElementContainerArray(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadElementContainerArrayP "ElementContainerArray* ReadNeXusFile::ReadElementContainerArrayP(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadElementContainerMatrix "ElementContainerMatrix ReadNeXusFile::ReadElementContainerMatrix(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadElementContainerMatrixP "ElementContainerMatrix* ReadNeXusFile::ReadElementContainerMatrixP(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadUInt4Container "UInt4Container ReadNeXusFile::ReadUInt4Container(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadUInt4ContainerArray "UInt4ContainerArray ReadNeXusFile::ReadUInt4ContainerArray(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadUInt4ContainerMatrix "UInt4ContainerMatrix ReadNeXusFile::ReadUInt4ContainerMatrix(const string &Name) 

";
%feature("docstring") ReadNeXusFile::ReadTwoDimElementContainer "TwoDimElementContainer ReadNeXusFile::ReadTwoDimElementContainer(const string &Name) 

";
%feature("docstring") ReadNeXusFile::GetNextEntry2 "NXstatus ReadNeXusFile::GetNextEntry2(char *Name, char *nxclass, int *type)
============================================================================
    call NXgetnextentry directly

    Args:
        Name NXname(char[128]) for entry name
        nxclass NXname(char[128]) for class name, maybe
        type maybe a data type

    Returns:
        NX_OK(1), NX_ERROR(0), NX_EOD(-1) 

";
// File: classReadSerializationFile.xml

%feature("docstring") ReadSerializationFile "

    proxy class to read Manyo-lib data container by its serialization methods.
    This class is proxy/utility class to use Boost serialization features from python scripts. It is also enabled to use it from C++ codes.
    Following types are supported UInt4, Int4, std::string, Double, vector<UInt4>, vector<Int4>, vector<std::string>, vector<Double> HeaderBase, ElementContainer, ElementContainerArray, ElementContainerMatrix UInt4Container, UInt4ContainerArray, UInt4ContainerMatrix.
    Split serialization modes are implemented by distinct methods.
    C++ includes: ReadSerializationFile.hh 

";
%feature("docstring") ReadSerializationFile::ReadSerializationFile "ReadSerializationFile< Archive >::ReadSerializationFile(const char *filename) 

";
%feature("docstring") ReadSerializationFile::Load "void ReadSerializationFile< Archive >::Load(UInt4 &data) 

    
void ReadSerializationFile< Archive >::Load(Int4 &data) 
    
void ReadSerializationFile< Archive >::Load(std::string &data) 
    
void ReadSerializationFile< Archive >::Load(Double &data) 
    
void ReadSerializationFile< Archive >::Load(vector< UInt4 > &data) 
    
void ReadSerializationFile< Archive >::Load(vector< Int4 > &data) 
    
void ReadSerializationFile< Archive >::Load(vector< std::string > &data) 
    
void ReadSerializationFile< Archive >::Load(vector< Double > &data) 
    
void ReadSerializationFile< Archive >::Load(HeaderBase &data) 
    
void ReadSerializationFile< Archive >::Load(ElementContainer &data) 
    
void ReadSerializationFile< Archive >::Load(ElementContainerArray &data) 
    
void ReadSerializationFile< Archive >::Load(ElementContainerMatrix &data) 
    
void ReadSerializationFile< Archive >::Load(UInt4Container &data) 
    
void ReadSerializationFile< Archive >::Load(UInt4ContainerArray &data) 
    
void ReadSerializationFile< Archive >::Load(UInt4ContainerMatrix &data) 
";
%feature("docstring") ReadSerializationFile::LoadUInt4 "UInt4 ReadSerializationFile< Archive >::LoadUInt4(void) 

";
%feature("docstring") ReadSerializationFile::LoadUInt4Vector "vector<UInt4> ReadSerializationFile< Archive >::LoadUInt4Vector(void) 

";
%feature("docstring") ReadSerializationFile::LoadInt4 "Int4 ReadSerializationFile< Archive >::LoadInt4(void) 

";
%feature("docstring") ReadSerializationFile::LoadInt4Vector "vector<Int4> ReadSerializationFile< Archive >::LoadInt4Vector(void) 

";
%feature("docstring") ReadSerializationFile::LoadStr "std::string ReadSerializationFile< Archive >::LoadStr(void) 

";
%feature("docstring") ReadSerializationFile::LoadStringVector "vector<std::string> ReadSerializationFile< Archive >::LoadStringVector(void) 

";
%feature("docstring") ReadSerializationFile::LoadDouble "Double ReadSerializationFile< Archive >::LoadDouble(void) 

";
%feature("docstring") ReadSerializationFile::LoadDoubleVector "vector<Double> ReadSerializationFile< Archive >::LoadDoubleVector(void) 

";
%feature("docstring") ReadSerializationFile::LoadHeaderBase "HeaderBase ReadSerializationFile< Archive >::LoadHeaderBase(void) 

";
%feature("docstring") ReadSerializationFile::LoadElementContainer "ElementContainer ReadSerializationFile< Archive >::LoadElementContainer(void) 

";
%feature("docstring") ReadSerializationFile::LoadElementContainerArray "ElementContainerArray ReadSerializationFile< Archive >::LoadElementContainerArray(void) 

";
%feature("docstring") ReadSerializationFile::LoadElementContainerMatrix "ElementContainerMatrix ReadSerializationFile< Archive >::LoadElementContainerMatrix(void) 

";
%feature("docstring") ReadSerializationFile::LoadUInt4Container "UInt4Container ReadSerializationFile< Archive >::LoadUInt4Container(void) 

";
%feature("docstring") ReadSerializationFile::LoadUInt4ContainerArray "UInt4ContainerArray ReadSerializationFile< Archive >::LoadUInt4ContainerArray(void) 

";
%feature("docstring") ReadSerializationFile::LoadUInt4ContainerMatrix "UInt4ContainerMatrix ReadSerializationFile< Archive >::LoadUInt4ContainerMatrix(void) 

";
%feature("docstring") ReadSerializationFile::SplitLoad "void ReadSerializationFile< Archive >::SplitLoad(ElementContainerArray &data) 

    
void ReadSerializationFile< Archive >::SplitLoad(ElementContainerMatrix &data) 
    
void ReadSerializationFile< Archive >::SplitLoad(UInt4ContainerArray &data) 
    
void ReadSerializationFile< Archive >::SplitLoad(UInt4ContainerMatrix &data) 
";
%feature("docstring") ReadSerializationFile::SplitLoadElementContainerArray "ElementContainerArray ReadSerializationFile< Archive >::SplitLoadElementContainerArray(void) 

";
%feature("docstring") ReadSerializationFile::SplitLoadElementContainerMatrix "ElementContainerMatrix ReadSerializationFile< Archive >::SplitLoadElementContainerMatrix(void) 

";
%feature("docstring") ReadSerializationFile::SplitLoadUInt4ContainerArray "UInt4ContainerArray ReadSerializationFile< Archive >::SplitLoadUInt4ContainerArray(void) 

";
%feature("docstring") ReadSerializationFile::SplitLoadUInt4ContainerMatrix "UInt4ContainerMatrix ReadSerializationFile< Archive >::SplitLoadUInt4ContainerMatrix(void) 

";
// File: classReadTextFile.xml

%feature("docstring") ReadTextFile "C++ includes: ReadTextFile.hh 

";
%feature("docstring") ReadTextFile::ReadTextFile "ReadTextFile::ReadTextFile()
=============================
    Constructor. 

";
%feature("docstring") ReadTextFile::~ReadTextFile "ReadTextFile::~ReadTextFile()
==============================
    Destructor. 

";
%feature("docstring") ReadTextFile::SetFileName "void ReadTextFile::SetFileName(string TargetFileName)
======================================================
    Set the target file name in the string type. The file size of the target file is estimated in this method. The line number of the file can be obtained with \"PutSize()\". 

";
%feature("docstring") ReadTextFile::Dump "void ReadTextFile::Dump()
==========================
    Dump the contents of target file to STD-out. 

";
%feature("docstring") ReadTextFile::PutSize "UInt4 ReadTextFile::PutSize()
==============================
    Returns the number of lines contained in the target file. 

";
%feature("docstring") ReadTextFile::Put "string ReadTextFile::Put(UInt4 IndexNumber)
============================================
    Returns IndexNumber-th value in string type format. 

    
vector< string > ReadTextFile::Put(UInt4 IndexNumber, string Delimiter)
========================================================================
    Returns a vector whose size is defined by the second argument. The IndexNumber-th line is devided by using the second argument as a delimiter. 
";
// File: classReadWriteTextFile.xml

%feature("docstring") ReadWriteTextFile "

    This class cannot work on MacOS system. Because the function of \"fopen()\" is different from that on Linux and FreeBSD system.
    C++ includes: ReadWriteTextFile.hh 

";
%feature("docstring") ReadWriteTextFile::ReadWriteTextFile "ReadWriteTextFile::ReadWriteTextFile(string _FileName, UInt4 _LockFlag=0)
==========================================================================
    Constructor. In ordinary case, you can omit the second argument. The target file will be open in append mode. 

";
%feature("docstring") ReadWriteTextFile::~ReadWriteTextFile "ReadWriteTextFile::~ReadWriteTextFile()
========================================
    Destructor. When this method is called, the file descriptor defined in the constructor will be closed. 

";
%feature("docstring") ReadWriteTextFile::ReSetTarget "void ReadWriteTextFile::ReSetTarget(string _FileName, UInt4 _LockFlag=0) 

";
%feature("docstring") ReadWriteTextFile::Read "void ReadWriteTextFile::Read()
===============================
    The file descriptor opened by the constructor is re-opened in read-mode, and read the target file. The contents of the target file can be obtained with vector<string> Put(). 

";
%feature("docstring") ReadWriteTextFile::Put "vector<string> ReadWriteTextFile::Put() 

";
%feature("docstring") ReadWriteTextFile::Write "void ReadWriteTextFile::Write(vector< string > StrVec)
=======================================================
    The argument of vector<string> is written to the target file. Each element in \"StrVec\" corresponds to each line in the file. The target file will be closed in the destructor of this class. 

";

// File: classS1.xml
%feature("docstring") S1 "

binary function object used in ElementContainer::Ave() and ElementContainer::Integrate()

S1 is used to calculate (E[i] * (X[i+1] - X[i]))^2 instead of normal inner_product which calculates E[i]*(X[i+1]-X[i]) ";


// File: classS2.xml
%feature("docstring") S2 "

binary function object used in ElementContainer::Ave() and ElementContainer::Integrate()

S2 is used to calculate 1 / (Error[i] * Error[i]) ";


// File: classS3.xml
%feature("docstring") S3 "

binary function object used in ElementContainer::Ave() and ElementContainer::Integrate()

S3 is used to calculate T[i] / (Error[i] * Error[i]) ";

// File: classSearchInHeader.xml

%feature("docstring") SearchInHeader "

    Find function in Header.
    This function allows users to find ElementContainer(s) or ElementContainerArray(s) which include given \"Key\" and values in the Header information
    Example:
    | SIH = Manyo.SearchInHeader()
    | SIH.SetTarget( dat )         # set ElementContainerMatrix or ElementContainerArray
    | SIH.Search( \"PIXELID\", 3 )   # serch PIXELID=3
    | res_vect = SIH.PutResults()  # return vector< vector<UInt4> >, vector<UInt4> include [ index of ECM, index of ECA ]
    |                              # ec = dat( ret_vect[0][0], ret_vect[0][1] ) to get first result container.
    or simply one
    | res_eca = SIH.PutResultAsArray()  # return ElementContainerArray including required ElementContainers
    C++ includes: SearchInHeader.hh 

";
%feature("docstring") SearchInHeader::SearchInHeader "SearchInHeader::SearchInHeader(bool flag=false)
================================================
    Constructor.

    Args:
        flag (bool):Debug flag. true for showing debug messages, false (default) for not 

    
SearchInHeader::SearchInHeader(ElementContainerMatrix *target)
===============================================================
    Constructor.

    Args:
        target ( ElementContainerMatrix): Target data 
    
SearchInHeader::SearchInHeader(ElementContainerArray *target)
==============================================================
    Constructor.

    Args:
        target ( ElementContainerArray): Target data 
";
%feature("docstring") SearchInHeader::~SearchInHeader "SearchInHeader::~SearchInHeader()
==================================
    Destructor. 

";
%feature("docstring") SearchInHeader::SetTarget "void SearchInHeader::SetTarget(ElementContainerMatrix *target)
===============================================================
    Set target ElementContainerMatrix.
    Search command search in the target container. The target can be set ElementContainerMatrix SetTarget( ElementContainerMatrix *target );

    Args:
        target (ElementContainerMatrix* ): Target data 

    
void SearchInHeader::SetTarget(ElementContainerArray *target)
==============================================================
    Set target ElementContainerArray.
    Search command search in the target container. The target can be set ElementContainerArray SetTarget( ElementContainerArray *target );

    Args:
        target (ElementContainerArray* ): Target data 
";
%feature("docstring") SearchInHeader::Search "bool SearchInHeader::Search(string key, Int4 val)
==================================================
    Search ElementContainer by given Int4 value with key.
    Search( string key, Int4 val );

    Args:
        key (string): Key in Header for searching
        val (Int4): value for searching

    Returns:
        true no trouble
        false trouble happens 

    
bool SearchInHeader::Search(string key, Int4 val_lower, Int4 val_upper)
========================================================================
    Search ElementContainer by given Int4 value range with key.
    Search( string key, Int4 val_lower, Int4 val_upper );

    Args:
        key (string): Key in Header for searching
        val_lower (Int4): lower limit value for searching
        val_upper (Int4): upper limit value for searching

    Returns:
        true no trouble
        false trouble happens 
    
bool SearchInHeader::Search(string key, double val_lower, double val_upper)
============================================================================
    Search ElementContainer by given Double value range with key.
    Search( string key, double val_lower, double val_upper );

    Args:
        key (string): Key in Header for searching
        val_lower (Double): lower limit value for searching
        val_upper (Double): upper limit value for searching

    Returns:
        true no trouble
        false trouble happens 
    
bool SearchInHeader::Search(string key, string val, bool isStrict=false)
=========================================================================
    Search ElementContainer by given string with key.
    Search( string key, string val, bool isStrict );

    Args:
        key (string): Key in Header for searching
        val (string): value for searching
        isStrict (bool): false means value in Header include given value, true means value in Header is equal strictly.

    Returns:
        true no trouble
        false trouble happens 
";
%feature("docstring") SearchInHeader::SearchArray "bool SearchInHeader::SearchArray(string key, Int4 val)
=======================================================
    Search ElementContainerArray by given Int4 value with key.
    SearchArray( string key, Int4 val );

    Args:
        key (string): Key in Header for searching
        val (Int4): value for searching

    Returns:
        true no trouble
        false trouble happens 

    
bool SearchInHeader::SearchArray(string key, Int4 val_lower, Int4 val_upper)
=============================================================================
    Search ElementContainerArray by given Int4 value range with key.
    SearchArray( string key, Int4 val_lower, Int4 val_upper );

    Args:
        key (string): Key in Header for searching
        val_lower (Int4): lower limit value for searching
        val_upper (Int4): upper limit value for searching

    Returns:
        true no trouble
        false trouble happens 
    
bool SearchInHeader::SearchArray(string key, Double val_lower, Double val_upper)
=================================================================================
    Search ElementContainerArray by given Double value range with key.
    SearchArray( string key, double val_lower, double val_upper );

    Args:
        key (string) Key in Header for searching
        val_lower (Double): lower limit value for searching
        val_upper (Double): upper limit value for searching

    Returns:
        true no trouble
        false trouble happens 
    
bool SearchInHeader::SearchArray(string key, string str_val, bool isStrict=false)
==================================================================================
    Search ElementContainerArray by given.
    SearchArray( string key, string str_val, bool isStrict );

    Args:
        key (string): Key in Header for searching
        val (string): value for searching
        isStrict (bool): false means value in Header include given value, true means value in Header is equal strictly.

    Returns:
        true no trouble
        false trouble happens 
";
%feature("docstring") SearchInHeader::PutResultAsArray "ElementContainerArray SearchInHeader::PutResultAsArray()
=========================================================
    Return current results of Search method.
    Return current results of Search method as ElementContainerArray

    Returns:
        ElementContainerArray 

";
%feature("docstring") SearchInHeader::PutResultSearchArray "ElementContainerMatrix SearchInHeader::PutResultSearchArray()
==============================================================
    Return current results of SearchArray method.
    Return current results of Search method as ElementContainermatrix

    Returns:
        ElementContainerMatrix 

";
%feature("docstring") SearchInHeader::PutResults "vector< vector<UInt4> > SearchInHeader::PutResults()
=====================================================
    Return current results.
    Return current results as index

    Returns:
        _ResultIndex 

";
%feature("docstring") SearchInHeader::PutResultIndex "vector< UInt4 > SearchInHeader::PutResultIndex(UInt4 index=0)
==============================================================
    Return current results.
    Return current results of ElementContainerArray index in given ElementContainerMatrix or ElementContainer index in ElementContainerArray

    Args:
        index (UInt4): if index=0, return ElementContainerArray index. index=1 ElementContainer index

    Returns:
        (vector<UInt4>) index of ElementContainerArray or ElementContainer 

";
%feature("docstring") SearchInHeader::ShowResults "void SearchInHeader::ShowResults()
===================================
    Show set of psd and pixel index for current results. 

";
%feature("docstring") SearchInHeader::ChangeDebugFlag "void SearchInHeader::ChangeDebugFlag(bool flag)
================================================
    Change Debug flag.

    Args:
        flag (bool): Debug flug. true for showing debug messages. false(default) for not. 

";
%feature("docstring") SearchInHeader::FindLimitElementDoubleVector "vector< Double > SearchInHeader::FindLimitElementDoubleVector(string key, UInt4 index)
=======================================================================================
    Find limit of values in double vector element with given key and index.

    Args:
        key (string): Index Key in Header for searching
        index (UInt4): index number of target element in given vector 

";
// File: classSerialNeutronExchanger.xml

%feature("docstring") SerialNeutronExchanger "

    basic class for the network exchange of Manyo-lib data containers with Boost serialization
    SerialNeutronExchanger needs ASIO_local or ASIO_remote for the boost asio iostream.
    C++ includes: SerialNeutronExchanger.hh 

";
%feature("docstring") SerialNeutronExchanger::SerialNeutronExchanger "SerialNeutronExchanger::SerialNeutronExchanger(ASIO_local &Al) 

    
SerialNeutronExchanger::SerialNeutronExchanger(ASIO_remote &Ar) 
    
SerialNeutronExchanger::SerialNeutronExchanger(boost::asio::ip::tcp::iostream *_h) 
";
%feature("docstring") SerialNeutronExchanger::Transmit "void SerialNeutronExchanger::Transmit(const T &val)
====================================================
    Transmit any type of object with boost::serialization (binary) and boost::asio

    Args:
        val reference to the object to transmit (mainly UInt4, Int4, std::string, Double and there std::vector, and Manyo's object HeaderBase, {Element, UInt4}Container{, Array, Matrix} 

";
%feature("docstring") SerialNeutronExchanger::Receive "bool SerialNeutronExchanger::Receive(T &val)
=============================================
    Receive any type of object with boost::serialization (binary) and boost::asio

    Args:
        val reference to the object to receive and write to (mainly UInt4, Int4, std::string, Double and there std::vector, and Manyo's object HeaderBase, {Element, UInt4}Container{, Array, Matrix} 

";
%feature("docstring") SerialNeutronExchanger::ReceiveUInt4 "UInt4 SerialNeutronExchanger::ReceiveUInt4(void) 

";
%feature("docstring") SerialNeutronExchanger::ReceiveInt4 "Int4 SerialNeutronExchanger::ReceiveInt4(void) 

";
%feature("docstring") SerialNeutronExchanger::ReceiveString "std::string SerialNeutronExchanger::ReceiveString(void) 

";
%feature("docstring") SerialNeutronExchanger::ReceiveDouble "Double SerialNeutronExchanger::ReceiveDouble(void) 

";
// File: classSerialPythonServerClient.xml

%feature("docstring") SerialPythonServerClient "C++ includes: SerialPythonServerClient.hh 

";
%feature("docstring") SerialPythonServerClient::SerialPythonServerClient "SerialPythonServerClient::SerialPythonServerClient(const std::string remotehost, const std::string remoteport) 

";
%feature("docstring") SerialPythonServerClient::~SerialPythonServerClient "SerialPythonServerClient::~SerialPythonServerClient() 

";
%feature("docstring") SerialPythonServerClient::Start "bool SerialPythonServerClient::Start(const std::vector< std::string > &s, const UInt4 umax=0)
==============================================================================================

    Args:
        s python script to execute at remote host
        umax max time for the connection timeout (m sec), 0 means never timed out

    Returns:
        false when connection failed 

";
%feature("docstring") SerialPythonServerClient::refSNE "SerialNeutronExchanger & SerialPythonServerClient::refSNE(void) const 

";
// File: classSimpleIOVectorToTextFile.xml

%feature("docstring") SimpleIOVectorToTextFile "

    Convert Header and 3 double vectors into a text file.
    This writes a text file from header information and 3 double vectors. This is normaly used as one of methods on ElementContainer.
    C++ includes: SimpleIOVectorToTextFile.hh 

";
%feature("docstring") SimpleIOVectorToTextFile::SimpleIOVectorToTextFile "SimpleIOVectorToTextFile::SimpleIOVectorToTextFile()
=====================================================
    Constructor. 

";
%feature("docstring") SimpleIOVectorToTextFile::~SimpleIOVectorToTextFile "SimpleIOVectorToTextFile::~SimpleIOVectorToTextFile()
======================================================
    Destructor. 

";
%feature("docstring") SimpleIOVectorToTextFile::SetTarget "void SimpleIOVectorToTextFile::SetTarget(HeaderBase hh, vector< Double > xvec, vector< Double > yvec, vector< Double > evec, bool isHist=false)
================================================================================================================================================
    Set information to be written to a text file.

    Args:
        hh ( HeaderBase)
        xvec (vector<Double>)
        yvec (vector<Double>)
        evec (vector<Double>)
        isHist (bool)

    Returns:
        None 

    
void SimpleIOVectorToTextFile::SetTarget(vector< Double > xvec, vector< Double > yvec, vector< Double > evec, bool isHist=false)
=================================================================================================================================
    Set information to be written to a text file.

    Args:
        xvec (vector<Double>)
        yvec (vector<Double>)
        evec (vector<Double>)
        isHist (bool)

    Returns:
        None 
    
void SimpleIOVectorToTextFile::SetTarget(vector< Double > avec, vector< Double > xvec, vector< Double > yvec, vector< Double > evec)
=====================================================================================================================================
    Set information to be written to a text file.

    Args:
        avec (vector<Double>)
        xvec (vector<Double>)
        yvec (vector<Double>)
        evec (vector<Double>)

    Returns:
        None 
    
void SimpleIOVectorToTextFile::SetTarget(HeaderBase hh, vector< Double > avec, vector< Double > xvec, vector< Double > yvec, vector< Double > evec)
====================================================================================================================================================
    Set information to be written to a text file.

    Args:
        hh ( HeaderBase)
        avec (vector<Double>)
        xvec (vector<Double>)
        yvec (vector<Double>)
        evec (vector<Double>)

    Returns:
        None 
    
void SimpleIOVectorToTextFile::SetTarget(Double a, vector< Double > xvec, vector< Double > yvec, vector< Double > evec)
========================================================================================================================
    Set information to be written to a text file.

    Args:
        a (Double)
        xvec (vector<Double>)
        yvec (vector<Double>)
        evec (vector<Double>)

    Returns:
        None 
    
void SimpleIOVectorToTextFile::SetTarget(HeaderBase hh, Double a, vector< Double > xvec, vector< Double > yvec, vector< Double > evec)
=======================================================================================================================================
    Set information to be written to a text file.

    Args:
        hh ( HeaderBase)
        a (Double)
        xvec (vector<Double>)
        yvec (vector<Double>)
        evec (vector<Double>)

    Returns:
        None 
";
%feature("docstring") SimpleIOVectorToTextFile::SaveFile "void SimpleIOVectorToTextFile::SaveFile(string _filename) 

    
void SimpleIOVectorToTextFile::SaveFile(string _filename, Int4 _prec) 
    
void SimpleIOVectorToTextFile::SaveFile(string _filename, Char _deli) 
    
void SimpleIOVectorToTextFile::SaveFile(string _filename, Int4 _prec, Char _deli)
==================================================================================
    Save a text file named _filename.

    Args:
        _filename (string)
        _prec (Int4)
        _deli (Char)

    Returns:
        None 
";
%feature("docstring") SimpleIOVectorToTextFile::LoadFile "void SimpleIOVectorToTextFile::LoadFile(string _filename)
==========================================================
    Load data from a text file named _filename.

    Args:
        _filename (string)

    Returns:
        None 

";
%feature("docstring") SimpleIOVectorToTextFile::PutX "vector<Double> SimpleIOVectorToTextFile::PutX()
================================================
    Put X-key double vector.

    Returns:
        vector<Double> 

";
%feature("docstring") SimpleIOVectorToTextFile::PutY "vector<Double> SimpleIOVectorToTextFile::PutY()
================================================
    Put Y-key double vector.

    Returns:
        vector<Double> 

";
%feature("docstring") SimpleIOVectorToTextFile::PutE "vector<Double> SimpleIOVectorToTextFile::PutE()
================================================
    Put E-key double vector.

    Returns:
        vector<Double> 

";
// File: classSplitString.xml

%feature("docstring") SplitString "

    Split a string with the delimiter string key into an array.
    An input string of \"Source\" is splited by \"SplitKey\". \"SplitKey\" is used as the delimiter string. The \"PutSize()\" should be called just after getting the array to get its size.
    Dynamic arrays produced in this class should be delete in the user functions, because this class does not have the delete function. In most cases, the arrays will be installed into data containers, and they have already possessed the delete functions.
    C++ includes: SplitString.hh 

";
%feature("docstring") SplitString::SplitString "SplitString::SplitString()
===========================
    Constructor, this method does not have the argument. 

";
%feature("docstring") SplitString::~SplitString "SplitString::~SplitString()
============================
    Destructor. This method should be called at the end of using this class. 

";
%feature("docstring") SplitString::Split "vector<string> SplitString::Split(string Source, string SplitKey) 

";
%feature("docstring") SplitString::PutUInt4 "vector<UInt4> SplitString::PutUInt4(string Source, string SplitKey) 

";
%feature("docstring") SplitString::PutDouble "vector<Double> SplitString::PutDouble(string Source, string SplitKey) 

";
%feature("docstring") SplitString::PutStringArray "vector< string > SplitString::PutStringArray(string Source, string SplitKey)
=============================================================================
    Split the string of the first argument and return an string type array. \"SplitKey\" is used as a delimiter string. The size of the array can be gotton from \"PutSize()\", it should be called just after executing of this method. If spaces exist at the ends of the each string, this method will delete them. 

";
%feature("docstring") SplitString::PutStringArrayWithSpace "vector< string > SplitString::PutStringArrayWithSpace(string Source, string SplitKey) 

";
%feature("docstring") SplitString::PutInt2Array "vector< Int2 > SplitString::PutInt2Array(string Source, string SplitKey)
=========================================================================
    Split the string of the first argument and return an Int2 type array. \"SplitKey\" is used as a delimiter string. The size of the array can be gotton from \"PutSize()\", it should be called just after executing of this method. 

";
%feature("docstring") SplitString::PutInt4Array "vector< Int4 > SplitString::PutInt4Array(string Source, string SplitKey)
=========================================================================
    Split the string of the first argument and return an Int4 type array. \"SplitKey\" is used as a delimiter string. The size of the array can be gotton from \"PutSize()\", it should be called just after executing of this method. 

";
%feature("docstring") SplitString::PutUInt2Array "vector< UInt2 > SplitString::PutUInt2Array(string Source, string SplitKey)
===========================================================================
    Split the string of the first argument and return an UInt2 type array. \"SplitKey\" is used as a delimiter string. The size of the array can be gotton from \"PutSize()\", it should be called just after executing of this method. 

";
%feature("docstring") SplitString::PutUInt4Array "vector< UInt4 > SplitString::PutUInt4Array(string Source, string SplitKey)
===========================================================================
    Split the string of the first argument and return an UInt4 type array. \"SplitKey\" is used as a delimiter string. The size of the array can be gotton from \"PutSize()\", it should be called just after executing of this method. 

";
%feature("docstring") SplitString::PutFloatArray "vector< Float > SplitString::PutFloatArray(string Source, string SplitKey)
===========================================================================
    Split the string of the first argument and return an Float type array. \"SplitKey\" is used as a delimiter string. The size of the array can be gotton from \"PutSize()\", it should be called just after executing of this method. 

";
%feature("docstring") SplitString::PutDoubleArray "vector< Double > SplitString::PutDoubleArray(string Source, string SplitKey)
=============================================================================
    Split the string of the first argument and return an Double type array. \"SplitKey\" is used as a delimiter string. The size of the array can be gotton from \"PutSize()\", it should be called just after executing of this method. 

";
// File: classStlMapDouble.xml

%feature("docstring") StlMapDouble "C++ includes: StlMapDouble.hh 

";
%feature("docstring") StlMapDouble::StlMapDouble "StlMapDouble::StlMapDouble() 

    
StlMapDouble::StlMapDouble(const StlMapDouble &ob) 
";
%feature("docstring") StlMapDouble::~StlMapDouble "StlMapDouble::~StlMapDouble() 

";
%feature("docstring") StlMapDouble::clear "void StlMapDouble::clear() 

";
%feature("docstring") StlMapDouble::Append "void StlMapDouble::Append(const string &key, vector< Double > &value) 

";
%feature("docstring") StlMapDouble::Add "void StlMapDouble::Add(const string &key, vector< Double > &value) 

";
%feature("docstring") StlMapDouble::Put "vector< Double > & StlMapDouble::Put(const string &key) 

    
vector< Double > & StlMapDouble::Put(UInt4 index) 
";
%feature("docstring") StlMapDouble::Erase "void StlMapDouble::Erase(const string &key) 

";
%feature("docstring") StlMapDouble::Delete "void StlMapDouble::Delete(const string &key) 

";
%feature("docstring") StlMapDouble::Replace "void StlMapDouble::Replace(const string &key, vector< Double > &value) 

";
%feature("docstring") StlMapDouble::Copy "void StlMapDouble::Copy(const string &OldKey, const string &NewKey) 

";
%feature("docstring") StlMapDouble::CheckKey "UInt4 StlMapDouble::CheckKey(const string &key) 

";
%feature("docstring") StlMapDouble::Reverse "void StlMapDouble::Reverse()
=============================
    reverse all std::vector 

";
%feature("docstring") StlMapDouble::Size "UInt4 StlMapDouble::Size() const
=================================

    Returns:
        the number of vector stored in this object 

    
UInt4 StlMapDouble::Size(const string &key) const
==================================================

    Returns:
        the size of vector which has the key 
";
%feature("docstring") StlMapDouble::PutKeyList "vector< string > StlMapDouble::PutKeyList() 

";
%feature("docstring") StlMapDouble::DumpKeyList "void StlMapDouble::DumpKeyList() 

";
%feature("docstring") StlMapDouble::PutIndexNumber "Int8 StlMapDouble::PutIndexNumber(const string &Key)
=====================================================
    The speed of this method is very slow, I do not recommend to use this method.
    This method will return -1, when Key is not registered in this map. 

";
// File: classStringTools.xml

%feature("docstring") StringTools "

    Collection of string tools.
    This class is the collection of string tools. A string is splited into string element with a delimiter string by using \"SplitString( string )\".
    C++ includes: StringTools.hh 

";
%feature("docstring") StringTools::StringTools "StringTools::StringTools()
===========================
    Constructor. 

";
%feature("docstring") StringTools::~StringTools "StringTools::~StringTools()
============================
    Destructor. 

";
%feature("docstring") StringTools::SplitString "vector< string > StringTools::SplitString(string s, string d, bool doTrim=true) 

    
vector< string > StringTools::SplitString(string s)
====================================================
    The given string is splited into the string elements with delimiters of \"space\", \"comma\" and \"tab\". The results is returned in the vector of string type. If argument d is set, d is used as a delimiter and \"space\" and \"\\\\n\" are ignored when doTrim is true. [inamura 130621] 
";
%feature("docstring") StringTools::StringToDouble "Double StringTools::StringToDouble(string s)
=============================================
    This method converts a given string into the value of double. 

";
%feature("docstring") StringTools::StringToFloat "Float StringTools::StringToFloat(string s)
===========================================
    This method converts a given string into the value of float. 

";
%feature("docstring") StringTools::StringToInt4 "Int4 StringTools::StringToInt4(string s)
=========================================
    This method converts a given string into the integer. 

";
%feature("docstring") StringTools::StringToUInt4 "UInt4 StringTools::StringToUInt4(string s)
===========================================
    This method converts a given string into the integer. 

";
%feature("docstring") StringTools::DoubleToString "string StringTools::DoubleToString(Double d)
=============================================
    This method converts a given value into a string. 

";
%feature("docstring") StringTools::FloatToString "string StringTools::FloatToString(Float f)
===========================================
    This method converts a given value into a string. 

";
%feature("docstring") StringTools::Int4ToString "string StringTools::Int4ToString(Int4 i)
=========================================
    This method converts a given integer into a string. 

";
%feature("docstring") StringTools::UInt4ToString "string StringTools::UInt4ToString(UInt4 i)
===========================================
    Converts an unsigned integer into a string. 

";
%feature("docstring") StringTools::VecUInt4ToString "string StringTools::VecUInt4ToString(vector< UInt4 > v) 

";
%feature("docstring") StringTools::VecInt4ToString "string StringTools::VecInt4ToString(vector< Int4 > v) 

";
%feature("docstring") StringTools::VecStringToString "string StringTools::VecStringToString(vector< string > v) 

";
%feature("docstring") StringTools::VecDoubleToString "string StringTools::VecDoubleToString(vector< Double > v) 

";
// File: classSwapBytes.xml

%feature("docstring") SwapBytes "

    Converter for binary data into Intel CPU format.
    If you use Intel CPU or compatible, the binary data array read from disks should be convert by this class. Because the converted data array overwrites the source array, You can delete the object of this class just after calling swap().
    When you use this class, you must define data type as following,
    | SwapBytes<UInt4>    *converter1 = new SwapBytes<UInt4>    //for integer
    C++ includes: SwapBytes.hh 

";
%feature("docstring") SwapBytes::SwapBytes "SwapBytes< T >::SwapBytes()
============================
    Constructor. You should define data type handled in this class as above example. 

";
%feature("docstring") SwapBytes::~SwapBytes "SwapBytes< T >::~SwapBytes()
=============================
    Destructor. 

";
%feature("docstring") SwapBytes::swap "void SwapBytes< T >::swap(T *pBuffer, UInt8 BufferLength)
==========================================================
    Execute the conversion. The argument of \"pBuffer\" is the pointer of array converted in this function, and \"BufferLength\" is the size of the array. The converted data array overwrites the old data. 

";
// File: classTwoDimElementContainer.xml

%feature("docstring") TwoDimElementContainer "

    Define a two dimensional detector with ElementContainer.
    A two dimensional area detector will be defined with this class. Because the dimension, the number of detector elements, is defined in the constructor, you should not use the constructor without its argument. If you construct this class with vector<UInt4> v = [3,4,5], this class will have 3+4+5 detector elements. When you want to access the data, use operator()( UInt4 Xindex, UInt4 Yindex ) or Put( UInt4 Xindex, UInt4 Yindex ). Put(2,3) will returns the fourth ElementContainer of third group.
    C++ includes: TwoDimElementContainer.hh 

";
%feature("docstring") TwoDimElementContainer::TwoDimElementContainer "TwoDimElementContainer::TwoDimElementContainer(vector< UInt4 > Dimension)
==========================================================================
    Constructor. 

    
TwoDimElementContainer::TwoDimElementContainer()
=================================================
    Constructor. Probably, you does not need this constructor. 
    
TwoDimElementContainer::TwoDimElementContainer(const TwoDimElementContainer &ob)
=================================================================================
    Override the copy constructor. 
";
%feature("docstring") TwoDimElementContainer::~TwoDimElementContainer "TwoDimElementContainer::~TwoDimElementContainer()
==================================================
    Destructor. 

";
%feature("docstring") TwoDimElementContainer::PutHeader "HeaderBase TwoDimElementContainer::PutHeader()
===============================================
    Returns header object. 

";
%feature("docstring") TwoDimElementContainer::PutHeaderPointer "HeaderBase* TwoDimElementContainer::PutHeaderPointer()
=======================================================
    Returns the pointer of header object. 

";
%feature("docstring") TwoDimElementContainer::InputHeader "void TwoDimElementContainer::InputHeader(HeaderBase Header)
============================================================
    this method set a header object. If header object has already input in this class, the existing object will be deleted, and set with the argument. 

";
%feature("docstring") TwoDimElementContainer::Put "ElementContainer TwoDimElementContainer::Put(UInt4 Xindex, UInt4 Yindex)
=========================================================================
    Return the object of ElementContainer. The meaning of the arguments was written in the manual of this class. 

";
%feature("docstring") TwoDimElementContainer::PutDimension "vector<UInt4> TwoDimElementContainer::PutDimension()
=====================================================
    Returns the dimension of the detector. The return value is the same as the argument of the constructor. 

";
%feature("docstring") TwoDimElementContainer::ConvertToMatrix "ElementContainerMatrix TwoDimElementContainer::ConvertToMatrix()
=================================================================
    Convert to ElementContainerMatrix from the object of this class 

";
%feature("docstring") TwoDimElementContainer::PutPackedContainer "vector< ElementContainer > TwoDimElementContainer::PutPackedContainer()
========================================================================
    This method is called from the NeXus and network distributing APIs. 

";
%feature("docstring") TwoDimElementContainer::InputPackedContainer "void TwoDimElementContainer::InputPackedContainer(vector< ElementContainer > obj)
==================================================================================
    This method is called from the NeXus and network distributing APIs. 

";
// File: classUInt4Container.xml

%feature("docstring") UInt4Container "

    vector<UInt4> container with their name tag.
    This class is data container class like \"ElementContainer\". Functionalities of class methods in this class is similar to the methods of \"ElementContainer\". See the manual of \"ElementContainer\".
    C++ includes: UInt4Container.hh 

";
%feature("docstring") UInt4Container::UInt4Container "UInt4Container::UInt4Container() 

    
UInt4Container::UInt4Container(HeaderBase *Header) 
    
UInt4Container::UInt4Container(const UInt4Container &ob) 
";
%feature("docstring") UInt4Container::~UInt4Container "UInt4Container::~UInt4Container() 

";
%feature("docstring") UInt4Container::PutTableSize "UInt4 UInt4Container::PutTableSize() 

";
%feature("docstring") UInt4Container::PutSize "UInt4 UInt4Container::PutSize() 

    
UInt4 UInt4Container::PutSize(UInt4 IndexNumber) 
    
UInt4 UInt4Container::PutSize(string Key) 
";
%feature("docstring") UInt4Container::PutTableSizeDouble "UInt4 UInt4Container::PutTableSizeDouble() 

";
%feature("docstring") UInt4Container::PutSizeDouble "UInt4 UInt4Container::PutSizeDouble() 

    
UInt4 UInt4Container::PutSizeDouble(UInt4 IndexNumber) 
    
UInt4 UInt4Container::PutSizeDouble(string Key) 
";
%feature("docstring") UInt4Container::PutIndexNumber "UInt4 UInt4Container::PutIndexNumber(string Key) 

";
%feature("docstring") UInt4Container::PutIndexNumberDouble "UInt4 UInt4Container::PutIndexNumberDouble(string Key) 

";
%feature("docstring") UInt4Container::PutName "string UInt4Container::PutName(UInt4 IndexNumber) 

";
%feature("docstring") UInt4Container::PutNameDouble "string UInt4Container::PutNameDouble(UInt4 IndexNumber) 

";
%feature("docstring") UInt4Container::PutHeader "HeaderBase UInt4Container::PutHeader() 

";
%feature("docstring") UInt4Container::PutHeaderPointer "HeaderBase* UInt4Container::PutHeaderPointer() 

";
%feature("docstring") UInt4Container::InputHeader "void UInt4Container::InputHeader(HeaderBase Header) 

";
%feature("docstring") UInt4Container::Reverse "void UInt4Container::Reverse(void)
===================================
    reverse all std::vector 

";
%feature("docstring") UInt4Container::DumpKey "void UInt4Container::DumpKey() 

";
%feature("docstring") UInt4Container::Dump "void UInt4Container::Dump() 

    
void UInt4Container::Dump(UInt4 size) 
";
%feature("docstring") UInt4Container::DumpValue "void UInt4Container::DumpValue() 

    
void UInt4Container::DumpValue(UInt4 size) 
";
%feature("docstring") UInt4Container::DumpFromVectorContainer "void UInt4Container::DumpFromVectorContainer() 

    
void UInt4Container::DumpFromVectorContainer(UInt4 size) 
";
%feature("docstring") UInt4Container::Add "void UInt4Container::Add(string Key, vector< UInt4 > value) 

    
void UInt4Container::Add(string Key, PyObject *value) 
    
void UInt4Container::Add(string Key, UInt4 *&Array, UInt4 ArraySize) 
";
%feature("docstring") UInt4Container::AddDouble "void UInt4Container::AddDouble(string Key, vector< Double > value) 

    
void UInt4Container::AddDouble(string Key, PyObject *value) 
    
void UInt4Container::AddDouble(string Key, Double *&Array, UInt4 ArraySize) 
";
%feature("docstring") UInt4Container::Put "vector< UInt4 > UInt4Container::Put(UInt4 IndexNumber) 

    
vector< UInt4 > UInt4Container::Put(string Key) 
    
UInt4 UInt4Container::Put(string Key, UInt4 Index) 
";
%feature("docstring") UInt4Container::PutDouble "vector< Double > UInt4Container::PutDouble(UInt4 IndexNumber) 

    
vector< Double > UInt4Container::PutDouble(string Key) 
    
Double UInt4Container::PutDouble(string Key, UInt4 Index) 
";
%feature("docstring") UInt4Container::PutList "PyObject * UInt4Container::PutList(string Key) 

";
%feature("docstring") UInt4Container::PutListDouble "PyObject * UInt4Container::PutListDouble(string Key) 

";
%feature("docstring") UInt4Container::CheckKey "UInt4 UInt4Container::CheckKey(string Key) 

";
%feature("docstring") UInt4Container::CheckKeyDouble "UInt4 UInt4Container::CheckKeyDouble(string Key) 

";
%feature("docstring") UInt4Container::PutMergedKey "string UInt4Container::PutMergedKey() 

";
%feature("docstring") UInt4Container::PutMergedKeyDouble "string UInt4Container::PutMergedKeyDouble() 

";
%feature("docstring") UInt4Container::PutSizeVector "vector< UInt4 > UInt4Container::PutSizeVector() 

";
%feature("docstring") UInt4Container::PutSizeVectorDouble "vector< UInt4 > UInt4Container::PutSizeVectorDouble() 

";
%feature("docstring") UInt4Container::PutMergedDataVector "vector< UInt4 > UInt4Container::PutMergedDataVector() 

";
%feature("docstring") UInt4Container::PutMergedDataVectorDouble "vector< Double > UInt4Container::PutMergedDataVectorDouble() 

";
%feature("docstring") UInt4Container::MakeContainer "void UInt4Container::MakeContainer(string MergedKey, vector< UInt4 > SizeVector, vector< UInt4 > MergedDataVector, HeaderBase h)
=================================================================================================================================
    The object of HeaderBase, the fourth argument, will be deleted in this function. If the object extracted with \"PutHeader()\" is installed with this function, you should copy it before use this function. 

    
void UInt4Container::MakeContainer(string MergedKey, vector< UInt4 > SizeVector, vector< UInt4 > MergedDataVector, string MergedKeyDouble, vector< UInt4 > SizeVectorDouble, vector< Double > MergedDataVectorDouble, HeaderBase h)
====================================================================================================================================================================================================================================
    This method will be used from the outside of this class. 
";
%feature("docstring") UInt4Container::ConvertIntoElementContainer "ElementContainer UInt4Container::ConvertIntoElementContainer()
===============================================================
    The contents stored in this class is comverted into the class object of ElementContainer. 

";
// File: classUInt4ContainerArray.xml

%feature("docstring") UInt4ContainerArray "

    Data container for a set of UInt4Container-s and HeaderBase.
    This class is data container class like \"ElementContainerArray\". Functionalities of class methods in this class is similar to the methods of \"ElementContainerArray\". See the manual of \"ElementContainerArray\".
    C++ includes: UInt4ContainerArray.hh 

";
%feature("docstring") UInt4ContainerArray::UInt4ContainerArray "UInt4ContainerArray::UInt4ContainerArray() 

    
UInt4ContainerArray::UInt4ContainerArray(HeaderBase pheader) 
    
UInt4ContainerArray::UInt4ContainerArray(const NeutronVector< UInt4Container, HeaderBase > &ob) 
";
%feature("docstring") UInt4ContainerArray::ConvertIntoElementContainerArray "ElementContainerArray UInt4ContainerArray::ConvertIntoElementContainerArray() 

";
// File: classUInt4ContainerMatrix.xml

%feature("docstring") UInt4ContainerMatrix "

    Data container for a set of UInt4ContainerArray-s and HeaderBase.
    This class is data container class like \"ElementContainerMatrix\". Functionalities of class methods in this class is similar to the methods of \"ElementContainerMatrix\". See the manual of \"ElementContainerMatrix\".
    C++ includes: UInt4ContainerMatrix.hh 

";
%feature("docstring") UInt4ContainerMatrix::UInt4ContainerMatrix "UInt4ContainerMatrix::UInt4ContainerMatrix() 

    
UInt4ContainerMatrix::UInt4ContainerMatrix(HeaderBase pheader) 
    
UInt4ContainerMatrix::UInt4ContainerMatrix(const NeutronVector< UInt4ContainerArray, HeaderBase > &ob) 
";
%feature("docstring") UInt4ContainerMatrix::ConvertIntoElementContainerMatrix "ElementContainerMatrix UInt4ContainerMatrix::ConvertIntoElementContainerMatrix() 

";
// File: classVectorTool.xml

%feature("docstring") VectorTool "

    Exchange tools of an Array and a Vector.
    This class is a exchange tool of an Array and a Vector, can be applied to various types of vectors and arrays. Since the execution speed of Python is slower than C++, you should only use the Python environment for reading and writing Python List. \"C++ vector\"s can be recognized in the Python environment like \"Python List\", on the other hand, \"C++ array\" can only manipulate in the Python environment with special functions.
    (a) If you want to change a \"Python List\" to a \"C++ vector\", (1) Make a \"C++ vector\" by using the MakeVectorInt4() of this class, (2) Copy values from the List to the Vector in Python environment with a for-loop.
    (b) If you want to change a \"Python List\" to a \"C++ array\", (1) Run (a), then, (2) Copy the vector to an array with \"VectorToArray( vector )\" in this class.
    (c) If you want to change a \"C++ vector\" to a \"Python List\", (1) Python is able to handle C++ vector like Python List.
    (d) If you want to change a \"C++ array\" to a \"Python List\", (1) change an array to a vector by \"ArrayToVector()\", and then, (2) see (c).
    C++ includes: VectorTool.hh 

";
%feature("docstring") VectorTool::VectorTool "VectorTool::VectorTool() 

";
%feature("docstring") VectorTool::~VectorTool "VectorTool::~VectorTool() 

";
%feature("docstring") VectorTool::ArrayToVector "vector< Double > VectorTool::ArrayToVector(Double *p, UInt4 size) 

    
vector< Float > VectorTool::ArrayToVector(Float *p, UInt4 size) 
    
vector< Int4 > VectorTool::ArrayToVector(Int4 *p, UInt4 size) 
    
vector< UInt4 > VectorTool::ArrayToVector(UInt4 *p, UInt4 size) 
    
vector< Int2 > VectorTool::ArrayToVector(Int2 *p, UInt4 size) 
    
vector< UInt2 > VectorTool::ArrayToVector(UInt2 *p, UInt4 size) 
    
vector< string > VectorTool::ArrayToVector(string *p, UInt4 size) 
    
vector< bool > VectorTool::ArrayToVector(bool *p, UInt4 size) 
";
%feature("docstring") VectorTool::MakeVectorDouble "vector< Double > VectorTool::MakeVectorDouble(UInt4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorFloat "vector< Float > VectorTool::MakeVectorFloat(UInt4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorInt4 "vector< Int4 > VectorTool::MakeVectorInt4(Int4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorUInt4 "vector< UInt4 > VectorTool::MakeVectorUInt4(UInt4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorInt2 "vector< Int2 > VectorTool::MakeVectorInt2(Int2 size=0) 

";
%feature("docstring") VectorTool::MakeVectorUInt2 "vector< UInt2 > VectorTool::MakeVectorUInt2(UInt2 size=0) 

";
%feature("docstring") VectorTool::MakeVectorString "vector< string > VectorTool::MakeVectorString(UInt4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorBool "vector< bool > VectorTool::MakeVectorBool(UInt4 size=0) 

";
%feature("docstring") VectorTool::ReadVectorString "vector< string > VectorTool::ReadVectorString(string FileName) 

";
%feature("docstring") VectorTool::MakeVectorDoubleP "vector< Double > * VectorTool::MakeVectorDoubleP(UInt4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorFloatP "vector< Float > * VectorTool::MakeVectorFloatP(UInt4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorInt4P "vector< Int4 > * VectorTool::MakeVectorInt4P(Int4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorUInt4P "vector< UInt4 > * VectorTool::MakeVectorUInt4P(UInt4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorInt2P "vector< Int2 > * VectorTool::MakeVectorInt2P(Int2 size=0) 

";
%feature("docstring") VectorTool::MakeVectorUInt2P "vector< UInt2 > * VectorTool::MakeVectorUInt2P(UInt2 size=0) 

";
%feature("docstring") VectorTool::MakeVectorStringP "vector< string > * VectorTool::MakeVectorStringP(UInt4 size=0) 

";
%feature("docstring") VectorTool::MakeVectorBoolP "vector< bool > * VectorTool::MakeVectorBoolP(UInt4 size=0) 

";
%feature("docstring") VectorTool::VectorToArray "Double * VectorTool::VectorToArray(vector< Double > v) 

    
Float * VectorTool::VectorToArray(vector< Float > v) 
    
Int4 * VectorTool::VectorToArray(vector< Int4 > v) 
    
UInt4 * VectorTool::VectorToArray(vector< UInt4 > v) 
    
Int2 * VectorTool::VectorToArray(vector< Int2 > v) 
    
UInt2 * VectorTool::VectorToArray(vector< UInt2 > v) 
    
string * VectorTool::VectorToArray(vector< string > v) 
    
bool * VectorTool::VectorToArray(vector< bool > v) 
";
%feature("docstring") VectorTool::MakeDoubleDoublePair "pair< Double, Double > VectorTool::MakeDoubleDoublePair(Double First, Double Second) 

";
// File: classWriteNeXusFile.xml

%feature("docstring") WriteNeXusFile "

    Make Binary data in NeXus format.
    This class make binary data in NeXus format. The API of NeXus is only provided for JAVA, Fortrun and C-language. NeXus data files will be written with this class on C++ and python language. The test codes utilized with this class is attached this file, \"WriteNeXusFile.hh\".
    If you want to make NeXus files compressed by the gzip library, see the comment of the constructor.
    C++ includes: WriteNeXusFile.hh 

";
%feature("docstring") WriteNeXusFile::WriteNeXusFile "WriteNeXusFile::WriteNeXusFile(const string &FileName, const string &UserName=\"UserName\", UInt4 CompMode=1)
==============================================================================================================
    Constructor. Set output file-name and your user-name. If CompMode is 1 or omitted, the output data file will be compressed with the gzip library. If it is not 1, the output file will not be compressed.@param CompMode 0, 1(default) for NX_COMP_NONE or NX_COMPLZW 

    
WriteNeXusFile::WriteNeXusFile(NXhandle r_handle, UInt4 CompMode=1) 
";
%feature("docstring") WriteNeXusFile::~WriteNeXusFile "WriteNeXusFile::~WriteNeXusFile()
==================================
    Destructor, NeXus binary file is closed in this method. 

";
%feature("docstring") WriteNeXusFile::PutHandle "NXhandle WriteNeXusFile::PutHandle() 

";
%feature("docstring") WriteNeXusFile::PutLink "NXlink WriteNeXusFile::PutLink() 

";
%feature("docstring") WriteNeXusFile::CloseNeXusFile "void WriteNeXusFile::CloseNeXusFile() 

";
%feature("docstring") WriteNeXusFile::AppendAttribute "void WriteNeXusFile::AppendAttribute(const string &Name, string value) 

    
void WriteNeXusFile::AppendAttribute(const string &Name, UInt4 value) 
    
void WriteNeXusFile::AppendAttribute(const string &Name, Int4 value) 
    
void WriteNeXusFile::AppendAttribute(const string &Name, Double value) 
    
void WriteNeXusFile::AppendAttribute(const string &Name, vector< Int4 > value) 
    
void WriteNeXusFile::AppendAttribute(const string &Name, vector< Double > value) 
    
void WriteNeXusFile::AppendAttribute(const string &Name, vector< string > value) 
    
void WriteNeXusFile::AppendAttribute(HeaderBase *header) 
";
%feature("docstring") WriteNeXusFile::MakeOpenGroup "void WriteNeXusFile::MakeOpenGroup(const string &Name, string Class)
=====================================================================
    make and open directory of XML. \"NXmakegroup(.......)\" and \"NXopengroup(......)\" are called in this method. 

";
%feature("docstring") WriteNeXusFile::CloseGroup "void WriteNeXusFile::CloseGroup()
==================================
    \"NXclosegroup(.....) is called in this method.\" 

";
%feature("docstring") WriteNeXusFile::CloseData "void WriteNeXusFile::CloseData()
=================================
    \"NXclosedata(.....) is called in this method.\" 

";
%feature("docstring") WriteNeXusFile::WriteData "void WriteNeXusFile::WriteData(const string &Name, const T &t)
===============================================================
    template method to write any class with NeXus format by calling their method T::NXwrite()
    WriteNeXusFile should be a friend class of each class. Each T::NXwrite() methods write their data by calling WriteNeXusFile::WriteData() method recursively.

    Args:
        Name name of data written in NeXus file. If this Name is \"\" the element name will be set automatically as \"ManyoLibData\".
        t reference to the object whose class has NXwrite(). 

    
void WriteNeXusFile::WriteData(const string &Name, const std::vector< T * > &t)
================================================================================
    template method to write a stl vector of pointers directly.
    It is used to write data in UInt4Container (vector<vector<double> *> vd).

    Args:
        t reference to the stl vector, all data pointed by t[] should be written 
    
void WriteNeXusFile::WriteData(const string &Name, const std::map< string, T > &t)
===================================================================================
    template method to write a stl map of any classes
    It is used to write data in Manyo's StlMapDouble (map< string, vector<Double> > M) and HeaderBase (std::map<string, int> _keymap)

    Args:
        t reference to the stl map 
    
void WriteNeXusFile::WriteData(const string &Name, UInt4 value)
================================================================
    < Write data only with attribute, \"Name\". Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, Int4 value)
===============================================================
    Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, Double value)
=================================================================
    Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, string value)
=================================================================
    Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, bool value) 
    
void WriteNeXusFile::WriteData(const string &Name, const UInt4 *value, UInt4 size)
===================================================================================
    Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, const Int4 *value, UInt4 size)
==================================================================================
    Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, const Double *value, UInt4 size) 
    
void WriteNeXusFile::WriteData(const string &Name, const Double *value, UInt4 size1, UInt4 size2)
==================================================================================================
    Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, const vector< string > &value)
==================================================================================
    Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, const vector< UInt4 > &value)
=================================================================================
    Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, const vector< Int4 > &value)
================================================================================
    Write data with its name. 
    
void WriteNeXusFile::WriteData(const string &Name, const vector< Double > &value) 
    
void WriteNeXusFile::WriteData(const string &Name, const vector< vector< Double > > &value) 
";
%feature("docstring") WriteNeXusFile::WriteDataP "void WriteNeXusFile::WriteDataP(const string &Name, vector< Double > *value)
=============================================================================
    Write data with its name. 

    
void WriteNeXusFile::WriteDataP(const string &Name, ElementContainer *EC) 
    
void WriteNeXusFile::WriteDataP(const string &Name, ElementContainerArray *ECA) 
    
void WriteNeXusFile::WriteDataP(const string &Name, ElementContainerMatrix *ECM) 
    
void WriteNeXusFile::WriteDataP(const string &Name, HeaderBase *Header) 
";
%feature("docstring") WriteNeXusFile::WriteData1 "void WriteNeXusFile::WriteData1(const string &Name, ElementContainer EC)
=========================================================================
    Write data with its name. If the first argument is \"\", the element name will be set automatically as \"ElementContainer\". 

    
void WriteNeXusFile::WriteData1(const string &Name, HeaderBase Header)
=======================================================================
    Write data with its name. If the first argument is \"\", the element name will be set automatically as \"HeaderBase\". 
    
void WriteNeXusFile::WriteData1(const string &Name, ElementContainerArray ECA)
===============================================================================
    Write data with its name. If the first argument is \"\", the element name will be set automatically as \"ElementContainerArray\". 
    
void WriteNeXusFile::WriteData1(const string &Name, ElementContainerMatrix ECM)
================================================================================
    Write data with its name. If the first argument is \"\", the element name will be set automatically as \"ElementContainerArray\". 
    
void WriteNeXusFile::WriteData1(const string &Name, UInt4ContainerMatrix UCM) 
    
void WriteNeXusFile::WriteData1(const string &Name, UInt4ContainerArray UCA) 
    
void WriteNeXusFile::WriteData1(const string &Name, UInt4Container UC) 
    
void WriteNeXusFile::WriteData1(const string &Name, TwoDimElementContainer TDEC) 
";
%feature("docstring") WriteNeXusFile::MakeLink "void WriteNeXusFile::MakeLink(NXlink Link)
===========================================
    This method is not effective, because the function of link is not prepared in NeXus API. The function of \"NXgetgroupID()\" is not work, but \"NXgetdataID() can be work well. \" 

";
%feature("docstring") WriteNeXusFile::WriteDataWithAttribute "void WriteNeXusFile::WriteDataWithAttribute(const string &Name, string value, const string &attrname, string attrvalue)
========================================================================================================================
    This method is used for creating Nxspe file for Horace software produced by R. Murasaki @Tohoku Univ (r.murasaki@dc.tohoku.ac.jp) 

";
// File: classWriteSerializationFile.xml

%feature("docstring") WriteSerializationFile "

    proxy class to write Manyo-lib data container by its serialization methods.
    This class is proxy/utility class to use Boost serialization features from python scripts. It is also enabled to use it from C++ codes.
    Following types are supported UInt4, Int4, std::string, Double, vector<UInt4>, vector<Int4>, vector<std::string>, vector<Double> HeaderBase, ElementContainer, ElementContainerArray, ElementContainerMatrix UInt4Container, UInt4ContainerArray, UInt4ContainerMatrix.
    Split serialization modes are implemented by distinct methods.
    C++ includes: WriteSerializationFile.hh 

";
%feature("docstring") WriteSerializationFile::WriteSerializationFile "WriteSerializationFile< Archive >::WriteSerializationFile(const char *filename) 

";
%feature("docstring") WriteSerializationFile::Save "void WriteSerializationFile< Archive >::Save(const UInt4 &data) 

    
void WriteSerializationFile< Archive >::Save(const Int4 &data) 
    
void WriteSerializationFile< Archive >::Save(const std::string &data) 
    
void WriteSerializationFile< Archive >::Save(const Double &data) 
    
void WriteSerializationFile< Archive >::Save(const vector< UInt4 > &data) 
    
void WriteSerializationFile< Archive >::Save(const vector< Int4 > &data) 
    
void WriteSerializationFile< Archive >::Save(const vector< std::string > &data) 
    
void WriteSerializationFile< Archive >::Save(const vector< Double > &data) 
    
void WriteSerializationFile< Archive >::Save(const HeaderBase &data) 
    
void WriteSerializationFile< Archive >::Save(const ElementContainer &data) 
    
void WriteSerializationFile< Archive >::Save(const ElementContainerArray &data) 
    
void WriteSerializationFile< Archive >::Save(const ElementContainerMatrix &data) 
    
void WriteSerializationFile< Archive >::Save(const UInt4Container &data) 
    
void WriteSerializationFile< Archive >::Save(const UInt4ContainerArray &data) 
    
void WriteSerializationFile< Archive >::Save(const UInt4ContainerMatrix &data) 
";
%feature("docstring") WriteSerializationFile::SplitSave "void WriteSerializationFile< Archive >::SplitSave(const ElementContainerArray &data, const unsigned int splitnum=1) 

    
void WriteSerializationFile< Archive >::SplitSave(const ElementContainerMatrix &data, const unsigned int splitnum=1) 
    
void WriteSerializationFile< Archive >::SplitSave(const UInt4ContainerArray &data, const unsigned int splitnum=1) 
    
void WriteSerializationFile< Archive >::SplitSave(const UInt4ContainerMatrix &data, const unsigned int splitnum=1) 
";
// File: classWriteTextFile.xml

%feature("docstring") WriteTextFile "C++ includes: WriteTextFile.hh 

";
%feature("docstring") WriteTextFile::WriteTextFile "WriteTextFile::WriteTextFile(string FileName)
==============================================
    Constructor. \"FileName\" is the target file name. 

";
%feature("docstring") WriteTextFile::~WriteTextFile "WriteTextFile::~WriteTextFile()
================================
    Destructor. The file descriptor created in this class will be closed in this method. 

";
%feature("docstring") WriteTextFile::Write "void WriteTextFile::Write(string st)
=====================================
    The value of the argument is appended to the target file defined in the constructor. \"\\\\n\" should be added at the tail end of the string. 

    
void WriteTextFile::Write(vector< string > st)
===============================================
    Each element of the argument of this method is passed to \"Write(string)\". Please read the manual of it. 
";

// File: classcore_1_1ConvManyoDoxy2Swig_1_1Doxy2SWIG.xml
%feature("docstring") core::ConvManyoDoxy2Swig::Doxy2SWIG "

Converts Doxygen generated XML files into a file containing docstrings that can be used by SWIG-1.3.x that have support for feature(\"docstring\").  Once the data is parsed it is stored in self.pieces. ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::__init__ "def core.ConvManyoDoxy2Swig.Doxy2SWIG.__init__(self, src)

Initialize the instance given a source object (file or filename). ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::generate "def core.ConvManyoDoxy2Swig.Doxy2SWIG.generate(self)

Parses the file set in the initialization.  The resulting data is stored in `self.pieces`. ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::parse "def core.ConvManyoDoxy2Swig.Doxy2SWIG.parse(self, node)

Parse a given node.  This function in turn calls the `parse_<nodeType>` functions which handle the respective nodes. ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::parse_Document "def core.ConvManyoDoxy2Swig.Doxy2SWIG.parse_Document(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::parse_Text "def core.ConvManyoDoxy2Swig.Doxy2SWIG.parse_Text(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::parse_Element "def core.ConvManyoDoxy2Swig.Doxy2SWIG.parse_Element(self, node)

Parse an `ELEMENT_NODE`.  This calls specific `do_<tagName>` handers for different elements.  If no handler is available the `generic_parse` method is called.  All tagNames specified in `self.ignores` are simply ignored. ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::add_text "def core.ConvManyoDoxy2Swig.Doxy2SWIG.add_text(self, value)

Adds text corresponding to `value` into `self.pieces`. ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::get_specific_nodes "def core.ConvManyoDoxy2Swig.Doxy2SWIG.get_specific_nodes(self, node, names)

Given a node and a sequence of strings in `names`, return a dictionary containing the names as keys and child `ELEMENT_NODEs`, that have a `tagName` equal to the name. ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::generic_parse "def core.ConvManyoDoxy2Swig.Doxy2SWIG.generic_parse(self, node, pad=0)

A Generic parser for arbitrary tags in a node.  Parameters:   - node:  A node in the DOM.  - pad: `int` (default: 0)     If 0 the node data is not padded with newlines.  If 1 it    appends a newline after parsing the childNodes.  If 2 it    pads before and after the nodes are processed.  Defaults to    0. ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::space_parse "def core.ConvManyoDoxy2Swig.Doxy2SWIG.space_parse(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_compoundname "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_compoundname(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_compounddef "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_compounddef(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_includes "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_includes(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_parameterlist "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_parameterlist(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_para "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_para(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_parametername "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_parametername(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_parameterdefinition "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_parameterdefinition(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_detaileddescription "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_detaileddescription(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_briefdescription "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_briefdescription(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_memberdef "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_memberdef(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_definition "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_definition(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_sectiondef "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_sectiondef(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_simplesect "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_simplesect(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_argsstring "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_argsstring(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_member "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_member(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_doxygenindex "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_doxygenindex(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_programlisting "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_programlisting(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_codeline "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_codeline(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::do_highlight "def core.ConvManyoDoxy2Swig.Doxy2SWIG.do_highlight(self, node) ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::write "def core.ConvManyoDoxy2Swig.Doxy2SWIG.write(self, fname, mode='w') ";

%feature("docstring")  core::ConvManyoDoxy2Swig::Doxy2SWIG::clean_pieces "def core.ConvManyoDoxy2Swig.Doxy2SWIG.clean_pieces(self, pieces)

Cleans the list of strings given as `pieces`.  It replaces multiple newlines by a maximum of 2 and returns a new list. It also wraps the paragraphs nicely. ";

