/*
$Id: HeaderBase.cc 2310 2011-10-07 03:44:47Z jisuzuki $
*/


#include "HeaderBase.hh"
////////////////////////////////////
HeaderBase::
HeaderBase()
{
  MakeMaps();
}
///////////////////////////////////
/*
HeaderBase::
HeaderBase( string DumpedString )
{
  MakeMaps();
  InputString( DumpedString );
}
*/
///////////////////////////////////
HeaderBase::
HeaderBase( const HeaderBase &ob )
{
  Int4Map         = new Map< Int4 > (*ob.Int4Map);
  DoubleMap       = new Map< Double > (*ob.DoubleMap);
  StringMap       = new Map< string > (*ob.StringMap);
  Int4VectorMap   = new Map< vector< Int4 >   > (*ob.Int4VectorMap);
  DoubleVectorMap = new Map< vector< Double > > (*ob.DoubleVectorMap);
  StringVectorMap = new Map< vector< string > > (*ob.StringVectorMap);

  _keymap = ob._keymap;
}
//////////////////////////////////////////
//HeaderBase &HeaderBase :: operator=( HeaderBase &ob )
HeaderBase HeaderBase :: operator=( const HeaderBase &ob )
{
  *Int4Map         = *ob.Int4Map;
  *DoubleMap       = *ob.DoubleMap;
  *StringMap       = *ob.StringMap;
  *Int4VectorMap   = *ob.Int4VectorMap;
  *DoubleVectorMap = *ob.DoubleVectorMap;
  *StringVectorMap = *ob.StringVectorMap;

  _keymap = ob._keymap;

  return *this;
}
//////////////////////////////////////////
HeaderBase::
~HeaderBase()
{
  //for( UInt4 i=0; i<Int4VectorMap -> Size(); i++){
  //  delete Int4VectorMap -> Put( i );
  //}
  //for( UInt4 i=0; i<DoubleVectorMap -> Size(); i++){
  //  delete DoubleVectorMap -> Put( i );
  //}
  //for( UInt4 i=0; i<StringVectorMap -> Size(); i++){
  //  delete StringVectorMap -> Put( i );
  //}

  delete Int4Map;
  delete DoubleMap;
  delete StringMap;
  delete Int4VectorMap;
  delete DoubleVectorMap;
  delete StringVectorMap;

}
////////////////////////////////////
void HeaderBase::
AddInt4List( string Key, PyObject *List )
{
  vector< Int4 > vec = 
    __gCppToPython.ListToInt4Vector( List );
  
  if( vec.size() == 0 ){
    cout << "HeaderBase::AddInt4List( string Key, PyObject *List )" << endl;
    cout << "The Python List cannot be converted from Python-List to vector<Int4>."
	 << "Please check each content of the List-object." << endl;
    return;
  }

  Add( Key, vec );
}
////////////////////////////////////
void HeaderBase::
AddDoubleList( string Key, PyObject *List )
{
  vector< Double > vec = 
    __gCppToPython.ListToDoubleVector( List );
  
  if( vec.size() == 0 ){
    cout << "HeaderBase::AddDoubleList( string Key, PyObject *List )" << endl;
    cout << "The Python List cannot be converted from Python-List to vector<Double>."
	 << "Please check each content of the List-object." << endl;
    return;
  }

  Add( Key, vec );
}
////////////////////////////////////
void HeaderBase::
AddStringList( string Key, PyObject *List )
{
  vector< string > vec = 
    __gCppToPython.ListToStringVector( List );

  if( vec.size() == 0 ){
    cout << "HeaderBase::AddStringList( string Key, PyObject *List )" << endl;
    cout << "The Python List cannot be converted from Python-List to vector<string>."
	 << "Please check each content of the List-object." << endl;
    return;
  }

  Add( Key, vec );
}
////////////////////////////////////
void HeaderBase::
Add( string Key, Int4 value )
{ 
  if( _keymap[Key] > 0 ){
    cout << "\"" << Key << "\"" << " has been registered for " << _keyTypeName[_keymap[Key]] << " in this HeaderBase," << endl;
    cout << "you should choose another key." << endl;
    return;
  }
  Int4Map  ->_Add(Key,value); 
  _keymap[Key] = 1;
}
////////////////////////////////////
void HeaderBase::
Add( string Key, Double value )
{ 
  if( _keymap[Key] > 0 ){
    cout << "\"" << Key << "\"" << " has been registered for " << _keyTypeName[_keymap[Key]] << " in this HeaderBase," << endl;
    cout << "you should choose another key." << endl;
    return;
  }
  DoubleMap->_Add(Key,value); 
  _keymap[Key] = 2;
}
////////////////////////////////////
void HeaderBase::
Add( string Key, string value )
{ 
  if( _keymap[Key] > 0 ){
    cout << "\"" << Key << "\"" << " has been registered for " << _keyTypeName[_keymap[Key]] << " in this HeaderBase," << endl;
    cout << "you should choose another key." << endl;
    return;
  }
  StringMap->_Add(Key,value); 
  _keymap[Key] = 3;
}
////////////////////////////////////
void HeaderBase::
Add( string Key, vector<Int4> value )
{ 
  if( _keymap[Key] > 0 ){
    cout << "\"" << Key << "\"" << " has been registered for " << _keyTypeName[_keymap[Key]] << " in this HeaderBase," << endl;
    cout << "you should choose another key." << endl;
    return;
  }
  Int4VectorMap  ->_Add( Key, value ); 
  _keymap[Key] = 4;
}
////////////////////////////////////
void HeaderBase::
Add( string Key, vector<Double> value )
{ 
  if( _keymap[Key] > 0 ){
    cout << "\"" << Key << "\"" << " has been registered for " << _keyTypeName[_keymap[Key]] << " in this HeaderBase," << endl;
    cout << "you should choose another key." << endl;
    return;
  }
  DoubleVectorMap->_Add( Key, value ); 
  _keymap[Key] = 5;
}
////////////////////////////////////
void HeaderBase::
Add( string Key, vector<string> value )
{ 
  if( _keymap[Key] > 0 ){
    cout << "\"" << Key << "\"" << " has been registered for " << _keyTypeName[_keymap[Key]] << " in this HeaderBase," << endl;
    cout << "you should choose another key." << endl;
    return;
  }
  StringVectorMap->_Add( Key,value ); 
  _keymap[Key] = 6;
}
////////////////////////////////////
string HeaderBase::
DumpToString()
{
  
  string str;
  str.clear();
  char buf[1024];
  UInt4 size;
 
  //////// Dump start for Int4Map
  size = Int4Map->Size();
  snprintf( buf, sizeof(buf), "%d", size );
  str = str + ( string( buf ) + "#,#" );
  
  if( size == 0 ){
    str = str + "None" + "#,#";
    str = str + "None" + "#,#";
  }
  else{
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( Int4Map->PutKey(i) + "\\," );
    }
    str = str + ( Int4Map->PutKey(size-1) + "#,#" );

    for( UInt4 i=0; i<size-1; i++ ){
      snprintf( buf, sizeof(buf), "%d", Int4Map->Put(i) );
      str = str + ( string( buf ) + "," );
    }
    snprintf( buf, sizeof(buf), "%d", Int4Map->Put(size-1) );
    str = str + ( string( buf ) + "#,#" );
  } //////// Dump end for Int4Map

  //////// Dump start for DoubleMap
  size = DoubleMap->Size();
  snprintf( buf, sizeof(buf), "%d", size );
  str = str + ( string( buf ) + "#,#" );
  
  if( size == 0 ){
    str = str + "None" + "#,#";
    str = str + "None" + "#,#";
  }
  else{
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( DoubleMap->PutKey(i) + "\\," );
    }
    str = str + ( DoubleMap->PutKey(size-1) + "#,#" );

    for( UInt4 i=0; i<size-1; i++ ){
      snprintf( buf, sizeof(buf), "%.9f", DoubleMap->Put(i) );
      str = str + ( string( buf ) + "," );
    }
    snprintf( buf, sizeof(buf), "%.9f", DoubleMap->Put(size-1) );
    str = str + ( string( buf ) + "#,#" );
  } //////// Dump end for DoubleMap

  //////// Dump start for StringMap
  size = StringMap->Size();
  snprintf( buf, sizeof(buf), "%d", size );
  str = str + ( string( buf ) + "#,#" );
  
  if( size == 0 ){
    str = str + "None" + "#,#";
    str = str + "None" + "#,#";
  }
  else{
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( StringMap->PutKey(i) + "\\," );
    }
    str = str + ( StringMap->PutKey(size-1) + "#,#" );

    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( StringMap->Put(i) + "\\," );
    }
    str = str + ( StringMap->Put(size-1) + "#,#" );
  } //////// Dump end for StringMap

  //////// Dump start for Int4VectorMap
  size = Int4VectorMap->Size();
  snprintf( buf, sizeof(buf), "%d", size );
  str = str + ( string( buf ) + "#,#" );
  
  if( size != 0 ){
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( Int4VectorMap->PutKey(i) + "\\," );
    }
    str = str + ( Int4VectorMap->PutKey(size-1) + "#,#" );

    vector<Int4> TargetVec;
    for( UInt4 i=0; i<size; i++ ){
      TargetVec = Int4VectorMap -> Put( i );
      UInt4 VecSize = (UInt4)(TargetVec . size());
      snprintf( buf, sizeof(buf), "%d", VecSize );
      str = str + ( string( buf ) + "#,#" );
      if( VecSize == 0 ){
	str = str + "None" + "#,#";
      }
      else{
	for( UInt4 s=0; s<VecSize-1; s++){
	  snprintf( buf, sizeof(buf), "%d", TargetVec[s] );
	  str = str + ( string( buf ) + "," );
	}
	snprintf( buf, sizeof(buf), "%d", TargetVec[VecSize-1] );
	str = str + ( string( buf ) + "#,#" );
      }
    }
  } //////// Dump end for Int4VectorMap

  //////// Dump start for DoubleVectorMap
  size = DoubleVectorMap->Size();
  snprintf( buf, sizeof(buf), "%d", size );
  str = str + ( string( buf ) + "#,#" );
  
  if( size != 0 ){
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( DoubleVectorMap->PutKey(i) + "\\," );
    }
    str = str + ( DoubleVectorMap->PutKey(size-1) + "#,#" );

    vector<Double> TargetVec;
    for( UInt4 i=0; i<size; i++ ){
      TargetVec = DoubleVectorMap -> Put( i );
      UInt4 VecSize = (UInt4)(TargetVec . size());
      snprintf( buf, sizeof(buf), "%d", VecSize );
      str = str + ( string( buf ) + "#,#" );
      if( VecSize == 0 ){
	str = str + "None" + "#,#";
      }
      else{
	for( UInt4 s=0; s<VecSize-1; s++){
	  snprintf( buf, sizeof(buf), "%.9f", TargetVec[s] );
	  str = str + ( string( buf ) + "," );
	}
	snprintf( buf, sizeof(buf), "%.9f", TargetVec[VecSize-1] );
	str = str + ( string( buf ) + "#,#" );
      }
    }
  } //////// Dump end for DoubleVectorMap

  //////// Dump start for StringVectorMap
  size = StringVectorMap->Size();
  snprintf( buf, sizeof(buf), "%d", size );
  str = str + ( string( buf ) + "#,#" );
  
  if( size != 0 ){
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( StringVectorMap->PutKey(i) + "\\," );
    }
    str = str + ( StringVectorMap->PutKey(size-1) + "#,#" );

    vector<string> TargetVec;
    for( UInt4 i=0; i<size; i++ ){
      TargetVec = StringVectorMap -> Put( i );
      UInt4 VecSize = (UInt4)(TargetVec . size());
      snprintf( buf, sizeof(buf), "%d", VecSize );
      str = str + ( string( buf ) + "#,#" );
      if( VecSize == 0 ){
	str = str + "None" + "#,#";
      }
      else{
	for( UInt4 s=0; s<VecSize-1; s++){
	  str = str + ( TargetVec[s] + "\\," );
	}
	str = str + ( TargetVec[VecSize-1] + "#,#" );
      }
    }
  } //////// Dump end for StringVectorMap
  return str;
  

  /*
  string str;
  str.clear();
  char buf[1024];
  UInt4 size;
 
  //////// Dump start for Int4Map
  size = Int4Map->Size();
  sprintf( buf, "%d", size );
  str = str + ( string( buf ) + "\n" );
  
  if( size == 0 ){
    str = str + "None" + "\n";
    str = str + "None" + "\n";
  }
  else{
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( Int4Map->PutKey(i) + "," );
    }
    str = str + ( Int4Map->PutKey(size-1) + "\n" );

    for( UInt4 i=0; i<size-1; i++ ){
      sprintf( buf, "%d", Int4Map->Put(i) );
      str = str + ( string( buf ) + "," );
    }
    sprintf( buf, "%d", Int4Map->Put(size-1) );
    str = str + ( string( buf ) + "\n" );
  } //////// Dump end for Int4Map

  //////// Dump start for DoubleMap
  size = DoubleMap->Size();
  sprintf( buf, "%d", size );
  str = str + ( string( buf ) + "\n" );
  
  if( size == 0 ){
    str = str + "None" + "\n";
    str = str + "None" + "\n";
  }
  else{
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( DoubleMap->PutKey(i) + "," );
    }
    str = str + ( DoubleMap->PutKey(size-1) + "\n" );

    for( UInt4 i=0; i<size-1; i++ ){
      sprintf( buf, "%.9f", DoubleMap->Put(i) );
      str = str + ( string( buf ) + "," );
    }
    sprintf( buf, "%.9f", DoubleMap->Put(size-1) );
    str = str + ( string( buf ) + "\n" );
  } //////// Dump end for DoubleMap

  //////// Dump start for StringMap
  size = StringMap->Size();
  sprintf( buf, "%d", size );
  str = str + ( string( buf ) + "\n" );
  
  if( size == 0 ){
    str = str + "None" + "\n";
    str = str + "None" + "\n";
  }
  else{
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( StringMap->PutKey(i) + "," );
    }
    str = str + ( StringMap->PutKey(size-1) + "\n" );

    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( StringMap->Put(i) + "," );
    }
    str = str + ( StringMap->Put(size-1) + "\n" );
  } //////// Dump end for StringMap

  //////// Dump start for Int4VectorMap
  size = Int4VectorMap->Size();
  sprintf( buf, "%d", size );
  str = str + ( string( buf ) + "\n" );
  
  if( size != 0 ){
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( Int4VectorMap->PutKey(i) + "," );
    }
    str = str + ( Int4VectorMap->PutKey(size-1) + "\n" );

    vector<Int4> TargetVec;
    for( UInt4 i=0; i<size; i++ ){
      TargetVec = Int4VectorMap -> Put( i );
      UInt4 VecSize = TargetVec . size();
      sprintf( buf, "%d", VecSize );
      str = str + ( string( buf ) + "\n" );
      if( VecSize == 0 ){
	str = str + "None" + "\n";
      }
      else{
	for( UInt4 s=0; s<VecSize-1; s++){
	  sprintf( buf, "%d", TargetVec[s] );
	  str = str + ( string( buf ) + "," );
	}
	sprintf( buf, "%d", TargetVec[VecSize-1] );
	str = str + ( string( buf ) + "\n" );
      }
    }
  } //////// Dump end for Int4VectorMap

  //////// Dump start for DoubleVectorMap
  size = DoubleVectorMap->Size();
  sprintf( buf, "%d", size );
  str = str + ( string( buf ) + "\n" );
  
  if( size != 0 ){
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( DoubleVectorMap->PutKey(i) + "," );
    }
    str = str + ( DoubleVectorMap->PutKey(size-1) + "\n" );

    vector<Double> TargetVec;
    for( UInt4 i=0; i<size; i++ ){
      TargetVec = DoubleVectorMap -> Put( i );
      UInt4 VecSize = TargetVec . size();
      sprintf( buf, "%d", VecSize );
      str = str + ( string( buf ) + "\n" );
      if( VecSize == 0 ){
	str = str + "None" + "\n";
      }
      else{
	for( UInt4 s=0; s<VecSize-1; s++){
	  sprintf( buf, "%.9f", TargetVec[s] );
	  str = str + ( string( buf ) + "," );
	}
	sprintf( buf, "%.9f", TargetVec[VecSize-1] );
	str = str + ( string( buf ) + "\n" );
      }
    }
  } //////// Dump end for DoubleVectorMap

  //////// Dump start for StringVectorMap
  size = StringVectorMap->Size();
  sprintf( buf, "%d", size );
  str = str + ( string( buf ) + "\n" );
  
  if( size != 0 ){
    for( UInt4 i=0; i<size-1; i++ ){
      str = str + ( StringVectorMap->PutKey(i) + "," );
    }
    str = str + ( StringVectorMap->PutKey(size-1) + "\n" );

    vector<string> TargetVec;
    for( UInt4 i=0; i<size; i++ ){
      TargetVec = StringVectorMap -> Put( i );
      UInt4 VecSize = TargetVec . size();
      sprintf( buf, "%d", VecSize );
      str = str + ( string( buf ) + "\n" );
      if( VecSize == 0 ){
	str = str + "None" + "\n";
      }
      else{
	for( UInt4 s=0; s<VecSize-1; s++){
	  str = str + ( TargetVec[s] + "," );
	}
	str = str + ( TargetVec[VecSize-1] + "\n" );
      }
    }
  } //////// Dump end for StringVectorMap
  return str;
  */
}
////////////////////////////////////
void HeaderBase::
InputFile( string FileName )
{
  ReadWriteTextFile *r = new ReadWriteTextFile( FileName );
  r -> Read();
  vector<string> s = r -> Put();
  UInt4 size = (UInt4)(s.size());
  string ss;
  for( UInt4 i=0; i<size; i++ ){
    ss = ss + "\n" + s[i];
  }
  InputString( ss );
  delete r;
}
////////////////////////////////////
void HeaderBase::
InputString( string s )
{
  SplitString *split = new SplitString();
  vector<string> v = split -> PutStringArray( s, "#,#" );

  if (v.size()<12) return; //[inamura 200516]

  UInt4 Current = 0;

  // Receive Int4 start
  UInt4 size = atoi( v[Current++].c_str() );
  if( size == 0 ){
    Current = Current + 2;
  }
  else{
    string tmp=v[Current++];
    vector<string> key = split->PutStringArray( tmp, "\\," );
    vector<Int4>   IntVector = split->PutInt4Array( v[Current++],"," );
    if (key.size()!=size)
        key = split->PutStringArray( tmp, "," );
    for( UInt4 i=0; i<size; i++ ){
      Add( key[i], IntVector[i] );
    }
  }
  // Receive Int4 end
  

  // Receive Double start
  size = atoi( v[Current++].c_str() );
  if( size == 0 ){
    Current = Current + 2;
  }
  else{
    string tmp=v[Current++];
    vector<string> key = split->PutStringArray( tmp, "\\," );
    vector<Double> DoubleVector = split->PutDoubleArray( v[Current++],"," );
    if (key.size()!=size)
        key = split->PutStringArray( tmp, "," );
    for( UInt4 i=0; i<size; i++ ){
      Add( key[i], DoubleVector[i] );
    }
  }
  // Receive Double end


  // Receive String start
  size = atoi( v[Current++].c_str() );
  if( size == 0 ){
    Current = Current + 2;
  }
  else{
    string tmp=v[Current++];
    vector<string> key = split->PutStringArray( tmp, "\\," );
    if (key.size()!=size)
        key = split->PutStringArray( tmp, "," );
    vector<string> StringVector = split->PutStringArray( v[Current++],"\\," );
    if (StringVector.size()!=size){
        Current--;
        StringVector = split->PutStringArray( v[Current++],"," );
    }
    for( UInt4 i=0; i<size; i++ ){
      Add( key[i], StringVector[i] );
    }
  }
  // Receive String end

  
  // Receive Int4 vector start
  size = atoi( v[Current++].c_str() );
  if( size != 0 ){
    string tmp=v[Current++];
    vector<string> key = split->PutStringArray( tmp, "\\," );
    if (key.size()!=size)
      key = split->PutStringArray( tmp, "," );
    
    for( UInt4 i=0; i<size; i++ ){
      
      UInt4 VecSize = atoi( v[Current++].c_str() );
      if( VecSize == 0){
	Current++;
	//vector<Int4> *Vemp = new vector<Int4>;
	//Int4VectorMap -> Add( key[i], Vemp );
	vector<Int4> Vemp;
	Vemp.clear();
	Add( key[i], Vemp );
      }
      else{
	vector<Int4> Vec = split -> PutInt4Array( v[Current++].c_str(), "," );
	//vector<Int4> *V = new vector<Int4>( Vec.size() );
	//for( UInt4 t=0; t<Vec.size(); t++ ){
	//  ( *V )[t] = Vec[t];
	//}
	//Int4VectorMap -> Add( key[i], V );

	vector<Int4> V( Vec.size() );
	for( UInt4 t=0; t<Vec.size(); t++ ){
	  V[t] = Vec[t];
	}
	Add( key[i], V );
      }
    }
  }
  // Receive Int4 vector end

  // Receive Double vector start
  size = atoi( v[Current++].c_str() );
  if( size != 0 ){
    string tmp=v[Current++];
    vector<string> key = split->PutStringArray( tmp, "\\," );
    if (key.size()!=size)
      key = split->PutStringArray( tmp, "," );
    
    for( UInt4 i=0; i<size; i++ ){
      
      UInt4 VecSize = atoi( v[Current++].c_str() );
      if( VecSize == 0){
	Current++;
	//vector<Double> *Vemp = new vector<Double>;
	//DoubleVectorMap -> Add( key[i], Vemp );
	vector<Double> Vemp;
	Vemp.clear();
	Add( key[i], Vemp );
      }
      else{
	vector<Double> Vec = split -> PutDoubleArray( v[Current++].c_str(), "," );
	//vector<Double> *V = new vector<Double>( Vec.size() );
	//for( UInt4 t=0; t<Vec.size(); t++ ){
	//  ( *V )[t] = Vec[t];
	//}
	//DoubleVectorMap -> Add( key[i], V );
	vector<Double> V( Vec.size() );
	for( UInt4 t=0; t<Vec.size(); t++ ){
	  V[t] = Vec[t];
	}
	Add( key[i], V );
      }
    }
  }
  // Receive Double vector end

  // Receive String vector start
  size = atoi( v[Current++].c_str() );
  if( size != 0 ){
    string tmp=v[Current++];
    vector<string> key = split->PutStringArray( tmp, "\\," );
    if (key.size()!=size)
      key = split->PutStringArray( tmp, "," );
    
    for( UInt4 i=0; i<size; i++ ){
      
      UInt4 VecSize = atoi( v[Current++].c_str() );
      if( VecSize == 0){
	Current++; 
	//vector<string> *Vemp = new vector<string>;
	//StringVectorMap -> Add( key[i], Vemp );

	vector<string> Vemp;
	Vemp.clear();
	Add( key[i], Vemp );
      }
      else{
        string tmp=v[Current++];
	vector<string> Vec = split -> PutStringArray( tmp.c_str(), "\\," );
        if (Vec.size()!=VecSize)
          Vec = split -> PutStringArray( tmp.c_str(), "," );
	//vector<string> *V = new vector<string>( Vec.size() );
	//for( UInt4 t=0; t<Vec.size(); t++ ){
	//  ( *V )[t] = Vec[t];
	//}
	//StringVectorMap -> Add( key[i], V );
	
	vector<string> V( Vec.size() );
	for( UInt4 t=0; t<Vec.size(); t++ ){
	  V[t] = Vec[t];
	}
	Add( key[i], V );
      }
    }
  }
  delete split;
}
////////////////////////////////////
void HeaderBase::
MakeMaps() // private
{
  Int4Map         = new Map< Int4 >;
  DoubleMap       = new Map< Double >;
  StringMap       = new Map< string >;
  Int4VectorMap   = new Map< vector< Int4 >   >;
  DoubleVectorMap = new Map< vector< Double > >;
  StringVectorMap = new Map< vector< string > >;

  Int4Map         -> Clear();
  DoubleMap       -> Clear();
  StringMap       -> Clear();
  Int4VectorMap   -> Clear();
  DoubleVectorMap -> Clear();
  StringVectorMap -> Clear();

  _keyTypeName.resize(7);
  _keyTypeName[0] = "";
  _keyTypeName[1] = "Int4";
  _keyTypeName[2] = "Double";
  _keyTypeName[3] = "string";
  _keyTypeName[4] = "vector<Int4>";
  _keyTypeName[5] = "vector<Double>";
  _keyTypeName[6] = "vector<string>";

}
////////////////////////////////////
////////////////////////////////////
PyObject* HeaderBase::
PyDump()
{
  vector<string> vs;
  vs.clear();
  string ss;
  StringTools *st = new StringTools();


  /*****************************************************/
  vs.push_back( "***Int4Map***" );
  vs.push_back( "Index\tKey\tValue" );
  UInt4 s = Int4Map -> Size();
  for( UInt4 i=0; i<s; i++ ){
    vs.push_back( st->UInt4ToString(i) + "\t" + Int4Map -> PutKey( i ) 
	 + "\t" + st->Int4ToString( Int4Map -> Put( i ) ) );
  }

  vs.push_back( "***DoubleMap***" );
  vs.push_back( "Index\tKey\tValue" );
  s = DoubleMap -> Size();
  for( UInt4 i=0; i<s; i++ ){
    vs.push_back(
		 st->UInt4ToString(i) + "\t" + DoubleMap -> PutKey( i ) 
		 +"\t" +  st->DoubleToString(DoubleMap -> Put( i ) ) ); 
  }

  vs.push_back( "***StringMap***" );
  vs.push_back( "Index\tKey\tValue" );
  s = StringMap -> Size();
  for( UInt4 i=0; i<s; i++ ){
    vs.push_back( 
		 st->UInt4ToString(i) + "\t" + StringMap -> PutKey( i ) 
		 + "\t" +  StringMap -> Put( i ) ); 
  }

  UInt4 size;
  
  vs.push_back( "***Int4VectorMap***" );
  vs.push_back( "Index\tKey\tSize\tValue" );
  size = Int4VectorMap -> Size();
  UInt4 DumpSize = 22;

  for( UInt4 s=0; s<size; s++ ){
    ss = st->UInt4ToString(s) + "\t"
	 + Int4VectorMap -> PutKey( s ) + "\t";

    vector<Int4> Vec = Int4VectorMap -> Put( s );
    UInt4 VecSize = (UInt4)(Vec . size());
    ss = ss + st->UInt4ToString(VecSize) + "\t";

    if( VecSize ==0 ){
      ss = ss + "[ None ]";
    }
    else if( VecSize <= DumpSize ){
      ss = ss + "[ ";
      for( UInt4 vs=0; vs<VecSize-1; vs++ ){
	ss = ss + st->UInt4ToString(Vec[vs]) + ",";
      }
      ss = ss + st->UInt4ToString(Vec[VecSize-1]) + " ]";
    }
    else{
      ss = ss + "[";
      for( UInt4 vs=0; vs<DumpSize-2; vs++ ){
	ss = ss + st->UInt4ToString(Vec[vs]) + ",";
      }
      ss = ss + st->UInt4ToString(Vec[DumpSize-2]) + " ......]";
    }
    vs.push_back( ss );
  }
  //vs.push_back( ss );

  vs.push_back( "***DoubleVectorMap***" );
  vs.push_back( "Index\tKey\tSize\tValue" );
  size = DoubleVectorMap -> Size();

  for( UInt4 s=0; s<size; s++ ){
    ss = st->UInt4ToString(s) + "\t"
	 + DoubleVectorMap -> PutKey( s ) + "\t";

    vector<Double> Vec = DoubleVectorMap -> Put( s );
    UInt4 VecSize = (UInt4)(Vec . size());
    ss = ss + st->UInt4ToString(VecSize) + "\t";
    
    if( VecSize ==0 ){
      ss = ss + "[ None ]";
    }
    else if( VecSize <= DumpSize ){
      ss = ss + "[ ";
      for( UInt4 vs=0; vs<VecSize-1; vs++ ){
	ss = ss + st->DoubleToString(Vec[vs]) + ",";
      }
      ss = ss + st->DoubleToString(Vec[VecSize-1]) + " ]";
    }
    else{
      ss = ss + "[";
      for( UInt4 vs=0; vs<DumpSize-2; vs++ ){
	ss = ss +  st->DoubleToString(Vec[vs]) + ",";
      }
      ss = ss + st->DoubleToString(Vec[DumpSize-2]) + " ......]";
    }
    vs.push_back( ss );
  }
  //vs.push_back( ss );
  
  vs.push_back( "***StringVectorMap***" );
  vs.push_back( "Index\tKey\tSize\tValue" );
  size = StringVectorMap -> Size();
  
  for( UInt4 s=0; s<size; s++ ){
    ss = st->UInt4ToString(s) + "\t"
	 + StringVectorMap -> PutKey( s ) + "\t";
    
    vector<string> Vec = StringVectorMap -> Put( s );
    UInt4 VecSize = (UInt4)(Vec . size());
    ss = ss + st->UInt4ToString(VecSize) + "\t";
    
    if( VecSize ==0 ){
      ss = ss + "[ None ]";
    }
    else if( VecSize <= DumpSize ){
      ss = ss + "[ ";
      for( UInt4 vs=0; vs<VecSize-1; vs++ ){
	ss = ss + "'" + Vec[vs] + "'" + ",";
      }
      ss = ss + "'" + Vec[VecSize-1] + "'" + " ]";
    }
    else{
      ss = ss + "[";
      for( UInt4 vs=0; vs<DumpSize-2; vs++ ){
	ss = ss + "'" + Vec[vs] + "'" + ",";
      }
      ss = ss + "'" + Vec[DumpSize-2] + "'" + " ......]";
    }
    vs.push_back( ss );
  }
  //vs.push_back(ss);
  /*****************************/


  CppToPython *cp = new CppToPython();
  PyObject *r = cp -> VectorStringToList( vs );
  delete cp;
  delete st;
  return r;
}
////////////////////////////////////
void HeaderBase::
Dump()
{
  cout << "***Int4Map***" << endl;
  cout << "Index\tKey\tValue"   << endl;
  UInt4 s = Int4Map -> Size();
  for( UInt4 i=0; i<s; i++ ){
    cout << i << "\t" << Int4Map -> PutKey( i ) 
	 << "\t" <<  Int4Map -> Put( i ) << endl; 
  }
  cout << endl;

  cout << "***DoubleMap***" << endl;
  cout << "Index\tKey\tValue"   << endl;
  s = DoubleMap -> Size();
  for( UInt4 i=0; i<s; i++ ){
    cout << i << "\t" << DoubleMap -> PutKey( i ) 
	 << "\t" <<  DoubleMap -> Put( i ) << endl; 
  }
  cout << endl;

  cout << "***StringMap***" << endl;
  cout << "Index\tKey\tValue"   << endl;
  s = StringMap -> Size();
  for( UInt4 i=0; i<s; i++ ){
    cout << i << "\t" << StringMap -> PutKey( i ) 
	 << "\t" <<  StringMap -> Put( i ) << endl; 
  }
  cout << endl;

  UInt4 size;
  
  cout << "***Int4VectorMap***" << endl;
  cout << "Index\tKey\tSize\tValue"   << endl;
  size = Int4VectorMap -> Size();
  UInt4 DumpSize = 22;

  for( UInt4 s=0; s<size; s++ ){
    cout << s << "\t"
	 << Int4VectorMap -> PutKey( s ) << "\t";

    vector<Int4> Vec = Int4VectorMap -> Put( s );
    UInt4 VecSize = (UInt4)(Vec . size());
    cout << VecSize << "\t";

    if( VecSize ==0 ){
      cout << "[ None ]" << endl;
    }
    else if( VecSize <= DumpSize ){
      cout << "[ ";
      for( UInt4 vs=0; vs<VecSize-1; vs++ ){
	cout << Vec[vs] << ",";
      }
      cout << Vec[VecSize-1] << " ]" << endl;
    }
    else{
      cout << "[";
      for( UInt4 vs=0; vs<DumpSize-2; vs++ ){
	cout << Vec[vs] << ",";
      }
      cout << Vec[DumpSize-2] << " ......]" << endl;
    }
  }
  cout << endl;

  cout << "***DoubleVectorMap***" << endl;
  cout << "Index\tKey\tSize\tValue"   << endl;
  size = DoubleVectorMap -> Size();

  for( UInt4 s=0; s<size; s++ ){
    cout << s << "\t"
	 << DoubleVectorMap -> PutKey( s ) << "\t";

    vector<Double> Vec = DoubleVectorMap -> Put( s );
    UInt4 VecSize = (UInt4)(Vec . size());
    cout << VecSize << "\t";
    
    if( VecSize ==0 ){
      cout << "[ None ]" << endl;
    }
    else if( VecSize <= DumpSize ){
      cout << "[ ";
      for( UInt4 vs=0; vs<VecSize-1; vs++ ){
	cout << Vec[vs] << ",";
      }
      cout << Vec[VecSize-1] << " ]" << endl;
    }
    else{
      cout << "[";
      for( UInt4 vs=0; vs<DumpSize-2; vs++ ){
	cout << Vec[vs] << ",";
      }
      cout << Vec[DumpSize-2] << " ......]" << endl;
    }
  }
  cout << endl;
  
  cout << "***StringVectorMap***" << endl;
  cout << "Index\tKey\tSize\tValue"   << endl;
  size = StringVectorMap -> Size();
  
  for( UInt4 s=0; s<size; s++ ){
    cout << s << "\t"
	 << StringVectorMap -> PutKey( s ) << "\t";
    
    vector<string> Vec = StringVectorMap -> Put( s );
    UInt4 VecSize = (UInt4)(Vec . size());
    cout << VecSize << "\t";
    
    if( VecSize ==0 ){
      cout << "[ None ]" << endl;
    }
    else if( VecSize <= DumpSize ){
      cout << "[ ";
      for( UInt4 vs=0; vs<VecSize-1; vs++ ){
	cout << "'" << Vec[vs] << "'" << ",";
      }
      cout << "'" << Vec[VecSize-1] << "'" << " ]" << endl;
    }
    else{
      cout << "[";
      for( UInt4 vs=0; vs<DumpSize-2; vs++ ){
	cout << "'" << Vec[vs] << "'" << ",";
      }
      cout << "'" << Vec[DumpSize-2] << "'" << " ......]" << endl;
    }
  }
  cout << endl;
}
////////////////////////////////////
Int4 HeaderBase::
PutInt4( string Key )
{
  UInt4 N = _keymap[Key];
  if( N == 1 ){
    return Int4Map->Put( Key );
  }

  else if( N == 2 ){
    return ( (Int4)( DoubleMap->Find( Key ) ) );
  }

  else if( N == 3 ){
    string s = StringMap->Find( Key );
    Char *c = new Char[ s.size()+1 ];
    strcpy( c, s.c_str() );
    c[ s.size() ] = '\0';

    if( strncmp( c, "0", 1 ) != 0 && atoi( c ) == 0 ){
      cout << "HeaderBase::PutInt4(string)" << endl;
      cout << "Failed in converting the variable "
	   << "from string to Int4." << endl;
      cout << "Anyway, returns zero." << endl;
    }

    Int4 r = atoi( c );
    delete [] c ;
    return r;
    //return atoi( c );
  }

  else{
    cout << "HeaderBase::PutInt4(string)"<< endl;
    cout << "\"" << Key << "\"" << " is not contained "
	 << "in this storage. Returns zero." << endl;
    return 0;
  }
  
  return 0;
}
////////////////////////////////////
Double HeaderBase::
PutDouble( string Key )
{
  UInt4 N = _keymap[Key];
  if( N == 2 ){
    return DoubleMap->Find( Key );
  }
  
  else if( N == 1 ){
    return (Double)( Int4Map->Put( Key ) );
  }

  else if( N == 3 ){
    string s = StringMap->Find( Key );
    Char *c = new Char[ s.size()+1 ];
    strcpy( c, s.c_str() );
    c[ s.size() ] = '\0';

    if( strncmp( c, "0", 1 ) != 0 && atof( c ) == 0.0 ){
      cout << "HeaderBase::PutDouble(string)" << endl;
      cout << "Failed in converting the variable "
	   << "from string to double." << endl;
      cout << "Anyway, returns zero." << endl;
    }

    Double r = atof( c );
    delete [] c ;
    return r;
    //return atof( c );
  }

  else{
    cout << "HeaderBase::PutDouble(string)"<< endl;
    cout << "\"" << Key << "\"" << " is not contained "
	 << "in this storage. Returns zero." << endl;
    return 0.0;
  }

  return 0.0;
}
////////////////////////////////////
string HeaderBase::
PutString( string Key )
{
  UInt4 N = _keymap[Key];
  if( N != 3 ){
    if( N == 1 ){
      Char buf[256];
      snprintf( buf, sizeof(buf), "%d", Int4Map->Put( Key ) );
      return ( string( buf ) );
    }
    if( N == 2 ){
      Char buf[256];
      snprintf( buf, sizeof(buf), "%.9f", DoubleMap->Put( Key ) );
      return ( string( buf ) );
    }
    if( N == 0 ) return "";
  }
  return StringMap->Put( Key );
}
////////////////////////////////////
vector<Int4> HeaderBase::
PutInt4Vector( string Key )
{
  Int4 N = Int4VectorMap->_Check( Key );
  if( N == -1 ){
    cout << "HeaderBase::PutInt4Vector(string)" << endl;
    cout << "Cannot find your key ! [" << Key << "]" << endl;
    cout << "Returns an empty vector." << endl;
    
    vector<Int4> vec;
    vec.clear();
    return vec;
  }
  return Int4VectorMap->Put( N );
}
////////////////////////////////////
vector<Double> HeaderBase::
PutDoubleVector( string Key )
{
  Int4 N = DoubleVectorMap->_Check( Key );
  if( N == -1 ){
    cout << "HeaderBase::PutDoubleVector(string)" << endl;
    cout << "Cannot find your key ! [" << Key << "]" << endl;
    cout << "Returns an empty vector." << endl;
    
    vector<Double> vec;
    vec.clear();
    return vec;
  }
  return DoubleVectorMap->Put( N );
}
////////////////////////////////////
vector<string> HeaderBase::
PutStringVector( string Key )
{
  Int4 N = StringVectorMap->_Check( Key );
  if( N == -1 ){
    cout << "HeaderBase::PutStringVector(string)" << endl;
    cout << "Cannot find your key ! [" << Key << "]" << endl;
    cout << "Returns an empty vector." << endl;

    vector<string> vec;
    vec.clear();
    return vec;
  }
  return StringVectorMap->Put( N );
}
////////////////////////////////////
void HeaderBase::
Search( string Key )
{
  switch(_keymap[Key]) {
  case 1:
    cout << Key << " is Int4." << endl;
    break;
  case 2:
    cout << Key << " is Double." << endl;
    break;
  case 3:
    cout << Key << " is String." << endl;
    break;
  case 4:
    cout << Key << " is Int4Vector." << endl;
    break;
  case 5:
    cout << Key << " is DoubleVector." << endl;
    break;
  case 6:
    cout << Key << " is StringVector." << endl;
    break;
  default:
    cout << Key << " is not found in this storage." << endl;
  }
}
////////////////////////////////////
void HeaderBase::
Erase( string Key )
{
  switch(_keymap[Key]) {
  case 1:
    Int4Map -> Remove( Key );
    break;
  case 2:
    DoubleMap -> Remove( Key );
    break;
  case 3:
    StringMap -> Remove( Key );
    break;
  case 4:
    Int4VectorMap -> Remove( Key );
    break;
  case 5:
    DoubleVectorMap -> Remove( Key );
    break;
  case 6:
    StringVectorMap -> Remove( Key );
    break;
  default:
    cout << "\"" << Key << "\"" 
	 << " cannot be found in the Maps," << endl;
    cout << "you should choose correct keys." << endl;
  }
  _keymap.erase(Key);
}
////////////////////////////////////
void HeaderBase::
clear()
{
  Int4Map   -> Clear();
  DoubleMap -> Clear();
  StringMap -> Clear();

  // Delete dynamically objects.
  // These functionality are not provided in "Map".

  //UInt4 size = Int4VectorMap -> Size();
  //for( UInt4 s=0; s<size; s++ ) delete Int4VectorMap->Put( s );
  //size = DoubleVectorMap -> Size();
  //for( UInt4 s=0; s<size; s++ ) delete DoubleVectorMap->Put( s );
  //size = StringVectorMap -> Size();
  //for( UInt4 s=0; s<size; s++ ) delete StringVectorMap->Put( s );

  Int4VectorMap   -> Clear();
  DoubleVectorMap -> Clear();
  StringVectorMap -> Clear();
}
