%include "carrays.i"
%include "std_string.i"
%include "std_vector.i"
%include "std_pair.i"
%include "VectorDef.i"

%{
#include "Header.hh"
#include "CollectArchitecture.hh"
#include "CppToPython.hh"
#include "DoubleBinArrange.hh"
#include "ElementContainer.hh"
#include "ElementContainerAppendError.hh"
#include "ElementContainerArray.hh"
#include "ElementContainerMatrix.hh"
#include "Header.hh"
#include "HeaderBase.hh"
#include "ManipulatorBase.hh"
#include "Map.hh"
#include "NeXusFileIO.hh"
#include "NeutronReadBinaryData.hh"
#include "NeutronVector.hh"
#include "NeutronWriteBinaryData.hh"
#include "OperatorBase.hh"
#include "PyRunOnCPP.hh"
#include "ReadNeXusFile.hh"
#include "ReadSerializationFile.hh"
#include "ReadWriteTextFile.hh"
#include "WriteTextFile.hh"
#include "SerialNeutronExchanger.hh"
#include "SimpleIOVectorToTextFile.hh"
#include "SplitString.hh"
#include "StlMapDouble.hh"
#include "StringTools.hh"
#include "SwapBytes.hh"
#include "TwoDimElementContainer.hh"
#include "UInt4Container.hh"
#include "UInt4ContainerArray.hh"
#include "UInt4ContainerMatrix.hh"
#include "WriteNeXusFile.hh"
#include "WriteSerializationFile.hh"
#include "GslHistogram.hh"
#include "GaussianEventData.hh"
#include "GslRandGenerator.hh"
#include "VectorTool.hh"
#include "ReadTextFile.hh"
#include "SerialPythonServerClient.hh"
#include "SearchInHeader.hh"
#include "ManyoDataIO.hh"


%}

%rename(equal) *::operator=;
%rename(__getitem__) ElementContainer::operator[];
%rename(__getitem__) NeutronVector::operator[];
%rename(__getitem__) ElementContainerArray::operator[];
%rename(__getitem__) ElementContainerMatrix::operator[];
%rename(__getitem__) UInt4Container::operator[];
%rename(__getitem__) UInt4ContainerArray::operator[];
%rename(__getitem__) UInt4ContainerMatrix::operator[];
%include "Header.hh"

%include "DoxySwig.i"

%include "TemplateDef.i"


%include "CollectArchitecture.hh"
%include "CppToPython.hh"
%include "DoubleBinArrange.hh"
%include "ElementContainer.hh"
%include "ElementContainerAppendError.hh"
%include "ElementContainerArray.hh"
%include "ElementContainerMatrix.hh"
%include "Header.hh"
%include "HeaderBase.hh"
%include "ManipulatorBase.hh"
%include "Map.hh"
%include "NeXusFileIO.hh"
%include "NeutronReadBinaryData.hh"
%include "NeutronVector.hh"
%include "NeutronWriteBinaryData.hh"
%include "OperatorBase.hh"
%include "PyRunOnCPP.hh"
%include "ReadNeXusFile.hh"
%include "ReadSerializationFile.hh"
%include "ReadWriteTextFile.hh"
%include "SerialNeutronExchanger.hh"
%include "SimpleIOVectorToTextFile.hh"
%include "SplitString.hh"
%include "StlMapDouble.hh"
%include "StringTools.hh"
%include "SwapBytes.hh"
%include "TwoDimElementContainer.hh"
%include "UInt4Container.hh"
%include "UInt4ContainerArray.hh"
%include "UInt4ContainerMatrix.hh"
%include "WriteNeXusFile.hh"
%include "WriteSerializationFile.hh"
%include "GslHistogram.hh"
%include "GaussianEventData.hh"
%include "GslRandGenerator.hh"
%include "VectorTool.hh"
%include "ReadTextFile.hh"
%include "WriteTextFile.hh"
%include "SerialPythonServerClient.hh"
%include "SearchInHeader.hh"
%include "ManyoDataIO.hh"

namespace std {
        %template(StringVector)  vector<string>;
        %template(Int2Vector)    vector<Int2>;
        %template(UInt2Vector)   vector<UInt2>;
        %template(Int4Vector)    vector<Int4>;
        %template(UInt4Vector)   vector<UInt4>;
        %template(Int8Vector)    vector<Int8>;
        %template(UInt8Vector)   vector<UInt8>;
        %template(FloatVector)   vector<Float>;
        %template(BoolVector)   vector<Bool>;
        %template(DoubleVector)  vector<Double>;
        %template(Int4VectorVector)  vector< vector<Int4> >; 
        %template(UInt4VectorVector)  vector< vector<UInt4> >; 
}

