/*
$Id: Map.cc 2247 2011-04-27 05:20:41Z jisuzuki $
*/


#include "Map.hh"
#ifndef MAP_CC
#define MAP_CC
///////////////////////////////////////////////////
template< class T >
Map< T >::
Map()
{
  KeyVector   = new vector< string >;
  ValueVector = new vector< T >;

  KeyVector   -> clear();
  ValueVector -> clear();
}
///////////////////////////////////////////////////
template< class T >
Map< T >::
~Map()
{
  delete KeyVector;
  delete ValueVector;
}
///////////////////////////////////////////////////
template< class T >
Map< T >::
Map(const Map<T> &ob)
{
  KeyVector   = new vector< string > (*ob.KeyVector);
  ValueVector = new vector< T > (*ob.ValueVector);
}
///////////////////////////////////////////////////
template< class T >
Map< T > Map< T >::
operator=(const Map<T> &ob)
{
  *KeyVector   = *ob.KeyVector;
  *ValueVector = *ob.ValueVector;

  return *this;
}
///////////////////////////////////////////////////
template< class T >
UInt4 Map< T >::
Size() const
{
  return (UInt4)(KeyVector -> size());
}
///////////////////////////////////////////////////
template< class T >
void Map< T >::
Add( string key, T value )
{
  Int4 s = _Check( key );

  if (s > -1) {

      cout << "Map::Add( string, T )" << endl;
      cout << "Your new key has been registered in this storage. ( " << key << ")" << endl;
      cout << "Please choose another key." << endl;
      return;
  }

  _Add(key, value);
}
///////////////////////////////////////////////////
template< class T >
void Map< T >::
_Add( string key, T value )
{
    KeyVector   -> push_back( key );
    ValueVector -> push_back( value );
}
///////////////////////////////////////////////////
template< class T >
T Map< T >::
Find( string key )
{
  Int4 s = _Check( key );

  if (s > -1) return (*ValueVector)[s];

  cout << "Map::Find(string)" << endl;
  cout << "Because the key of " << key 
       << " cannot be found in this storage," << endl;
  cout << "a value of zero is returned." << endl;
  //return ( T ) 0;
  T ret;
  return ret;
}
///////////////////////////////////////////////////
template< class T >
void Map< T >::
Clear()
{
  KeyVector   -> clear();
  ValueVector -> clear();
}
///////////////////////////////////////////////////
template< class T >
UInt4 Map< T >::
PutIndexNumber( string key )
{
  Int4 s = _Check( key );

  if (s > -1) return s;

  cout << "Map::PutIndexNumber(string)" << endl;
  cout << "Because the key of " << key 
       << " cannot be found in this storage," << endl;
  cout << "anyway a value of zero is returned." << endl;
  return 0;
  
}
///////////////////////////////////////////////////
template< class T >
void Map< T >::
Remove( UInt4 IndexNumber )
{  
  KeyVector   -> erase( KeyVector   -> begin()  + IndexNumber );
  ValueVector -> erase( ValueVector -> begin()  + IndexNumber );
}
///////////////////////////////////////////////////
template< class T >
void Map< T >::
Remove( string key )
{  
  Remove( PutIndexNumber( key ) );
}
///////////////////////////////////////////////////
template< class T >
void Map< T >::
Dump()
{
  UInt4 size = (UInt4)(KeyVector -> size());

  cout << "Index\tKey\tValue" << endl;
  for( UInt4 s=0; s<size; s++ ){
    cout << s              << "\t"
	 << *( KeyVector   -> begin() + s )   << endl;
  }

  /*
  UInt4 size = KeyVector -> size();

  cout << "Index\tKey\tValue" << endl;
  for( UInt4 s=0; s<size; s++ ){
    cout << s              << "\t"
	 << *( KeyVector   -> begin() + s )   << "\t"
	 << *( ValueVector -> begin() + s )   << endl;
  }
  */
}
///////////////////////////////////////////////////
template< class T >
UInt4 Map< T >::
Check( string Key )
{
  return (_Check( Key ) > -1) ? 1 : 0;
}
///////////////////////////////////////////////////
template< class T >
Int4 Map< T >::
_Check( string Key ) const
{
  UInt4 S = Size();

  for( UInt4 s=0; s<S; s++ ){
    if( ( *KeyVector )[s] == Key )
      return s;
  }
  return -1;
}
///////////////////////////////////////////////////
template< class T >
const T& Map< T >::
operator[]( const string &Key ) const
{
  Int4 i = _Check(Key);
  return (*ValueVector)[i];
}
///////////////////////////////////////////////////
template< class T >
T& Map< T >::
operator[]( const string &Key )
{
  Int4 i = _Check(Key);
  if (i==-1) {
    i = (Int4)(ValueVector->size());
    T t;
    KeyVector->push_back(Key);
    ValueVector->push_back(t);
  }
  return (*ValueVector)[i];
}

////////////////////////////////////
template< class T >
template <class Archive>
void Map<T>::
serialize(Archive &ar, const unsigned int ver) {
  ar & boost::serialization::
    make_nvp("KeyVector",   *KeyVector);
  ar & boost::serialization::
    make_nvp("ValueVector", *ValueVector);
}
#endif
