/*
$Id: ReadTextFile.cc 1597 2006-06-30 07:17:31Z suzuki $
*/


#include "ReadTextFile.hh"
/////////////////////////////////////////
ReadTextFile::
ReadTextFile()
{
  StringBuffer = NULL;
  split = NULL;
}
/////////////////////////////////////////
ReadTextFile::
~ReadTextFile()
{
  if( StringBuffer != NULL ) delete StringBuffer;
  if( split != NULL )        delete split;
}
/////////////////////////////////////////
void ReadTextFile::
SetFileName( string TargetFileName )
{
  Size = CheckFile( TargetFileName );

  if( StringBuffer != NULL ){
    delete StringBuffer;
    StringBuffer = NULL;
  }
  if( split != NULL ){
    delete split;
    split = NULL;
  }

  if( Size >0 ){
    StringBuffer = new vector< string >;
    split = new SplitString();
  }
  
  Read( TargetFileName );
}
/////////////////////////////////////////
UInt4 ReadTextFile::
PutSize(){
  if( StringBuffer == NULL ){
    return 0;
  }
  return (UInt4)(StringBuffer->size());
}
/////////////////////////////////////////
void ReadTextFile::
Dump()
{
  UInt4 Length = (UInt4)(StringBuffer -> size());
  for( UInt4 l=0; l<Length; l++ ){
    cout << l << "\t" << ( *StringBuffer )[l] << endl;
  }
}
/////////////////////////////////////////
string ReadTextFile::
Put( UInt4 IndexNumber )
{
  if( IndexNumber >= StringBuffer->size() ){
    cout << "\"IndexNumber\" should be smaller than "
	 << "the number of lines of the target file." << endl;
    return "zero";
  }
  return ( *StringBuffer )[IndexNumber];
}
//////////////////////////////////////////
vector<string> ReadTextFile::
Put( UInt4 IndexNumber, string Delimiter )
{
  return split -> PutStringArray( Put(IndexNumber), Delimiter );
}
//////////////////////////////////////////
UInt4 ReadTextFile::
CheckFile( string FileName )
{
  ifstream inputfile;
  inputfile.open( FileName.c_str() );
  if( !inputfile ){
    cout << "Cannot open " << FileName << " !" << endl;
    return 0;
  }

  UInt4 line = 0;
  char c;

  while( inputfile.get( c ) ){
    if( c == '\n' ){
      line++;
    }
  }
  
  inputfile.close();
  return line;
}
///////////////////////////////////////////
void  ReadTextFile::
Read( string FileName )
{
  ifstream inputfile;
  inputfile.open( FileName.c_str() );
  if( !inputfile ){
    cout << "Cannot open " << FileName << " !" << endl;
    return;
  }

  Char *c = new Char[2];
  c[0] = '\0'; 
  c[1] = '\0';

  string Buffer;
  Buffer.clear();

  while( inputfile.get( c[0] ) ){
    string cc( c );
    Buffer = Buffer + cc;
  }

  vector<string> v = split -> PutStringArray( Buffer, "\n" );
  UInt4 size = (UInt4)(v.size());
  for( UInt4 s=0; s<size; s++ ){
    StringBuffer -> push_back( v[s] );
  }
  
  inputfile.close();
  delete [] c;
}
///////////////////////////////////////////
