/*
$Id: StlMapDouble.cc 2110 2010-04-07 04:35:47Z jisuzuki $
*/


#include "StlMapDouble.hh"
////////////////////////////////////////////////
StlMapDouble ::
StlMapDouble()
{
}
////////////////////////////////////////////////
StlMapDouble ::
~StlMapDouble()
{
}
////////////////////////////////////////////////
StlMapDouble ::
StlMapDouble( const StlMapDouble &ob )
  : M(ob.M)
{
}
////////////////////////////////////////////////
StlMapDouble &StlMapDouble ::
operator=( const StlMapDouble &ob )
{
  M = ob.M;
  return *this;
}
////////////////////////////////////////////////
////////////////////////////////////////////////
Int8 StlMapDouble ::
PutIndexNumber( const string &Key )
{
  map< string, vector<Double> >::iterator ipi = M.begin();
  Int8 r = 0;
  while( ipi  != M.end() ){
    if( ipi->first == Key ){
      return r;
    }
    ipi++;
    r++;
  }
  return -1;
}
////////////////////////////////////////////////
vector<string> StlMapDouble ::
PutKeyList()
{
  vector<string> StrList;
  StrList.clear();
  
//  map< string, vector<Double> >::iterator p  = M.begin();
  map< string, vector<Double> >::iterator pe = M.end();
  
  for( map< string, vector<Double> >::iterator p = M.begin(); p != pe; p++ ){
    StrList.push_back( p -> first );
  }
  
  return StrList;
}
////////////////////////////////////////////////
void StlMapDouble ::
DumpKeyList()
{
  UInt4 i = 0;
  map< string, vector<Double> >::iterator pe = M.end();
  for( map< string, vector<Double> >::iterator p = M.begin(); p != pe; p++ ){
    cout << i++ << "\t" << p -> first << endl;
  }
}
////////////////////////////////////////////////
void StlMapDouble ::
Append( const string &key, vector<Double> &value )
{
  if( ( M.insert( pair< string, vector<Double> >( key, value ) ) ).second == 0 ){
    cout << key << " has already registered in this map." << endl;
    cout << "Please retry with the other key." << endl; 
  }
}
////////////////////////////////////////////////
/*
void StlMapDouble :: 
AppendP( string key, vector<Double> *value ){
  Append( key, *value );
}
*/
////////////////////////////////////////////////
vector<Double> &StlMapDouble ::
Put( const string &key )
{
  if( M.find( key ) == M.end() ){
    cout << key << " is not registered in this map." << endl;
    static vector<Double> tmp;
    return tmp;
  }
  return M[ key ];
}
////////////////////////////////////////////////
vector<Double> &StlMapDouble ::
Put( const UInt4 index )
{
  if( M.size() <= index ){
    cout << " The argument, index, is too large." << endl;
    static vector<Double> tmp;
    tmp.clear();
    return tmp;
  }

  map< string, vector<Double> >::iterator p = M.begin();
  
  for( UInt4 i=0; i<index; i++ ){
    p++;
  }
  return p->second;
}
////////////////////////////////////////////////
const vector<Double>& StlMapDouble ::
ref( const string &key ) const
{
  map< string, vector<Double> >::const_iterator p = M.find( key );
  if( p == M.end() ){
    cout << key << " is not registered in this map." << endl;
  }
  return p->second;
}
////////////////////////////////////////////////
const vector<Double>* StlMapDouble ::
PutPointer( const UInt4 index ) const
{
  if( M.size() <= index ){
    cout << " The argument, index, is too large." << endl;
    return NULL;
  }

  map< string, vector<Double> >::const_iterator p = M.begin();
  for( UInt4 i=0; i<index; i++ ){
    p++;
  }
  return &( p->second );
}
////////////////////////////////////////////////
void StlMapDouble ::
Erase( const string &key )
{
  if( M.find( key ) == M.end() ){
    cout << key << " has not registered in this map." << endl;
  }
  M.erase( key );  
}
////////////////////////////////////////////////
void StlMapDouble ::
Replace( const string &key, vector<Double> &value )
{
  if( M.find( key ) == M.end() ){
    cout << key << " has not registered in this map." << endl;
    return;
  }
  M[ key ] = value;
}
////////////////////////////////////////////////
void StlMapDouble ::
Copy( const string &OldKey, const string &NewKey )
{
  if( M.find( OldKey ) == M.end() ){
    cout << OldKey << " has not registered in this map." << endl;
    cout << OldKey << " is not copied." << endl;
    return;
  }
  M[ NewKey ] = M[ OldKey ];
}
////////////////////////////////////////////////
