/*
$Id: StringTools.hh 1903 2008-03-22 04:32:09Z jisuzuki $
*/


#include "Header.hh"

#ifndef STRINGTOOLS
#define STRINGTOOLS

//!Collection of string tools
/*!This class is the collection of string tools.
  A string is splited into string element with 
  a delimiter string by using "SplitString( string )".
 */
class StringTools
{
public:
  StringTools(){}
  /*!<Constructor. */
 ~StringTools(){}
  /*!<Destructor. */

  vector<string> SplitString( string s, string d, bool doTrim=true ); //[inamura 130621]
  vector<string> SplitString( string s );
  /*!<The given string is splited into the string
   elements with delimiters of "space", "comma" and "tab".
   The results is returned in the vector of string type.
   If argument d is set, d is used as a delimiter and
   "space" and "\n" are ignored when doTrim is true. [inamura 130621]
   */

  Double StringToDouble( string s );
  /*!<This method converts a given string into the 
   value of double.*/
  Float  StringToFloat( string s );
  /*!<This method converts a given string into the 
   value of float.*/
  Int4   StringToInt4( string s );
  /*!<This method converts a given string into the 
   integer.*/
  UInt4   StringToUInt4( string s );
  /*!<This method converts a given string into the 
   integer.*/
  
  string DoubleToString( Double d );
  /*!<This method converts a given value into a string.*/
  string FloatToString( Float f );
  /*!<This method converts a given value into a string.*/
  string Int4ToString( Int4 i );
  /*!<This method converts a given integer into a string.*/
  string UInt4ToString( UInt4 i );
  /*!< Converts an unsigned integer into a string. */

  string VecUInt4ToString( vector<UInt4> v );
  string VecInt4ToString( vector<Int4> v );
  string VecStringToString( vector<string> v );
  string VecDoubleToString( vector<Double> v );
  

};

#endif
