/*
$Id: VectorTool.cc 2292 2011-08-09 02:25:55Z jisuzuki $
*/


#include "VectorTool.hh"
//////////////////////////////////////////
vector<Double> VectorTool::
ArrayToVector( Double *p, UInt4 size )
{
  vector<Double> v; v.clear();
  for( UInt4 i=0; i<size; i++ ){
    v.push_back( *( p+i ) );
  }
  return v;
}
vector<Float>  VectorTool::
ArrayToVector( Float *p,  UInt4 size )
{
  vector<Float> v; v.clear();
  for( UInt4 i=0; i<size; i++ ){
    v.push_back( *( p+i ) );
  }
  return v;
}
vector<Int4>   VectorTool::
ArrayToVector( Int4 *p,   UInt4 size )
{
  vector<Int4> v; v.clear();
  for( UInt4 i=0; i<size; i++ )
    v.push_back( *( p+i ) );
  return v;
}
vector<UInt4>  VectorTool::
ArrayToVector( UInt4 *p,  UInt4 size )
{
  vector<UInt4> v; v.clear();
  for( UInt4 i=0; i<size; i++ )
    v.push_back( *( p+i ) );
  return v;
}
vector<Int2>   VectorTool::
ArrayToVector( Int2 *p,   UInt4 size )
{
  vector<Int2> v; v.clear();
  for( UInt4 i=0; i<size; i++ )
    v.push_back( *( p+i ) );
  return v;
}
vector<UInt2>  VectorTool::
ArrayToVector( UInt2 *p,  UInt4 size )
{
  vector<UInt2> v; v.clear();
  for( UInt4 i=0; i<size; i++ )
    v.push_back( *( p+i ) );
  return v;
}
vector<string> VectorTool::
ArrayToVector( string *p, UInt4 size )
{
  vector<string> v; v.clear();
  for( UInt4 i=0; i<size; i++ )
    v.push_back( *( p+i ) );
  return v;
}
vector<bool> VectorTool::
ArrayToVector( bool *p, UInt4 size )
{
  vector<bool> v; v.clear();
  for( UInt4 i=0; i<size; i++ )
    v.push_back( *( p+i ) );
  return v;
}
////////////////////////////////////////////////
vector<Double> VectorTool::
MakeVectorDouble( UInt4 size )
{ 
  vector<Double> v( size ); 
  for( UInt4 i=0; i<size; i++ )
    v[i] = (Double)i;
  return v; 
}
////////////////////////////////////////////////
vector<Float>  VectorTool::
MakeVectorFloat( UInt4 size )
{
  vector<Float> v( size ); 
  for( UInt4 i=0; i<size; i++ )
    v[i] = (Float)i;
  return v; 
}
////////////////////////////////////////////////
vector<Int4>   VectorTool::
MakeVectorInt4( Int4 size )
{
  vector<Int4> v( size ); 
  for( Int4 i=0; i<size; i++ )
    v[i] = (Int4)i;
  return v; 
}
////////////////////////////////////////////////
vector<UInt4>  VectorTool::
MakeVectorUInt4( UInt4 size )
{
  vector<UInt4> v( size ); 
  for( UInt4 i=0; i<size; i++ )
    v[i] = (UInt4)i;
  return v; 
}
////////////////////////////////////////////////
vector<Int2>   VectorTool::
MakeVectorInt2( Int2 size )
{
  vector<Int2> v( size ); 
  for( Int2 i=0; i<size; i++ )
    v[i] = 0;
  return v; 
}
////////////////////////////////////////////////
vector<UInt2>  VectorTool::
MakeVectorUInt2(  UInt2 size )
{
  vector<UInt2> v( size ); 
  for( UInt2 i=0; i<size; i++ )
    v[i] = 0;
  return v; 
}
////////////////////////////////////////////////
vector<string> VectorTool::
MakeVectorString(  UInt4 size )
{
  vector<string> v( size ); 
  for( UInt4 i=0; i<size; i++ )
    v[i] = "0";
  return v; 
}
////////////////////////////////////////////////
vector<string> VectorTool::
ReadVectorString( string FileName )
{
  ReadTextFile *rt = new ReadTextFile();
  rt -> SetFileName( FileName );
  UInt4 n = rt -> PutSize();
  
  vector<string> v; 
  for( UInt4 i=0; i<n; i++ ){
    v.push_back( rt->Put( i ) );
  }
  delete rt;
  return v; 
}
////////////////////////////////////////////////
vector<bool> VectorTool::
MakeVectorBool(  UInt4 size )
{
  vector<bool> v( size ); 
  for( UInt4 i=0; i<size; i++ )
    v[i] = 0;
  return v; 
}
////////////////////////////////////////////////
Double * VectorTool::
VectorToArray( vector<Double> v )
{
  UInt4 size = (UInt4)(v.size());
  Double *p = new Double [ size ];
  for( UInt4 i=0; i<size; i++ ) p[i] = v[i];
  return p;
}
Float  * VectorTool::
VectorToArray( vector<Float>  v )
{
  UInt4 size = (UInt4)(v.size());
  Float *p = new Float [ size ];
  for( UInt4 i=0; i<size; i++ ) p[i] = v[i];
  return p;
}
Int4   * VectorTool::
VectorToArray( vector<Int4>   v )
{
  UInt4 size = (UInt4)(v.size());
  Int4 *p = new Int4 [ size ];
  for( UInt4 i=0; i<size; i++ ) p[i] = v[i];
  return p;
}
UInt4  * VectorTool::
VectorToArray( vector<UInt4>  v )
{
  UInt4 size = (UInt4)(v.size());
  UInt4 *p = new UInt4 [ size ];
  for( UInt4 i=0; i<size; i++ ) p[i] = v[i];
  return p;
}
Int2   * VectorTool::
VectorToArray( vector<Int2>  v )
{
  UInt4 size = (UInt4)(v.size());
  Int2 *p = new Int2 [ size ];
  for( UInt4 i=0; i<size; i++ ) p[i] = v[i];
  return p;
}
UInt2  * VectorTool::
VectorToArray( vector<UInt2> v )
{
  UInt4 size = (UInt4)(v.size());
  UInt2 *p = new UInt2 [ size ];
  for( UInt4 i=0; i<size; i++ ) p[i] = v[i];
  return p;
}
string * VectorTool::
VectorToArray( vector<string> v )
{
  UInt4 size = (UInt4)(v.size());
  string *p = new string [ size ];
  for( UInt4 i=0; i<size; i++ ) p[i] = v[i];
  return p;
}
bool * VectorTool::
VectorToArray( vector<bool> v )
{
  UInt4 size = (UInt4)(v.size());
  bool *p = new bool [ size ];
  for( UInt4 i=0; i<size; i++ ) p[i] = v[i];
  return p;
}
//////////////////////////////////////////



////////////////////////////////////////////////
vector<Double>* VectorTool::
MakeVectorDoubleP( UInt4 size )
{ 
  vector<Double> *v = new vector<Double>( size ); 
  for( UInt4 i=0; i<size; i++ )
    ( *v )[i] = (Double)i;
  return v; 
}
////////////////////////////////////////////////
vector<Float>*  VectorTool::
MakeVectorFloatP(  UInt4 size )
{
  vector<Float> *v = new vector<Float>( size ); 
  for( UInt4 i=0; i<size; i++ )
    ( *v )[i] = (Float)i;
  return v; 
}
////////////////////////////////////////////////
vector<Int4>*   VectorTool::
MakeVectorInt4P(  Int4 size )
{
  vector<Int4> *v = new vector<Int4>( size ); 
  for( Int4 i=0; i<size; i++ )
    ( *v )[i] = (Int4)i;
  return v; 
}
////////////////////////////////////////////////
vector<UInt4>*  VectorTool::
MakeVectorUInt4P(  UInt4 size )
{
  vector<UInt4> *v = new vector<UInt4>( size ); 
  for( UInt4 i=0; i<size; i++ )
    ( *v )[i] = (UInt4)i;
  return v; 
}
////////////////////////////////////////////////
vector<Int2>*   VectorTool::
MakeVectorInt2P(  Int2 size )
{
  vector<Int2> *v = new vector<Int2>( size ); 
  for( Int2 i=0; i<size; i++ )
    ( *v )[i] = (Int2)i;
  return v; 
}
////////////////////////////////////////////////
vector<UInt2>*  VectorTool::
MakeVectorUInt2P(  UInt2 size )
{
  vector<UInt2> *v = new vector<UInt2>( size ); 
  for( UInt2 i=0; i<size; i++ )
    ( *v )[i] = (UInt2)i;
  return v; 
}
////////////////////////////////////////////////
vector<string>* VectorTool::
MakeVectorStringP(  UInt4 size )
{
  vector<string> *v = new vector<string>( size ); 
  for( UInt4 i=0; i<size; i++ )
    ( *v )[i] = "";
  return v; 
}
////////////////////////////////////////////////
vector<bool>* VectorTool::
MakeVectorBoolP(  UInt4 size )
{
  vector<bool> *v = new vector<bool>( size ); 
  for( UInt4 i=0; i<size; i++ )
    ( *v )[i] = 0;
  return v; 
}
////////////////////////////////////////////////
pair<Double,Double> VectorTool::
MakeDoubleDoublePair( Double First, Double Second ){
  pair<Double,Double> r;
  r.first  = First;
  r.second = Second;
  return r;
}
////////////////////////////////////////////////
