#!/usr/bin/env python
# -*- coding:utf-8 -*-

"""
Emaki package
dialog.EmakiSimpleDialog
Revision 0.1
Author: ITO, Takayoshi (CROSS)
Last update: Nov. 7th, 2012
"""

import wx

class EmakiSimpleDialog(wx.Dialog):
    def __init__(self, parent=None, title='', size=(240,240), queries = []):
        wx.Dialog.__init__(self, parent, wx.ID_ANY, title=title, size=size)
        self.tcResponses = []
        szMain = wx.BoxSizer(wx.VERTICAL)
        self.szItems = wx.FlexGridSizer(len(queries), 2, vgap = 5, hgap=5)
        for query in queries:
            self.szItems.Add(wx.StaticText(self, wx.ID_ANY, query[0]), flag=wx.ALL|wx.ALIGN_CENTER, border=5)
            self.tcResponses.append(wx.TextCtrl(self, wx.ID_ANY, query[1]))
            self.szItems.Add(self.tcResponses[-1], flag=wx.ALL|wx.ALIGN_CENTER, border=5)
            
        szButton = self.CreateButtonSizer(wx.OK|wx.CANCEL)
        szMain.Add(self.szItems)
        szMain.Add(szButton)
        self.SetSizer(szMain)

    def PutItems(self):
        rows = self.szItems.GetRows()
        responses = []
        for tc in self.tcResponses:
            responses.append(tc.GetValue())
        return responses

