// File: classAnaEnvironPeriodInfo.xml

%feature("docstring") AnaEnvironPeriodInfo "C++ includes: UtsusemiAnaEnvironReader.hh 

";
%feature("docstring") AnaEnvironPeriodInfo::AnaEnvironPeriodInfo "AnaEnvironPeriodInfo::AnaEnvironPeriodInfo() 

    
AnaEnvironPeriodInfo::AnaEnvironPeriodInfo(const AnaEnvironPeriodInfo &obj) 
";
%feature("docstring") AnaEnvironPeriodInfo::~AnaEnvironPeriodInfo "AnaEnvironPeriodInfo::~AnaEnvironPeriodInfo() 

";
// File: classCaseInfoReaderBase.xml

%feature("docstring") CaseInfoReaderBase "

    Load CaseInfo.xml.
    This is a base class to make classes to load CaseInfo.xml and store their imformation.
    C++ includes: CaseInfoReaderBase.hh 

";
%feature("docstring") CaseInfoReaderBase::CaseInfoReaderBase "CaseInfoReaderBase::CaseInfoReaderBase()
=========================================
    Constructor. 

    
CaseInfoReaderBase::CaseInfoReaderBase(string filename)
========================================================
    Constructor.

    Args:
        filename (string) the file name of CaseInfo to parse

    Returns:
        None 
";
%feature("docstring") CaseInfoReaderBase::~CaseInfoReaderBase "CaseInfoReaderBase::~CaseInfoReaderBase()
==========================================
    Destructor. 

";
%feature("docstring") CaseInfoReaderBase::ReadFile "bool CaseInfoReaderBase::ReadFile(string filename)
===================================================
    Read CaseInfo xml file to parse xml.

    Args:
        filename (string) the file name

    Returns:
        true
        false 

";
%feature("docstring") CaseInfoReaderBase::Clear "void CaseInfoReaderBase::Clear()
=================================
    Clear xml information.

    Args:
        None

    Returns:
        None
        None 

";
%feature("docstring") CaseInfoReaderBase::ImportCaseInfo "bool CaseInfoReaderBase::ImportCaseInfo(string filename=\"\")
==============================================================
    Analyze CaseInfo.

    Args:
        filename (string) The file name to be analyzed. If empty, use the parsed information.

    Returns:
        true
        false 

";
%feature("docstring") CaseInfoReaderBase::SetTimeSlicing "void CaseInfoReaderBase::SetTimeSlicing(vector< Double > tmp)
==============================================================
    Set the time slice information directly.
    tmp[(<caseId> - 1) * 2] : lower side of time range @caseId tmp[(<caseId> - 1) * 2 + 1] : upper side of time range @caseId

    Args:
        tmp (vector<Double>) CaseId and list of time range

    Returns:
        None 

";
// File: classConvManyoDoxy2Swig_1_1Doxy2SWIG.xml

%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG "

    Converts Doxygen generated XML files into a file containing docstrings that can be used by SWIG-1.3.x that have support for feature(\"docstring\").  Once the data is parsed it is stored in self.pieces. 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::__init__ "def ConvManyoDoxy2Swig.Doxy2SWIG.__init__(self, src)
=====================================================
    Initialize the instance given a source object (file or filename). 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::generate "def ConvManyoDoxy2Swig.Doxy2SWIG.generate(self)
================================================
    Parses the file set in the initialization.  The resulting data is stored in `self.pieces`. 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::parse "def ConvManyoDoxy2Swig.Doxy2SWIG.parse(self, node)
===================================================
    Parse a given node.  This function in turn calls the `parse_<nodeType>` functions which handle the respective nodes. 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::parse_Document "def ConvManyoDoxy2Swig.Doxy2SWIG.parse_Document(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::parse_Text "def ConvManyoDoxy2Swig.Doxy2SWIG.parse_Text(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::parse_Element "def ConvManyoDoxy2Swig.Doxy2SWIG.parse_Element(self, node)
===========================================================
    Parse an `ELEMENT_NODE`.  This calls specific `do_<tagName>` handers for different elements.  If no handler is available the `generic_parse` method is called.  All tagNames specified in `self.ignores` are simply ignored. 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::add_text "def ConvManyoDoxy2Swig.Doxy2SWIG.add_text(self, value)
=======================================================
    Adds text corresponding to `value` into `self.pieces`. 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::get_specific_nodes "def ConvManyoDoxy2Swig.Doxy2SWIG.get_specific_nodes(self, node, names)
=======================================================================
    Given a node and a sequence of strings in `names`, return a dictionary containing the names as keys and child `ELEMENT_NODEs`, that have a `tagName` equal to the name. 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::generic_parse "def ConvManyoDoxy2Swig.Doxy2SWIG.generic_parse(self, node, pad=0)
==================================================================
    A Generic parser for arbitrary tags in a node.  Parameters:   - node:  A node in the DOM.  - pad: `int` (default: 0)     If 0 the node data is not padded with newlines.  If 1 it    appends a newline after parsing the childNodes.  If 2 it    pads before and after the nodes are processed.  Defaults to    0. 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::space_parse "def ConvManyoDoxy2Swig.Doxy2SWIG.space_parse(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_compoundname "def ConvManyoDoxy2Swig.Doxy2SWIG.do_compoundname(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_compounddef "def ConvManyoDoxy2Swig.Doxy2SWIG.do_compounddef(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_includes "def ConvManyoDoxy2Swig.Doxy2SWIG.do_includes(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_parameterlist "def ConvManyoDoxy2Swig.Doxy2SWIG.do_parameterlist(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_para "def ConvManyoDoxy2Swig.Doxy2SWIG.do_para(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_parametername "def ConvManyoDoxy2Swig.Doxy2SWIG.do_parametername(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_parameterdefinition "def ConvManyoDoxy2Swig.Doxy2SWIG.do_parameterdefinition(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_detaileddescription "def ConvManyoDoxy2Swig.Doxy2SWIG.do_detaileddescription(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_briefdescription "def ConvManyoDoxy2Swig.Doxy2SWIG.do_briefdescription(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_memberdef "def ConvManyoDoxy2Swig.Doxy2SWIG.do_memberdef(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_definition "def ConvManyoDoxy2Swig.Doxy2SWIG.do_definition(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_sectiondef "def ConvManyoDoxy2Swig.Doxy2SWIG.do_sectiondef(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_simplesect "def ConvManyoDoxy2Swig.Doxy2SWIG.do_simplesect(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_argsstring "def ConvManyoDoxy2Swig.Doxy2SWIG.do_argsstring(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_member "def ConvManyoDoxy2Swig.Doxy2SWIG.do_member(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_doxygenindex "def ConvManyoDoxy2Swig.Doxy2SWIG.do_doxygenindex(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_programlisting "def ConvManyoDoxy2Swig.Doxy2SWIG.do_programlisting(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_codeline "def ConvManyoDoxy2Swig.Doxy2SWIG.do_codeline(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::do_highlight "def ConvManyoDoxy2Swig.Doxy2SWIG.do_highlight(self, node) 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::write "def ConvManyoDoxy2Swig.Doxy2SWIG.write(self, fname, mode='w') 

";
%feature("docstring") ConvManyoDoxy2Swig::Doxy2SWIG::clean_pieces "def ConvManyoDoxy2Swig.Doxy2SWIG.clean_pieces(self, pieces)
============================================================
    Cleans the list of strings given as `pieces`.  It replaces multiple newlines by a maximum of 2 and returns a new list. It also wraps the paragraphs nicely. 

";
// File: classD4MatGroup.xml

%feature("docstring") D4MatGroup "C++ includes: UtsusemiD4Matrix2.hh 

";
%feature("docstring") D4MatGroup::D4MatGroup "D4MatGroup::D4MatGroup() 

    
D4MatGroup::D4MatGroup(HeaderBase *hh) 
";
%feature("docstring") D4MatGroup::~D4MatGroup "D4MatGroup::~D4MatGroup() 

";
%feature("docstring") D4MatGroup::PutHeaderPointer "HeaderBase* D4MatGroup::PutHeaderPointer() 

";
%feature("docstring") D4MatGroup::PutPointer "D4MatOne* D4MatGroup::PutPointer(UInt4 i) 

";
%feature("docstring") D4MatGroup::PutSize "UInt4 D4MatGroup::PutSize() 

";
%feature("docstring") D4MatGroup::Save "bool D4MatGroup::Save(string filepath, bool withComp=false) 

";
%feature("docstring") D4MatGroup::Load "bool D4MatGroup::Load(string filepath) 

";
// File: classD4MatOne.xml

%feature("docstring") D4MatOne "C++ includes: UtsusemiD4Matrix2.hh 

";
%feature("docstring") D4MatOne::D4MatOne "D4MatOne::D4MatOne() 

    
D4MatOne::D4MatOne(const D4MatOne &p) 
";
%feature("docstring") D4MatOne::~D4MatOne "D4MatOne::~D4MatOne() 

";
%feature("docstring") D4MatOne::PutHeaderPointer "HeaderBase* D4MatOne::PutHeaderPointer() 

";
%feature("docstring") D4MatOne::Save "bool D4MatOne::Save(string filepath) 

    
bool D4MatOne::Save(ofstream &ofs) 
";
%feature("docstring") D4MatOne::Savez "bool D4MatOne::Savez(ofstream &ofs) 

";
%feature("docstring") D4MatOne::Load "bool D4MatOne::Load(ifstream &ifs) 

";
// File: classD4MatrixCalc.xml

%feature("docstring") D4MatrixCalc "

    Class for calculation between D4Matrix.
    C++ includes: D4MatrixCalc.hh 

";
%feature("docstring") D4MatrixCalc::D4MatrixCalc "D4MatrixCalc::D4MatrixCalc()
=============================
    Constructor. 

";
%feature("docstring") D4MatrixCalc::~D4MatrixCalc "D4MatrixCalc::~D4MatrixCalc()
==============================
    Destructor. 

";
%feature("docstring") D4MatrixCalc::OpenMat1 "void D4MatrixCalc::OpenMat1(string datapath, string paramfile)
===============================================================
    Opens the first D4Mat data file.

    Args:
        datapath (string) the path to the folder in which D4Mat data files are placed.
        paramfile (string) the file name of the parameter xml file of target D4Mat data

    Returns:
        None 

";
%feature("docstring") D4MatrixCalc::OpenMat2 "void D4MatrixCalc::OpenMat2(string datapath, string paramfile)
===============================================================
    Opens the second D4Mat data file.

    Args:
        datapath (string) the path to the folder in which D4Mat data files are placed.
        paramfile (string) the file name of the parameter xml file of target D4Mat data

    Returns:
        None 

";
%feature("docstring") D4MatrixCalc::CalcBetweenTwo "void D4MatrixCalc::CalcBetweenTwo(string ope, string outpath, string outparamfile)
===================================================================================
    Calculates between two D4Mat data opened by OpenMat1 and OpenMat2 with given operator.

    Args:
        ope (string) the operator for the calculation \"+\", \"-\", \"*\" or \"-\"
        outpath (string) the path to the directory to save calculated D4Mat data
        outparamfile (string) the file name of the parameter xml file to be saved.

    Returns:
        None 

    
void D4MatrixCalc::CalcBetweenTwo(string ope, Double coef1, Double coef2, string outpath, string outparamfile)
===============================================================================================================
    Calculates between two D4Mat data opened by OpenMat1 and OpenMat2 with given operator and coeficiencies.
    calculate between <coef1> * D4Mat1 and <coef2> * D4Mat2.

    Args:
        ope (string) the operator for the calculation \"+\", \"-\", \"*\" or \"-\"
        coef1 (double) the coeficiency to the first D4Mat data
        coef2 (double) the coeficiency to the second D4Mat data
        outpath (string) the path to the directory to save calculated D4Mat data
        outparamfile (string) the file name of the parameter xml file to be saved.

    Returns:
        None 
";
// File: classDetectorInfoEditorBase.xml

%feature("docstring") DetectorInfoEditorBase "C++ includes: DetectorInfoEditorBase.hh 

";
%feature("docstring") DetectorInfoEditorBase::DetectorInfoEditorBase "DetectorInfoEditorBase::DetectorInfoEditorBase()
=================================================
    Constructor. 

    
DetectorInfoEditorBase::DetectorInfoEditorBase(string dfile, bool workAsReader=true)
=====================================================================================
    Constructor.

    Args:
        dfile (string) DetectorInfo file path to be read
        workAsReader (bool) 
";
%feature("docstring") DetectorInfoEditorBase::~DetectorInfoEditorBase "DetectorInfoEditorBase::~DetectorInfoEditorBase()
==================================================
    Destructor. 

";
%feature("docstring") DetectorInfoEditorBase::Clear "void DetectorInfoEditorBase::Clear(UInt4 index=0)
==================================================
    Clears stored parameters.
    This deletes information by given index. index = 0 : all (default) index = 1 : InstrumentInfo index = 2 : TfpInfo index = 3 : TfpCalcParams index = 4 : PositionInfo index = 5 : BankInfo

    Args:
        index (UInt4)

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::Read "bool DetectorInfoEditorBase::Read(string arg)
==============================================
    Reads DetectorInfo.xml and import information.

    Args:
        arg (string) path/to/DetectorInfo.xml or DetectorInfo string

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::Write "bool DetectorInfoEditorBase::Write(string filepath)
====================================================
    Writes DetectorInfo.xml.

    Args:
        filepath (string)

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::OutXml "string DetectorInfoEditorBase::OutXml(bool withIndent=false)
=============================================================
    Returns DetectorInfo as string.

    Args:
        withIndent(bool) false : output text without an indent format

    Returns:
        string 

";
%feature("docstring") DetectorInfoEditorBase::ImportInstInfo "void DetectorInfoEditorBase::ImportInstInfo()
==============================================
    Import \"instrumentInfo\" from DetectorInfo.xml.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::_makeInstInfoXml "void DetectorInfoEditorBase::_makeInstInfoXml()
================================================
    make \"instrumentInfo\" xml element

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::ImportTfpInfo "void DetectorInfoEditorBase::ImportTfpInfo()
=============================================
    Import \"tfp\" info from DetectorInfo.xml.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::_makeTfpInfoXml "void DetectorInfoEditorBase::_makeTfpInfoXml()
===============================================
    make \"tfp\" xml element

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::ImportTfpCalcParams "void DetectorInfoEditorBase::ImportTfpCalcParams()
===================================================
    Import \"tfpCalcParams\" from DetectorInfo.xml.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::_makeTfpCalcParamsXml "void DetectorInfoEditorBase::_makeTfpCalcParamsXml()
=====================================================
    make \"tfpCalcParams\" xml element

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::ImportPosiInfo "void DetectorInfoEditorBase::ImportPosiInfo()
==============================================
    Import \"positionInfo\" from DetectorInfo.xml.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::_makePosiInfoXml "void DetectorInfoEditorBase::_makePosiInfoXml()
================================================
    make \"positionInfo\" xml element

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::ImportBankInfo "void DetectorInfoEditorBase::ImportBankInfo()
==============================================
    Import \"bankInfo\" from DetectorInfo.xml.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::_makeBankInfoXml "void DetectorInfoEditorBase::_makeBankInfoXml()
================================================
    make \"bankInfo\" xml element

    Args:
        None

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::Dump "void DetectorInfoEditorBase::Dump(Int4 index=DUMP_ALL)
=======================================================
    Shows imported information.

    Args:
        index (Int4)

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::_makeOutputXml "bool DetectorInfoEditorBase::_makeOutputXml()
==============================================
    Makes XML format from stored information.

    Args:
        None

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::SetInstInfoL1 "bool DetectorInfoEditorBase::SetInstInfoL1(Double _L1)
=======================================================
    Set L1 in InstrumentInfo.

    Args:
        L1 (Double) [mm]

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::SetInstInfoSamplePosition "bool DetectorInfoEditorBase::SetInstInfoSamplePosition(Double _px, Double _py, Double _pz)
===========================================================================================
    Set SamplePosition in InstrumentInfo.

    Args:
        _px (Double) [mm]
        _py (Double) [mm]
        _pz (Double) [mm]

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::SetInstInfoTypicalL2 "bool DetectorInfoEditorBase::SetInstInfoTypicalL2(Double _L2)
==============================================================
    Set the typical L2 in InstrumentInfo.
    which is used for the solid-angle correction

    Args:
        _L2 (Double) [mm]

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::SetInstInfoTypicalDS "bool DetectorInfoEditorBase::SetInstInfoTypicalDS(Double _dS)
==============================================================
    Set the typical dS (the area of one pixel) in InstrumentInfo.
    which is used for the solid-angle correction

    Args:
        _dS (Double) [mm]

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::SetTfpInfo "bool DetectorInfoEditorBase::SetTfpInfo(UInt4 pixId, Double A, Double B)
=========================================================================
    Set Time-focusing parameters (for ENG )

    Args:
        pixId (UInt4) pixel-Id
        A (Double) param A
        B (Double) param B

    Returns:
        true succeded
        false failed 

    
bool DetectorInfoEditorBase::SetTfpInfo(vector< UInt4 > pixIdList, vector< Double > AList, vector< Double > BList)
===================================================================================================================
    Set Time-focusing parameters (for ENG )

    Args:
        pixIdList (vector<UInt4>) list of pixId
        AList (vector<Double>) list of A
        BList (vector<Double>) list of B

    Returns:
        true succeded
        false failed 
";
%feature("docstring") DetectorInfoEditorBase::PutTfpInfo "vector< Double > DetectorInfoEditorBase::PutTfpInfo(UInt4 pixId)
=================================================================
    Put Tfp parameters of given pixId.

    Args:
        pixId (UInt4) pixel-Id

    Returns:
        vector<Double> returned A and B 

";
%feature("docstring") DetectorInfoEditorBase::DeleteTfpInfo "bool DetectorInfoEditorBase::DeleteTfpInfo(UInt4 pixId, bool isForced=false)
=============================================================================
    Delete Tfp parameters of given pixId.

    Args:
        pixId (UInt4) pixel-Id
        isForced (bool) execute without warning message

    Returns:
        true succeded
        false failed 

    
bool DetectorInfoEditorBase::DeleteTfpInfo(vector< UInt4 > pixIdList, bool isForced=false)
===========================================================================================
    Delete Tfp parameters of given pixId.

    Args:
        pixIdList (vector<UInt4>) list of pixel-Id
        isForced (bool) execute without warning message

    Returns:
        true succeded
        false failed 
";
%feature("docstring") DetectorInfoEditorBase::SetTfpCalcParamsPsdRef "bool DetectorInfoEditorBase::SetTfpCalcParamsPsdRef(Double psd_ref_l2, Double psd_ref_theta)
=============================================================================================
    Set Time-focusing Calculation Parameters.

    Args:
        psd_ref_l2 (Double) Reference L2
        psd_ref_theta (Double) Reference Theta

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::SetPositionInfo "bool DetectorInfoEditorBase::SetPositionInfo(UInt4 detId, UInt4 numAxis, vector< Double > params)
==================================================================================================
    Set Position info parameters.

    Args:
        detId (UInt4) detector ID
        numAxis (UInt4) the number of axes
        params (vector<Double>)

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::DeletePositionInfo "bool DetectorInfoEditorBase::DeletePositionInfo(UInt4 detId, bool isForced=false)
==================================================================================
    Delete Position info parameters of given detectorId.

    Args:
        detId (UInt4) detector ID
        isForced (bool) execute without warning message

    Returns:
        true succeded
        false failed 

    
bool DetectorInfoEditorBase::DeletePositionInfo(vector< UInt4 > detIdList, bool isForced=false)
================================================================================================
    Delete Position info parameters of given detectorId.

    Args:
        detIdList (vector<UInt4>) list of detId
        isForced (bool) execute without warning message

    Returns:
        true succeded
        false failed 
";
%feature("docstring") DetectorInfoEditorBase::PutPositionInfoNumAxis "UInt4 DetectorInfoEditorBase::PutPositionInfoNumAxis(UInt4 detId)
==================================================================
    Put NumAxis in Position info parameters of given detectorId.

    Args:
        detId (UInt4) detector ID

    Returns:
        UInt4 NumAxis 

";
%feature("docstring") DetectorInfoEditorBase::PutPositionInfoParams "vector< Double > DetectorInfoEditorBase::PutPositionInfoParams(UInt4 detId)
============================================================================
    Put parameters in Position info of given detectorId.

    Args:
        detId (UInt4) detector ID

    Returns:
        vector<Double> parameters 

";
%feature("docstring") DetectorInfoEditorBase::PutPositionInfoDetIdList "vector< UInt4 > DetectorInfoEditorBase::PutPositionInfoDetIdList()
===================================================================
    Put list of detId stored as Position Inof.

    Args:
        None

    Returns:
        vector<UInt4> list of detId 

";
%feature("docstring") DetectorInfoEditorBase::SetBankInfo "bool DetectorInfoEditorBase::SetBankInfo(UInt4 bankId, string bankName, string conts)
======================================================================================
    Set BankInfo.

    Args:
        bankId (UInt4) Bank ID
        bankName (string) Bank Name
        conts (string)

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::DeleteBankInfo "bool DetectorInfoEditorBase::DeleteBankInfo(UInt4 bankId)
==========================================================
    Delete BankInfo of given bankId.

    Args:
        bankId (UInt4) Bank ID

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::PutBankInfo "vector< string > DetectorInfoEditorBase::PutBankInfo(UInt4 bankId)
===================================================================
    Put BankInfo of given bankId.

    Args:
        bankId (UInt4) Bank ID

    Returns:
        vector<string> <BankName>,<Conts1,Conts2,...> 

";
%feature("docstring") DetectorInfoEditorBase::SetInfoAsReader "bool DetectorInfoEditorBase::SetInfoAsReader()
===============================================
    Converts WiringInfo into the format to be read from histogram creation methods.

    Args:
        None

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorBase::ClearReader "void DetectorInfoEditorBase::ClearReader(UInt4 index=0)
========================================================
    Clears the WiringInfo data to be read from histogram creation methods.

    Args:
        index (UInt4) index of variables to be cleared.

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorBase::PutInstL1 "Double DetectorInfoEditorBase::PutInstL1()
===========================================
    Put L1.

    Args:
        None

    Returns:
        Double L1[mm] 

";
%feature("docstring") DetectorInfoEditorBase::PutInstSamplePosition "vector< Double > DetectorInfoEditorBase::PutInstSamplePosition()
=================================================================
    Put Sample Position.

    Args:
        None

    Returns:
        vector<Double> [px,py,pz] [mm] 

";
%feature("docstring") DetectorInfoEditorBase::PutInstTypicalL2 "Double DetectorInfoEditorBase::PutInstTypicalL2()
==================================================
    Put the typical L2 stored.

    Args:
        None

    Returns:
        Double L2 [mm] 

";
%feature("docstring") DetectorInfoEditorBase::PutInstTypicalDS "Double DetectorInfoEditorBase::PutInstTypicalDS()
==================================================
    Put the typical dS (the area of one pixel) stored.

    Args:
        None

    Returns:
        Double dS [mm*mm] 

";
%feature("docstring") DetectorInfoEditorBase::PutBankIdList "vector< Int4 > DetectorInfoEditorBase::PutBankIdList()
=======================================================
    Puts List of Bank ID.

    Args:
        None

    Returns:
        List of BankId (vector<Int4>). 

";
%feature("docstring") DetectorInfoEditorBase::PutDetIdInBank "vector< Int4 > DetectorInfoEditorBase::PutDetIdInBank(UInt4 bankId)
====================================================================
    Puts range of DetId in Bank ID given by an argument.

    Args:
        bankId(UInt4) bank ID p *

    Returns:
        range of detId (vector<Int4>). 

    
vector< Int4 > DetectorInfoEditorBase::PutDetIdInBank(string bankName)
=======================================================================
    Puts range of DetId in Bank ID given by an argument.

    Args:
        bankName (String) bank Name

    Returns:
        range of detId (vector<Int4>). 
";
%feature("docstring") DetectorInfoEditorBase::PutBankName "vector< string > DetectorInfoEditorBase::PutBankName()
=======================================================
    Puts List of Banks name.
    attribute \"name\" in bank tag

    Args:
        None

    Returns:
        list of banks name (vector<string>). 

";
%feature("docstring") DetectorInfoEditorBase::PutTfp "vector< vector< Double > > * DetectorInfoEditorBase::PutTfp()
==============================================================
    Put Time focusing parameters loaded from DetectorInfo file.

    Args:
        None

    Returns:
        timeFocParam 

";
// File: classDetectorInfoEditorNeunet.xml

%feature("docstring") DetectorInfoEditorNeunet "C++ includes: DetectorInfoEditorNeunet.hh 

";
%feature("docstring") DetectorInfoEditorNeunet::DetectorInfoEditorNeunet "DetectorInfoEditorNeunet::DetectorInfoEditorNeunet()
=====================================================
    Constructor. 

    
DetectorInfoEditorNeunet::DetectorInfoEditorNeunet(string dfile, bool workAsReader=true)
=========================================================================================
    Constructor.

    Args:
        dfile (string) DetectorInfo file path to be read
        workAsReader (bool) 
";
%feature("docstring") DetectorInfoEditorNeunet::~DetectorInfoEditorNeunet "DetectorInfoEditorNeunet::~DetectorInfoEditorNeunet()
======================================================
    Destructor. 

";
%feature("docstring") DetectorInfoEditorNeunet::Clear "void DetectorInfoEditorNeunet::Clear(UInt4 index=0)
====================================================
    Clears stored parameters.
    This deletes information by given index. index = 0 : all (default) index = 1 : InstrumentInfo index = 2 : TfpInfo index = 3 : TfpCalcParams index = 4 : PositionInfo index = 5 : BankInfo

    Args:
        index (UInt4)

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorNeunet::Read "bool DetectorInfoEditorNeunet::Read(string arg)
================================================
    Reads DetectorInfo.xml and import information.

    Args:
        arg (string) path/to/DetectorInfo.xml or DetectorInfo as string

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") DetectorInfoEditorNeunet::Write "bool DetectorInfoEditorNeunet::Write(string filepath)
======================================================
    Writes DetectorInfo.xml.

    Args:
        filepath (string)

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") DetectorInfoEditorNeunet::OutXml "string DetectorInfoEditorNeunet::OutXml(bool withIndent=false)
===============================================================
    Returns DetectorInfo as string.

    Args:
        withIndent(bool) false : output text without an indent format

    Returns:
        string 

";
%feature("docstring") DetectorInfoEditorNeunet::_makeOutputXmlNeunet "bool DetectorInfoEditorNeunet::_makeOutputXmlNeunet()
======================================================
    Makes XML format from stored information.

    Args:
        None

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorNeunet::SetInfoAsReader "bool DetectorInfoEditorNeunet::SetInfoAsReader()
=================================================
    Converts WiringInfo into the format to be read from histogram creation methods.

    Args:
        None

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorNeunet::ClearReader "void DetectorInfoEditorNeunet::ClearReader(UInt4 index=0)
==========================================================
    Clears the WiringInfo data to be read from histogram creation methods.

    Args:
        index (UInt4) index of variables to be cleared.

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorNeunet::CalcPsdPixelPosition "vector< double > DetectorInfoEditorNeunet::CalcPsdPixelPosition(UInt4 det_id, UInt4 pixelNo, UInt4 numOfPixel)
===============================================================================================================
    Calculate pixel position.
    This calculates pixel position by given detector ID, Pixel no and number of pixels

    Args:
        det_id (UInt4) detector ID
        pixelNo (UInt4) pixel NO in a PSD of det_id ( 0 <= pixelNo < numOfPixel )
        numOfPixel (UInt4) the number of pixels in a PSD

    Returns:
        position (vector<double>) [px,py,pz] 

";
%feature("docstring") DetectorInfoEditorNeunet::CalcPsdPixelSolidAngle "Double DetectorInfoEditorNeunet::CalcPsdPixelSolidAngle(UInt4 det_id, UInt4 pixelNo, UInt4 numOfPixel)
=======================================================================================================
    Calculates Solid Angle by given detId and Pixel No.

    Args:
        det_id (UInt4)
        pixelNo (UInt4)
        numOfPixel (UInt4)

    Returns:
        None 

";
// File: classDetectorInfoEditorReadout2d.xml

%feature("docstring") DetectorInfoEditorReadout2d "C++ includes: DetectorInfoEditorReadout2d.hh 

";
%feature("docstring") DetectorInfoEditorReadout2d::DetectorInfoEditorReadout2d "DetectorInfoEditorReadout2d::DetectorInfoEditorReadout2d()
===========================================================
    Constructor. 

    
DetectorInfoEditorReadout2d::DetectorInfoEditorReadout2d(string dfile, bool workAsReader=true)
===============================================================================================
    Constructor.

    Args:
        dfile (string) DetectorInfo file path to be read
        workAsReader (bool) 
";
%feature("docstring") DetectorInfoEditorReadout2d::~DetectorInfoEditorReadout2d "DetectorInfoEditorReadout2d::~DetectorInfoEditorReadout2d()
============================================================
    Destructor. 

";
%feature("docstring") DetectorInfoEditorReadout2d::Clear "void DetectorInfoEditorReadout2d::Clear(UInt4 index=0)
=======================================================
    Clears stored parameters.
    This deletes information by given index. index = 0 : all (default) index = 1 : InstrumentInfo index = 2 : TfpInfo index = 3 : TfpCalcParams index = 4 : PositionInfo index = 5 : BankInfo

    Args:
        index (UInt4)

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorReadout2d::Read "bool DetectorInfoEditorReadout2d::Read(string arg)
===================================================
    Reads DetectorInfo.xml and import information.

    Args:
        arg (string) path/to/DetectorInfo.xml or DetectorInfo as string

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") DetectorInfoEditorReadout2d::Write "bool DetectorInfoEditorReadout2d::Write(string filepath)
=========================================================
    Writes DetectorInfo.xml.

    Args:
        filepath (string)

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") DetectorInfoEditorReadout2d::OutXml "string DetectorInfoEditorReadout2d::OutXml(bool withIndent=false)
==================================================================
    Returns DetectorInfo as string.

    Args:
        withIndent(bool) false : output text without an indent format

    Returns:
        string 

";
%feature("docstring") DetectorInfoEditorReadout2d::_makeOutputXmlReadout2d "bool DetectorInfoEditorReadout2d::_makeOutputXmlReadout2d()
============================================================
    Makes XML format from stored information.

    Args:
        None

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorReadout2d::SetInfoAsReader "bool DetectorInfoEditorReadout2d::SetInfoAsReader()
====================================================
    Converts WiringInfo into the format to be read from histogram creation methods.

    Args:
        None

    Returns:
        true succeded
        false failed 

";
%feature("docstring") DetectorInfoEditorReadout2d::ClearReader "void DetectorInfoEditorReadout2d::ClearReader(UInt4 index=0)
=============================================================
    Clears the WiringInfo data to be read from histogram creation methods.

    Args:
        index (UInt4) index of variables to be cleared.

    Returns:
        None 

";
%feature("docstring") DetectorInfoEditorReadout2d::CalcReadout2dPixelPosition "bool DetectorInfoEditorReadout2d::CalcReadout2dPixelPosition(UInt4 det_id, UInt4 x_size, UInt4 y_size, vector< vector< Double > * > *posi_vec)
===============================================================================================================================================
    Calculate pixel position.
    This calculates pixel position by given detector ID, Pixel size

    Args:
        det_id (UInt4) detector ID
        x_size (UInt4) x-axis size
        y_size (UInt4) y-axis size
        posi_vec (vector< vector<Double> >) Positions [pixelNo][axes] pixelNo= x_size*py + px

    Returns:
        true No Error
        false Error 

";
%feature("docstring") DetectorInfoEditorReadout2d::CalcReadout2dPixelSolidAngle "vector< Double > DetectorInfoEditorReadout2d::CalcReadout2dPixelSolidAngle(UInt4 det_id, UInt4 x_size, UInt4 y_size, vector< vector< Double > * > *posi_vec)
=============================================================================================================================================================
    Calculates Solid Angle by given detId and Pixel size.

    Args:
        det_id (UInt4)
        x_size (UInt4) x-axis size
        y_size (UInt4) y-axis size
        posi_vec (vector< vector<Double> >) Positions [pixelNo][axes] pixelNo= x_size*py + px

    Returns:
        vector of solid angle [pixelNo] 

";
// File: classDetectorInfoTagDefineBase.xml

%feature("docstring") DetectorInfoTagDefineBase "C++ includes: DetectorInfoEditorBase.hh 

";
%feature("docstring") DetectorInfoTagDefineBase::DetectorInfoTagDefineBase "DetectorInfoTagDefineBase::DetectorInfoTagDefineBase()
=======================================================
    Constructor. 

";
%feature("docstring") DetectorInfoTagDefineBase::~DetectorInfoTagDefineBase "DetectorInfoTagDefineBase::~DetectorInfoTagDefineBase()
========================================================
    Destructor. 

";
// File: classEventDataCreator.xml

%feature("docstring") EventDataCreator "

    Create Event data file from scinario in text.
    tt= EventDataCreator() evt=tt.encodePidClockEvent( 1111, 2000 ) evt.encode().hex() '5b000000000004575c00001f40000000' f=open(\"test.edb\",\"wb\") f.write(v.encode()) 16 f.close()
    C++ includes: UtsusemiEventDataCreator.hh 

";
%feature("docstring") EventDataCreator::EventDataCreator "EventDataCreator::EventDataCreator()
=====================================
    Constructor. 

";
%feature("docstring") EventDataCreator::~EventDataCreator "EventDataCreator::~EventDataCreator()
======================================
    Destructor. 

";
%feature("docstring") EventDataCreator::encodePidClockEvent "string EventDataCreator::encodePidClockEvent(int pid, double clock) 

";
%feature("docstring") EventDataCreator::encodeNeutronEvent "string EventDataCreator::encodeNeutronEvent(double tof, int mod, int psd) 

";
%feature("docstring") EventDataCreator::encodeTrignetEvent "string EventDataCreator::encodeTrignetEvent(double tof, int sid1, int sid2, int val1, int val2=0) 

";
%feature("docstring") EventDataCreator::output "bool EventDataCreator::output(string path_in, string path_n, string path_t) 

";
// File: classHistogramBinToPoint.xml

%feature("docstring") HistogramBinToPoint "

    Histogram format to points.
    This makes points data, which means that there is one-to-one correspondence between X-values ans Y-values ( not like Histogram ).
    C++ includes: HistogramBinToPoint.hh 

";
%feature("docstring") HistogramBinToPoint::HistogramBinToPoint "HistogramBinToPoint::HistogramBinToPoint()
===========================================
    Constructor. 

    
HistogramBinToPoint::HistogramBinToPoint(ElementContainer *ec)
===============================================================
    Constructor.

    Args:
        ec target ElementContainer 
";
%feature("docstring") HistogramBinToPoint::~HistogramBinToPoint "HistogramBinToPoint::~HistogramBinToPoint()
============================================
    Destructor. 

";
%feature("docstring") HistogramBinToPoint::Convert "void HistogramBinToPoint::Convert()
====================================
    executes conversion

    Returns:
        None 

";
%feature("docstring") HistogramBinToPoint::PutXo "vector<Double> HistogramBinToPoint::PutXo()
============================================
    Returns original X data.

    Returns:
        original X data as double vector 

";
%feature("docstring") HistogramBinToPoint::PutX "vector< Double > HistogramBinToPoint::PutX()
=============================================
    Returns X data of points.

    Returns:
        X data as double vector 

";
%feature("docstring") HistogramBinToPoint::PutY "vector< Double > HistogramBinToPoint::PutY()
=============================================
    Returns Y data of points.

    Returns:
        X data as double vector 

";
%feature("docstring") HistogramBinToPoint::PutE "vector< Double > HistogramBinToPoint::PutE()
=============================================
    Returns E data of points.

    Returns:
        E data as double vector 

";
%feature("docstring") HistogramBinToPoint::PutXList "PyObject* HistogramBinToPoint::PutXList()
==========================================
    Return the Python-List assigned to X-value.

    Returns:
        X data as list of python object 

";
%feature("docstring") HistogramBinToPoint::PutYList "PyObject* HistogramBinToPoint::PutYList()
==========================================
    Return the Python-List assigned to Y-value.

    Returns:
        Y data as list of python object 

";
%feature("docstring") HistogramBinToPoint::PutEList "PyObject* HistogramBinToPoint::PutEList()
==========================================
    Return the Python-List assigned to E-value.

    Returns:
        E data as list of python object 

";
// File: classNxspeFileIO.xml

%feature("docstring") NxspeFileIO "

    Tools for treating T0 event in eventdata.
    C++ includes: NxspeFileIO.hh 

";
%feature("docstring") NxspeFileIO::NxspeFileIO "NxspeFileIO::NxspeFileIO()
===========================
    Constructor. 

";
%feature("docstring") NxspeFileIO::~NxspeFileIO "NxspeFileIO::~NxspeFileIO()
============================
    Destructor. 

";
%feature("docstring") NxspeFileIO::SetData "bool NxspeFileIO::SetData(ElementContainerMatrix *ECM, Double angle=0.0, Double temperature=300.0)
===================================================================================================
    Sets ElementContainerMatrix to be saved as nxspe.

    Args:
        ECM (ElementContainerMatrxi*) The data to be saved.
        angle (Double) The angle value required by nxspe form.
        temperature (Double) The temperature value required by nxspe form.

    Returns:
        true
        false 

";
%feature("docstring") NxspeFileIO::SetSampleInfo "void NxspeFileIO::SetSampleInfo(Double angle, Double temperature)
==================================================================
    Sets sample information required by nxspe form.

    Args:
        angle (Double) The angle value required by nxspe form.
        temperature (Double) The temperature value required by nxspe form.

    Returns:
        None 

";
%feature("docstring") NxspeFileIO::Save "bool NxspeFileIO::Save(string filepath, string username=\"MLFuser\")
=====================================================================
    Save as nxspe.

    Args:
        filepath (string) File path.
        username (string) The username parameter required by nxspe.

    Returns:
        true
        false 

";
%feature("docstring") NxspeFileIO::Read "bool NxspeFileIO::Read(ElementContainerMatrix *ECM, string filepath, UInt4 pixelNo=100)
========================================================================================
    Read nxspe file.

    Args:
        ECM (ElementContainerMatrix) Empty container to be imported.
        filepath (string) File path.
        pixelNo (UInt) The number of pixels in a group as PSD.

    Returns:
        true
        false 

";
%feature("docstring") NxspeFileIO::Test "void NxspeFileIO::Test() 

";
// File: classShamotoDymPDF.xml

%feature("docstring") ShamotoDymPDF "C++ includes: ShamotoDymPDF.hh 

";
%feature("docstring") ShamotoDymPDF::ShamotoDymPDF "ShamotoDymPDF::ShamotoDymPDF(bool useMF=true)
==============================================
    Constructor. 

";
%feature("docstring") ShamotoDymPDF::~ShamotoDymPDF "ShamotoDymPDF::~ShamotoDymPDF()
================================
    Destructor. 

";
%feature("docstring") ShamotoDymPDF::SetData "void ShamotoDymPDF::SetData(ElementContainerMatrix *ecm)
=========================================================
    Set data to be calculated.

    Args:
        ecm (ElementContainerMatrix)

    Returns:
        None 

    
void ShamotoDymPDF::SetData(ElementContainerArray *eca)
========================================================
    Set data to be calculated.

    Args:
        eca (ElementContainerArray)

    Returns:
        None 
";
%feature("docstring") ShamotoDymPDF::SetSlicedData "void ShamotoDymPDF::SetSlicedData(ElementContainerArray *eca)
==============================================================
    Set the empty data container to be stored the sliced data by the Execute method.

    Args:
        eca (ElementContainerArray)

    Returns:
        None 

";
%feature("docstring") ShamotoDymPDF::SetSliceWidth "void ShamotoDymPDF::SetSliceWidth(Double delta_hw, Double min_hw=0.0, Double max_hw=0.0)
=========================================================================================
    Set parameters used for slicing along to energy axis.
    min_hw == max_hw means the use of all energy reange in data.

    Args:
        delta_hw (Double) Energy bin width
        min_hw (Double) Minimun value of enargy range
        max_hw (Double) Maximun value of enargy range

    Returns:
        None 

";
%feature("docstring") ShamotoDymPDF::SetCf "void ShamotoDymPDF::SetCf(Double cf)
=====================================
    Set correction factor parameters used for the magnetic form factor calculation.

    Args:
        cf (Double)

    Returns:
        None 

";
%feature("docstring") ShamotoDymPDF::SetMagFormFact "void ShamotoDymPDF::SetMagFormFact(Double _A1, Double _a2, Double _B1, Double _b2, Double _C1, Double _c2, Double _D)
======================================================================================================================
    Set parameters used for the magnetic form factor calculation.
    A1*exp(-a2*s*s) + B1*exp(-b2*s*s) + C1*exp(-c2*s*s) + D where s = Q/(4*PI)

    Args:
        _A1 (Double)
        _a2 (Double)
        _B1 (Double)
        _b2 (Double)
        _C1 (Double)
        _c2 (Double)
        _D (Double)

    Returns:
        None 

";
%feature("docstring") ShamotoDymPDF::Slice "bool ShamotoDymPDF::Slice(ElementContainerMatrix *ecm, ElementContainerArray *eca, Double delta_hw, Double min_hw=0.0, Double max_hw=0.0)
==========================================================================================================================================
    Do slice of the original data using the energy range and width given by SetSliceWidth.
    min_hw == max_hw means the use of all energy reange in data. G(r, E) is calcualted from this sliced data

    Args:
        ecm (ElementContainerMatrix) original data (S(Q,E))
        eca (ElementContainerArray) sliced data
        delta_hw (Double) Energy bin width
        min_hw (Double) Minimum value of enargy range
        max_hw (Double) Maximum value of enargy range

    Returns:
        true succeeded.
        false failed. 

";
%feature("docstring") ShamotoDymPDF::SetRRange "bool ShamotoDymPDF::SetRRange(Double dR, Double maxR)
======================================================
    Set r range of calculated data G(r, E)

    Args:
        dR (Double) bin width of r
        maxR (Double) Maximum value of r range

    Returns:
        true succeeded.
        false failed. 

";
%feature("docstring") ShamotoDymPDF::Execute "bool ShamotoDymPDF::Execute(bool doSlice=true)
===============================================
    Execute the calculation of G(r, E) from the sliced data.

    Args:
        doSlice (bool) plot S(Q, E) or not befor G(r, E) calculation.

    Returns:
        true succeeded.
        false failed. 

";
%feature("docstring") ShamotoDymPDF::TurnOffMF "void ShamotoDymPDF::TurnOffMF(bool off=true)
=============================================
    Change the flag to use the magnetic form factor when G(r, E) calculation.

    Args:
        off (bool) true means \"Not use the magnetic form factor\"

    Returns:
        None 

";
%feature("docstring") ShamotoDymPDF::PutResult "ElementContainerArray ShamotoDymPDF::PutResult(bool isXaxisR=true)
===================================================================
    Put the result G(r, E) or S(Q, E)

    Args:
        isXaxisR (bool) true means G(r, E) returns, false means S(Q, E)

    Returns:
        None 

";
%feature("docstring") ShamotoDymPDF::PutSlicedMap "ElementContainerArray ShamotoDymPDF::PutSlicedMap()
====================================================
    Put the sliced data S(Q, E)

    Args:
        None

    Returns:
        None 

";
%feature("docstring") ShamotoDymPDF::Test "bool ShamotoDymPDF::Test(string _inputfile, string _outputfile, ElementContainerArray *_eca)
=============================================================================================
    Test code.

    Args:
        _inputfile (string) test file path of sample 1d (hw, Intensity, Error) data at const hw
        _outputfile (string) output file path which is calcutated as G(r, hw)

    Returns:
        true succeeded.
        false failed. 

";
// File: classShamotoMagFormFact.xml

%feature("docstring") ShamotoMagFormFact "

    Magnetic Form factor s = Q/(4*PI) A1*exp(-a2*s*s) + B1*exp(-b2*s*s) + C1*exp(-c2*s*s) + D SetMagFormFact(A1, a2, B1, b2, C1, c2, D)
    DPDF = mu.ShamotoDymPDF() DPDF.SetData(DAT) DPDF.SetSliceWidth(0.2, 1.0, 12.5) DPDF.SetCf(74.84) DPDF.SetMagFormFact(0.4220, 17.684, 0.5948, 6.005, 0.0043, -0.609, -0.0219) DPDF.SetRRange(0.1, 40.0) DPDF.Execute() ECA = DPDF.PutResult(True)
    C++ includes: ShamotoDymPDF.hh 

";
%feature("docstring") ShamotoMagFormFact::ShamotoMagFormFact "ShamotoMagFormFact::ShamotoMagFormFact() 

";
%feature("docstring") ShamotoMagFormFact::~ShamotoMagFormFact "ShamotoMagFormFact::~ShamotoMagFormFact() 

";
%feature("docstring") ShamotoMagFormFact::Calc "Double ShamotoMagFormFact::Calc(Double Q) 

";
// File: classT0TreatToolsNeunet.xml

%feature("docstring") T0TreatToolsNeunet "

    Tools for treating T0 event in eventdata.
    C++ includes: T0TreatToolsNeunet.hh 

";
%feature("docstring") T0TreatToolsNeunet::T0TreatToolsNeunet "T0TreatToolsNeunet::T0TreatToolsNeunet()
=========================================
    Constructor. 

";
%feature("docstring") T0TreatToolsNeunet::~T0TreatToolsNeunet "T0TreatToolsNeunet::~T0TreatToolsNeunet()
==========================================
    Destructor. 

";
// File: classT0TreatToolsReadout.xml

%feature("docstring") T0TreatToolsReadout "

    Tools for treating T0 event in eventdata.
    C++ includes: T0TreatToolsReadout.hh 

";
%feature("docstring") T0TreatToolsReadout::T0TreatToolsReadout "T0TreatToolsReadout::T0TreatToolsReadout()
===========================================
    Constructor. 

";
%feature("docstring") T0TreatToolsReadout::~T0TreatToolsReadout "T0TreatToolsReadout::~T0TreatToolsReadout()
============================================
    Destructor. 

";
// File: classT0TreatToolsReadoutWLSF32.xml

%feature("docstring") T0TreatToolsReadoutWLSF32 "

    Tools for treating T0 event in eventdata.
    C++ includes: T0TreatToolsReadoutWLSF32.hh 

";
%feature("docstring") T0TreatToolsReadoutWLSF32::T0TreatToolsReadoutWLSF32 "T0TreatToolsReadoutWLSF32::T0TreatToolsReadoutWLSF32()
=======================================================
    Constructor. 

";
%feature("docstring") T0TreatToolsReadoutWLSF32::~T0TreatToolsReadoutWLSF32 "T0TreatToolsReadoutWLSF32::~T0TreatToolsReadoutWLSF32()
========================================================
    Destructor. 

";
// File: classTofToEnergyChoppers.xml

%feature("docstring") TofToEnergyChoppers "

    Function for converting Time-of-flight to Energy.
    This function requires header information as below : ElementContainerMatrix must have incident neutron energy value with \"L1\" key. ElementContainerArray (PSD) must have the type (\"PSD\" or \"MONITOR\") with \"TYPE\" key. ElementContainer (Pixel) must have pixel position information with \"PixelPosition\" key.
    ElementContainer must have Time of flight as Key-X. Units: L1 [mm], PixelPosition [mm], TOF offset [micro-sec]
    C++ includes: TofToEnergyChoppers.hh 

";
%feature("docstring") TofToEnergyChoppers::TofToEnergyChoppers "TofToEnergyChoppers::TofToEnergyChoppers()
===========================================
    Constructor. 

";
%feature("docstring") TofToEnergyChoppers::~TofToEnergyChoppers "TofToEnergyChoppers::~TofToEnergyChoppers()
============================================
    Destructor. 

";
%feature("docstring") TofToEnergyChoppers::TofToEnergy "void TofToEnergyChoppers::TofToEnergy(double Tof_offset)
=========================================================
    Convert TOF to EnergyTransfer.

    Args:
        Tof_offset Use this to shift the origin of TOF [micro-sec]

    Returns:
        None 

    
void TofToEnergyChoppers::TofToEnergy(double Tof_offset, vector< Double > new_bin)
===================================================================================
    Convert TOF to EnergyTransfer with rebinning.

    Args:
        Tof_offset use this to shift the origin of TOF [micro-sec]
        new_bin new binning of TOF

    Returns:
        None 
    
void TofToEnergyChoppers::TofToEnergy(double L1, double Tof_offset)
====================================================================
    Convert TOF to EnergyTransfer.

    Args:
        L1 the distanse between neutron source to sample position [mm]
        Tof_offset Use this to shift the origin of TOF [micro-sec]

    Returns:
        None 
    
void TofToEnergyChoppers::TofToEnergy(double L1, double Tof_offset, vector< Double > new_bin)
==============================================================================================
    Convert TOF to EnergyTransfer with rebinning.

    Args:
        L1 the distanse between neutron source to sample position [mm]
        Tof_offset use this to shift the origin of TOF [micro-sec]
        new_bin new binning of TOF

    Returns:
        None 
";
// File: classTofToEnergyTransfer.xml

%feature("docstring") TofToEnergyTransfer "

    Function for converting Time-of-flight to Energy Transfer.
    This function requires header information as below : ElementContainerMatrix must have incident neutron energy value with \"Ei\" key. ElementContainerArray (PSD) must have the type (\"PSD\" or \"MONITOR\") with \"TYPE\" key. ElementContainer (Pixel) must have pixel position information with \"PixelPosition\" key.
    ElementContainer must have Time of flight as Key-X. Units: L1 [mm], PixelPosition [mm], Tof_offset [micro-sec]
    C++ includes: TofToEnergyTransfer.hh 

";
%feature("docstring") TofToEnergyTransfer::TofToEnergyTransfer "TofToEnergyTransfer::TofToEnergyTransfer()
===========================================
    Constructor. 

";
%feature("docstring") TofToEnergyTransfer::~TofToEnergyTransfer "TofToEnergyTransfer::~TofToEnergyTransfer()
============================================
    Destructor. 

";
%feature("docstring") TofToEnergyTransfer::Tof2EnergyTransfer "void TofToEnergyTransfer::Tof2EnergyTransfer(double Tof_offset)
================================================================
    Convert TOF to EnergyTransfer.

    Args:
        Tof_offset Use this to shift the origin of TOF

    Returns:
        None 

    
void TofToEnergyTransfer::Tof2EnergyTransfer(double Tof_offset, vector< Double > new_bin)
==========================================================================================
    Convert TOF to EnergyTransfer with rebinning.

    Args:
        Tof_offset use this to shift the origin of TOF
        new_bin new binning of TOF

    Returns:
        None 
    
void TofToEnergyTransfer::Tof2EnergyTransfer(double L1, double Tof_offset)
===========================================================================
    Convert TOF to EnergyTransfer.

    Args:
        L1 the distanse between neutron source to sample position [mm]
        Tof_offset Use this to shift the origin of TOF [micro-sec]

    Returns:
        None 
    
void TofToEnergyTransfer::Tof2EnergyTransfer(double L1, double Tof_offset, vector< Double > new_bin)
=====================================================================================================
    Convert TOF to EnergyTransfer with rebinning.

    Args:
        L1 the distanse between neutron source to sample position [mm]
        Tof_offset use this to shift the origin of TOF [micro-sec]
        new_bin new binning of TOF

    Returns:
        None 
";
// File: classTreatD4Matrix2XmlParams.xml

%feature("docstring") TreatD4Matrix2XmlParams "C++ includes: UtsusemiD4Matrix2.hh 

";
%feature("docstring") TreatD4Matrix2XmlParams::TreatD4Matrix2XmlParams "TreatD4Matrix2XmlParams::TreatD4Matrix2XmlParams() 

    
TreatD4Matrix2XmlParams::TreatD4Matrix2XmlParams(string) 
";
%feature("docstring") TreatD4Matrix2XmlParams::~TreatD4Matrix2XmlParams "TreatD4Matrix2XmlParams::~TreatD4Matrix2XmlParams() 

";
%feature("docstring") TreatD4Matrix2XmlParams::AddRunNo "void TreatD4Matrix2XmlParams::AddRunNo(UInt4 _runNo, Double _startAngle) 

";
%feature("docstring") TreatD4Matrix2XmlParams::ClearRunNo "void TreatD4Matrix2XmlParams::ClearRunNo() 

";
%feature("docstring") TreatD4Matrix2XmlParams::ImportXmlString "bool TreatD4Matrix2XmlParams::ImportXmlString(string xmlstring, bool withDR=false) 

";
%feature("docstring") TreatD4Matrix2XmlParams::PutXmlString "string TreatD4Matrix2XmlParams::PutXmlString() 

";
%feature("docstring") TreatD4Matrix2XmlParams::Clear "void TreatD4Matrix2XmlParams::Clear(bool onlyD4Mat2=true) 

";
// File: classUtsusemiAnaEnvironReader.xml

%feature("docstring") UtsusemiAnaEnvironReader "C++ includes: UtsusemiAnaEnvironReader.hh 

";
%feature("docstring") UtsusemiAnaEnvironReader::UtsusemiAnaEnvironReader "UtsusemiAnaEnvironReader::UtsusemiAnaEnvironReader(string envFileName, string UtsusemiUserXmlPath=\"\") 

    
UtsusemiAnaEnvironReader::UtsusemiAnaEnvironReader(UInt4 runNo, bool isQuiet=false) 
";
%feature("docstring") UtsusemiAnaEnvironReader::~UtsusemiAnaEnvironReader "UtsusemiAnaEnvironReader::~UtsusemiAnaEnvironReader() 

";
%feature("docstring") UtsusemiAnaEnvironReader::Read "bool UtsusemiAnaEnvironReader::Read(string envFileName, string UtsusemiUserXmlPath=\"\") 

    
bool UtsusemiAnaEnvironReader::Read(UInt4 runNo, bool isQuiet=false) 
";
%feature("docstring") UtsusemiAnaEnvironReader::Parse "bool UtsusemiAnaEnvironReader::Parse(string evnFilePath) 

";
%feature("docstring") UtsusemiAnaEnvironReader::PutParamFiles "vector< string > UtsusemiAnaEnvironReader::PutParamFiles(UInt4 runNo, UInt4 modeNo=0, bool isFullPath=false) 

";
%feature("docstring") UtsusemiAnaEnvironReader::Dump "void UtsusemiAnaEnvironReader::Dump() 

";
// File: classUtsusemiCalcContainers.xml

%feature("docstring") UtsusemiCalcContainers "

    Calclation between Manyo Containers.
    C++ includes: UtsusemiCalcContainers.hh 

";
%feature("docstring") UtsusemiCalcContainers::UtsusemiCalcContainers "UtsusemiCalcContainers::UtsusemiCalcContainers()
=================================================
    Constructor. 

";
%feature("docstring") UtsusemiCalcContainers::~UtsusemiCalcContainers "UtsusemiCalcContainers::~UtsusemiCalcContainers()
==================================================
    Destructor. 

";
%feature("docstring") UtsusemiCalcContainers::CalcContainers "ElementContainer UtsusemiCalcContainers::CalcContainers(Double coef1, ElementContainer *ec1, string ope, Double coef2, ElementContainer *ec2)
==============================================================================================================================================
    Calculates between two ElementContainers.
    Formura : coef1*ec1 [\"+\",\"-\",\"*\",\"/\"] coef2*ec2

    Args:
        coef1 (Double) coefficient for ec1
        ec1 (ElementContainer*) first ElementContainer
        ope (string) operator between ec1 and ec2 must be \"+\",\"-\",\"*\" or \"/\".
        coef2 (Double) coefficient for ec2
        ec2 (ElementContainer*) second ElementContainer

    Returns:
        ElementContainer as calculation result 

    
ElementContainerArray UtsusemiCalcContainers::CalcContainers(Double coef1, ElementContainerArray *eca1, string ope, Double coef2, ElementContainerArray *eca2)
===============================================================================================================================================================
    Calculates between two ElementContainerArrays.
    Formura : coef1*eca1 [\"+\",\"-\",\"*\",\"/\"] coef2*eca2

    Args:
        coef1 (Double) coefficient for ec1
        eca1 (ElementContainerArray*) first ElementContainerArray
        ope (string) operator between ec1 and ec2 must be \"+\",\"-\",\"*\" or \"/\".
        coef2 (Double) coefficient for ec2
        eca2 (ElementContainerArray*) second ElementContainerArray

    Returns:
        ElementContainerArray as calculation result 
    
ElementContainerArray UtsusemiCalcContainers::CalcContainers(Double coef1, ElementContainerArray *eca, string ope, Double coef2, ElementContainer *ec)
=======================================================================================================================================================
    Calculates between ElementContainerArray and ElementContainer.
    Formura : coef1*eca [\"+\",\"-\",\"*\",\"/\"] coef2*ec ec operates to each ElementContainer in given ElementContainerArray

    Args:
        coef1 (Double) coefficient for eca
        eca (ElementContainerArray*) ElementContainerArray
        ope (string) operator between ec1 and ec2 must be \"+\",\"-\",\"*\" or \"/\".
        coef2 (Double) coefficient for ec
        ec (ElementContainer*) ElementContainer

    Returns:
        ElementContainerArray as calculation result 
    
ElementContainerMatrix UtsusemiCalcContainers::CalcContainers(Double coef1, ElementContainerMatrix *ecm1, string ope, Double coef2, ElementContainerMatrix *ecm2)
==================================================================================================================================================================
    Calculates between two ElementContainerMatrixs.
    Formura : coef1*ecm1 [\"+\",\"-\",\"*\",\"/\"] coef2*ecm2

    Args:
        coef1 (Double) coefficient for ecm1
        ecm1 (ElementContainerMatrix*) first ElementContainerMatrix
        ope (string) operator between ec1 and ec2 must be \"+\",\"-\",\"*\" or \"/\".
        coef2 (Double) coefficient for ecm2
        ecm2 (ElementContainerMatrix*) second ElementContainerMatrix

    Returns:
        ElementContainerMatrix as calculation result 
    
ElementContainerMatrix UtsusemiCalcContainers::CalcContainers(Double coef1, ElementContainerMatrix *ecm, string ope, Double coef2, ElementContainerArray *eca)
===============================================================================================================================================================
    Calculates between ElementContainerMatrix and ElementContainerArray.
    Formura : coef1*ecm [\"+\",\"-\",\"*\",\"/\"] coef2*eca eca operates to each ElementContainerArray in given ElementContainerMatrix

    Args:
        coef1 (Double) coefficient for ecm
        ecm (ElementContainerMatrix*) ElementContainerMatrix
        ope (string) operator between ec1 and ec2 must be \"+\",\"-\",\"*\" or \"/\".
        coef2 (Double) coefficient for eca
        eca (ElementContainerArray*) ElementContainerArray

    Returns:
        ElementContainerMatrix as calculation result 
    
ElementContainerMatrix UtsusemiCalcContainers::CalcContainers(Double coef1, ElementContainerMatrix *ecm, string ope, Double coef2, ElementContainer *ec)
=========================================================================================================================================================
    Calculates between ElementContainerMatrix and ElementContainer.
    Formura : coef1*ecm [\"+\",\"-\",\"*\",\"/\"] coef2*ec ec operates to each ElementContainer in given ElementContainerMatrix

    Args:
        coef1 (Double) coefficient for ecm
        ecm (ElementContainerMatrix*) ElementContainerMatrix
        ope (string) operator between ec1 and ec2 must be \"+\",\"-\",\"*\" or \"/\".
        coef2 (Double) coefficient for ec
        ec (ElementContainer*) ElementContainer

    Returns:
        ElementContainerMatrix as calculation result 
    
bool UtsusemiCalcContainers::CalcContainers(ElementContainerMatrix *ret_ecm, Double coef1, ElementContainerMatrix *ecm1, string ope, Double coef2, ElementContainerMatrix *ecm2)
=================================================================================================================================================================================
    Calculates faster between two ElementContainerMatrixs.
    Formura : coef1*ecm1 [\"+\",\"-\",\"*\",\"/\"] coef2*ecm2

    Args:
        ret_ecm (ElementContainerMatrix) Empty ElementContainerMatrix which calculated result is set.
        coef1 (Double) coefficient for ecm1
        ecm1 (ElementContainerMatrix*) first ElementContainerMatrix
        ope (string) operator between ec1 and ec2 must be \"+\",\"-\",\"*\" or \"/\".
        coef2 (Double) coefficient for ecm2
        ecm2 (ElementContainerMatrix*) second ElementContainerMatrix

    Returns:
        true succeeded
        false failed 
    
bool UtsusemiCalcContainers::CalcContainers(ElementContainerArray *ret_eca, Double coef1, ElementContainerArray *eca1, string ope, Double coef2, ElementContainerArray *eca2)
==============================================================================================================================================================================
    Calculates faster between two ElementContainerArrays.
    Formura : coef1*eca1 [\"+\",\"-\",\"*\",\"/\"] coef2*eca2

    Args:
        ret_eca (ElementContainerArray) Empty ElementContainerArray which calculated result is set.
        coef1 (Double) coefficient for ecm1
        eca1 (ElementContainerArray*) first ElementContainerArray
        ope (string) operator between ec1 and ec2 must be \"+\",\"-\",\"*\" or \"/\".
        coef2 (Double) coefficient for eca2
        eca2 (ElementContainerArray*) second ElementContainerArray

    Returns:
        true succeeded
        false failed 
";
%feature("docstring") UtsusemiCalcContainers::CheckOperator "UInt4 UtsusemiCalcContainers::CheckOperator(string ope)
========================================================
    Checks whether given operator is valid or not.

    Args:
        ope (string) operator between ec1 and ec2 must be \"+\",\"-\",\"*\" or \"/\".

    Returns:
        true ope is valid
        false invalid 

";
// File: classUtsusemiCaseInfoReaderTrignet.xml

%feature("docstring") UtsusemiCaseInfoReaderTrignet "

    Read Case info File and store information.
    for Trignet This can import case info File and store information for easy using to make histogram.
    C++ includes: UtsusemiCaseInfoReaderTrignet.hh 

";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::UtsusemiCaseInfoReaderTrignet "UtsusemiCaseInfoReaderTrignet::UtsusemiCaseInfoReaderTrignet()
===============================================================
    Constructor. 

    
UtsusemiCaseInfoReaderTrignet::UtsusemiCaseInfoReaderTrignet(string filename)
==============================================================================
    Constructor.

    Args:
        filename (string) path to CaseInfo.xml 
";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::~UtsusemiCaseInfoReaderTrignet "UtsusemiCaseInfoReaderTrignet::~UtsusemiCaseInfoReaderTrignet()
================================================================
    Destructor. 

";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::Initialize "void UtsusemiCaseInfoReaderTrignet::Initialize()
=================================================
    Initializes some parameters. 

";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::ImportCaseInfo "Int4 UtsusemiCaseInfoReaderTrignet::ImportCaseInfo(string filename=\"\")
=========================================================================
    Loads and stores CaseInfo.

    Args:
        filename (string) path to CaseInfo.xml 

";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::PutTrignetInfo "vector< vector< UtsusemiTrignetCondGroup * > * > * UtsusemiCaseInfoReaderTrignet::PutTrignetInfo()
===================================================================================================
    Puts whole stored information.

    Args:
        None

    Returns:
        Cases including Array for Condition-Group 

    
vector< UtsusemiTrignetCondGroup * > * UtsusemiCaseInfoReaderTrignet::PutTrignetInfo(UInt4 caseId)
===================================================================================================
    Puts stored information by a given caseId.

    Args:
        caseId (UInt4) caseId

    Returns:
        Array for Condition-Group 
";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::PutTrignetCounterInfo "vector<UtsusemiTrignetCounter*>* UtsusemiCaseInfoReaderTrignet::PutTrignetCounterInfo()
========================================================================================
    Puts stored information by a given caseId.

    Returns:
        instance of UtsusemiTrignetCounter 

";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::PutNumOfCases "UInt4 UtsusemiCaseInfoReaderTrignet::PutNumOfCases(bool isOnlyFilter=false)
============================================================================
    Puts the number of cases read in ImportCaseInfo.

    Args:
        None

    Returns:
        the number of stored cases 

";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::PutNumOfEachCases "pair< UInt4, UInt4 > UtsusemiCaseInfoReaderTrignet::PutNumOfEachCases() 

";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::DumpCases "void UtsusemiCaseInfoReaderTrignet::DumpCases(UInt4 caseId=0)
==============================================================
    Dumps stored Filter information briefly.

    Args:
        caseId (UInt4)

    Returns:
        None 

";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::DumpCases2 "void UtsusemiCaseInfoReaderTrignet::DumpCases2(UInt4 caseId=0)
===============================================================
    Dumps stored Filter information briefly.

    Args:
        caseId (UInt4)

    Returns:
        None 

";
%feature("docstring") UtsusemiCaseInfoReaderTrignet::DumpTrignetCounter "void UtsusemiCaseInfoReaderTrignet::DumpTrignetCounter()
=========================================================
    Dumps stored Counter information briefly.

    Args:
        None

    Returns:
        None 

";
// File: classUtsusemiCheckDataProcess.xml

%feature("docstring") UtsusemiCheckDataProcess "C++ includes: UtsusemiCheckDataProcess.hh 

";
%feature("docstring") UtsusemiCheckDataProcess::UtsusemiCheckDataProcess "UtsusemiCheckDataProcess::UtsusemiCheckDataProcess() 

";
%feature("docstring") UtsusemiCheckDataProcess::~UtsusemiCheckDataProcess "UtsusemiCheckDataProcess::~UtsusemiCheckDataProcess() 

";
%feature("docstring") UtsusemiCheckDataProcess::CheckProcess "bool UtsusemiCheckDataProcess::CheckProcess(ElementContainerMatrix *ecm, string process, bool isExact=true) 

    
bool UtsusemiCheckDataProcess::CheckProcess(ElementContainerArray *eca, string process, bool isExact=true) 
    
bool UtsusemiCheckDataProcess::CheckProcess(ElementContainer *ec, string process, bool isExact=true) 
";
%feature("docstring") UtsusemiCheckDataProcess::AddProcess "void UtsusemiCheckDataProcess::AddProcess(ElementContainerMatrix *ecm, string process) 

    
void UtsusemiCheckDataProcess::AddProcess(ElementContainerArray *eca, string process) 
    
void UtsusemiCheckDataProcess::AddProcess(ElementContainer *ec, string process) 
";
%feature("docstring") UtsusemiCheckDataProcess::RemoveProcess "void UtsusemiCheckDataProcess::RemoveProcess(ElementContainerMatrix *ecm, string process, bool isExact=true) 

    
void UtsusemiCheckDataProcess::RemoveProcess(ElementContainerArray *eca, string process, bool isExact=true) 
    
void UtsusemiCheckDataProcess::RemoveProcess(ElementContainer *ec, string process, bool isExact=true) 
";
// File: classUtsusemiContainerTextConverter.xml

%feature("docstring") UtsusemiContainerTextConverter "

    Save data in Manyo Containers as text file.
    C++ includes: UtsusemiContainerTextConverter.hh 

";
%feature("docstring") UtsusemiContainerTextConverter::UtsusemiContainerTextConverter "UtsusemiContainerTextConverter::UtsusemiContainerTextConverter() 

    
UtsusemiContainerTextConverter::UtsusemiContainerTextConverter(ElementContainer *_EC) 
    
UtsusemiContainerTextConverter::UtsusemiContainerTextConverter(ElementContainerArray *_ECA) 
    
UtsusemiContainerTextConverter::UtsusemiContainerTextConverter(ElementContainerMatrix *_ECM) 
";
%feature("docstring") UtsusemiContainerTextConverter::~UtsusemiContainerTextConverter "UtsusemiContainerTextConverter::~UtsusemiContainerTextConverter() 

";
%feature("docstring") UtsusemiContainerTextConverter::SetTarget "void UtsusemiContainerTextConverter::SetTarget(ElementContainer *_EC) 

    
void UtsusemiContainerTextConverter::SetTarget(ElementContainerArray *_ECA) 
    
void UtsusemiContainerTextConverter::SetTarget(ElementContainerMatrix *_ECM) 
";
%feature("docstring") UtsusemiContainerTextConverter::Save "bool UtsusemiContainerTextConverter::Save(string filename) 

    
bool UtsusemiContainerTextConverter::Save(string filename, ElementContainer *_EC) 
    
bool UtsusemiContainerTextConverter::Save(string filename, ElementContainerArray *_ECA) 
    
bool UtsusemiContainerTextConverter::Save(string filename, ElementContainerMatrix *_ECM) 
";
%feature("docstring") UtsusemiContainerTextConverter::Load "bool UtsusemiContainerTextConverter::Load(string filename, ElementContainer *_EC) 

    
bool UtsusemiContainerTextConverter::Load(string filename, ElementContainerArray *_ECA) 
    
bool UtsusemiContainerTextConverter::Load(string filename, ElementContainerMatrix *_ECM) 
";
// File: classUtsusemiD4Matrix.xml

%feature("docstring") UtsusemiD4Matrix "

    Class for treating 4-dimensional data.
    This can import and conbine several data of single crystal sample with dirrent conditions produced from VisualCont2.
    C++ includes: UtsusemiD4Matrix.hh 

";
%feature("docstring") UtsusemiD4Matrix::UtsusemiD4Matrix "UtsusemiD4Matrix::UtsusemiD4Matrix()
=====================================
    Constructor. 

    
UtsusemiD4Matrix::UtsusemiD4Matrix(bool isDebugMode)
=====================================================
    Constructor.

    Args:
        isDebugMode shows some comments and parameters on executing. 
";
%feature("docstring") UtsusemiD4Matrix::~UtsusemiD4Matrix "UtsusemiD4Matrix::~UtsusemiD4Matrix()
======================================
    Destructor. 

";
%feature("docstring") UtsusemiD4Matrix::SetEf "bool UtsusemiD4Matrix::SetEf(double _ef) 

";
%feature("docstring") UtsusemiD4Matrix::PutEf "Double UtsusemiD4Matrix::PutEf() 

";
%feature("docstring") UtsusemiD4Matrix::SetMaxSizeOfBlock "void UtsusemiD4Matrix::SetMaxSizeOfBlock(Double _size)
=======================================================
    Sets maximum file size for one block of allocated D4Matrix binary file.
    All file size can not be exceeded this size

    Args:
        _size (Double) maximum file size

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::AllocateNewMat "void UtsusemiD4Matrix::AllocateNewMat(vector< Double > a1range, vector< Double > a2range, vector< Double > a3range, vector< Double > a4range, vector< string > titles, vector< string > units, string data_dir, string paramfile) 

    
bool UtsusemiD4Matrix::AllocateNewMat(PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *titles, PyObject *units, string data_dir, string paramfile)
========================================================================================================================================================================================
    Makes new D4Matrix files on disk.
    Each range consists of three values, start, end and width.

    Args:
        a1range first axis range
        a2range second axis range
        a3range third axis range
        a4range fourth axis range
        titles titles for axes
        units units for axes
        data_dir path to data dir (including xml file)
        paramfile file name of parameter xml file

    Returns:
        False Failed.
        True Succeeded. 
";
%feature("docstring") UtsusemiD4Matrix::OpenMat "bool UtsusemiD4Matrix::OpenMat(string datapath, string paramfile)
==================================================================
    Open D4Matrix files existing on disk.
    Read parameter file and open file pointers given by parameters.

    Args:
        datapath path to data dir
        paramfile file name of parameter xml file

    Returns:
        False Failed.
        True Succeeded. 

";
%feature("docstring") UtsusemiD4Matrix::CloseMat "void UtsusemiD4Matrix::CloseMat()
==================================
    Closes opened D4Matrix files.
    Close all file pointers opened by _OpenDat method.

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::isMatOpened "bool UtsusemiD4Matrix::isMatOpened()
=====================================
    Returns whether D4Matrix files are opened or not.

    Returns:
        true D4Matrix files are opened.
        false Not opened. 

";
%feature("docstring") UtsusemiD4Matrix::isStatusOK "bool UtsusemiD4Matrix::isStatusOK()
====================================
    Returns status of results to be executed.

    Returns:
        true OK.
        false Bad. 

";
%feature("docstring") UtsusemiD4Matrix::AddToMatFromText "void UtsusemiD4Matrix::AddToMatFromText(string filename)
=========================================================
    Adds TEXT data to D4Matrix files.
    Read TEXT data produced by VisualCont2 and add these values to D4Matrix files

    Args:
        filename full path to parameter

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::AddToMatFromPyList "Int4 UtsusemiD4Matrix::AddToMatFromPyList(string title, PyObject *ax1, PyObject *ax2, PyObject *ax3, PyObject *ax4, PyObject *ii, PyObject *ee)
================================================================================================================================================
    Adds python List object data to D4Matrix files.
    Adds Sliced data produced by VisualCont2 to D4Matrix files

    Args:
        title string which indicates this data
        ax1 Python list object for AX1
        ax2 Python list object for AX2
        ax3 Python list object for AX3
        ax4 Python list object for AX4
        ii Python list object for Intensity
        ee Python list object for Error

    Returns:
        0 No Error
        -1 Error 

";
%feature("docstring") UtsusemiD4Matrix::SubtractFromMatByText "void UtsusemiD4Matrix::SubtractFromMatByText(string filename)
==============================================================
    Subtracts TEXT data from D4Matrix files.
    Read TEXT data produced by VisualCont2 and subtract these values from D4Matrix files

    Args:
        filename full path to parameter

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::AddToMatFromBin "bool UtsusemiD4Matrix::AddToMatFromBin(string filename)
========================================================
    Adds BINARY data to D4Matrix files.
    Read binary data converted from TEXT data of VisualCont2 and add these values to D4Matrix files

    Args:
        filename full path to parameter 

";
%feature("docstring") UtsusemiD4Matrix::AddToMatFromBinFolder "bool UtsusemiD4Matrix::AddToMatFromBinFolder(string folderpath, string _ext=\".vbin\") 

";
%feature("docstring") UtsusemiD4Matrix::SubtractFromMatByBin "void UtsusemiD4Matrix::SubtractFromMatByBin(string filename)
=============================================================
    Subtracts BINARY data from D4Matrix files.
    Read binary data converted from TEXT data of VisualCont2 and subtract these values from D4Matrix files

    Args:
        filename full path to parameter

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::SliceMat "void UtsusemiD4Matrix::SliceMat(vector< Double > a1range, vector< Double > a2range, vector< Double > a3range, vector< Double > a4range, vector< string > def_axes, vector< Double > foldings) 

    
bool UtsusemiD4Matrix::SliceMat(PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *def_axes, PyObject *foldings)
====================================================================================================================================================
    Slices D4Matrix by parameters.
    Picks up the region given by parameters from D4Matrix and make vector data for visualization. Users can set 4 axes ranges and the role of each axis by using string \"X\", \"Y\" and \"T\". \"X\" and \"Y\" mean X and Y axis on visualization. Two axes indicated by \"T\" are summarized. Each range must consits of two values, begin and end;

    Args:
        a1range (list of float) first axis range [min, max]
        a2range (list of float) second axis range [min, max]
        a3range (list of float) third axis range [min, max]
        a4range (list of float) fourth axis range [min, max]
        def_axes (list of str) role of each axis, for example [ \"X\", \"Y\", \"T\", \"T\" ]
        foldings (list of float) folding values, [] means [ -1, -1, -1, -1]

    Returns:
        False Failed.
        True Succeeded. 
";
%feature("docstring") UtsusemiD4Matrix::SliceMat1d "void UtsusemiD4Matrix::SliceMat1d(vector< Double > a1range, vector< Double > a2range, vector< Double > a3range, vector< Double > a4range, vector< string > def_axes, vector< Double > foldings) 

";
%feature("docstring") UtsusemiD4Matrix::Slice2d "bool UtsusemiD4Matrix::Slice2d(ElementContainerArray *_eca, PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *def_axes, PyObject *foldings)
================================================================================================================================================================================
    Slices D4Matrix by parameters from Python.
    Picks up the region given by parameters from D4Matrix and make vector data for visualization. Users can set 4 axes ranges and the role of each axis by using string \"X\", \"Y\" and \"T\". \"X\" and \"Y\" mean X and Y axis on visualization. Two axes indicated by \"T\" are summarized. Each range must consits of two values, begin and end;

    Args:
        a1range (list of float) first axis range [min, max]
        a2range (list of float) second axis range [min, max]
        a3range (list of float) third axis range [min, max]
        a4range (list of float) fourth axis range [min, max]
        def_axes (list of str) role of each axis, for example [ \"X\", \"Y\", \"T\", \"T\" ]
        foldings (list of float) folding values, [] means [ -1, -1, -1, -1]

    Returns:
        False Failed.
        True Succeeded. 

    
ElementContainerArray UtsusemiD4Matrix::Slice2d(PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *def_axes, PyObject *foldings) 
";
%feature("docstring") UtsusemiD4Matrix::PutSliceResults "vector< Double > UtsusemiD4Matrix::PutSliceResults(UInt4 type, UInt4 Xindex)
=============================================================================
    Put Sliced data as vector.
    Put vector made by SliceMat. This method puts a vector with X index.'type' indicates the type of data.

    Args:
        type indicates data type 0:Intensity, 1:Error, 2:X array, 3:Y array
        Xindex indicates index of vectors of Intensity and Error.

    Returns:
        string vector 

";
%feature("docstring") UtsusemiD4Matrix::PickUpInten "vector< Double > UtsusemiD4Matrix::PickUpInten(Double a1, Double a2, Double a3, Double a4)
===========================================================================================
    Picks up data at a point on D4Matrix.
    Picks up data at a point indicated by given parameters and show its intensity and error.

    Args:
        a1 A1 axis
        a2 A2 axis
        a3 A3 axis
        a4 A4 axis

    Returns:
        vector of two values for intensity and error. 

";
%feature("docstring") UtsusemiD4Matrix::ReplaceInten "void UtsusemiD4Matrix::ReplaceInten(Double a1, Double a2, Double a3, Double a4, Double Inten, Double Error, Double Counts)
===========================================================================================================================
    Replaces data at a point on D4Matrix.
    Replaces data at a point indicated by given parameters with given Intensity, Error and Counts.

    Args:
        a1 A1 axis
        a2 A2 axis
        a3 A3 axis
        a4 A4 axis
        Inten Value for Intensity to be replaced
        Error Value for Error to be replaced
        Counts Value for the number of summarized data

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::PutSlicedECA "ElementContainerArray UtsusemiD4Matrix::PutSlicedECA()
=======================================================
    Puts Sliced data as ElementContainerArray.
    Sliced data are stored in list of vectors. This method constructs ElementContainerArray from these vectors. ElementContainerArray can be sent to M2Plot directly.

    Returns:
        ElementContainerArray 

";
%feature("docstring") UtsusemiD4Matrix::PutFileComponents "vector<string> UtsusemiD4Matrix::PutFileComponents()
=====================================================
    Puts list for file component of D4Matrix.

    Returns:
        file_components 

";
%feature("docstring") UtsusemiD4Matrix::PutAxRange "vector< Double > UtsusemiD4Matrix::PutAxRange(UInt4 i_ax)
==========================================================
    Puts axis range.
    Puts axis range in range_list by given index i_ax as vector

    Args:
        i_ax index of axis

    Returns:
        range_list[ i_ax ] 

";
%feature("docstring") UtsusemiD4Matrix::PutAxTitle "string UtsusemiD4Matrix::PutAxTitle(UInt4 i_ax)
================================================
    Puts axis title.

    Args:
        i_ax index of axis title

    Returns:
        ax_titles[ i_ax ] 

";
%feature("docstring") UtsusemiD4Matrix::SetAxTitle "void UtsusemiD4Matrix::SetAxTitle(UInt4 i_ax, string title)
============================================================
    Sets axis title.

    Args:
        i_ax index of axis title
        title axis title

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::SetAxTitles "void UtsusemiD4Matrix::SetAxTitles(vector< string > titles, bool isSaved) 

    
void UtsusemiD4Matrix::SetAxTitles(PyObject *titles, bool isSaved)
===================================================================
    Sets axis titles and save parames xml file.

    Args:
        titles string vector or list for axis titles
        isSaved flag for save file after set of titles

    Returns:
        None 
";
%feature("docstring") UtsusemiD4Matrix::PutAxUnit "string UtsusemiD4Matrix::PutAxUnit(UInt4 i_ax)
===============================================
    Puts axis unit.

    Args:
        i_ax index of axis title

    Returns:
        ax_units[ i_ax ] 

";
%feature("docstring") UtsusemiD4Matrix::SetAxUnit "void UtsusemiD4Matrix::SetAxUnit(UInt4 i_ax, string title)
===========================================================
    Sets axis unit.

    Args:
        i_ax index of axis unit
        title axis unit

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::SetAxUnits "void UtsusemiD4Matrix::SetAxUnits(vector< string > units, bool isSaved) 

    
void UtsusemiD4Matrix::SetAxUnits(PyObject *units, bool isSaved)
=================================================================
    Sets axis units and save parames xml file.

    Args:
        units string vector or list for axis units
        isSaved flag for save file after set of units

    Returns:
        None 
";
%feature("docstring") UtsusemiD4Matrix::SavePyListToBin "void UtsusemiD4Matrix::SavePyListToBin(string filepath, PyObject *ax1, PyObject *ax2, PyObject *ax3, PyObject *ax4, PyObject *ii, PyObject *ee)
================================================================================================================================================
    Saves List object on python to binary file.
    Saves given list object on python to binary file as the format to be loaded by AddToMatFromBin.

    Args:
        filepath file path of save binary file
        ax1 Python list object for AX1
        ax2 Python list object for AX2
        ax3 Python list object for AX3
        ax4 Python list object for AX4
        ii Python list object for Intensity
        ee Python list object for Error

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::AddMatToMat "void UtsusemiD4Matrix::AddMatToMat(string dir_from, string file_from, string dir_to, string file_to)
=====================================================================================================
    Adds data of saved Matrix files to other Matrix data files.
    This is mainly used for rebinning of matrix

    Args:
        dir_from directory path to original data
        file_from file name to original data
        dir_to directory path to new data
        file_to file name to new data

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix::PutOpenedDataPath "vector< string > UtsusemiD4Matrix::PutOpenedDataPath()
=======================================================
    Puts opened data path.
    This pushes d4mat_data_dir and d4mat_param_file

    Returns:
        string vector including d4mat_data_dir and d4mat_param_file 

";
%feature("docstring") UtsusemiD4Matrix::GetPartOfD4Mat "Int4 UtsusemiD4Matrix::GetPartOfD4Mat(UInt4 fs_index, float data[], UInt4 top_posi, UInt4 get_size) 

";
%feature("docstring") UtsusemiD4Matrix::SaveParamXml "Int4 UtsusemiD4Matrix::SaveParamXml(string datapath, string paramfilepath)
===========================================================================
    Saves parameters to XML file.

    Args:
        paramfilepath The path to XML file of parameters

    Returns:
        0 No Error
        -1 Error 

";
%feature("docstring") UtsusemiD4Matrix::SliceMat3D "Int4 UtsusemiD4Matrix::SliceMat3D(ElementContainerMatrix *_ecm, vector< Double > a1range, vector< Double > a2range, vector< Double > a3range, vector< Double > a4range, vector< string > def_axes, vector< Double > foldings, vector< string > key_axes) 

    
bool UtsusemiD4Matrix::SliceMat3D(ElementContainerMatrix *_ecm, PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *def_axes, PyObject *foldings, PyObject *key_axes) 
";
%feature("docstring") UtsusemiD4Matrix::Slice3d "bool UtsusemiD4Matrix::Slice3d(ElementContainerMatrix *_ecm, PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *def_axes, PyObject *foldings, PyObject *key_axes)
=====================================================================================================================================================================================================
    Slices D4Matrix for 3D.
    Picks up the region given by parameters from D4Matrix and make vector data for visualization. Users can set 4 axes ranges and the role of each axis by using string \"X\", \"Y\", \"Z\" and \"T\". \"X\",\"Y\" and \"Z\" mean X, Y and Z axis on visualization. The other axis indicated by \"T\" are summarized. Each range must consits of two values, begin and end; SliceMat3D( dat, a1range, a2range, a3range, a4range, def_axes, foldings, key_axes );

    Args:
        data
        a1range (list of float) first axis range [min, max]
        a2range (list of float) second axis range [min, max]
        a3range (list of float) third axis range [min, max]
        a4range (list of float) fourth axis range [min, max]
        def_axes (list of str) role of each axis, for example [ \"X\", \"Y\", \"T\", \"T\" ]
        foldings (list of float) folding values, [] means [ -1, -1, -1, -1]
        key_axes (list of str) Key name for each range [ <KeyX>,<KeyY>,<KeyZ> ]

    Returns:
        False Failed.
        True Succeeded. 

    
ElementContainerMatrix UtsusemiD4Matrix::Slice3d(PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *def_axes, PyObject *foldings, PyObject *key_axes) 
";
%feature("docstring") UtsusemiD4Matrix::OutputText3D "Int4 UtsusemiD4Matrix::OutputText3D(vector< Double > a1range, vector< Double > a2range, vector< Double > a3range, vector< Double > a4range, vector< string > def_axes, vector< Double > foldings, string filename, bool isIgnoreMaskVal=false, string maskValStr=\"\") 

    
bool UtsusemiD4Matrix::OutputText3D(PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *def_axes, PyObject *foldings, string filename, bool isIgnoreMaskVal=false, string maskValStr=\"\")
=============================================================================================================================================================================================================================
    Slices as 3D axes data of D4Matrix to save as text file.
    OutputText3D( a1range, a2range, a3range, a4range, def_axes, foldings, filename, isIgnoreMaskVal, maskValStr );

    Args:
        a1range (list of float) first axis range [min, max]
        a2range (list of float) second axis range [min, max]
        a3range (list of float) third axis range [min, max]
        a4range (list of float) fourth axis range [min, max]
        def_axes (list of str) role of each axis, for example [ \"X\", \"Y\", \"T\", \"T\" ]
        foldings (list of float) folding values, [] means [ -1, -1, -1, -1]
        isIgnoreMaskVal (bool) ignore mask values ( does not save mask value ) or not
        maskValStr (str) if isIgnoreMaskVal==False, this string is used as the mask value in text file.

    Returns:
        True Succeeded.
        False Failed. 
";
%feature("docstring") UtsusemiD4Matrix::DumpD4MatToFile "Int4 UtsusemiD4Matrix::DumpD4MatToFile(vector< Double > a1range, vector< Double > a2range, vector< Double > a3range, vector< Double > a4range, vector< string > def_axes, vector< Double > foldings, string filename, bool isText=true, bool isAve=true) 

    
bool UtsusemiD4Matrix::DumpD4MatToFile(PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *def_axes, PyObject *foldings, string filename, bool isText=true, bool isAve=true)
===============================================================================================================================================================================================================
    Saves D4Matrix to text or binary file.
    DumpD4MatToFile( a1range, a2range, a3range, a4range, def_axes, foldings, filename, isText );

    Args:
        a1range (list of float) first axis range [min, max]
        a2range (list of float) second axis range [min, max]
        a3range (list of float) third axis range [min, max]
        a4range (list of float) fourth axis range [min, max]
        def_axes (list of str) role of each axis, for example [ \"X\", \"Y\", \"T\", \"T\" ]
        foldings (list of float) folding values, [] means [ -1, -1, -1, -1]
        isText (bool) If True, save data as text file.
        isAve (bool) If False, the intensity of a bin is the summation of the counts.

    Returns:
        True Succeeded.
        False Failed. 
";
%feature("docstring") UtsusemiD4Matrix::_CalcVirtualAngleInfo "void UtsusemiD4Matrix::_CalcVirtualAngleInfo(string wfile, string dfile) 

    
void UtsusemiD4Matrix::_CalcVirtualAngleInfo(ElementContainerMatrix *_ecm) 
";
%feature("docstring") UtsusemiD4Matrix::SetRunNoForVirtualMatrix "bool UtsusemiD4Matrix::SetRunNoForVirtualMatrix(UInt4 runNo, PyObject *hwInfo) 

";
%feature("docstring") UtsusemiD4Matrix::AllocateVirtualMat "void UtsusemiD4Matrix::AllocateVirtualMat(vector< Double > latticeConst, vector< Double > Uvec, vector< Double > Vvec, vector< Double > rotateSteps, vector< Double > viewAxes, vector< Double > hwInfo, vector< Double > phiSteps, vector< Double > a1range, vector< Double > a2range, vector< Double > a3range, vector< Double > a4range, vector< string > titles, vector< string > units) 

    
bool UtsusemiD4Matrix::AllocateVirtualMat(PyObject *latticeConst, PyObject *Uvec, PyObject *Vvec, PyObject *rotateSteps, PyObject *viewAxes, PyObject *phiSteps, PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *titles, PyObject *units)
================================================================================================================================================================================================================================================================================
    Makes Virtual Matrix in memory.
    AllocateVirtualMat( latticeConst, Uvec, Vvec, rotateSteps, viewAxes, phiSteps , a1range, a2range, a3range, a4range, titles )

    Args:
        latticeConst (list of float) Lattice Constant [a,b,c,alpha,beta,gamma]
        Uvec (list of float) U-vector
        Vvec (list of float) V-vector
        rotateSteps (list of float) Steps for rotation [ 1, -5 ] means -5 degree rotation aroung Y axis
        viewAxes (list of float) List of matrix for axes projection
        phiStep (list of float) List of angles for sample orientations
        a1range (list of float) first axis range [min, max]
        a2range (list of float) second axis range [min, max]
        a3range (list of float) third axis range [min, max]
        a4range (list of float) fourth axis range [min, max]
        titles (list of str) Titles
        units (list of str) Units

    Returns:
        True succeeded.
        False failed. 
";
%feature("docstring") UtsusemiD4Matrix::EstimateRangeOfVirtualMat "vector< Double > UtsusemiD4Matrix::EstimateRangeOfVirtualMat(vector< Double > latticeConst, vector< Double > Uvec, vector< Double > Vvec, vector< Double > rotateSteps, vector< Double > viewAxes, vector< Double > hwInfo, vector< Double > phiSteps) 

    
PyObject * UtsusemiD4Matrix::EstimateRangeOfVirtualMat(PyObject *latticeConst, PyObject *Uvec, PyObject *Vvec, PyObject *rotateSteps, PyObject *viewAxes, PyObject *phiSteps)
==============================================================================================================================================================================
    Estimates range of Virtual Matrix.
    EstimateRangeOfVirtualMat( latticeConst, Uvec, Vvec, rotateSteps, viewAxes, phiSteps )

    Args:
        latticeConst (list of float) Lattice Constant [a,b,c,alpha,beta,gamma]
        Uvec (list of float) U-vector
        Vvec (list of float) V-vector
        rotateSteps (list of float) Steps for rotation [ 1, -5 ] means -5 degree rotation aroung Y axis
        viewAxes (list of float) List of matrix for axes projection
        phiStep (list of float) List of angles for sample orientations

    Returns:
        ranges for all axes (list of float) 
";
%feature("docstring") UtsusemiD4Matrix::SliceVirtualMat "void UtsusemiD4Matrix::SliceVirtualMat(vector< Double > a1range, vector< Double > a2range, vector< Double > a3range, vector< Double > a4range, vector< string > def_axes, vector< Double > foldings) 

";
%feature("docstring") UtsusemiD4Matrix::isVirtualMode "bool UtsusemiD4Matrix::isVirtualMode() 

";
%feature("docstring") UtsusemiD4Matrix::isDirectGeometry "bool UtsusemiD4Matrix::isDirectGeometry() 

";
// File: classUtsusemiD4Matrix2.xml

%feature("docstring") UtsusemiD4Matrix2 "

    D4Mat on memory.
    C++ includes: UtsusemiD4Matrix2.hh 

";
%feature("docstring") UtsusemiD4Matrix2::UtsusemiD4Matrix2 "UtsusemiD4Matrix2::UtsusemiD4Matrix2()
=======================================
    Constructor.

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix2::~UtsusemiD4Matrix2 "UtsusemiD4Matrix2::~UtsusemiD4Matrix2()
========================================
    Destructor.

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix2::SetCrystalParametersToHeader "Int4 UtsusemiD4Matrix2::SetCrystalParametersToHeader(HeaderBase *head, vector< Double > LatticeConsts, vector< Double > Uvec, vector< Double > Vvec, vector< Double > Rvec)
============================================================================================================================================================================
    Sets crystal parameters.
    This sets crystal parameters to HeaderBase.

    Args:
        head (HeaderBase*) target HeaderBase
        LatticeConsts (vector<Double>) Lattice constants <a, b, c, alpha, beta, gamma>
        Uvec (vector<Double>) U vector (ki parallel vector in coordinate system inside sample)
        Vvec (vector<Double>) V vector (ki perpendicular in coordinate system inside sample)
        Rvec (vector<Double>) Rotation Steps

    Returns:
        0 no trouble
        -1 trouble happened. 

";
%feature("docstring") UtsusemiD4Matrix2::SetCrystalParametersFromInnerHead "bool UtsusemiD4Matrix2::SetCrystalParametersFromInnerHead(ElementContainerMatrix *ecm, Double phi=0.0) 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatParameters "Int4 UtsusemiD4Matrix2::SetD4MatParameters(Int4 runNo, vector< Double > dataRedParam, vector< Double > LatticeConsts, vector< Double > Uvec, vector< Double > Vvec, vector< Double > Rvec) 

    
bool UtsusemiD4Matrix2::SetD4MatParameters(Int4 runNo, PyObject *dataRedParam, PyObject *LatticeConsts, PyObject *Uvec, PyObject *Vvec, PyObject *Rvec)
========================================================================================================================================================
    Sets D4Mat2 parameters into Header.
    This sets D4Mat2 parameters to HeaderBase.

    Args:
        runNo (Int4) runNo
        dataRedParam (vector<Double>) time_slice_start, time_slice_end, Ei, dHW, hw_min, hw_max, start_deg, end_deg, step_deg
        LatticeConsts (vector<Double>) Lattice constants <a, b, c, alpha, beta, gamma>
        Uvec (vector<Double>) U vector (ki parallel vector in coordinate system inside sample)
        Vvec (vector<Double>) V vector (ki perpendicular in coordinate system inside sample)
        Rvec (vector<Double>) Rotation Steps

    Returns:
        0 no trouble
        -1 trouble happened. 
";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatMode "bool UtsusemiD4Matrix2::SetD4MatMode(UInt4 mode) 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatContinousMode "void UtsusemiD4Matrix2::SetD4MatContinousMode() 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatSampleInfo "bool UtsusemiD4Matrix2::SetD4MatSampleInfo(vector< Double > LatticeConsts, vector< Double > Uvec, vector< Double > Vvec, vector< Double > Rvec) 

    
bool UtsusemiD4Matrix2::SetD4MatSampleInfo(PyObject *LatticeConsts, PyObject *Uvec, PyObject *Vvec, PyObject *Rvec) 
";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatDataReductionInfo "bool UtsusemiD4Matrix2::SetD4MatDataReductionInfo(vector< Double > dataRedParam) 

    
bool UtsusemiD4Matrix2::SetD4MatDataReductionInfo(PyObject *dataRedParam) 
";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatDataReductionOptions "bool UtsusemiD4Matrix2::SetD4MatDataReductionOptions(string maskInfo, Double normFactor, string timeIndepBack=\"\", string detEffi=\"\") 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatDataReductionContinuosAddRunNo "bool UtsusemiD4Matrix2::SetD4MatDataReductionContinuosAddRunNo(UInt4 runNO, Double startAngle) 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatDataReductionContinuosClearRunNo "void UtsusemiD4Matrix2::SetD4MatDataReductionContinuosClearRunNo() 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatDataReductionContinuosSetDeviceEncode "bool UtsusemiD4Matrix2::SetD4MatDataReductionContinuosSetDeviceEncode(string device) 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatDataReductionContinuosSetAnglePerEncode "bool UtsusemiD4Matrix2::SetD4MatDataReductionContinuosSetAnglePerEncode(UInt4 ape) 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatDataReductionContinuosSetTrigNETDIO "bool UtsusemiD4Matrix2::SetD4MatDataReductionContinuosSetTrigNETDIO(UInt4 dio=1) 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatDataReductionStepByStepGonioAtZero "bool UtsusemiD4Matrix2::SetD4MatDataReductionStepByStepGonioAtZero(Double gaz) 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatDataReductionStepByStepAddRunAngles "void UtsusemiD4Matrix2::SetD4MatDataReductionStepByStepAddRunAngles(string runNos, double ang, double norm, double normFactor) 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatProjectionAxesInfo "bool UtsusemiD4Matrix2::SetD4MatProjectionAxesInfo(vector< Double > PA) 

    
bool UtsusemiD4Matrix2::SetD4MatProjectionAxesInfo(PyObject *PA) 
    
bool UtsusemiD4Matrix2::SetD4MatProjectionAxesInfo(vector< Double > PA, vector< string > titles, vector< string > units) 
    
bool UtsusemiD4Matrix2::SetD4MatProjectionAxesInfo(PyObject *PA, PyObject *titles, PyObject *units) 
";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatSliceAxis "bool UtsusemiD4Matrix2::SetD4MatSliceAxis(string _id, string _type, double _min, double _max, double _width, double _folding) 

";
%feature("docstring") UtsusemiD4Matrix2::SetD4MatRunNo "bool UtsusemiD4Matrix2::SetD4MatRunNo(Int4 runNo) 

";
%feature("docstring") UtsusemiD4Matrix2::PutD4MatRunNo "Int4 UtsusemiD4Matrix2::PutD4MatRunNo()
========================================
    Puts RunNo from D4Mat2 parameters in Header.
    This return run number from D4Mat2 parameters in HeaderBase.

    Args:
        None

    Returns:
        runNo (Int4) 

";
%feature("docstring") UtsusemiD4Matrix2::PutD4MatDataRedParams "vector< Double > UtsusemiD4Matrix2::PutD4MatDataRedParams(bool fromData=false)
===============================================================================
    Puts Data Reduction Parameters from Header.
    This return data reduction parameters of D4Mat2 from HeaderBase.

    Args:
        fromDATA where is DR params obtained. True:From DATA False: from _HH

    Returns:
        vector<Double> 

";
%feature("docstring") UtsusemiD4Matrix2::PutD4MatLatticeConsts "vector< Double > UtsusemiD4Matrix2::PutD4MatLatticeConsts()
============================================================
    Puts Lattice Constants parameters from Header.
    This return lattice constants parameters of D4Mat2 from HeaderBase.

    Args:
        None

    Returns:
        vector<Double> 

";
%feature("docstring") UtsusemiD4Matrix2::PutD4MatUVvects "vector< Double > UtsusemiD4Matrix2::PutD4MatUVvects()
======================================================
    Puts U-vector and V-vector parameters from Header.
    This return U and V vectors of D4Mat2 from HeaderBase.

    Args:
        None

    Returns:
        vector<Double> 

";
%feature("docstring") UtsusemiD4Matrix2::ImportEcmsContRot "Int4 UtsusemiD4Matrix2::ImportEcmsContRot(UtsusemiEventDataConverterNeunet *EDC, const vector< UInt4 > CaseId, const vector< Double > Phi, const vector< Double > Kickers, const string maskfile, const Double dOmega, const Double normFactor, const string detEffi, const UInt4 reductCase=15) 

    
bool UtsusemiD4Matrix2::ImportEcmsContRot(UtsusemiEventDataConverterNeunet *EDC, PyObject *CaseId, PyObject *Phi, PyObject *Kickers, const string maskfile, const Double dOmega, const Double normFactor, const string detEffi, const UInt4 reductCase=15) 
";
%feature("docstring") UtsusemiD4Matrix2::ImportEcmsContRotPseudoOnLine "Int4 UtsusemiD4Matrix2::ImportEcmsContRotPseudoOnLine(UtsusemiEventDataMonitorNeunet *EDC, const vector< UInt4 > CaseId, const vector< Double > Phi, const string maskfile, const Double dOmega, const Double normFactor, const string detEffi, const bool isRefresh=false, const UInt4 reductCase=15) 

";
%feature("docstring") UtsusemiD4Matrix2::ImportEcmContRot "bool UtsusemiD4Matrix2::ImportEcmContRot(ElementContainerMatrix *ecm, const UInt4 caseId, const double ang, const UInt4 reductCase=15) 

";
%feature("docstring") UtsusemiD4Matrix2::AllocateD4MatPseudoOnLine "void UtsusemiD4Matrix2::AllocateD4MatPseudoOnLine(UInt4 num_of_cases) 

";
%feature("docstring") UtsusemiD4Matrix2::RemoveEcm "Int4 UtsusemiD4Matrix2::RemoveEcm(UInt4 runNo) 

    
Int4 UtsusemiD4Matrix2::RemoveEcm(string label)
================================================
    Removes ElementContainer.
    This removes one ElementContainer by given runNo or label RemoveEcm( UInt4 runNo ); RemoveEcm( string label );

    Args:
        head (HeaderBase*) target HeaderBase
        LatticeConsts (vector<Double>) Lattice constants <a, b, c, alpha, beta, gamma>
        Uvec (vector<Double>) U vector (ki parallel vector in coordinate system inside sample)
        Vvec (vector<Double>) V vector (ki perpendicular in coordinate system inside sample)
        reductCase (UInt4) DataReuction pattern 1:NormByKickers, 2:KiKfCorrect, 4:NormBySolidAngle, 7:All 0:No reduction

    Returns:
        0 no trouble
        -1 trouble happened. 
";
%feature("docstring") UtsusemiD4Matrix2::ClearAll "void UtsusemiD4Matrix2::ClearAll()
===================================
    Clears D4Mat.
    This resets D4Mat

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix2::_Slice2D "bool UtsusemiD4Matrix2::_Slice2D(ElementContainerArray *eca, vector< Double > ax1range, vector< Double > ax2range, vector< Double > ax3range, vector< Double > ax4range, vector< string > type, vector< Double > folding, vector< string > axunits) 

";
%feature("docstring") UtsusemiD4Matrix2::Slice2d "bool UtsusemiD4Matrix2::Slice2d(ElementContainerArray *eca, PyObject *Ax1, PyObject *Ax2, PyObject *Ax3, PyObject *Ax4, PyObject *DiagFolding, PyObject *AxUnits) 

    
bool UtsusemiD4Matrix2::Slice2d(ElementContainerArray *eca, vector< Double > ax1range, vector< Double > ax2range, vector< Double > ax3range, vector< Double > ax4range, vector< string > axType, vector< Double > folding, vector< string > axunits) 
    
ElementContainerArray UtsusemiD4Matrix2::Slice2d(vector< Double > ax1range, vector< Double > ax2range, vector< Double > ax3range, vector< Double > ax4range, vector< string > type, vector< Double > folding, vector< string > axunits) 
    
ElementContainerArray UtsusemiD4Matrix2::Slice2d(PyObject *ax1range, PyObject *ax2range, PyObject *ax3range, PyObject *ax4range, PyObject *type, PyObject *folding, PyObject *AxUnits)
=======================================================================================================================================================================================
    Slices D4Mat by given parameters.
    This slices D4Mat by given parametes and makes ElementContainerArray as result

    Args:
        ax1range (vector<Double>) range for axis 1
        ax2range (vector<Double>) range for axis 2
        ax3range (vector<Double>) range for axis 3
        ax4range (vector<Double>) range for axis 4
        type (vector<string>) types for each axis \"X\",\"Y\",\"T\"
        folding (vector<Double>) folding information

    Returns:
        ElementContainerArray results of sliced data 
";
%feature("docstring") UtsusemiD4Matrix2::_Slice3D "bool UtsusemiD4Matrix2::_Slice3D(ElementContainerMatrix *ecm, vector< Double > ax1range, vector< Double > ax2range, vector< Double > ax3range, vector< Double > ax4range, vector< string > type, vector< Double > folding) 

";
%feature("docstring") UtsusemiD4Matrix2::Slice3d "bool UtsusemiD4Matrix2::Slice3d(ElementContainerMatrix *ecm, PyObject *Ax1, PyObject *Ax2, PyObject *Ax3, PyObject *Ax4, PyObject *DiagFolding) 

    
ElementContainerMatrix UtsusemiD4Matrix2::Slice3d(vector< Double > ax1range, vector< Double > ax2range, vector< Double > ax3range, vector< Double > ax4range, vector< string > type, vector< Double > folding) 
    
ElementContainerMatrix UtsusemiD4Matrix2::Slice3d(PyObject *ax1range, PyObject *ax2range, PyObject *ax3range, PyObject *ax4range, PyObject *axistype, PyObject *folding)
=========================================================================================================================================================================
    Slices D4Mat by given parameters.
    This slices D4Mat by given parametes and makes ElementContainerArray as result

    Args:
        ax1range (vector<Double>) range for axis 1
        ax2range (vector<Double>) range for axis 2
        ax3range (vector<Double>) range for axis 3
        ax4range (vector<Double>) range for axis 4
        type (vector<string>) types for each axis \"X\",\"Y\",\"Z\",\"T\"
        folding (vector<Double>) folding information

    Returns:
        ElementContainerMatrix results of sliced data 
";
%feature("docstring") UtsusemiD4Matrix2::WriteData "Int4 UtsusemiD4Matrix2::WriteData(string filename)
===================================================
    Saves D4Mat data using Boost Serialization.

    Args:
        filename (string)

    Returns:
        0 no trouble
        -1 trouble happened. 

";
%feature("docstring") UtsusemiD4Matrix2::ReadData "Int4 UtsusemiD4Matrix2::ReadData(string filename)
==================================================
    Loads D4Mat data using Boost Serialization.

    Args:
        filename (string)

    Returns:
        0 no trouble
        -1 trouble happened. 

";
%feature("docstring") UtsusemiD4Matrix2::PutD4matPointer "D4MatGroup* UtsusemiD4Matrix2::PutD4matPointer()
=================================================
    Puts D4Mat data pointer.

    Args:
        None

    Returns:
        ElementContainerArray*) 

";
%feature("docstring") UtsusemiD4Matrix2::ResetD4mat "void UtsusemiD4Matrix2::ResetD4mat()
=====================================
    Clear D4Mat data.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix2::GetAxLimit "vector< Double > UtsusemiD4Matrix2::GetAxLimit()
=================================================
    Puts axes ranges of D4Mat.

    Args:
        None

    Returns:
        vector<Double> 

";
%feature("docstring") UtsusemiD4Matrix2::PutQRange "PyObject* UtsusemiD4Matrix2::PutQRange()
=========================================
    Puts axes ranges of D4Mat.

    Args:
        None

    Returns:
        python list object [ax1_min, ax1_max, ax2_min, ... , ax4_max] 

";
%feature("docstring") UtsusemiD4Matrix2::AllocateD4MatOnDisk "bool UtsusemiD4Matrix2::AllocateD4MatOnDisk(vector< Double > a1range, vector< Double > a2range, vector< Double > a3range, vector< Double > a4range, vector< string > titles, vector< string > units, string data_dir, string paramfile) 

    
bool UtsusemiD4Matrix2::AllocateD4MatOnDisk(PyObject *a1range, PyObject *a2range, PyObject *a3range, PyObject *a4range, PyObject *titles, PyObject *units, string data_dir, string paramfile)
==============================================================================================================================================================================================
    Makes new D4Matrix files on disk.
    Each range consists of three values, start, end and width.

    Args:
        a1range first axis range
        a2range second axis range
        a3range third axis range
        a4range fourth axis range
        titles titles for axes
        units units for axes
        data_dir path to data dir (including xml file)
        paramfile file name of parameter xml file

    Returns:
        None 
";
%feature("docstring") UtsusemiD4Matrix2::SaveParamXmlD4MatOnDisk "Int4 UtsusemiD4Matrix2::SaveParamXmlD4MatOnDisk(string d4mat_datadir, string d4mat_param_file, vector< string > name_of_blocks, vector< UInt4 > index_of_blocks, vector< vector< Double > > ranges, vector< string > axtitles, vector< string > units, vector< string > pathbinfiles) 

    
Int4 UtsusemiD4Matrix2::SaveParamXmlD4MatOnDisk(string d4mat_datadir, string d4mat_param_file, vector< string > name_of_blocks, vector< UInt4 > index_of_blocks, vector< Double > ax1range, vector< Double > ax2range, vector< Double > ax3range, vector< Double > ax4range, vector< string > axtitles, vector< string > axunits, vector< string > pathbinfiles) 
";
%feature("docstring") UtsusemiD4Matrix2::ImportEcmStepByStep "Int4 UtsusemiD4Matrix2::ImportEcmStepByStep(ElementContainerMatrix *ecm, double ang, double norm, double normFactor) 

    
Int4 UtsusemiD4Matrix2::ImportEcmStepByStep(ElementContainerMatrix *ecm, double ang, string label, bool isStepByStep=true) 
";
%feature("docstring") UtsusemiD4Matrix2::Projection "bool UtsusemiD4Matrix2::Projection(vector< Double > viewAxis) 

    
bool UtsusemiD4Matrix2::Projection(UInt4 ind, vector< Double > viewAxis) 
    
bool UtsusemiD4Matrix2::Projection(PyObject *viewAxis) 
";
%feature("docstring") UtsusemiD4Matrix2::ProjectionStepByStep "bool UtsusemiD4Matrix2::ProjectionStepByStep(PyObject *viewAxis) 

";
%feature("docstring") UtsusemiD4Matrix2::ExportEcmFromStepByStep "bool UtsusemiD4Matrix2::ExportEcmFromStepByStep(ElementContainerMatrix *ecm, UInt4 index) 

";
%feature("docstring") UtsusemiD4Matrix2::PutLabelsOfImportedEcm "vector< string > UtsusemiD4Matrix2::PutLabelsOfImportedEcm() 

";
%feature("docstring") UtsusemiD4Matrix2::SetAveragingOnSlice "void UtsusemiD4Matrix2::SetAveragingOnSlice(bool useAve=true)
==============================================================
    Set intensity caluculation mode (average or summation) in _Slice2D and _Slice3D.

    Args:
        useAve (bool) true : Average, false : summation

    Returns:
        None 

";
%feature("docstring") UtsusemiD4Matrix2::SetXtalParam "void UtsusemiD4Matrix2::SetXtalParam(string xtalparam) 

";
%feature("docstring") UtsusemiD4Matrix2::PutXtalParam "string UtsusemiD4Matrix2::PutXtalParam() 

";
%feature("docstring") UtsusemiD4Matrix2::SaveXtalParam "bool UtsusemiD4Matrix2::SaveXtalParam(string filepath) 

";
%feature("docstring") UtsusemiD4Matrix2::SaveData "bool UtsusemiD4Matrix2::SaveData(string filepath, bool withComp=false) 

";
%feature("docstring") UtsusemiD4Matrix2::LoadData "bool UtsusemiD4Matrix2::LoadData(string filepath) 

";
%feature("docstring") UtsusemiD4Matrix2::Empty "bool UtsusemiD4Matrix2::Empty() 

";
%feature("docstring") UtsusemiD4Matrix2::MakeVirtualD4Mat2 "bool UtsusemiD4Matrix2::MakeVirtualD4Mat2(ElementContainerMatrix *ecm, vector< Double > angles, vector< string > labels) 

";
%feature("docstring") UtsusemiD4Matrix2::PutSize "UInt4 UtsusemiD4Matrix2::PutSize() 

";
%feature("docstring") UtsusemiD4Matrix2::MakeXmlStringFromHeader "string UtsusemiD4Matrix2::MakeXmlStringFromHeader(HeaderBase *hh) 

";
%feature("docstring") UtsusemiD4Matrix2::PutTreatD4Mat2XmlParams "TreatD4Matrix2XmlParams* UtsusemiD4Matrix2::PutTreatD4Mat2XmlParams() 

";
// File: classUtsusemiDaqInfo.xml

%feature("docstring") UtsusemiDaqInfo "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") UtsusemiDaqInfo::UtsusemiDaqInfo "UtsusemiDaqInfo::UtsusemiDaqInfo()
===================================
    Constructor. 

    
UtsusemiDaqInfo::UtsusemiDaqInfo(const UtsusemiDaqInfo &obj)
=============================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiDaqInfo::~UtsusemiDaqInfo "UtsusemiDaqInfo::~UtsusemiDaqInfo()
====================================
    Destructor. 

";
%feature("docstring") UtsusemiDaqInfo::ClearList "void UtsusemiDaqInfo::ClearList() 

";
%feature("docstring") UtsusemiDaqInfo::PutAliveList "vector< UInt4 > UtsusemiDaqInfo::PutAliveList()
================================================
    Puts list of ModList index alived.

    Args:
        None

    Returns:
        vector of index 

";
// File: classUtsusemiDetAxisInfo.xml

%feature("docstring") UtsusemiDetAxisInfo "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") UtsusemiDetAxisInfo::UtsusemiDetAxisInfo "UtsusemiDetAxisInfo::UtsusemiDetAxisInfo()
===========================================
    Constructor. 

    
UtsusemiDetAxisInfo::UtsusemiDetAxisInfo(const UtsusemiDetAxisInfo &obj)
=========================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiDetAxisInfo::~UtsusemiDetAxisInfo "UtsusemiDetAxisInfo::~UtsusemiDetAxisInfo()
============================================
    Destructor. 

";
// File: classUtsusemiDetInfo.xml

%feature("docstring") UtsusemiDetInfo "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") UtsusemiDetInfo::UtsusemiDetInfo "UtsusemiDetInfo::UtsusemiDetInfo()
===================================
    Constructor. 

    
UtsusemiDetInfo::UtsusemiDetInfo(const UtsusemiDetInfo &obj)
=============================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiDetInfo::~UtsusemiDetInfo "UtsusemiDetInfo::~UtsusemiDetInfo()
====================================
    Destructor. 

";
// File: classUtsusemiDetectorEfficiencyCorrection.xml

%feature("docstring") UtsusemiDetectorEfficiencyCorrection "

    Detector Efficiency correction.
    Usage: correction using approximate values stored in DetEffi.dat DF = UtsusemiDetectorEfficiencyCorrection() if DF.LoadDataFile( \"path/to/DetEffi.dat\" ): DF.Execute( dat )
    Usage: Make DetEffi.dat DF = UtsusemiDetectorEfficiencyCorrection() if DF.Initialize( \"path/to/DetectorInfo.xml\", \"SIK-SUS304-3He-PSD\" ): DF.MakeApproximateData( \"path/to/DetEffi.dat\", <Ef_min>, <Ef_max>, <Ef_num>, <th_min>, <th_max>, <th_num> )
    This class is based on MlfDetectorEfficiencyCorrection at rev301 or later
    C++ includes: UtsusemiDetectorEfficiencyCorrection.hh 

";
%feature("docstring") UtsusemiDetectorEfficiencyCorrection::UtsusemiDetectorEfficiencyCorrection "UtsusemiDetectorEfficiencyCorrection::UtsusemiDetectorEfficiencyCorrection() 

    
UtsusemiDetectorEfficiencyCorrection::UtsusemiDetectorEfficiencyCorrection(string _detInfo, string _detName) 
    
UtsusemiDetectorEfficiencyCorrection::UtsusemiDetectorEfficiencyCorrection(UInt4 _runNo, string _detName, UInt4 _modeNo=0) 
    
UtsusemiDetectorEfficiencyCorrection::UtsusemiDetectorEfficiencyCorrection(string _datFile)
============================================================================================
    Constructor.
    UtsusemiDetectorEfficiencyCorrection() UtsusemiDetectorEfficiencyCorrection( string _detInfo, string _detName=\"\" ) UtsusemiDetectorEfficiencyCorrection( UInt4 _runNo, string _detName, UInt4 _modeNo=0 ); UtsusemiDetectorEfficiencyCorrection( string _datFile )

    Args:
        _detInfo (string) path to DetectorInfo.xml which must include <detectorStructure>.
        _detName (string) Detector Name like \"SUS304-3He-PSD\". This name must be included <detectorStructure>.
        _runNo (UInt4) runNo to find the suitable DetectorInfo.xml
        _modNo (UInt4) mode number to choose DetectorInfo.xml
        _datFile (string) path to file storing approxmate correction values as matrix format.

    Returns:
        None 
";
%feature("docstring") UtsusemiDetectorEfficiencyCorrection::~UtsusemiDetectorEfficiencyCorrection "UtsusemiDetectorEfficiencyCorrection::~UtsusemiDetectorEfficiencyCorrection()
==============================================================================
    Destructor. 

";
%feature("docstring") UtsusemiDetectorEfficiencyCorrection::Initialize "bool UtsusemiDetectorEfficiencyCorrection::Initialize(string _detInfo, string _detName) 

    
bool UtsusemiDetectorEfficiencyCorrection::Initialize(UInt4 _runNo, string _detName, UInt4 _modeNo=0)
======================================================================================================
    Sets DetectorInfo and detNmae.
    Sets DetectorInfo (including <detectorStructure>) and detName to set parameters for calculations of detector efficiency.

    Args:
        _detInfo (string) path to DetectorInfo.xml which must include <detectorStructure>.
        _detName (string) Detector Name like \"SUS304-3He-PSD\". This name must be included <detectorStructure>.
        _runNo (UInt4) runNo to find the suitable DetectorInfo.xml
        _modNo (UInt4) mode number to choose DetectorInfo.xml

    Returns:
        true suceeded.
        false failed. 
";
%feature("docstring") UtsusemiDetectorEfficiencyCorrection::LoadDataFile "bool UtsusemiDetectorEfficiencyCorrection::LoadDataFile(string _datFile, string additionalPath=\"\")
=====================================================================================================
    Loads data from file storing approximate values of detector efficiency.

    Args:
        _datFile (string) path of data file to be saved
        additionalPath (string) path of folder to be search _datFile

    Returns:
        true : succeeded.
        false : failed. 

";
// File: classUtsusemiDetectorInfoBankInfo.xml

%feature("docstring") UtsusemiDetectorInfoBankInfo "C++ includes: DetectorInfoEditorBase.hh 

";
%feature("docstring") UtsusemiDetectorInfoBankInfo::UtsusemiDetectorInfoBankInfo "UtsusemiDetectorInfoBankInfo::UtsusemiDetectorInfoBankInfo()
=============================================================
    Constructor. 

    
UtsusemiDetectorInfoBankInfo::UtsusemiDetectorInfoBankInfo(const UtsusemiDetectorInfoBankInfo &obj)
====================================================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiDetectorInfoBankInfo::~UtsusemiDetectorInfoBankInfo "UtsusemiDetectorInfoBankInfo::~UtsusemiDetectorInfoBankInfo()
==============================================================
    Destructor. 

";
%feature("docstring") UtsusemiDetectorInfoBankInfo::AddBank "void UtsusemiDetectorInfoBankInfo::AddBank(UInt4 bankId, string name, string conts) 

";
%feature("docstring") UtsusemiDetectorInfoBankInfo::DelBank "bool UtsusemiDetectorInfoBankInfo::DelBank(UInt4 bankId) 

";
%feature("docstring") UtsusemiDetectorInfoBankInfo::PutBank "vector< string > UtsusemiDetectorInfoBankInfo::PutBank(UInt4 bankId) 

";
// File: classUtsusemiDetectorInfoEditorBase.xml

%feature("docstring") UtsusemiDetectorInfoEditorBase "C++ includes: UtsusemiDetectorInfoEditorBase.hh 

";
%feature("docstring") UtsusemiDetectorInfoEditorBase::UtsusemiDetectorInfoEditorBase "UtsusemiDetectorInfoEditorBase::UtsusemiDetectorInfoEditorBase()
=================================================================
    Constructor. 

    
UtsusemiDetectorInfoEditorBase::UtsusemiDetectorInfoEditorBase(string dfile, bool workAsReader)
================================================================================================
    Constructor with arguments.

    Args:
        dfile (string) path/to/DetectorInfo.xml to be loaded
        workAsReader (bool) swich the mode to work as a reader 
";
%feature("docstring") UtsusemiDetectorInfoEditorBase::~UtsusemiDetectorInfoEditorBase "UtsusemiDetectorInfoEditorBase::~UtsusemiDetectorInfoEditorBase()
==================================================================
    Destructor. 

";
// File: classUtsusemiDetectorInfoEditorNeunet.xml

%feature("docstring") UtsusemiDetectorInfoEditorNeunet "C++ includes: UtsusemiDetectorInfoEditorNeunet.hh 

";
%feature("docstring") UtsusemiDetectorInfoEditorNeunet::UtsusemiDetectorInfoEditorNeunet "UtsusemiDetectorInfoEditorNeunet::UtsusemiDetectorInfoEditorNeunet()
=====================================================================
    Constructor. 

    
UtsusemiDetectorInfoEditorNeunet::UtsusemiDetectorInfoEditorNeunet(string dfile, bool workAsReader)
====================================================================================================
    Constructor with arguments.

    Args:
        dfile (string) path/to/DetectorInfo.xml to be loaded
        workAsReader (bool) swich the mode to work as a reader 
";
%feature("docstring") UtsusemiDetectorInfoEditorNeunet::~UtsusemiDetectorInfoEditorNeunet "UtsusemiDetectorInfoEditorNeunet::~UtsusemiDetectorInfoEditorNeunet()
======================================================================
    Destructor. 

";
// File: classUtsusemiDetectorInfoEditorTemplate.xml

%feature("docstring") UtsusemiDetectorInfoEditorTemplate "C++ includes: UtsusemiDetectorInfoEditorTemplate.hh 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::UtsusemiDetectorInfoEditorTemplate "UtsusemiDetectorInfoEditorTemplate< T1 >::UtsusemiDetectorInfoEditorTemplate() 

    
UtsusemiDetectorInfoEditorTemplate< T1 >::UtsusemiDetectorInfoEditorTemplate(string dfile, bool workAsReader) 
";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::~UtsusemiDetectorInfoEditorTemplate "UtsusemiDetectorInfoEditorTemplate< T1 >::~UtsusemiDetectorInfoEditorTemplate() 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::SetRunNo "bool UtsusemiDetectorInfoEditorTemplate< T1 >::SetRunNo(UInt4 runNo, UInt4 mode_no=0, string env_file=\"\")
============================================================================================================
    sets run No and environ_ana.xml
    This set run number and read environ_ana.xml to select WiringInfo and DetecorInfo sutable for the run number. If evn_file is empty(), this uses python-utsusemi/XXX/ana/xml(_UtsusemiUserXmlPath)/environ_ana.xml. If evn_file is set, the path of env_file is used as _UtsusemiUserXmlPath. bool SetRunNo( UInt4 runNo, string env_file=\"\" ) bool SetRunNo( string runNos, string env_file=\"\" )

    Args:
        runNo (UInt4) run number
        runNos (string) run numbers. format : \"1234,1235\"
        env_file (string) environ_ana.xml which includes several WiringInfo and DetectorInfo for each run number.
        dfile (string) set directly DetectorInfo file

    Returns:
        true : succeeded
        false : failed 

    
bool UtsusemiDetectorInfoEditorTemplate< T1 >::SetRunNo(string runNos, string mode_no=\"0\", string env_file=\"\") 
    
bool UtsusemiDetectorInfoEditorTemplate< T1 >::SetRunNo(UInt4 runNo, string dfile) 
";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::SetRunNoWithDetectorInfo "bool UtsusemiDetectorInfoEditorTemplate< T1 >::SetRunNoWithDetectorInfo(string runNos, string dfile) 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::MakeTempDetectorInfo "string UtsusemiDetectorInfoEditorTemplate< T1 >::MakeTempDetectorInfo(string _path=\"\")
=========================================================================================
    make and save the temporal detector info to create histogram
    this returns a path of the saved temporal detector info file string MakeTempDetectorInfo()

    Args:
        None

    Returns:
        (string) : the path of output detector info file 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::PutDE "T1* UtsusemiDetectorInfoEditorTemplate< T1 >::PutDE() 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::PutBankIdList "vector<Int4> UtsusemiDetectorInfoEditorTemplate< T1 >::PutBankIdList() 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::PutBankInfo "vector<string> UtsusemiDetectorInfoEditorTemplate< T1 >::PutBankInfo(UInt4 bankId) 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::PutInstL1 "Double UtsusemiDetectorInfoEditorTemplate< T1 >::PutInstL1() 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::PutInstTypicalL2 "Double UtsusemiDetectorInfoEditorTemplate< T1 >::PutInstTypicalL2() 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::PutInstTypicalDS "Double UtsusemiDetectorInfoEditorTemplate< T1 >::PutInstTypicalDS() 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::SetInstInfoL1 "bool UtsusemiDetectorInfoEditorTemplate< T1 >::SetInstInfoL1(Double _L1) 

";
%feature("docstring") UtsusemiDetectorInfoEditorTemplate::SetInstInfoSamplePosition "bool UtsusemiDetectorInfoEditorTemplate< T1 >::SetInstInfoSamplePosition(Double _px, Double _py, Double _pz) 

";
// File: classUtsusemiDetectorInfoInstInfo.xml

%feature("docstring") UtsusemiDetectorInfoInstInfo "C++ includes: DetectorInfoEditorBase.hh 

";
%feature("docstring") UtsusemiDetectorInfoInstInfo::UtsusemiDetectorInfoInstInfo "UtsusemiDetectorInfoInstInfo::UtsusemiDetectorInfoInstInfo()
=============================================================
    Constructor. 

    
UtsusemiDetectorInfoInstInfo::UtsusemiDetectorInfoInstInfo(const UtsusemiDetectorInfoInstInfo &obj)
====================================================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiDetectorInfoInstInfo::~UtsusemiDetectorInfoInstInfo "UtsusemiDetectorInfoInstInfo::~UtsusemiDetectorInfoInstInfo()
==============================================================
    Destructor. 

";
// File: classUtsusemiDetectorInfoPosiInfo.xml

%feature("docstring") UtsusemiDetectorInfoPosiInfo "C++ includes: DetectorInfoEditorBase.hh 

";
%feature("docstring") UtsusemiDetectorInfoPosiInfo::UtsusemiDetectorInfoPosiInfo "UtsusemiDetectorInfoPosiInfo::UtsusemiDetectorInfoPosiInfo()
=============================================================
    Constructor. 

    
UtsusemiDetectorInfoPosiInfo::UtsusemiDetectorInfoPosiInfo(const UtsusemiDetectorInfoPosiInfo &obj)
====================================================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiDetectorInfoPosiInfo::~UtsusemiDetectorInfoPosiInfo "UtsusemiDetectorInfoPosiInfo::~UtsusemiDetectorInfoPosiInfo()
==============================================================
    Destructor. 

";
%feature("docstring") UtsusemiDetectorInfoPosiInfo::Clear "void UtsusemiDetectorInfoPosiInfo::Clear() 

";
%feature("docstring") UtsusemiDetectorInfoPosiInfo::AddPosi "void UtsusemiDetectorInfoPosiInfo::AddPosi(UInt4 detId, UInt4 numAxis, vector< Double > posi) 

";
%feature("docstring") UtsusemiDetectorInfoPosiInfo::DelPosi "bool UtsusemiDetectorInfoPosiInfo::DelPosi(UInt4 detId, bool isForced) 

";
%feature("docstring") UtsusemiDetectorInfoPosiInfo::PutPosiNumAxis "UInt4 UtsusemiDetectorInfoPosiInfo::PutPosiNumAxis(UInt4 detId) 

";
%feature("docstring") UtsusemiDetectorInfoPosiInfo::PutPosi "vector< Double > UtsusemiDetectorInfoPosiInfo::PutPosi(UInt4 detId) 

";
%feature("docstring") UtsusemiDetectorInfoPosiInfo::PutDetIdList "vector< UInt4 > UtsusemiDetectorInfoPosiInfo::PutDetIdList() 

";
// File: classUtsusemiDetectorInfoTfp.xml

%feature("docstring") UtsusemiDetectorInfoTfp "C++ includes: DetectorInfoEditorBase.hh 

";
%feature("docstring") UtsusemiDetectorInfoTfp::UtsusemiDetectorInfoTfp "UtsusemiDetectorInfoTfp::UtsusemiDetectorInfoTfp()
===================================================
    Constructor. 

    
UtsusemiDetectorInfoTfp::UtsusemiDetectorInfoTfp(const UtsusemiDetectorInfoTfp &obj)
=====================================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiDetectorInfoTfp::~UtsusemiDetectorInfoTfp "UtsusemiDetectorInfoTfp::~UtsusemiDetectorInfoTfp()
====================================================
    Destructor. 

";
%feature("docstring") UtsusemiDetectorInfoTfp::ClearList "void UtsusemiDetectorInfoTfp::ClearList() 

";
%feature("docstring") UtsusemiDetectorInfoTfp::AddTfp "void UtsusemiDetectorInfoTfp::AddTfp(UInt4 pixelId, Double A, Double B) 

";
// File: classUtsusemiDetectorInfoTfpCalcParams.xml

%feature("docstring") UtsusemiDetectorInfoTfpCalcParams "C++ includes: DetectorInfoEditorBase.hh 

";
%feature("docstring") UtsusemiDetectorInfoTfpCalcParams::UtsusemiDetectorInfoTfpCalcParams "UtsusemiDetectorInfoTfpCalcParams::UtsusemiDetectorInfoTfpCalcParams()
=======================================================================
    Constructor. 

    
UtsusemiDetectorInfoTfpCalcParams::UtsusemiDetectorInfoTfpCalcParams(const UtsusemiDetectorInfoTfpCalcParams &obj)
===================================================================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiDetectorInfoTfpCalcParams::~UtsusemiDetectorInfoTfpCalcParams "UtsusemiDetectorInfoTfpCalcParams::~UtsusemiDetectorInfoTfpCalcParams()
========================================================================
    Destructor. 

";
// File: classUtsusemiEventCasesDecoderBase.xml

%feature("docstring") UtsusemiEventCasesDecoderBase "

    Decode Cases by Event Data.
    C++ includes: UtsusemiEventCasesDecoderBase.hh 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::UtsusemiEventCasesDecoderBase "UtsusemiEventCasesDecoderBase::UtsusemiEventCasesDecoderBase() 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::~UtsusemiEventCasesDecoderBase "UtsusemiEventCasesDecoderBase::~UtsusemiEventCasesDecoderBase() 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::ReadCaseInfoFile "void UtsusemiEventCasesDecoderBase::ReadCaseInfoFile(string filepath)
======================================================================
    Imports Case Info file.

    Args:
        filepath (string) path to CaseInfo file

    Returns:
        None 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::ReadCaseEvent "void UtsusemiEventCasesDecoderBase::ReadCaseEvent(UInt4 index, vector< string > evt_files, vector< string > t0b_files) 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::ReadCaseEventFiles "void UtsusemiEventCasesDecoderBase::ReadCaseEventFiles(UInt4 index, vector< string > evt_files, vector< string > t0b_files)
============================================================================================================================
    Reads event data files for cases.

    Args:
        files (vector<string>) pathes to event data file

    Returns:
        None 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::CalcIncrementPosi "Double UtsusemiEventCasesDecoderBase::CalcIncrementPosi(Double *tof, UInt4 *pixelId, UInt4 *caseId)
====================================================================================================
    Calculation increment position (tof shift)
    If bin position(tof) shifts by case id and pixelId, use this function. This is used in original Increment function.

    Args:
        tof (Double*) tof
        pixelId (UInt4*) given pixel id
        caseNo (UInt4*) given case number

    Returns:
        tof (Double) shifted tof 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::GetCaseFromTof "UInt4 UtsusemiEventCasesDecoderBase::GetCaseFromTof(const UInt4 pixelId, Double *tof, vector< UInt4 > *caseVec)
================================================================================================================
    Returns CaseId from given pixel id and tof.
    This is used in original Increment function.

    Args:
        pixelId (UInt4*) given pixel id
        tof (Double*) tof
        caseVec (vecotr<UInt4>*) given vector of cases

    Returns:
        caseId (UInt4) if 0, this tof will not be incremented to histogram. 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::PutT0Index "vector< UInt4 > UtsusemiEventCasesDecoderBase::PutT0Index()
============================================================
    Puts T0Index.

    Args:
        None

    Returns:
        T0Index vector 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::PutT0ClockDiff "vector< Double > UtsusemiEventCasesDecoderBase::PutT0ClockDiff()
=================================================================
    Puts differencies clocks between frames.

    Args:
        None

    Returns:
        diffencies clocks vector 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::PutCaseTable "vector< vector< UInt4 > * > * UtsusemiEventCasesDecoderBase::PutCaseTable()
============================================================================
    Puts CaseTable.

    Args:
        None

    Returns:
        CaseTable 

";
%feature("docstring") UtsusemiEventCasesDecoderBase::CheckCaseTableWithT0Index "void UtsusemiEventCasesDecoderBase::CheckCaseTableWithT0Index() 

";
// File: classUtsusemiEventCasesDecoderTemplate.xml

%feature("docstring") UtsusemiEventCasesDecoderTemplate "

    Decode Cases by Event Data.
    C++ includes: UtsusemiEventCasesDecoderTemplate.hh 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::UtsusemiEventCasesDecoderTemplate "UtsusemiEventCasesDecoderTemplate< T1, T2 >::UtsusemiEventCasesDecoderTemplate()
=================================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::~UtsusemiEventCasesDecoderTemplate "UtsusemiEventCasesDecoderTemplate< T1, T2 >::~UtsusemiEventCasesDecoderTemplate()
==================================================================================
    Destructor. 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::CalcIncrementPosi "Double UtsusemiEventCasesDecoderTemplate< T1, T2 >::CalcIncrementPosi(Double *tof, UInt4 *pixelId, UInt4 *caseId)
==================================================================================================================
    Calculation increment position (tof shift)
    If bin position(tof) shifts by case id and pixelId, use this function. This is used in original Increment function.

    Args:
        tof (Double*) tof
        pixelId (UInt4*) given pixel id
        caseNo (UInt4*) given case number

    Returns:
        tof (Double) shifted tof 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::GetCaseFromTof "UInt4 UtsusemiEventCasesDecoderTemplate< T1, T2 >::GetCaseFromTof(const UInt4 pixelId, Double *tof, vector< UInt4 > *caseVec)
==============================================================================================================================
    Returns CaseId from given pixel id and tof.
    This is used in original Increment function.

    Args:
        pixelId (UInt4*) given pixel id
        tof (Double*) tof
        caseVec (vecotr<UInt4>*) given vector of cases

    Returns:
        caseId (UInt4) if 0, this tof will not be incremented to histogram. 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::PutT0Index "vector< UInt8 > UtsusemiEventCasesDecoderTemplate< T1, T2 >::PutT0Index()
==========================================================================
    Puts T0Index.

    Args:
        None

    Returns:
        T0Index vector 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::PutPulseId "vector< UInt8 > UtsusemiEventCasesDecoderTemplate< T1, T2 >::PutPulseId()
==========================================================================
    Puts PulseId list.

    Args:
        None

    Returns:
        PulseId vector 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::PutT0ClockDiff "vector< Double > UtsusemiEventCasesDecoderTemplate< T1, T2 >::PutT0ClockDiff()
===============================================================================
    Puts differencies clocks between frames.

    Args:
        None

    Returns:
        diffencies clocks vector 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::PutCaseTable "vector< vector< UInt4 > * > * UtsusemiEventCasesDecoderTemplate< T1, T2 >::PutCaseTable()
==========================================================================================
    Puts CaseTable.

    Args:
        None

    Returns:
        CaseTable 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::PutT0TreatTools "T1* UtsusemiEventCasesDecoderTemplate< T1, T2 >::PutT0TreatTools()
===================================================================
    Puts T0TreatToolsXXX pointer.

    Args:
        _tt (T1*) instance of T0TreatToolsXXX

    Returns:
        None 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::PutFilter "T2* UtsusemiEventCasesDecoderTemplate< T1, T2 >::PutFilter()
=============================================================
    Puts Filger function pointer.

    Args:
        _ff (T2*) instance of Filter function

    Returns:
        None 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::ReadCaseInfoFile "void UtsusemiEventCasesDecoderTemplate< T1, T2 >::ReadCaseInfoFile(string filepath)
====================================================================================
    Imports Case Info file.

    Args:
        filepath (string) path to CaseInfo file

    Returns:
        None 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::ReadCaseEvent "void UtsusemiEventCasesDecoderTemplate< T1, T2 >::ReadCaseEvent(UInt4 index, vector< string > evt_files, vector< string > t0b_files) 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::ReadCaseEventFiles "void UtsusemiEventCasesDecoderTemplate< T1, T2 >::ReadCaseEventFiles(UInt4 index, vector< string > evt_files, vector< string > t0b_files)
==========================================================================================================================================
    Reads event data files for cases.

    Args:
        evt_files (vector<string>) pathes to event data file
        t0b_files (vector<string>) pathes to t0b event data file

    Returns:
        None 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::PutListOfCases "vector<UInt4> UtsusemiEventCasesDecoderTemplate< T1, T2 >::PutListOfCases()
============================================================================
    Puts list of cases.

    Args:
        None

    Returns:
        list of cases 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::CheckCaseTableWithT0Index "void UtsusemiEventCasesDecoderTemplate< T1, T2 >::CheckCaseTableWithT0Index()
==============================================================================
    Checks and rewrite Case table using T0Index.

    Returns:
        None 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::PutNumOfT0ListInCases "vector< UInt4 > UtsusemiEventCasesDecoderTemplate< T1, T2 >::PutNumOfT0ListInCases(Double tof=1.0)
===================================================================================================
    Returns the number of T0 for each case.
    retVal[caseId] = T0 counts at caseId

    Args:
        tof (Double) Time-of-flight point in each frame to be determined caseId

    Returns:
        vector of the number of T0 : index is caseId : ret[caseId] included caseId=0 <- ret.size() = num_of_cases + 1 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::_CopyCaseTable "void UtsusemiEventCasesDecoderTemplate< T1, T2 >::_CopyCaseTable(vector< UInt4 > *target, vector< UInt4 > *orig)
=================================================================================================================
    Copies function between vector pointers.

    Args:
        target (vector<UInt4>*) copy to
        orig (vector<UInt4>*) copy from

    Returns:
        None 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::SetParamsForShiftTof "void UtsusemiEventCasesDecoderTemplate< T1, T2 >::SetParamsForShiftTof(vector< vector< Double > * > *pixelPositionVect, vector< Double > *L1Vect, vector< Double > *T0ShiftVect)
=================================================================================================================================================================================
    Sets some parameters for TOF shift.
    TOF detected at detectors may be shifted that at the sample position.

    Args:
        pixelPositionVect pixel position <pixelId><axis>
        LiVect L2 for each pixel <pixelId>
        T0ShiftVect T0 shift for each pixel <pixelId>

    Returns:
        None 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::ShiftTofAtSample "Double UtsusemiEventCasesDecoderTemplate< T1, T2 >::ShiftTofAtSample(Double tof, UInt4 pixelId)
================================================================================================
    Calculates tof at the sample position.

    Args:
        tof (Double) TOF at a detector
        pixelId (UInt4) pixelID

    Returns:
        shifted tof 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::ReadT0IndexEventFile "Int4 UtsusemiEventCasesDecoderTemplate< T1, T2 >::ReadT0IndexEventFile(string t0Data, UInt4 num_of_clocks=0) 

    
Int4 UtsusemiEventCasesDecoderTemplate< T1, T2 >::ReadT0IndexEventFile(vector< string > t0DataSet, UInt4 num_of_clocks=0)
==========================================================================================================================
    Reads T0Index Event data file.
    This calls _TT->reatT0IndexEvent()

    Args:
        t0Data (string) path to T0 event data file
        t0DataSet (vector<string>) list of path to T0 event data files
        num_clocks (UInt4) number of clocks before first T0

    Returns:
        0 successful 
";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::PutMeasPeriodFromT0 "vector< Double > UtsusemiEventCasesDecoderTemplate< T1, T2 >::PutMeasPeriodFromT0()
====================================================================================
    Puts the period to be measured.

    Args:
        None

    Returns:
        date and time of the period 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::SetRangeOfSingleTimeSlicing "bool UtsusemiEventCasesDecoderTemplate< T1, T2 >::SetRangeOfSingleTimeSlicing(double startSec, double endSec)
==============================================================================================================
    Sets time range for time slice of event data.
    Values for time are indicated the passed time [sec] from head of event data

    Args:
        startSec start time [sec]
        endSec end time [sec]

    Returns:
        true succeeded
        false failed 

    
bool UtsusemiEventCasesDecoderTemplate< T1, T2 >::SetRangeOfSingleTimeSlicing(string startDate, string endDate)
================================================================================================================
    Sets time range for time slice of event data.
    Values for time are indicated the passed time [sec] from head of event data string format : \"YYYY,MM,DD,hh,mm,ss,s.ss\", \"2011,1,22,13,54,22,0.54\"

    Args:
        startDate start date string
        endDate end date string

    Returns:
        true succeeded
        false failed 
";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::MakeTimeSlicingCases "void UtsusemiEventCasesDecoderTemplate< T1, T2 >::MakeTimeSlicingCases(vector< string > _t0b_files) 

";
%feature("docstring") UtsusemiEventCasesDecoderTemplate::SetTimeSlicing "void UtsusemiEventCasesDecoderTemplate< T1, T2 >::SetTimeSlicing(vector< Double > tmp) 

";
// File: classUtsusemiEventDataConverterMWPC.xml

%feature("docstring") UtsusemiEventDataConverterMWPC "

    Load Event Data and convert to Histogram from 2d-scintillation counter PCMT.
    LoadParamFiles( \"WiringInfo.xml\", \"DetectorInfo.xml\", \"CaseInfo.xml\" ) LoadTrignetEventFile( runNo, \"/data\", \"\" ) SetHistAllocation() ecm = ElementContainerMatrix() SetElementContainerMatrix( ecm, runNo, \"/data\", \"\" )
    C++ includes: UtsusemiEventDataConverterMWPC.hh 

";
%feature("docstring") UtsusemiEventDataConverterMWPC::UtsusemiEventDataConverterMWPC "UtsusemiEventDataConverterMWPC::UtsusemiEventDataConverterMWPC()
=================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterMWPC::~UtsusemiEventDataConverterMWPC "UtsusemiEventDataConverterMWPC::~UtsusemiEventDataConverterMWPC()
==================================================================
    Destructor. 

";
// File: classUtsusemiEventDataConverterNeunet.xml

%feature("docstring") UtsusemiEventDataConverterNeunet "

    Load Event Data and convert to Histogram for Inelastic scattering.
    LoadParamFiles( \"WiringInfo.xml\", \"DetectorInfo.xml\", \"CaseInfo.xml\" ) LoadTrignetEventFile( runNo, \"/data\", \"\" ) SetHistAllocation() ecm = ElementContainerMatrix() SetElementContainerMatrix( ecm, runNo, \"/data\", \"\" )
    C++ includes: UtsusemiEventDataConverterNeunet.hh 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::UtsusemiEventDataConverterNeunet "UtsusemiEventDataConverterNeunet::UtsusemiEventDataConverterNeunet()
=====================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::~UtsusemiEventDataConverterNeunet "UtsusemiEventDataConverterNeunet::~UtsusemiEventDataConverterNeunet()
======================================================================
    Destructor. 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::LoadParamFiles "bool UtsusemiEventDataConverterNeunet::LoadParamFiles(string w_file, string d_file, string c_file=\"\")
========================================================================================================
    Loads parameter files.
    This executes SetEventParams and SetCaseInfoParams of EventDataConverterTemplate.

    Args:
        w_file (string) Wiring Info file path
        d_file (string) Detector Info file path
        c_file (string) Case Info file path

    Returns:
        true : succeeded.
        false : failed. 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::SetElementContainerNeunet "void UtsusemiEventDataConverterNeunet::SetElementContainerNeunet(UInt4 outer_pixel_id, ElementContainer *ec, UInt4 caseId=1)
=============================================================================================================================
    Sets Histogram into ElementContainer.

    Args:
        outer_pixel_id (UInt4) pixel_id
        ec (ElementContainer*)
        caseId (UInt4)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::LoadEventDataFiles "Int4 UtsusemiEventDataConverterNeunet::LoadEventDataFiles(UInt4 runNumber, string pathToData=\"\", string pathToT0data=\"\") 

    
Int4 UtsusemiEventDataConverterNeunet::LoadEventDataFiles(vector< UInt4 > runNumbers, string pathToData=\"\", string pathToT0data=\"\")
========================================================================================================================================
    Loads event data files.

    Args:
        runNumber (UInt4) run number
        runNumbers (<vector<UInt4>) a seriese of run numbers
        pathToData (string) path to root directory of instruments event data folders (\"/data\")
        pathToT0data (string) path to directory to store T0Index event data files

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo 
";
%feature("docstring") UtsusemiEventDataConverterNeunet::SetElementContainerMatrix "Int4 UtsusemiEventDataConverterNeunet::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 caseId=1) 

    
Int4 UtsusemiEventDataConverterNeunet::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 runNuber, string pathToData, string pathToT0data=\"\", UInt4 caseId=1) 
    
Int4 UtsusemiEventDataConverterNeunet::SetElementContainerMatrix(ElementContainerMatrix *ecm, vector< UInt4 > runNuber, string pathToData, string pathToT0data=\"\", UInt4 caseId=1)
=====================================================================================================================================================================================
    Sets Histogram into ElementContainerMatrix.
    SetElementContainerMatrix( ElementContainerMatrix* ecm, UInt4 caseId=1 ) SetElementContainerMatrix( ElementContainerMatrix* ecm, string instCode, UInt4 runNuber, string pathToData=\"\", string pathToT0data=\"\", UInt4 caseId=1 )

    Args:
        ecm (ElementContainerMatrix*)
        instCode (string) Instrument code
        runNumber (UInt4) run number
        pathToData (string) path to root directory of instruments event data folders (\"/data\")
        pathToT0data (string) path to directory to store T0Index event data files
        caseId (UInt4) case ID

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo
        -3 : Wrong defined TOF binning info ( failed to load WiringInfo ) 
";
%feature("docstring") UtsusemiEventDataConverterNeunet::MakeCaseTable "void UtsusemiEventDataConverterNeunet::MakeCaseTable(UInt4 runno, string pathToData=\"\", string pathToT0data=\"\", string trigModKey=\"\") 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::LoadTrignetEventFile "void UtsusemiEventDataConverterNeunet::LoadTrignetEventFile(UInt4 runno, string pathToData=\"\", string pathToT0data=\"\") 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::ReadTrignetEventFile "void UtsusemiEventDataConverterNeunet::ReadTrignetEventFile(string pathToTrigData, UInt4 index=0)
==================================================================================================
    Reads Trignet Event data file for cases.

    Args:
        pathToTrigData (string) path to TrigNET event data files
        index (UInt4) event file index

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::DumpCaseTable "vector< UInt4 > UtsusemiEventDataConverterNeunet::DumpCaseTable(UInt4 i1, UInt4 i2, bool isI1Size, bool isI2Size)
==================================================================================================================
    Dumps table of cases.

    Args:
        i1 (UInt4)
        i2 (UInt4)
        isI1Size (bool)
        isI2Size (bool)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::SetElementContainerMatrixForPseudOnLineMon "Int4 UtsusemiEventDataConverterNeunet::SetElementContainerMatrixForPseudOnLineMon(ElementContainerMatrix *ecm, UInt4 caseId=1, UInt4 runNo=999999)
===================================================================================================================================================
    Sets histograms to ElementContainermatrix as pseud on-line monitor.

    Args:
        ecm (ElementContainerMatrix*)
        caseId (UInt4) case ID
        runNo (UInt4) run number
        isI2Size (bool)

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo
        -3 : Wrong defined TOF binning info ( failed to load WiringInfo ) 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::SetDataPathTest "Int4 UtsusemiEventDataConverterNeunet::SetDataPathTest(string dataPath, string t0Path, UInt4 runNo) 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::PutListOfCounterConditions "vector< Double > UtsusemiEventDataConverterNeunet::PutListOfCounterConditions() 

";
%feature("docstring") UtsusemiEventDataConverterNeunet::SetTofOriginShift "bool UtsusemiEventDataConverterNeunet::SetTofOriginShift(UInt4 cType) 

    
bool UtsusemiEventDataConverterNeunet::SetTofOriginShift(UInt4 cType, vector< Double > params)
===============================================================================================
    Sets type and calculation parameter for Tof origin shift.
    This shift is defined by the lamda-depend function given in codes

    Args:
        cType (UInt4) pattern Id for function
        params (vector<Double>) parameters of cType function

    Returns:
        true succeeded
        false failed 
";
// File: classUtsusemiEventDataConverterNeunetWithPH.xml

%feature("docstring") UtsusemiEventDataConverterNeunetWithPH "

    Load Event Data and convert to Histogram for Inelastic scattering.
    LoadParamFiles( \"WiringInfo.xml\", \"DetectorInfo.xml\", \"CaseInfo.xml\" ) LoadTrignetEventFile( runNo, \"/data\", \"\" ) SetHistAllocation() ecm = ElementContainerMatrix() SetElementContainerMatrix( ecm, runNo, \"/data\", \"\" )
    C++ includes: UtsusemiEventDataConverterNeunetWithPH.hh 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::UtsusemiEventDataConverterNeunetWithPH "UtsusemiEventDataConverterNeunetWithPH::UtsusemiEventDataConverterNeunetWithPH()
=================================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::~UtsusemiEventDataConverterNeunetWithPH "UtsusemiEventDataConverterNeunetWithPH::~UtsusemiEventDataConverterNeunetWithPH()
==================================================================================
    Destructor. 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::LoadParamFiles "bool UtsusemiEventDataConverterNeunetWithPH::LoadParamFiles(string w_file, string d_file, string c_file=\"\")
==============================================================================================================
    Loads parameter files.
    This executes SetEventParams and SetCaseInfoParams of EventDataConverterTemplate.

    Args:
        w_file (string) Wiring Info file path
        d_file (string) Detector Info file path
        c_file (string) Case Info file path

    Returns:
        true : succeeded.
        false : failed. 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::SetElementContainerNeunet "void UtsusemiEventDataConverterNeunetWithPH::SetElementContainerNeunet(UInt4 outer_pixel_id, ElementContainer *ec, UInt4 caseId=1)
===================================================================================================================================
    Sets Histogram into ElementContainer.

    Args:
        outer_pixel_id (UInt4) pixel_id
        ec (ElementContainer*)
        caseId (UInt4)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::LoadEventDataFiles "Int4 UtsusemiEventDataConverterNeunetWithPH::LoadEventDataFiles(UInt4 runNumber, string pathToData=\"\", string pathToT0data=\"\") 

    
Int4 UtsusemiEventDataConverterNeunetWithPH::LoadEventDataFiles(vector< UInt4 > runNumbers, string pathToData=\"\", string pathToT0data=\"\")
==============================================================================================================================================
    Loads event data files.

    Args:
        runNumber (UInt4) run number
        runNumbers (<vector<UInt4>) a seriese of run numbers
        pathToData (string) path to root directory of instruments event data folders (\"/data\")
        pathToT0data (string) path to directory to store T0Index event data files

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo 
";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::SetElementContainerMatrix "Int4 UtsusemiEventDataConverterNeunetWithPH::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 caseId=1) 

    
Int4 UtsusemiEventDataConverterNeunetWithPH::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 runNuber, string pathToData, string pathToT0data=\"\", UInt4 caseId=1) 
    
Int4 UtsusemiEventDataConverterNeunetWithPH::SetElementContainerMatrix(ElementContainerMatrix *ecm, vector< UInt4 > runNuber, string pathToData, string pathToT0data=\"\", UInt4 caseId=1)
===========================================================================================================================================================================================
    Sets Histogram into ElementContainerMatrix.
    SetElementContainerMatrix( ElementContainerMatrix* ecm, UInt4 caseId=1 ) SetElementContainerMatrix( ElementContainerMatrix* ecm, string instCode, UInt4 runNuber, string pathToData=\"\", string pathToT0data=\"\", UInt4 caseId=1 )

    Args:
        ecm (ElementContainerMatrix*)
        instCode (string) Instrument code
        runNumber (UInt4) run number
        pathToData (string) path to root directory of instruments event data folders (\"/data\")
        pathToT0data (string) path to directory to store T0Index event data files
        caseId (UInt4) case ID

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo
        -3 : Wrong defined TOF binning info ( failed to load WiringInfo ) 
";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::LoadTrignetEventFile "void UtsusemiEventDataConverterNeunetWithPH::LoadTrignetEventFile(UInt4 runno, string pathToData=\"\", string pathToT0data=\"\") 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::ReadTrignetEventFile "void UtsusemiEventDataConverterNeunetWithPH::ReadTrignetEventFile(string pathToTrigData, UInt4 index=0)
========================================================================================================
    Reads Trignet Event data file for cases.

    Args:
        pathToTrigData (string) path to TrigNET event data files
        index (UInt4) event file index

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::DumpCaseTable "vector< UInt4 > UtsusemiEventDataConverterNeunetWithPH::DumpCaseTable(UInt4 i1, UInt4 i2, bool isI1Size, bool isI2Size)
========================================================================================================================
    Dumps table of cases.

    Args:
        i1 (UInt4)
        i2 (UInt4)
        isI1Size (bool)
        isI2Size (bool)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::SetElementContainerMatrixForPseudOnLineMon "Int4 UtsusemiEventDataConverterNeunetWithPH::SetElementContainerMatrixForPseudOnLineMon(ElementContainerMatrix *ecm, UInt4 caseId=1, UInt4 runNo=999999)
=========================================================================================================================================================
    Sets histograms to ElementContainermatrix as pseud on-line monitor.

    Args:
        ecm (ElementContainerMatrix*)
        caseId (UInt4) case ID
        runNo (UInt4) run number
        isI2Size (bool)

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo
        -3 : Wrong defined TOF binning info ( failed to load WiringInfo ) 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::SetDataPathTest "Int4 UtsusemiEventDataConverterNeunetWithPH::SetDataPathTest(string dataPath, string t0Path, UInt4 runNo) 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::PutListOfCounterConditions "vector< Double > UtsusemiEventDataConverterNeunetWithPH::PutListOfCounterConditions() 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::PutPulseHeightOfDet "ElementContainer UtsusemiEventDataConverterNeunetWithPH::PutPulseHeightOfDet(ElementContainerMatrix *ecm, UInt4 OuterDetId, UInt4 binSize=1) 

    
ElementContainer UtsusemiEventDataConverterNeunetWithPH::PutPulseHeightOfDet(ElementContainerArray *eca, UInt4 binSize=1)
==========================================================================================================================
    Makes Histogram of Pulse Height for each detector from its HeaderBase in ElementContainer.
    ElementContainer PutPulseHeightOfDet( ElementContainerMatrix* ecm, UInt4 OuterDetId, UInt4 binSize=1 ); ElementContainer PutPulseHeightOfDet( ElementContainerArray* eca, UInt4 binSize=1 );

    Args:
        ecm (ElementContainerMatrix*) target data
        OuterDetId (UInt4) target Det-Id
        eca (ElementContainerArray*) target data
        binSize (UInt4) binning size of axis

    Returns:
        ElementContainer 
";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPH::PutPulseHeightAll "ElementContainerArray UtsusemiEventDataConverterNeunetWithPH::PutPulseHeightAll(ElementContainerMatrix *ecm, UInt4 binSize=1)
==============================================================================================================================
    Makes Histogram of Pulse Height for all detectors from HeaderBase in ElementContainer.
    ElementContainerArray PutPulseHeightAll( ElementContainerMatrix* ecm, UInt4 binSize=1 );

    Args:
        ecm (ElementContainerMatrix*) target data
        binSize (UInt4) binning size of axis

    Returns:
        ElementContainerArray 

";
// File: classUtsusemiEventDataConverterNeunetWithPHDep.xml

%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep "

    Load Event Data and convert to Histogram for Inelastic scattering.
    LoadParamFiles( \"WiringInfo.xml\", \"DetectorInfo.xml\", \"CaseInfo.xml\" ) LoadTrignetEventFile( runNo, \"/data\", \"\" ) SetHistAllocation() ecm = ElementContainerMatrix() SetElementContainerMatrix( ecm, runNo, \"/data\", \"\" )
    C++ includes: UtsusemiEventDataConverterNeunetWithPHDep.hh 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::UtsusemiEventDataConverterNeunetWithPHDep "UtsusemiEventDataConverterNeunetWithPHDep::UtsusemiEventDataConverterNeunetWithPHDep()
=======================================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::~UtsusemiEventDataConverterNeunetWithPHDep "UtsusemiEventDataConverterNeunetWithPHDep::~UtsusemiEventDataConverterNeunetWithPHDep()
========================================================================================
    Destructor. 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::LoadParamFiles "bool UtsusemiEventDataConverterNeunetWithPHDep::LoadParamFiles(string w_file, string d_file, string c_file=\"\")
=================================================================================================================
    Loads parameter files.
    This executes SetEventParams and SetCaseInfoParams of EventDataConverterTemplate.

    Args:
        w_file (string) Wiring Info file path
        d_file (string) Detector Info file path
        c_file (string) Case Info file path

    Returns:
        true : succeeded.
        false : failed. 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::SetElementContainerNeunetWithPHDep "void UtsusemiEventDataConverterNeunetWithPHDep::SetElementContainerNeunetWithPHDep(UInt4 outer_pixel_id, ElementContainer *ec, UInt4 ph_i, UInt4 caseId=1)
===========================================================================================================================================================
    Sets Histogram into ElementContainer.

    Args:
        outer_pixel_id (UInt4) pixel_id
        ec (ElementContainer*)
        ph_i (UInt4)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::LoadEventDataFiles "Int4 UtsusemiEventDataConverterNeunetWithPHDep::LoadEventDataFiles(UInt4 runNumber, string pathToData=\"\", string pathToT0data=\"\") 

    
Int4 UtsusemiEventDataConverterNeunetWithPHDep::LoadEventDataFiles(vector< UInt4 > runNumbers, string pathToData=\"\", string pathToT0data=\"\")
=================================================================================================================================================
    Loads event data files.

    Args:
        runNumber (UInt4) run number
        runNumbers (<vector<UInt4>) a seriese of run numbers
        pathToData (string) path to root directory of instruments event data folders (\"/data\")
        pathToT0data (string) path to directory to store T0Index event data files

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo 
";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::SetElementContainerMatrix "Int4 UtsusemiEventDataConverterNeunetWithPHDep::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 caseId=1) 

    
Int4 UtsusemiEventDataConverterNeunetWithPHDep::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 runNuber, string pathToData, string pathToT0data=\"\", UInt4 caseId=1) 
    
Int4 UtsusemiEventDataConverterNeunetWithPHDep::SetElementContainerMatrix(ElementContainerMatrix *ecm, vector< UInt4 > runNuber, string pathToData, string pathToT0data=\"\", UInt4 caseId=1)
==============================================================================================================================================================================================
    Sets Histogram into ElementContainerMatrix.
    SetElementContainerMatrix( ElementContainerMatrix* ecm, UInt4 caseId=1 ) SetElementContainerMatrix( ElementContainerMatrix* ecm, string instCode, UInt4 runNuber, string pathToData=\"\", string pathToT0data=\"\", UInt4 caseId=1 )

    Args:
        ecm (ElementContainerMatrix*)
        instCode (string) Instrument code
        runNumber (UInt4) run number
        pathToData (string) path to root directory of instruments event data folders (\"/data\")
        pathToT0data (string) path to directory to store T0Index event data files
        caseId (UInt4) case ID

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo
        -3 : Wrong defined TOF binning info ( failed to load WiringInfo ) 
    
void UtsusemiEventDataConverterNeunetWithPHDep::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 runNumber, UInt4 det_min, UInt4 det_max, UInt4 num_of_pixel, UInt4 ph_min, UInt4 ph_max, UInt4 ph_bin, string histparam=\"tof,0,40000,100\", string pathToData=\"/data\", string pathToT0data=\"\", UInt4 caseId=1) 
";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::LoadTrignetEventFile "void UtsusemiEventDataConverterNeunetWithPHDep::LoadTrignetEventFile(UInt4 runno, string pathToData=\"\", string pathToT0data=\"\") 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::ReadTrignetEventFile "void UtsusemiEventDataConverterNeunetWithPHDep::ReadTrignetEventFile(string pathToTrigData, UInt4 index=0)
===========================================================================================================
    Reads Trignet Event data file for cases.

    Args:
        pathToTrigData (string) path to TrigNET event data files
        index (UInt4) event file index

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::DumpCaseTable "vector< UInt4 > UtsusemiEventDataConverterNeunetWithPHDep::DumpCaseTable(UInt4 i1, UInt4 i2, bool isI1Size, bool isI2Size)
===========================================================================================================================
    Dumps table of cases.

    Args:
        i1 (UInt4)
        i2 (UInt4)
        isI1Size (bool)
        isI2Size (bool)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::SetElementContainerMatrixForPseudOnLineMon "Int4 UtsusemiEventDataConverterNeunetWithPHDep::SetElementContainerMatrixForPseudOnLineMon(ElementContainerMatrix *ecm, UInt4 caseId=1, UInt4 runNo=999999)
============================================================================================================================================================
    Sets histograms to ElementContainermatrix as pseud on-line monitor.

    Args:
        ecm (ElementContainerMatrix*)
        caseId (UInt4) case ID
        runNo (UInt4) run number
        isI2Size (bool)

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo
        -3 : Wrong defined TOF binning info ( failed to load WiringInfo ) 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::SetDataPathTest "Int4 UtsusemiEventDataConverterNeunetWithPHDep::SetDataPathTest(string dataPath, string t0Path, UInt4 runNo) 

";
%feature("docstring") UtsusemiEventDataConverterNeunetWithPHDep::PutListOfCounterConditions "vector< Double > UtsusemiEventDataConverterNeunetWithPHDep::PutListOfCounterConditions() 

";
// File: classUtsusemiEventDataConverterRPMT.xml

%feature("docstring") UtsusemiEventDataConverterRPMT "

    Load Event Data and convert to Histogram from 2d-scintillation counter PCMT.
    LoadParamFiles( \"WiringInfo.xml\", \"DetectorInfo.xml\", \"CaseInfo.xml\" ) LoadTrignetEventFile( runNo, \"/data\", \"\" ) SetHistAllocation() ecm = ElementContainerMatrix() SetElementContainerMatrix( ecm, runNo, \"/data\", \"\" )
    C++ includes: UtsusemiEventDataConverterRPMT.hh 

";
%feature("docstring") UtsusemiEventDataConverterRPMT::UtsusemiEventDataConverterRPMT "UtsusemiEventDataConverterRPMT::UtsusemiEventDataConverterRPMT()
=================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterRPMT::~UtsusemiEventDataConverterRPMT "UtsusemiEventDataConverterRPMT::~UtsusemiEventDataConverterRPMT()
==================================================================
    Destructor. 

";
// File: classUtsusemiEventDataConverterReadoutTemplate.xml

%feature("docstring") UtsusemiEventDataConverterReadoutTemplate "

    Expansion of Template class for Convesion of event data from Readout module.
    read EvnetDataFile
    Decode Event data using Decode module
    C++ includes: UtsusemiEventDataConverterReadoutTemplate.hh 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::UtsusemiEventDataConverterReadoutTemplate "UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::UtsusemiEventDataConverterReadoutTemplate()
=================================================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::~UtsusemiEventDataConverterReadoutTemplate "UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::~UtsusemiEventDataConverterReadoutTemplate()
==================================================================================================
    Destructor. 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::ReadEventData "void UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::ReadEventData(UInt4 daqId, UInt4 modNo)
==================================================================================================
    Reads Event data file to make histograms.

    Args:
        daqId (UInt4) DAQ id
        modNo (UInt4) module No

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::CheckPulseIdTables "void UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::CheckPulseIdTables()
===============================================================================
    Compares PulseId between ReadoutGate and Readout.
    to make unified T0Index

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::LoadEventDataFiles "Int4 UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::LoadEventDataFiles(UInt4 runNumber, string pathToData, string pathToT0data) 

    
Int4 UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::LoadEventDataFiles(vector< UInt4 > runNumbers, string pathToData, string pathToT0data)
=================================================================================================================================================
    Reads Event data file to make histograms.

    Args:
        runNumber (UInt4) Run number
        runNumbers (vector<UInt4>) Run numbers
        pathToData (string) path to data folder like /data
        pathToT0Data (string) path to t0 index event data folder like /data

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo 
";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::SetElementContainerReadout "void UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::SetElementContainerReadout(UInt4 outer_pixel_id, ElementContainer *ec, UInt4 caseId)
===============================================================================================================================================
    Sets ElementContaienr from stored gsl_histogram.

    Args:
        outer_pixel_id (UInt4) Pixel ID
        ec (ElementContainer) target ElementContainer
        caseId (UInt4) Case ID

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::LoadParamFiles "bool UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::LoadParamFiles(string w_file, string d_file, string c_file=\"\")
===========================================================================================================================
    Loads parameter files.
    This executes SetEventParams and SetCaseInfoParams of EventDataConverterTemplate.

    Args:
        w_file (string) Wiring Info file path
        d_file (string) Detector Info file path
        c_file (string) Case Info file path

    Returns:
        true : succeeded.
        false : failed. 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::SetElementContainerMatrix "Int4 UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 caseId=1) 

    
Int4 UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 runNuber, string pathToData, string pathToT0data=\"\", UInt4 caseId=1) 
    
Int4 UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::SetElementContainerMatrix(ElementContainerMatrix *ecm, vector< UInt4 > runNuber, string pathToData, string pathToT0data=\"\", UInt4 caseId=1)
========================================================================================================================================================================================================
    Sets Histogram into ElementContainerMatrix.
    SetElementContainerMatrix( ElementContainerMatrix* ecm, UInt4 caseId=1 ) SetElementContainerMatrix( ElementContainerMatrix* ecm, string instCode, UInt4 runNuber, string pathToData=\"\", string pathToT0data=\"\", UInt4 caseId=1 )

    Args:
        ecm (ElementContainerMatrix*)
        instCode (string) Instrument code
        runNumber (UInt4) run number
        pathToData (string) path to root directory of instruments event data folders (\"/data\")
        pathToT0data (string) path to directory to store T0Index event data files
        caseId (UInt4) case ID

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo
        -3 : Wrong defined TOF binning info ( failed to load WiringInfo ) 
";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::LoadTrignetEventFile "void UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::LoadTrignetEventFile(UInt4 runno, string pathToData=\"\", string pathToT0data=\"\") 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::ReadTrignetEventFile "void UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::ReadTrignetEventFile(string pathToTrigData, UInt4 index=0)
=====================================================================================================================
    Reads Trignet Event data file for cases.

    Args:
        pathToTrigData (string) path to TrigNET event data files
        index (UInt4) event file index

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::DumpCaseTable "vector< UInt4 > UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::DumpCaseTable(UInt4 i1, UInt4 i2, bool isI1Size, bool isI2Size)
=====================================================================================================================================
    Dumps table of cases.

    Args:
        i1 (UInt4)
        i2 (UInt4)
        isI1Size (bool)
        isI2Size (bool)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::SetElementContainerMatrixForPseudOnLineMon "Int4 UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::SetElementContainerMatrixForPseudOnLineMon(ElementContainerMatrix *ecm, UInt4 caseId=1, UInt4 runNo=999999)
======================================================================================================================================================================
    Sets histograms to ElementContainermatrix as pseud on-line monitor.

    Args:
        ecm (ElementContainerMatrix*)
        caseId (UInt4) case ID
        runNo (UInt4) run number
        isI2Size (bool)

    Returns:
        0 : succeed
        -1 : Not found data folder with given run numbers
        -2 : Never loaded WiringInfo
        -3 : Wrong defined TOF binning info ( failed to load WiringInfo ) 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::SetDataPathTest "Int4 UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::SetDataPathTest(string dataPath, string t0Path, UInt4 runNo) 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::PutListOfCounterConditions "vector< Double > UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::PutListOfCounterConditions() 

";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::SetTofOriginShift "bool UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::SetTofOriginShift(UInt4 cType) 

    
bool UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::SetTofOriginShift(UInt4 cType, vector< Double > params) 
";
%feature("docstring") UtsusemiEventDataConverterReadoutTemplate::_SetElementContainerMatrix "virtual Int4 UtsusemiEventDataConverterReadoutTemplate< T1, T2 >::_SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 caseId=1)=0 

";
// File: classUtsusemiEventDataConverterReadoutWLSF32Template.xml

%feature("docstring") UtsusemiEventDataConverterReadoutWLSF32Template "

    Expansion of Template class for Convesion with Pulse Height.
    from EventData to Histogram on offline. read EvnetDataFile
    Decode Event data using Decode module
    Increment to gls histogram and make Pulse Height
    Put Pulse Height into HeaderBase for each ElementContainer This template requires the instanse successing UtsusemiNeutronEventDecorder.
    C++ includes: UtsusemiEventDataConverterReadoutWLSF32Template.hh 

";
%feature("docstring") UtsusemiEventDataConverterReadoutWLSF32Template::UtsusemiEventDataConverterReadoutWLSF32Template "UtsusemiEventDataConverterReadoutWLSF32Template< T1, T2 >::UtsusemiEventDataConverterReadoutWLSF32Template() 

";
%feature("docstring") UtsusemiEventDataConverterReadoutWLSF32Template::~UtsusemiEventDataConverterReadoutWLSF32Template "UtsusemiEventDataConverterReadoutWLSF32Template< T1, T2 >::~UtsusemiEventDataConverterReadoutWLSF32Template() 

";
%feature("docstring") UtsusemiEventDataConverterReadoutWLSF32Template::Increment "void UtsusemiEventDataConverterReadoutWLSF32Template< T1, T2 >::Increment(UInt4 daqId, UInt4 moduleNo, const UChar *data, UInt4 size, UInt4 ThNum, vector< Double > *Offset, vector< UInt4 > *Case)
====================================================================================================================================================================================================
    Increment intensity.
    Increment intensity of histogram by using information from decoded event

    Args:
        daqId (UInt4) DAQ id
        moduleNo (UInt4) Module No
        data (UChar*) event data
        size (UInt4) size of event data
        ThNum (UInt4) thread number
        Offset (Double) offset value

    Returns:
        None
        < This is Increment function
        < Why this needs ? Because DecodeEventData require different argument moduleNo. 

";
// File: classUtsusemiEventDataConverterSample.xml

%feature("docstring") UtsusemiEventDataConverterSample "

    Load Event Data and convert to Histogram for Inelastic scattering.
    C++ includes: UtsusemiEventDataConverterSample.hh 

";
%feature("docstring") UtsusemiEventDataConverterSample::UtsusemiEventDataConverterSample "UtsusemiEventDataConverterSample::UtsusemiEventDataConverterSample()
=====================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterSample::~UtsusemiEventDataConverterSample "UtsusemiEventDataConverterSample::~UtsusemiEventDataConverterSample()
======================================================================
    Destructor. 

";
// File: classUtsusemiEventDataConverterSimpleNeunet.xml

%feature("docstring") UtsusemiEventDataConverterSimpleNeunet "

    Load single event data file to convert to histogram briefly.
    tt= UtsusemiEventDataConverterSimpleNeunet() Set the number of pixels in a PSD tt.SetNumOfPixel(100) Set ABC parameters for each PSD A, B, C = ( 1100.000, 1.0, 65.00 ) tt.SetPsdParam( A, B, C ) Set min LLD and max LLD tt.SetPsdPH( 512, 4096 ) Set parameters for histogram conversion tt.SetHistParams( \"tof,0,40000,100\" ) Read event data file(s) to create histogram modNo = 0 tt.ReadEventData( modNo, \"SIK000373_00_000_000.edb\" ) Set histogram to ElementContainerMatrix ecm = ElementContainerMatrix() tt.SetElementContainerMatrix( ecm )
    C++ includes: UtsusemiEventDataConverterSimpleNeunet.hh 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::UtsusemiEventDataConverterSimpleNeunet "UtsusemiEventDataConverterSimpleNeunet::UtsusemiEventDataConverterSimpleNeunet()
=================================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::~UtsusemiEventDataConverterSimpleNeunet "UtsusemiEventDataConverterSimpleNeunet::~UtsusemiEventDataConverterSimpleNeunet()
==================================================================================
    Destructor. 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::SetL1 "void UtsusemiEventDataConverterSimpleNeunet::SetL1(Double L1) 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::SetNumOfMod "void UtsusemiEventDataConverterSimpleNeunet::SetNumOfMod(UInt4 n)
==================================================================
    Sets the number of NEUNET modules.
    This number is used to calculate detId (= n * 8)

    Args:
        n (UInt4) the number of NEUNET modules

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::SetNumOfPixel "void UtsusemiEventDataConverterSimpleNeunet::SetNumOfPixel(UInt4 _numPix)
==========================================================================
    Sets the number of pixels in a PSD.

    Args:
        _numPix (UInt4) the number of pixels in a PSD

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::SetPsdParam "void UtsusemiEventDataConverterSimpleNeunet::SetPsdParam(Double _A, Double _B, Double _C)
==========================================================================================
    Sets A B C parameters to all PSD.

    Args:
        _A (Double) parameter A
        _B (Double) parameter B
        _C (Double) parameter C

    Returns:
        None 

    
bool UtsusemiEventDataConverterSimpleNeunet::SetPsdParam(UInt4 detId, Double _A, Double _B, Double _C)
=======================================================================================================
    Sets A B C parameters to a PSD of given detId.

    Args:
        detId (UInt4) target detector ID
        _A (Double) parameter A
        _B (Double) parameter B
        _C (Double) parameter C

    Returns:
        true setting is succeeded
        false failed setting 
";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::SetPsdPosition "bool UtsusemiEventDataConverterSimpleNeunet::SetPsdPosition(UInt4 detId, vector< Double > det_info)
====================================================================================================
    Sets psd position information for each PSD of given detId.
    ( Under construction ) 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::SetPsdPH "void UtsusemiEventDataConverterSimpleNeunet::SetPsdPH(Double _minPH, Double _maxPH=4096)
=========================================================================================
    Sets the limitation for the pulse height.

    Args:
        _minPH (Double) lower limit of pulse height
        _maxPH (Double) upper limit of pulse height

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::SetPsdInfo "void UtsusemiEventDataConverterSimpleNeunet::SetPsdInfo(Double deltaX, Double offsetX)
=======================================================================================
    Sets PSD information for all PSD.

    Args:
        _minPH (Double) lower limit of pulse height
        _maxPH (Double) upper limit of pulse height

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::SetHistParams "bool UtsusemiEventDataConverterSimpleNeunet::SetHistParams(string _params)
===========================================================================
    Sets parameters to create histogram.

    Args:
        _params (String) histogram parameters

    Returns:
        true setting is succeeded
        false failed setting 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::ReadEventData "bool UtsusemiEventDataConverterSimpleNeunet::ReadEventData(UInt4 modNo, string _file)
======================================================================================
    Load event data file.

    Args:
        modNo (UInt4) NEUNET module No
        _file (String) the path to event data file

    Returns:
        true setting is succeeded
        false failed setting 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::SetElementContainerMatrix "bool UtsusemiEventDataConverterSimpleNeunet::SetElementContainerMatrix(ElementContainerMatrix *_ecm)
=====================================================================================================
    Sets created histogram data into given ElementContainerMatrix.

    Args:
        _ecm (ElementContainerMatrix) container

    Returns:
        true setting is succeeded
        false failed setting 

";
%feature("docstring") UtsusemiEventDataConverterSimpleNeunet::Test "void UtsusemiEventDataConverterSimpleNeunet::Test(ElementContainerMatrix *_ecm, UInt4 modNo, string _filePath) 

";
// File: classUtsusemiEventDataConverterTemplate.xml

%feature("docstring") UtsusemiEventDataConverterTemplate "

    Template class for Convesion.
    from EventData to Histogram on offline. read EvnetDataFile
    Decode Event data using Decode module
    Increment to gls histogram This template requires the instanse successing UtsusemiNeutronEventDecorder.
    C++ includes: UtsusemiEventDataConverterTemplate.hh 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::UtsusemiEventDataConverterTemplate "UtsusemiEventDataConverterTemplate< T1, T2 >::UtsusemiEventDataConverterTemplate()
===================================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::~UtsusemiEventDataConverterTemplate "UtsusemiEventDataConverterTemplate< T1, T2 >::~UtsusemiEventDataConverterTemplate()
====================================================================================
    Destructor. 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutEventDecoder "T1* UtsusemiEventDataConverterTemplate< T1, T2 >::PutEventDecoder()
====================================================================
    Puts instanse of event decoder class.

    Returns:
        instanse of event decoder class 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutCaseDecoder "T2* UtsusemiEventDataConverterTemplate< T1, T2 >::PutCaseDecoder()
===================================================================
    Puts instanse of case decoder class.

    Returns:
        instanse of case decoder class 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetEventParams "bool UtsusemiEventDataConverterTemplate< T1, T2 >::SetEventParams(std::string wiring_file, std::string detector_file)
======================================================================================================================
    Sets Wiring Info and Detector Info files.

    Args:
        wiring_file (string) path to Wiring Info file
        detector_file (string) path to Detector Info file

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetCaseInfoParams "void UtsusemiEventDataConverterTemplate< T1, T2 >::SetCaseInfoParams(std::string pathToCaseInfo)
=================================================================================================
    Sets CaseInfo file.

    Args:
        pathToCaseInfo (string) path to caseInfo file

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::AllocateGslHist "void UtsusemiEventDataConverterTemplate< T1, T2 >::AllocateGslHist(UInt4 numOfPixel=0, UInt4 numOfCases=0)
===========================================================================================================
    Allocate memory for GSL Histogram.
    This makes gslhistogram with the number of numOfPixel * numOfCases

    Args:
        numOfPixel (UInt4) the number of pixels
        numOfPixel (UInt4) the number of cases

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetHistBin "void UtsusemiEventDataConverterTemplate< T1, T2 >::SetHistBin(UInt4 innerPixelId, Double *tof, UInt4 Size)
===========================================================================================================
    Set binning of histogram with array.

    Args:
        innerPixelId (UInt4) inner pixel id
        tof (Double*) array of tof
        Size (UInt4) the number of array

    Returns:
        None 

    
void UtsusemiEventDataConverterTemplate< T1, T2 >::SetHistBin(UInt4 innerPixelId, vector< Double > xaxis)
==========================================================================================================
    Set binning of histogram with vector.
    This calls SetHistBin.

    Args:
        innerPixelId (UInt4) inner pixel id
        xaxis (vector<Double>) vector of tof

    Returns:
        None 
    
void UtsusemiEventDataConverterTemplate< T1, T2 >::SetHistBin()
================================================================
    Set binning of histogram.
    This calls SetHistBin using information loaded from wiring info and detector info
    return None 
    
void UtsusemiEventDataConverterTemplate< T1, T2 >::SetHistBin(ElementContainerMatrix *ecm, std::string _key=\"\") 
";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetHistAllocation "void UtsusemiEventDataConverterTemplate< T1, T2 >::SetHistAllocation(UInt4 num_of_multh=0)
===========================================================================================
    Allocation of GSL-Histogram and SetHistBin.
    This executes simple allocation as AllocateGslHist(); SethistBin();

    Args:
        num_of_multh (UInt4) set _NumOfMulTh if num_of_multh!=0

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::Increment "void UtsusemiEventDataConverterTemplate< T1, T2 >::Increment(UInt4 daqId, UInt4 moduleNo, const UChar *data, UInt4 size, UInt4 ThNum, vector< Double > *Offset, vector< UInt4 > *Case)
=======================================================================================================================================================================================
    Increment intensity.
    Increment intensity of histogram by using information from decoded event

    Args:
        daqId (UInt4) DAQ id
        moduleNo (UInt4) Module No
        data (UChar*) event data
        size (UInt4) size of event data
        ThNum (UInt4) thread number
        Offset (Double) offset value

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PreIncrement "void UtsusemiEventDataConverterTemplate< T1, T2 >::PreIncrement(UInt4 daqId, UInt4 moduleNo, const UChar *data, vector< UInt8 > T0Table, vector< Double > ClockTable, vector< vector< UInt4 > * > *CaseTable) 

    
void UtsusemiEventDataConverterTemplate< T1, T2 >::PreIncrement(UInt4 daqId, UInt4 moduleNo, const UChar *data, vector< UInt8 > T0Table)
=========================================================================================================================================
    Pre-process to convert event data to histogam.
    Pre-process to convert event data to histogam with multh-threading.

    Args:
        daqId (UInt4) DAQ id
        moduleNo (UInt4) module No
        data (UChar*) event data
        T0Table (vecrot<UInt4>) T0 index
        ClockTable (vector<Double>) Differences between instrument clocks
        CaseTable (vector<vector<UInt4>>) Table of cases pattern

    Returns:
        None 
";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetDataPathOld "void UtsusemiEventDataConverterTemplate< T1, T2 >::SetDataPathOld(std::string dataPath, std::string t0Path, vector< UInt4 > runNumbers, bool isReset=false) 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetDataPath "void UtsusemiEventDataConverterTemplate< T1, T2 >::SetDataPath(std::string dataPath, std::string t0Path, UInt4 runNo, bool isReset=false, vector< vector< vector< vector< Int4 > * > * > * > *_PixelInfoStore=NULL, vector< pair< UInt4, UInt4 > > *maskModules=NULL, bool makeT0b=true) 

    
void UtsusemiEventDataConverterTemplate< T1, T2 >::SetDataPath(std::string dataPath, std::string t0Path, vector< UInt4 > runNumbers, bool isReset=false, vector< vector< vector< vector< Int4 > * > * > * > *_PixelInfoStore=NULL, vector< pair< UInt4, UInt4 > > *maskModules=NULL, bool makeT0b=true)
========================================================================================================================================================================================================================================================================================================
    Sets path to Event data files.
    This makes list of Event data files and T0 event data files to be read. This finds data directories like /data/XXX, /data/XXX01, /data/XXX02, ... /data/XXX99, then search run_folder and data files in found data directoris from beggning as XXX -> XXX01 -> XXX02 -> ... If data files (edb) are founds, searching in directories stops.

    Args:
        dataPath (string) Path to Event data folder ( \"/data\" )
        t0Path (string) Path to T0Event data folder
        runNo (UInt4) RunNo
        runNumbers (vector<UInt4> list of RunNo to be combined
        isReset (bool) Resets previous file list or not
        _PixelInfoStore
        maskModules
        makeT0b (bool) true: try to create t0b

    Returns:
        None 
";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutDataFiles "vector< string > UtsusemiEventDataConverterTemplate< T1, T2 >::PutDataFiles(UInt4 daqId, UInt4 modNo, bool isEdb=true)
=======================================================================================================================
    Puts data file list.
    This puts data files with given daqId, modNo from made list of data files

    Args:
        daqId (UInt4) DAQ id
        modNo (UInt4) module No
        isEdb (bool) event data file (true) or t0b file (false)

    Returns:
        file list (vector<stirng>) 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutFilesSize "vector< UInt8 > UtsusemiEventDataConverterTemplate< T1, T2 >::PutFilesSize(vector< string > files)
===================================================================================================
    Puts file sizes of given pathes.

    Args:
        files (vector<string>) path list

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::ReadEventData "void UtsusemiEventDataConverterTemplate< T1, T2 >::ReadEventData(UInt4 daqId, UInt4 modNo)
===========================================================================================
    Read Event data file to make histograms.

    Args:
        daqId (UInt4) DAQ id
        modNo (UInt4) module No

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutHistId "UInt4 UtsusemiEventDataConverterTemplate< T1, T2 >::PutHistId(UInt4 PixelId, UInt4 CaseId=1)
=============================================================================================
    Puts Histogram ID from outer PixelId and CaseId.
    Histogram ID is used for allocated GSL-Histograms.

    Args:
        PixelId (UInt4) outer pixel ID
        CaseId (UInt4) case id

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutHist "vector< Double > UtsusemiEventDataConverterTemplate< T1, T2 >::PutHist(UInt4 PixelId, UInt4 CaseId=1)
======================================================================================================
    Puts intensity of histogram by outer PixelId and CaseId.

    Args:
        PixelId (UInt4) outer pixel ID
        CaseId (UInt4) case id

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutErr "vector< Double > UtsusemiEventDataConverterTemplate< T1, T2 >::PutErr(UInt4 PixelId, UInt4 CaseId=1)
=====================================================================================================
    Puts error of histogram by outer PixelId and CaseId.

    Args:
        PixelId (UInt4) outer pixel ID
        CaseId (UInt4) case id

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::TimeDependBackGroundCorrection "Double UtsusemiEventDataConverterTemplate< T1, T2 >::TimeDependBackGroundCorrection(bool isIntensity, vector< Double > *tof_vec, vector< Double > *hist_vec, vector< Double > *bg_info, vector< Double > *ret)
===============================================================================================================================================================================================================
    Executes time-depend background correction.

    Args:
        isIntensity (bool) hist_vec is the intensity (true) or errors (false).
        tof_vec (vector<Double>) TOF vector including backgrond region.
        hist_vec (vector<Double>) The intensity or error values
        bg_info (vector<Double>) Background Info [0]:patern, [1]:first tof val, [2]:last tof val
        ret (vector<Double>) corrected hist_vec.

    Returns:
        background intensity per unit (Double) 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::InitTimeDependBackGroundList "void UtsusemiEventDataConverterTemplate< T1, T2 >::InitTimeDependBackGroundList() 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::TimeDependBackGroundCorrectionByList "bool UtsusemiEventDataConverterTemplate< T1, T2 >::TimeDependBackGroundCorrectionByList(bool isIntensity, vector< Double > *tof_vec, vector< Double > *hist_vec, UInt4 pixelId, UInt4 multh, vector< Double > *ret, UInt4 caseId=1) 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::SaveTimeDependBackGroundListToFile "bool UtsusemiEventDataConverterTemplate< T1, T2 >::SaveTimeDependBackGroundListToFile(std::string filePath, UInt4 caseId=1) 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::ReadTimeDependBackGroundListFromFile "bool UtsusemiEventDataConverterTemplate< T1, T2 >::ReadTimeDependBackGroundListFromFile(std::string filePath) 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::ClearTimeDependBackGroundList "void UtsusemiEventDataConverterTemplate< T1, T2 >::ClearTimeDependBackGroundList() 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::ReadCaseEvent "void UtsusemiEventDataConverterTemplate< T1, T2 >::ReadCaseEvent(UInt4 index, vector< string > evt_files, vector< string > t0b_files) 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::ReadCaseEventFiles "void UtsusemiEventDataConverterTemplate< T1, T2 >::ReadCaseEventFiles(UInt4 index, vector< string > evt_files, vector< string > t0b_files)
===========================================================================================================================================
    Reads event data files for cases.

    Args:
        index (UInt4) index for files ( XXX001000_00_000_000.edb, _001.edb ... has same index )
        evt_files (vector<string>) pathes to neutron event data file
        t0b_files (vector<string>) pathes to t0b event data file

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetFlagOfPulseIdCheck "void UtsusemiEventDataConverterTemplate< T1, T2 >::SetFlagOfPulseIdCheck(bool flag=true)
=========================================================================================
    Sets flag of Pulse iD check.
    This flag is used to compare pulse id between neutrons event data and case (trignet) event data

    Args:
        flag (bool) true : do check on reading case event data

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetElementContainer "void UtsusemiEventDataConverterTemplate< T1, T2 >::SetElementContainer(UInt4 PixelId, ElementContainer *ec, UInt4 caseId=0)
============================================================================================================================
    Put histogram data into ElementContainer with Case.
    Before using this method, target ElementContainer must be created.

    Args:
        PixelId (UInt4) pixel Id
        ec (ElementContainer) target ElementContainer
        caseId (UInt4) case Id

    Returns:
        None
        }else if (tof_bin_type<5){ ec->Add(xlabel.first,_gslHist->at(innerId)->PutBin(),xlabel.second); if (_runNumber>0){ ec->Add(ylabel.first,PutHist( outerPixelId, caseId ),ylabel.second); ec->Add(elabel.first,PutErr( outerPixelId, caseId ),elabel.second ); }else{ vector<Double> dummy( (ec->Put(xlabel.first).size()-1),1 ); ec->Add(ylabel.first,dummy,ylabel.second); ec->Add(elabel.first,dummy,elabel.second ); } ec->SetKeys(xlabel.first,ylabel.first,elabel.first); }else if ((tof_bin_type==12)||(tof_bin_type==13)||(tof_bin_type==20)||(tof_bin_type==23)||(tof_bin_type==24)||(tof_bin_type==25)){ ec->Add(xlabel.first,_EventDecoder->PutXaxis(),xlabel.second); if (_runNumber>0){ ec->Add(ylabel.first,PutHist( outerPixelId, caseId ),ylabel.second); ec->Add(elabel.first,PutErr( outerPixelId, caseId ),elabel.second ); }else{ vector<Double> dummy( (ec->Put(xlabel.first).size()-1),1 ); ec->Add(ylabel.first,dummy,ylabel.second); ec->Add(elabel.first,dummy,elabel.second ); }
        ec->SetKeys(xlabel.first,ylabel.first,elabel.first); }else if ((tof_bin_type==21)||(tof_bin_type==22)||(tof_bin_type==27)){ vector<Double> xxv = _EventDecoder->PutXaxis(); vector<Double> yyv = PutHist( outerPixelId, caseId ); vector<Double> eev = PutErr( outerPixelId, caseId ); reverse( xxv.begin(),xxv.end() ); reverse( yyv.begin(),yyv.end() ); reverse( eev.begin(),eev.end() ); ec->Add(xlabel.first,xxv,xlabel.second); ec->Add(ylabel.first,yyv,ylabel.second); ec->Add(elabel.first,eev,elabel.second ); ec->SetKeys(xlabel.first,ylabel.first,elabel.first); 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::ResetHistogram "void UtsusemiEventDataConverterTemplate< T1, T2 >::ResetHistogram()
====================================================================
    Reset Histogram.
    Clear all values in bins of GslHistogram ( binning is kept )

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutNumOfCases "UInt4 UtsusemiEventDataConverterTemplate< T1, T2 >::PutNumOfCases()
====================================================================
    Return number of cases.

    Returns:
        UInt4 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutMeasTimeList "vector<Double> UtsusemiEventDataConverterTemplate< T1, T2 >::PutMeasTimeList() 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutListOfCases "vector<UInt4> UtsusemiEventDataConverterTemplate< T1, T2 >::PutListOfCases()
=============================================================================
    Puts list of cases.

    Args:
        None

    Returns:
        list of cases 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutNumOfT0ListInCases "vector<UInt4> UtsusemiEventDataConverterTemplate< T1, T2 >::PutNumOfT0ListInCases() 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::PutMeasTime "vector<Double> UtsusemiEventDataConverterTemplate< T1, T2 >::PutMeasTime()
===========================================================================
    put measuring period from instrument clock event
    This returns vector with 12 params. If conversion is failed, size of returned vector is one.

    Args:
        None

    Returns:
        vector<Double> vector with 12 params for begin time and end time (year,month,day,hour,minute,second,sub-second) x 2 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::AddRunInfoToHeader "bool UtsusemiEventDataConverterTemplate< T1, T2 >::AddRunInfoToHeader(HeaderBase *_hh, UInt4 caseId=1) 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetRangeOfSingleTimeSlicing "bool UtsusemiEventDataConverterTemplate< T1, T2 >::SetRangeOfSingleTimeSlicing(double startSec, double endSec)
===============================================================================================================
    Sets time range for time slice of event data.
    Values for time are indicated the passed time [sec] from head of event data

    Args:
        startSec start time [sec]
        endSec end time [sec]

    Returns:
        true succeeded
        false failed 

    
bool UtsusemiEventDataConverterTemplate< T1, T2 >::SetRangeOfSingleTimeSlicing(std::string startDate, std::string endDate)
===========================================================================================================================
    Sets time range for time slice of event data.
    Values for time are indicated the passed time [sec] from head of event data string format : \"YYYY,MM,DD,hh,mm,ss,s.ss\", \"2011,1,22,13,54,22,0.54\"

    Args:
        startDate start date string
        endDate end date string

    Returns:
        true succeeded
        false failed 
";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetTimeSlicing "void UtsusemiEventDataConverterTemplate< T1, T2 >::SetTimeSlicing(vector< Double > tmp) 

";
%feature("docstring") UtsusemiEventDataConverterTemplate::SetFramePeriod "void UtsusemiEventDataConverterTemplate< T1, T2 >::SetFramePeriod(Double _time) 

";
// File: classUtsusemiEventDataConverterTemplateWithPH.xml

%feature("docstring") UtsusemiEventDataConverterTemplateWithPH "

    Expansion of Template class for Convesion with Pulse Height.
    from EventData to Histogram on offline. read EvnetDataFile
    Decode Event data using Decode module
    Increment to gls histogram and make Pulse Height
    Put Pulse Height into HeaderBase for each ElementContainer This template requires the instanse successing UtsusemiNeutronEventDecorder.
    C++ includes: UtsusemiEventDataConverterTemplateWithPH.hh 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPH::UtsusemiEventDataConverterTemplateWithPH "UtsusemiEventDataConverterTemplateWithPH< T1, T2 >::UtsusemiEventDataConverterTemplateWithPH() 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPH::~UtsusemiEventDataConverterTemplateWithPH "UtsusemiEventDataConverterTemplateWithPH< T1, T2 >::~UtsusemiEventDataConverterTemplateWithPH() 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPH::SetHistAllocation "void UtsusemiEventDataConverterTemplateWithPH< T1, T2 >::SetHistAllocation() 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPH::Increment "void UtsusemiEventDataConverterTemplateWithPH< T1, T2 >::Increment(UInt4 daqId, UInt4 moduleNo, const UChar *data, UInt4 size, UInt4 ThNum, vector< Double > *Offset, vector< UInt4 > *Case)
=============================================================================================================================================================================================
    Increment intensity.
    Increment intensity of histogram by using information from decoded event

    Args:
        daqId (UInt4) DAQ id
        moduleNo (UInt4) Module No
        data (UChar*) event data
        size (UInt4) size of event data
        ThNum (UInt4) thread number
        Offset (Double) offset value

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPH::PutPulseHeight "vector<Int4> UtsusemiEventDataConverterTemplateWithPH< T1, T2 >::PutPulseHeight(UInt4 det_id) 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPH::SetMaxOfChannels "void UtsusemiEventDataConverterTemplateWithPH< T1, T2 >::SetMaxOfChannels(UInt4 max_channel=4096)
==================================================================================================
    Sets maximum number of channels for Pulse Height.

    Args:
        max_channels (UInt4) maximum number of channels

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPH::SetIsGateNet "void UtsusemiEventDataConverterTemplateWithPH< T1, T2 >::SetIsGateNet(bool isGateNet=false)
============================================================================================
    Sets maximum number of channels for Pulse Height.

    Args:
        isGateNet (bool) whether this data comes from GateNET or not.

    Returns:
        None 

";
// File: classUtsusemiEventDataConverterTemplateWithPHDep.xml

%feature("docstring") UtsusemiEventDataConverterTemplateWithPHDep "

    Expansion of Template class for Convesion with Pulse Height Dependency.
    from EventData to Histogram on offline. read EvnetDataFile
    Decode Event data using Decode module
    Increment to gls histogram and make Pulse Height
    Put Pulse Height into HeaderBase for each ElementContainer This template requires the instanse successing UtsusemiNeutronEventDecorder.
    C++ includes: UtsusemiEventDataConverterTemplateWithPHDep.hh 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPHDep::UtsusemiEventDataConverterTemplateWithPHDep "UtsusemiEventDataConverterTemplateWithPHDep< T1, T2 >::UtsusemiEventDataConverterTemplateWithPHDep() 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPHDep::~UtsusemiEventDataConverterTemplateWithPHDep "UtsusemiEventDataConverterTemplateWithPHDep< T1, T2 >::~UtsusemiEventDataConverterTemplateWithPHDep() 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPHDep::SetPulseHeightRange "void UtsusemiEventDataConverterTemplateWithPHDep< T1, T2 >::SetPulseHeightRange(UInt4 ph_min, UInt4 ph_max, UInt4 ph_bin) 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPHDep::SetHistAllocation "void UtsusemiEventDataConverterTemplateWithPHDep< T1, T2 >::SetHistAllocation() 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPHDep::Increment "void UtsusemiEventDataConverterTemplateWithPHDep< T1, T2 >::Increment(UInt4 daqId, UInt4 moduleNo, const UChar *data, UInt4 size, UInt4 ThNum, vector< Double > *Offset, vector< UInt4 > *Case)
================================================================================================================================================================================================
    Increment intensity.
    Increment intensity of histogram by using information from decoded event

    Args:
        daqId (UInt4) DAQ id
        moduleNo (UInt4) Module No
        data (UChar*) event data
        size (UInt4) size of event data
        ThNum (UInt4) thread number
        Offset (Double) offset value

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataConverterTemplateWithPHDep::SetIsGateNet "void UtsusemiEventDataConverterTemplateWithPHDep< T1, T2 >::SetIsGateNet(bool isGateNet=false)
===============================================================================================
    Sets maximum number of channels for Pulse Height.

    Args:
        isGateNet (bool) whether this data comes from GateNET or not.

    Returns:
        None 

";
// File: classUtsusemiEventDataConverterWLSF32.xml

%feature("docstring") UtsusemiEventDataConverterWLSF32 "

    Load Event Data and convert to Histogram from 2d-scintillation counter WLSF 32bit mode.
    LoadParamFiles( \"WiringInfo.xml\", \"DetectorInfo.xml\", \"CaseInfo.xml\" ) LoadTrignetEventFile( runNo, \"/data\", \"\" ) SetHistAllocation() ecm = ElementContainerMatrix() SetElementContainerMatrix( ecm, runNo, \"/data\", \"\" )
    C++ includes: UtsusemiEventDataConverterWLSF32.hh 

";
%feature("docstring") UtsusemiEventDataConverterWLSF32::UtsusemiEventDataConverterWLSF32 "UtsusemiEventDataConverterWLSF32::UtsusemiEventDataConverterWLSF32()
=====================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataConverterWLSF32::~UtsusemiEventDataConverterWLSF32 "UtsusemiEventDataConverterWLSF32::~UtsusemiEventDataConverterWLSF32()
======================================================================
    Destructor. 

";
// File: classUtsusemiEventDataMonitorContainer.xml

%feature("docstring") UtsusemiEventDataMonitorContainer "

    Event Data Monitor ( Differential Data Reduction )
    tt = UtsusemiEventDataMonitorXXXX() tt.SetDataFolder( \"/data\" ) tt.ParameterSet( wfile, dfile, cfile ) tt.AddAllDataModules() // repeat below tt.Update() dat = ElementContainerMatrix() tt.Output( dat ) tt.Clear() // if needed
    or tt.UpdataDataModules() tt.IncrementCases() tt.Increment(1,1) // give the only daqId and modNo required dat = ElementContainerMatrix() tt.Output( dat ) tt.Clear() // if needed
    C++ includes: UtsusemiEventDataMonitorTemplate.hh 

";
%feature("docstring") UtsusemiEventDataMonitorContainer::UtsusemiEventDataMonitorContainer "UtsusemiEventDataMonitorContainer::UtsusemiEventDataMonitorContainer()
=======================================================================
    < <filename, file size>
    < <filename, file size> 

    
UtsusemiEventDataMonitorContainer::UtsusemiEventDataMonitorContainer(const UtsusemiEventDataMonitorContainer &obj) 
";
%feature("docstring") UtsusemiEventDataMonitorContainer::~UtsusemiEventDataMonitorContainer "UtsusemiEventDataMonitorContainer::~UtsusemiEventDataMonitorContainer() 

";
// File: classUtsusemiEventDataMonitorMWPC.xml

%feature("docstring") UtsusemiEventDataMonitorMWPC "C++ includes: UtsusemiEventDataMonitorMWPC.hh 

";
%feature("docstring") UtsusemiEventDataMonitorMWPC::UtsusemiEventDataMonitorMWPC "UtsusemiEventDataMonitorMWPC::UtsusemiEventDataMonitorMWPC()
=============================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataMonitorMWPC::~UtsusemiEventDataMonitorMWPC "UtsusemiEventDataMonitorMWPC::~UtsusemiEventDataMonitorMWPC()
==============================================================
    Destructor. 

";
// File: classUtsusemiEventDataMonitorNeunet.xml

%feature("docstring") UtsusemiEventDataMonitorNeunet "C++ includes: UtsusemiEventDataMonitorNeunet.hh 

";
%feature("docstring") UtsusemiEventDataMonitorNeunet::UtsusemiEventDataMonitorNeunet "UtsusemiEventDataMonitorNeunet::UtsusemiEventDataMonitorNeunet()
=================================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataMonitorNeunet::~UtsusemiEventDataMonitorNeunet "UtsusemiEventDataMonitorNeunet::~UtsusemiEventDataMonitorNeunet()
==================================================================
    Destructor. 

";
%feature("docstring") UtsusemiEventDataMonitorNeunet::OutputEC "void UtsusemiEventDataMonitorNeunet::OutputEC(ElementContainer *ec, UInt4 pixelId, UInt4 caseId=1) 

";
%feature("docstring") UtsusemiEventDataMonitorNeunet::PutUtsusemiEventDataConverterNeunet "UtsusemiEventDataConverterNeunet* UtsusemiEventDataMonitorNeunet::PutUtsusemiEventDataConverterNeunet() 

";
// File: classUtsusemiEventDataMonitorRPMT.xml

%feature("docstring") UtsusemiEventDataMonitorRPMT "C++ includes: UtsusemiEventDataMonitorRPMT.hh 

";
%feature("docstring") UtsusemiEventDataMonitorRPMT::UtsusemiEventDataMonitorRPMT "UtsusemiEventDataMonitorRPMT::UtsusemiEventDataMonitorRPMT()
=============================================================
    Constructor. 

";
%feature("docstring") UtsusemiEventDataMonitorRPMT::~UtsusemiEventDataMonitorRPMT "UtsusemiEventDataMonitorRPMT::~UtsusemiEventDataMonitorRPMT()
==============================================================
    Destructor. 

";
// File: classUtsusemiEventDataMonitorTemplate.xml

%feature("docstring") UtsusemiEventDataMonitorTemplate "C++ includes: UtsusemiEventDataMonitorTemplate.hh 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::UtsusemiEventDataMonitorTemplate "UtsusemiEventDataMonitorTemplate< T1 >::UtsusemiEventDataMonitorTemplate(UInt4 ByteOfNeutronEvent=8)
=====================================================================================================
    < Constructor
    < 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::~UtsusemiEventDataMonitorTemplate "UtsusemiEventDataMonitorTemplate< T1 >::~UtsusemiEventDataMonitorTemplate()
============================================================================
    < Destructor
    < 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::PutEventDataConverter "T1* UtsusemiEventDataMonitorTemplate< T1 >::PutEventDataConverter() 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::ParameterSet "void UtsusemiEventDataMonitorTemplate< T1 >::ParameterSet(string _WireingFile, string _DetectorInfoFile, string _CaseInfoFile, UInt4 _MulTh=0, Int4 tofShiftPtnId=-1)
======================================================================================================================================================================
    < ParameterSet sets Event parameters
    <

    Args:
        _WireingFile (string) Wiring Info file path
        _DetectorInfoFile (string) Detector Info file path
        _CaseInfoFile (string)
        tofShiftPtnId (Int4) : this will be included in WiringInfo or DetectorInfo

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::AddDataFiles "void UtsusemiEventDataMonitorTemplate< T1 >::AddDataFiles(string TargetT0EventFilePath, string TargetEventDataFilePath, UInt4 DaqID)
=====================================================================================================================================
    < AddDataFiles adds Event data file(s) and T0Index event data file(s) pathes
    <

    Args:
        TargetT0EventFilePath (string or vector<string>) T0Index event data file path
        TargetEventDataFilePath (string or vector<string>) Event Data file path
        DaqID (UInt4 or vector<UInt4>)

    Returns:
        None 

    
void UtsusemiEventDataMonitorTemplate< T1 >::AddDataFiles(vector< string > TargetT0EventFilePath, vector< string > TargetEventDataFilePath, vector< UInt4 > DaqID) 
";
%feature("docstring") UtsusemiEventDataMonitorTemplate::Increment "void UtsusemiEventDataMonitorTemplate< T1 >::Increment(UInt4 index)
====================================================================
    < Increment increments data
    < This reads difference of data by index and add to histograms note : This is OBSOLETED! first version of differential data reduction

    Args:
        index (UInt4) Index of data

    Returns:
        None 

    
void UtsusemiEventDataMonitorTemplate< T1 >::Increment(bool doRead=true)
=========================================================================
    < Increment
    < This update all data for the differential data reduction

    Args:
        daqId (UInt4)
        modNo (UInt4)

    Returns:
        None 
    
void UtsusemiEventDataMonitorTemplate< T1 >::Increment(UInt4 daqId, UInt4 modNo, bool doRead=true) 
";
%feature("docstring") UtsusemiEventDataMonitorTemplate::SetDataFolder "void UtsusemiEventDataMonitorTemplate< T1 >::SetDataFolder(string dfolder)
===========================================================================
    < SetDataFolder
    < This sets data folder

    Args:
        dfolder (string) path to data folder same as UTSUSEMI_DATA_DIR

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::ClearDataModules "void UtsusemiEventDataMonitorTemplate< T1 >::ClearDataModules()
================================================================
    < ClearDataModules
    < This cleans the list of all modules given by WiringInfo or users

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::SetRunNumber "void UtsusemiEventDataMonitorTemplate< T1 >::SetRunNumber(UInt4 runNo)
=======================================================================
    < SetRunNumber
    < This sets run number of target for differential data reduction

    Args:
        runNo (UInt4) run number

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::AddAllDataModules "void UtsusemiEventDataMonitorTemplate< T1 >::AddAllDataModules()
=================================================================
    < AddAllDataModules
    < This adds all modules described in WiringInfo to the list to be used for differential data reduction

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::AddDataModule "void UtsusemiEventDataMonitorTemplate< T1 >::AddDataModule(UInt4 daqId, UInt4 modNo)
=====================================================================================
    < AddDataModule
    < This adds given modules to the list to be used for differential data reduction

    Args:
        daqId (UInt4)
        modNo (UInt4)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::UpdateDataModules "void UtsusemiEventDataMonitorTemplate< T1 >::UpdateDataModules()
=================================================================
    < UpdateDataModules
    < This updates all modules for the differential data reduction

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::UpdateDataModule "bool UtsusemiEventDataMonitorTemplate< T1 >::UpdateDataModule(UInt4 daqId, UInt4 modNo)
========================================================================================
    < UpdateDataModule
    < This updates given modules for the differential data reduction

    Args:
        daqId (UInt4)
        modNo (UInt4)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::FindTargetFile "pair<string,UInt4> UtsusemiEventDataMonitorTemplate< T1 >::FindTargetFile(UInt4 runNo, UInt4 daqId, UInt4 modNo, UInt4 num, string ext_code, bool useOnlyOneDir=true)
======================================================================================================================================================================
    < FindTargetFile
    < This gets the full path and file size of the data file of the given modules for the differential data reduction

    Args:
        runNO (UInt4)
        daqId (UInt4)
        modNo (UInt4)
        num (UInt4) the count number for same daqId and modNo
        ext_code (string) \".edb\" or \"t0b\"
        useOnlyOneDir (bool) whether using only \"XXX\" data folder or using also \"XXX01\", \"XXX02\"...

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::PutNumOfCases "UInt4 UtsusemiEventDataMonitorTemplate< T1 >::PutNumOfCases() 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::PutListOfCounterConditions "vector<Double> UtsusemiEventDataMonitorTemplate< T1 >::PutListOfCounterConditions()
====================================================================================
    < PutListOfCounterConditions()
    < This shows ListOfCounterConditions

    Args:
        None

    Returns:
        vector<Double> 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::Dump "void UtsusemiEventDataMonitorTemplate< T1 >::Dump(UInt4 ind=0)
===============================================================
    < Dump
    < This shows modules information ( file name, file size )

    Args:
        ind (UInt4) unknown

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::IncrementCases "bool UtsusemiEventDataMonitorTemplate< T1 >::IncrementCases()
==============================================================
    < IncrementCases
    < This update TrigNET data to make caseID list

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::Update "bool UtsusemiEventDataMonitorTemplate< T1 >::Update(bool doRead=true)
======================================================================
    < Updated data
    < This function executes commands below : UpdataDataModules() IncrementCases() Increment()
    bool Update()

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::Output "void UtsusemiEventDataMonitorTemplate< T1 >::Output(string OutputFileName)
===========================================================================
    < Output stored data
    < Output( string OutputFileName ); Output( ElementContainerMatrix* ecm ); Output( ElementContainer* ec, UInt4 pixelId );

    Args:
        OutputFileName (string) saves ElementContainer as files
        ecm (ElementContainerMatrix) gives ElementContainerMatrix
        pixelId (UInt4) pixel Id of ElementContainer to get

    Returns:
        None 

    
void UtsusemiEventDataMonitorTemplate< T1 >::Output(ElementContainerMatrix *ecm, UInt4 caseId=1) 
";
%feature("docstring") UtsusemiEventDataMonitorTemplate::Clear "void UtsusemiEventDataMonitorTemplate< T1 >::Clear()
=====================================================
    < Clear makes stored data empty
    < This makes intensities for each pixels to zero.

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::SetMeasTimeSliced "void UtsusemiEventDataMonitorTemplate< T1 >::SetMeasTimeSliced(HeaderBase *hh)
===============================================================================
    < SetMeasTimeSliced
    < This adds the information of the measurement period for sliced data

    Args:
        hh (HeaderBase*)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::SetKickers "void UtsusemiEventDataMonitorTemplate< T1 >::SetKickers(HeaderBase *hh, UInt4 caseId=0)
========================================================================================
    < SetKickers
    < This adds the number of kickers into HeaderBase

    Args:
        hh (HeaderBase*)
        caseId (UInt4)

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::ClearDataFileSets "void UtsusemiEventDataMonitorTemplate< T1 >::ClearDataFileSets()
=================================================================
    < ClearDataFileSets clears data files
    <

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::PutUpdatedCases "vector<UInt4> UtsusemiEventDataMonitorTemplate< T1 >::PutUpdatedCases()
========================================================================
    < PutUpdatedCases
    < This returns the list of cases that update happened on updating modules

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::ClearUpdatedCases "void UtsusemiEventDataMonitorTemplate< T1 >::ClearUpdatedCases()
=================================================================
    < ClearUpdatedCases
    < This clears the list of cases that update happened on updating modules

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiEventDataMonitorTemplate::AddRunInfoToHeader "bool UtsusemiEventDataMonitorTemplate< T1 >::AddRunInfoToHeader(HeaderBase *_hh, UInt4 caseId=1) 

";
// File: classUtsusemiFilterBase.xml

%feature("docstring") UtsusemiFilterBase "

    Filter used by UtsusemiEventCaseTemplate.
    C++ includes: UtsusemiFilterBase.hh 

";
%feature("docstring") UtsusemiFilterBase::UtsusemiFilterBase "UtsusemiFilterBase::UtsusemiFilterBase()
=========================================
    Constructor. 

";
%feature("docstring") UtsusemiFilterBase::~UtsusemiFilterBase "UtsusemiFilterBase::~UtsusemiFilterBase()
==========================================
    Destructor. 

";
%feature("docstring") UtsusemiFilterBase::PutNumOfCases "UInt4 UtsusemiFilterBase::PutNumOfCases()
==========================================
    Puts numOfCases.

    Args:
        None

    Returns:
        the number of cases 

";
%feature("docstring") UtsusemiFilterBase::PutListOfCases "vector< UInt4 > UtsusemiFilterBase::PutListOfCases()
=====================================================
    Puts list of cases.

    Args:
        None

    Returns:
        list of cases 

";
%feature("docstring") UtsusemiFilterBase::DumpCaseTable "void UtsusemiFilterBase::DumpCaseTable()
=========================================
    Dumps filterCaseTable on screen.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterBase::Clear "void UtsusemiFilterBase::Clear()
=================================
    Clears filterCaseTable and filterPulseIdList.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterBase::ReadCaseEvent "Int4 UtsusemiFilterBase::ReadCaseEvent(UInt4 index, vector< string > evt_files, vector< string > t0b_files)
============================================================================================================
    Reads Case Event file(s).
    This method is called from UtsusemiEventCasesDecoderTemplate class and has a role of the interface to this->ReadTrigEvent method.

    Args:
        index (UInt4) index of TrigNET event file
        evt_files (vector<string>) path to TrigNET event file(s). Given files are must be belong to same runnumber.
        t0b_files (vector<string>) T0 index table for the TrigNET event file

    Returns:
        0 : Succeeded to make filters
        -1 : Failed to make filters 

";
%feature("docstring") UtsusemiFilterBase::MakeFilterTables "void UtsusemiFilterBase::MakeFilterTables()
============================================
    Makes filterCaseTable and filterPulseIdList.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterBase::CheckAmbiguousFrame "void UtsusemiFilterBase::CheckAmbiguousFrame()
===============================================
    Checks and changes ambiguous frames.
    When a frame includes several 'cases', this function changes frame to include a case in a frame.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterBase::GetCaseFromTof "UInt4 UtsusemiFilterBase::GetCaseFromTof(const UInt4 pixelId, Double *tof, vector< UInt4 > *caseVec)
=====================================================================================================
    Returns CaseId from given pixel id and tof.
    This is used in original Increment function.

    Args:
        pixelId (UInt4*) given pixel id
        tof (Double*) tof
        caseVec (vecotr<UInt4>*) given vector of cases

    Returns:
        caseId (UInt4) if 0, this tof will not be incremented to histogram. 

";
%feature("docstring") UtsusemiFilterBase::isTimeSlicing "virtual bool UtsusemiFilterBase::isTimeSlicing() 

";
%feature("docstring") UtsusemiFilterBase::MakeTimeSlicingCases "virtual void UtsusemiFilterBase::MakeTimeSlicingCases(vector< UInt8 > _pulseId, vector< double > _clocks) 

";
%feature("docstring") UtsusemiFilterBase::SetTimeSlicing "virtual void UtsusemiFilterBase::SetTimeSlicing(vector< Double > tmp) 

";
%feature("docstring") UtsusemiFilterBase::ReadCaseInfoFile "Int4 UtsusemiFilterBase::ReadCaseInfoFile(std::string caseInfoFile)
====================================================================
    Reads Case Info file.

    Args:
        caseInfoFile (string) path to Case Info file

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterBase::ReadCaseEventFiles "Int4 UtsusemiFilterBase::ReadCaseEventFiles(UInt4 index, vector< string > evt_files, vector< vector< UInt8 > > t0b_index_list)
===============================================================================================================================
    Reads Case Event Files.

    Args:
        list_dataFile (vector<string>) list of path to Case Event files

    Returns:
        None 

";
// File: classUtsusemiFilterTrignet.xml

%feature("docstring") UtsusemiFilterTrignet "

    Filter used by UtsusemiEventCaseTemplate.
    C++ includes: UtsusemiFilterTrignet.hh 

";
%feature("docstring") UtsusemiFilterTrignet::UtsusemiFilterTrignet "UtsusemiFilterTrignet::UtsusemiFilterTrignet()
===============================================
    Constructor. 

";
%feature("docstring") UtsusemiFilterTrignet::~UtsusemiFilterTrignet "UtsusemiFilterTrignet::~UtsusemiFilterTrignet()
================================================
    Destructor. 

";
%feature("docstring") UtsusemiFilterTrignet::PutListOfCases "vector< UInt4 > UtsusemiFilterTrignet::PutListOfCases()
========================================================
    Puts list of cases.

    Args:
        None

    Returns:
        list of cases 

";
%feature("docstring") UtsusemiFilterTrignet::ReadCaseEvent "Int4 UtsusemiFilterTrignet::ReadCaseEvent(UInt4 index, vector< string > evt_files, vector< string > t0b_files)
===============================================================================================================
    Reads Case Event file(s).
    This method is called from UtsusemiEventCasesDecoderTemplate class and has a role of the interface to this->ReadTrigEvent method.

    Args:
        index (UInt4) index of TrigNET event file
        evt_files (vector<string>) path to TrigNET event file(s). Given files are must be belong to same runnumber.
        t0b_files (vector<string>) T0 index table for the TrigNET event file

    Returns:
        0 : Succeeded to make filters
        -1 : Failed to make filters 

";
%feature("docstring") UtsusemiFilterTrignet::MakeFilterTables "void UtsusemiFilterTrignet::MakeFilterTables()
===============================================
    Makes filterCaseTable and filterPulseIdList.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterTrignet::GetCaseFromTof "UInt4 UtsusemiFilterTrignet::GetCaseFromTof(const UInt4 pixelId, Double *tof, vector< UInt4 > *caseVec)
========================================================================================================
    Returns CaseId from given pixel id and tof.
    This is used in original Increment function.

    Args:
        pixelId (UInt4*) given pixel id
        tof (Double*) tof
        caseVec (vecotr<UInt4>*) given vector of cases

    Returns:
        caseId (UInt4) if 0, this tof will not be incremented to histogram. 

";
%feature("docstring") UtsusemiFilterTrignet::Initialize "void UtsusemiFilterTrignet::Initialize() 

";
%feature("docstring") UtsusemiFilterTrignet::ClearAllTables "void UtsusemiFilterTrignet::ClearAllTables(UInt4 index, bool makeNew=false) 

";
%feature("docstring") UtsusemiFilterTrignet::CaseSorting "void UtsusemiFilterTrignet::CaseSorting(const UChar *data, UInt8 size, UInt4 index, UInt4 ThNum)
=================================================================================================
    Sorts TrigNET evetns into each case.

    Args:
        data (UChar*) events
        size (UInt8) size of events (bytes)
        index (UInt4) index of TrigNET event file
        ThNum (UInt4) Thread number

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterTrignet::PreCaseSorting "void UtsusemiFilterTrignet::PreCaseSorting(const UChar *data, vector< UInt8 > T0Table, UInt4 index)
====================================================================================================
    Preprocess to CaseSorting.

    Args:
        data (UChar*) events
        T0Table (UInt8) T0 index table
        index (UInt4) index of TrigNET event file

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterTrignet::ReadTrigEvent "void UtsusemiFilterTrignet::ReadTrigEvent(std::string trig_event_file, std::string trig_t0_file, UInt4 index=0) 

    
void UtsusemiFilterTrignet::ReadTrigEvent(vector< std::string > trig_event_files, vector< std::string > trig_t0_files, UInt4 index=0)
======================================================================================================================================
    Reads TrigNET Event file as Case Event data file.

    Args:
        trig_event_file (string) path to TrigNET event file
        T0Table (vector<UInt4>) T0 index table for the TrigNET event file
        index (UInt4) index of TrigNET event file

    Returns:
        None 
";
%feature("docstring") UtsusemiFilterTrignet::ReadCaseInfoFile "Int4 UtsusemiFilterTrignet::ReadCaseInfoFile(std::string caseInfo_file)
========================================================================
    Reads Case Info file.

    Args:
        caseInfo_file (string) path to Case Info file

    Returns:
        0 : Succeeded. 

";
%feature("docstring") UtsusemiFilterTrignet::MakeCaseTable "void UtsusemiFilterTrignet::MakeCaseTable(bool isAppend=false)
===============================================================
    Makes filterCaseTable by analysis TrigNET event data file(s)

    Args:
        isAppend (bool) if you need not clear previous CaseTables.

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterTrignet::PutListOfCounterConditions "vector< pair< Double, Double > > UtsusemiFilterTrignet::PutListOfCounterConditions()
=====================================================================================
    Puts list of Counter-cases Conditions.

    Args:
        None

    Returns:
        list of conditions : index is CaseId 

";
%feature("docstring") UtsusemiFilterTrignet::DumpTrigEventFile "bool UtsusemiFilterTrignet::DumpTrigEventFile(std::string trig_file, std::string out_file, bool isDecorated=false)
===================================================================================================================
    Reads TrigNET event file and writes dump as text file.

    Args:
        trig_file (string) Path to Event File of TrigNET
        out_file (string) Path to output file
        isDecorated (bool) Output text decorated for easy-to-understand

    Returns:
        true : Succeeded
        false : Failed 

";
%feature("docstring") UtsusemiFilterTrignet::DumpCaseTable "void UtsusemiFilterTrignet::DumpCaseTable(string file=\"\") 

";
%feature("docstring") UtsusemiFilterTrignet::MakeTimeSlicingCases "void UtsusemiFilterTrignet::MakeTimeSlicingCases(vector< UInt8 > _pulseId, vector< double > _seconds) 

";
%feature("docstring") UtsusemiFilterTrignet::SetTimeSlicing "void UtsusemiFilterTrignet::SetTimeSlicing(vector< Double > tmp) 

";
%feature("docstring") UtsusemiFilterTrignet::ReadTrigEventFile "void UtsusemiFilterTrignet::ReadTrigEventFile(std::string trig_event_file, UInt4 index=0) 

    
void UtsusemiFilterTrignet::ReadTrigEventFile(std::string trig_event_file, vector< UInt8 > T0Table, UInt4 index=0)
===================================================================================================================
    Reads TrigNET Event file as Case Event data file (obsoleted)

    Args:
        trig_event_file (string) path to TrigNET event file
        T0Table (vector<UInt4>) T0 index table for the TrigNET event file
        index (UInt4) index of TrigNET event file

    Returns:
        None 
";
%feature("docstring") UtsusemiFilterTrignet::ReadCaseEventFiles "Int4 UtsusemiFilterTrignet::ReadCaseEventFiles(UInt4 index, vector< string > evt_files, vector< vector< UInt8 > > t0b_index_list)
==================================================================================================================================
    Reads TrigNET Event file as Case Event data files (obsoleted)

    Args:
        evt_files (vecto<string>) pathes to TrigNET event files
        t0b_files (vecto<string>) pathes to t0b event for TrigNET event files

    Returns:
        None 

";
%feature("docstring") UtsusemiFilterTrignet::isTimeSlicing "bool UtsusemiFilterTrignet::isTimeSlicing() 

";
// File: classUtsusemiFrameBoundaryInfo.xml

%feature("docstring") UtsusemiFrameBoundaryInfo "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") UtsusemiFrameBoundaryInfo::UtsusemiFrameBoundaryInfo "UtsusemiFrameBoundaryInfo::UtsusemiFrameBoundaryInfo() 

    
UtsusemiFrameBoundaryInfo::UtsusemiFrameBoundaryInfo(const UtsusemiFrameBoundaryInfo &obj) 
";
%feature("docstring") UtsusemiFrameBoundaryInfo::~UtsusemiFrameBoundaryInfo "UtsusemiFrameBoundaryInfo::~UtsusemiFrameBoundaryInfo() 

";
%feature("docstring") UtsusemiFrameBoundaryInfo::SetParams "bool UtsusemiFrameBoundaryInfo::SetParams(UInt4 fn, Double bv=0.0, string bt=\"\") 

";
// File: classUtsusemiGetHistogramTemplate.xml

%feature("docstring") UtsusemiGetHistogramTemplate "

    Creates Histogram from event data.
    read WiringInfo
    Set runNo and read suitable WiringInfo
    Set Histgram conversion parameter
    Set many parameters for the condition of histogram
    rewrite WiringInfo by given parameters
    create histogram from rewritten WiringInfo and DetectorInfo
    T1 : UtsusemiWiringInfoEditorXXX T2 : UtsusemiDetectorInfoEditorXXX
    Neuunet : T1= UtsusemiWiringInfoEditorNeunet T2=UtsusemiDetectorInfoEditorBbase
    RPMT : T1= UtsusemiWiringInfoEditorBase T2=UtsusemiDetectorInfoEditorBbase
    C++ includes: UtsusemiGetHistogramTemplate.hh 

";
%feature("docstring") UtsusemiGetHistogramTemplate::UtsusemiGetHistogramTemplate "UtsusemiGetHistogramTemplate< T1, T2 >::UtsusemiGetHistogramTemplate()
=======================================================================
    Constructor. 

";
%feature("docstring") UtsusemiGetHistogramTemplate::~UtsusemiGetHistogramTemplate "UtsusemiGetHistogramTemplate< T1, T2 >::~UtsusemiGetHistogramTemplate()
========================================================================
    Destructor. 

";
%feature("docstring") UtsusemiGetHistogramTemplate::Initialize "void UtsusemiGetHistogramTemplate< T1, T2 >::Initialize() 

";
%feature("docstring") UtsusemiGetHistogramTemplate::GetStatus "bool UtsusemiGetHistogramTemplate< T1, T2 >::GetStatus()
=========================================================
    Puts Status.
    bool GetStatus()

    Args:
        None

    Returns:
        true command execution succeeded
        false command execution failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetRunNo "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetRunNo(UInt4 runNo, UInt4 mode_no=0, std::string env_file=\"\")
===============================================================================================================
    sets run No and environ_ana.xml
    This set run number and read environ_ana.xml to select WiringInfo and DetecorInfo suitable for the run number. If evn_file is empty(), this uses UTSUSEMI_USR_DIR/ana/xml(_UtsusemiUserXmlPath)/environ_ana.xml. If evn_file is set, the path of env_file is used as _UtsusemiUserXmlPath. bool SetRunNo( UInt4 runNo, string env_file=\"\" ) bool SetRunNo( string runNos, string env_file=\"\" )

    Args:
        runNo (UInt4) run number
        mode_no (UInt4) Mode number defined in environ_ana.xml
        env_file (string) environ_ana.xml which includes several WiringInfo and DetectorInfo for each run number.

    Returns:
        true : succeeded
        false : failed 

    
bool UtsusemiGetHistogramTemplate< T1, T2 >::SetRunNo(std::string runNos, std::string mode_no=\"0\", std::string env_file=\"\")
================================================================================================================================
    sets run No and environ_ana.xml
    This set run number and read environ_ana.xml to select WiringInfo and DetecorInfo suitable for the run number. If evn_file is empty(), this uses UTSUSEMI_USR_DIR/ana/xml(_UtsusemiUserXmlPath)/environ_ana.xml. If evn_file is set, the path of env_file is used as _UtsusemiUserXmlPath. bool SetRunNo( UInt4 runNo, string env_file=\"\" ) bool SetRunNo( string runNos, string env_file=\"\" )

    Args:
        runNos (string) run numbers. format : \"1234,1235\"
        mode_no (UInt4) Mode number defined in environ_ana.xml
        env_file (string) environ_ana.xml which includes several WiringInfo and DetectorInfo for each run number.

    Returns:
        true : succeeded
        false : failed 
    
bool UtsusemiGetHistogramTemplate< T1, T2 >::SetRunNo(std::string runNos, std::string wfile, std::string dfile, std::string mode_no)
=====================================================================================================================================
    sets run No and environ_ana.xml
    This set run number and read environ_ana.xml to select WiringInfo and DetecorInfo suitable for the run number. If evn_file is empty(), this uses UTSUSEMI_USR_DIR/ana/xml(_UtsusemiUserXmlPath)/environ_ana.xml. If evn_file is set, the path of env_file is used as _UtsusemiUserXmlPath. bool SetRunNo( UInt4 runNo, string env_file=\"\" ) bool SetRunNo( string runNos, string env_file=\"\" )

    Args:
        runNos (string) run numbers. format : \"1234,1235\"
        wfile (string) WiringInfo.xml if required to indicate directly
        dfile (string) DetectorInfo.xml if required to indicate directly
        mode_no (UInt4) Mode number defined in environ_ana.xml

    Returns:
        true : succeeded
        false : failed 
    
bool UtsusemiGetHistogramTemplate< T1, T2 >::SetRunNo(UInt4 runNo, std::string wfile, std::string dfile, std::string mode_no)
==============================================================================================================================
    sets run No and environ_ana.xml
    This set run number and read environ_ana.xml to select WiringInfo and DetecorInfo suitable for the run number. If evn_file is empty(), this uses UTSUSEMI_USR_DIR/ana/xml(_UtsusemiUserXmlPath)/environ_ana.xml. If evn_file is set, the path of env_file is used as _UtsusemiUserXmlPath. bool SetRunNo( UInt4 runNo, string env_file=\"\" ) bool SetRunNo( string runNos, string env_file=\"\" )

    Args:
        runNo (UInt4) run number
        wfile (string) WiringInfo.xml if required to indicate directly
        dfile (string) DetectorInfo.xml if required to indicate directly
        mode_no (UInt4) Mode number defined in environ_ana.xml

    Returns:
        true : succeeded
        false : failed 
";
%feature("docstring") UtsusemiGetHistogramTemplate::SetConversionParameter "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetConversionParameter(std::string params, UInt4 _ptnId=0)
========================================================================================================
    sets conversion parameter for histogram creations
    bool SetConversionParameter( string params, UInt4 _ptnId=0 ) Format of params TOF delta-TOF const : tof,<min_tof>,<max_tof>,<delta_tof> d-TOF/TOF const : rtof,<min_tof>,<max_tof>,<racio>
    TOF with time forcusing delta-TOF const : tf-tof,<min_tof>,<max_tof>,<delta_tof> d-TOF/TOF const : tf-rtof,<min_tof>,<max_tof>,<racio>
    Lambda delta-lambda const : lambda,<min_lambda>,<max_lambda>,<delta_lambda> delta-lambda/lambda const : rlambda,<min_lambda>,<max_lambda>,<racio>
    Energy energy,<min_energy>,<max_energy>,<delta_energy>
    Momentum Transfer q,<min_Q>,<max_Q>,<delta_Q>[,<ki_x>,<ki_y>,<ki_z>]
    Energy Transfer hw,<Ei>,<min_hw>,<max_hw>,<delta_hw>[,<t0_shift>]
    d-value d,<min_d-val>,<max_d-val>,<delta_d-val>

    Args:
        params (string) parameters for histogram ceration
        _ptnId (UInt4) ID of this parameters in WiringInfo

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetDetRange "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetDetRange(std::string params=\"All\")
=====================================================================================
    sets detector range for histogram creations
    bool SetDetRange( string params=\"All\" ) Format of params \"All[:<number_of_pixels>]\" : use all detectors \"<startDetId>-<endDetId>[:<number_of_pixels>]\" : use detectors from <startDetId> to <endDetId> ( \"X-Y:Z,A-B:C,D-E:F...\" can be used for more settings in my plan ) \"<BankName>[:<number_of_pixels>[,<BankName>...]]: use detectors in the bank(s) described in DetectorInfo.xml

    Args:
        params (string) parameters for histogram ceration

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetFrameInfo "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetFrameInfo(std::string params=\"None\")
=======================================================================================
    sets Frame Info for histogram creations
    bool SetFrameInfo( string params ) Format of params \"<detType>[,<LLD_min> [,<LLD_max>] ]\" detType in {\"psd\",\"n2mon\",\"psd-ph\",\"n2mon-ph\"}
    \"-PH\" means that Pulse Height is calculated at the same time

    Args:
        params (string) parameters for histogram ceration

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetDetParam "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetDetParam(std::string params=\"psd\")
=====================================================================================
    sets detector parameter to use for histogram creations
    bool SetDetParam( string params=\"psd\" ) Format of params \"<detType>[,<LLD_min> [-<LLD_max>] ]\" detType in {\"psd\",\"n2mon\",\"psd-ph\",\"n2mon-ph\"}
    \"-PH\" means that Pulse Height is calculated at the same time
    default values for LLD are min=0, max=10000

    Args:
        params (string) detector parameters for histogram ceration

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetMaskInfo "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetMaskInfo(std::string params=\"NoFile\", UInt4 _ptnId=0)
========================================================================================================
    sets MASK for histogram creations
    bool SetMaskInfo( string params=\"NoFile\", UInt4 _ptnId=0 ) Format of params \"<Mask.xml>[,<TOF-Mask from>-< to > [,<TOF-Mask from>-<to>] ]\" Mask.xml = \"NoFile\" if no mask.

    Args:
        params (string) detector parameters for histogram ceration
        _ptnId (UInt4) ID of this parameters in WiringInfo

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetTimeDependBackGroundInfo "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetTimeDependBackGroundInfo(std::string params=\"None\")
======================================================================================================
    sets Tof region to be used for TimeDependBackground correction
    bool SetTimeDependBackGroundRegionInfo( string params=\"None\" ) Format of params \"None\" : not used this background correction \"tof0-tof1\" : tof0 is start tof of region, tof1 is last of region

    Args:
        params (string) TimeDepend BackGroundRegion

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetSaveFileOfTimeDependBackGround "void UtsusemiGetHistogramTemplate< T1, T2 >::SetSaveFileOfTimeDependBackGround(std::string path)
=================================================================================================
    sets the file name to store the time-depend background information
    bool SetSaveFileOfTimeDependBackGround( string path )@param path (string) the full path of file @retval None 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetFileOfTimeDependBackGround "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetFileOfTimeDependBackGround(std::string path)
=============================================================================================
    sets the file name which store the time-depend background information
    bool SetFileOfTimeDependBackGround( string path ) Format of params \"None\" : not used this background correction \"tof0-tof1\" : tof0 is start tof of region, tof1 is last of region

    Args:
        params (string) the name of the file (fullpath or only name)

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetTimeRange "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetTimeRange(std::string params=\"All\")
======================================================================================
    sets Time range for histogram creations
    bool SetTimeRange( string params=\"All\" ) Format of params \"All\" : use all detectors \"<startSec>,<endSec>\" : use events in measurement from <startSec> to <endSec> [sec] which Time format is the passed time from measurement start. \"<startDate>,<startTime>,<endDate>,<endTime>\" : use events in period of these params \"YYYY/MM/DD\",\"hh:mm:ss\",\"YYYY/MM/DD\",\"hh:mm:ss\"

    Args:
        params (string) parameters for histogram ceration

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetCaseInfo "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetCaseInfo(std::string params=\"None\")
======================================================================================
    sets case info for histogram creations
    bool SetCaseInfo( string params=\"None\" ) Format of params (not defined)

    Args:
        params (string) parameters for histogram ceration

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetTofShiftInfo "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetTofShiftInfo(std::string params)
=================================================================================
    sets Tof shift info for histogram creations
    bool SetTofShiftInfo( UInt4 ptnId ) bool SetTofShiftInfo( string params ) bool SetTofShiftInfo( string ptnId, string xparams=\"\", string lambdas=\"\" )
    params format : <ptnId>[,p1,p2,p3,...]

    Args:
        params (string) Pattern ID and its parameters as string
        ptnId (UInt4) Pattern ID for a method to calculate TOF shift.
        xparams (string) parameters for this Pattern ID method ( if need )
        lambdas (string) if scattered data in lambda axis, use this.

    Returns:
        true : succeeded
        false : failed 

    
bool UtsusemiGetHistogramTemplate< T1, T2 >::SetTofShiftInfo(UInt4 ptnId, std::string xparams=\"\", std::string lambdas=\"\") 
";
%feature("docstring") UtsusemiGetHistogramTemplate::MakeTempWiringInfo "std::string UtsusemiGetHistogramTemplate< T1, T2 >::MakeTempWiringInfo(std::string priv_path=\"\")
===================================================================================================
    make and save the temporal wiring info to create histogram
    this returns a path of the saved temporal wiring info file string MakeTempWiringInfo()

    Args:
        None

    Returns:
        (string) : the path of output wiring info file 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetL1 "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetL1(Double l1)
==============================================================
    sets L1 on DetectorInfo
    L1 means the distance between neutron source (moderator) and a sample bool SetL1( Double l1 )

    Args:
        l1 (Double)

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::SetSamplePosition "bool UtsusemiGetHistogramTemplate< T1, T2 >::SetSamplePosition(Double px, Double py, Double pz)
================================================================================================
    sets SamplePosition on DetectorInfo
    Sample Positions are set the absolute position of Sample bool SetSamplePosition( Double px, Double py, Double pz )

    Args:
        px (Double)
        py (Double)
        pz (Double)

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiGetHistogramTemplate::PutNumOfPixelForDet "UInt4 UtsusemiGetHistogramTemplate< T1, T2 >::PutNumOfPixelForDet(UInt4 _detId=0) 

";
%feature("docstring") UtsusemiGetHistogramTemplate::PutL1 "Double UtsusemiGetHistogramTemplate< T1, T2 >::PutL1() 

";
%feature("docstring") UtsusemiGetHistogramTemplate::PutTypicalL2 "Double UtsusemiGetHistogramTemplate< T1, T2 >::PutTypicalL2() 

";
%feature("docstring") UtsusemiGetHistogramTemplate::PutTypicalDS "Double UtsusemiGetHistogramTemplate< T1, T2 >::PutTypicalDS() 

";
%feature("docstring") UtsusemiGetHistogramTemplate::MakeTempDetectorInfo "std::string UtsusemiGetHistogramTemplate< T1, T2 >::MakeTempDetectorInfo()
===========================================================================
    make and save the temporal detector info to create histogram
    this returns a path of the saved temporal detector info file string MakeTempDetectorInfo()

    Args:
        None

    Returns:
        (string) : the path of output detector info file 

";
%feature("docstring") UtsusemiGetHistogramTemplate::MakeTempInfoFiles "virtual vector<std::string> UtsusemiGetHistogramTemplate< T1, T2 >::MakeTempInfoFiles()
========================================================================================
    make the temporal all info files to create histogram
    this returns a path of the info files ex. WiringInfo,DetectorInfo and CaseInfo vector<string> MakeTempInfoFiles()

    Args:
        None

    Returns:
        (vector<string>) : pathes for info files [0]=WiringInfo, [1]=DetectorInfo, [2]=CaseInfo 

";
// File: classUtsusemiGetNeunetHistogram.xml

%feature("docstring") UtsusemiGetNeunetHistogram "

    Creates Histogram from Neunet event data.
    read WiringInfo
    Set runNo and read suitable WiringInfo
    Set Histgram conversion parameter
    Set many parameters for the condition of histogram
    rewrite WiringInfo by given parameters
    create histogram from rewritten WiringInfo and DetectorInfo
    C++ includes: UtsusemiGetNeunetHistogram.hh 

";
%feature("docstring") UtsusemiGetNeunetHistogram::UtsusemiGetNeunetHistogram "UtsusemiGetNeunetHistogram::UtsusemiGetNeunetHistogram()
=========================================================
    Constructor. 

";
%feature("docstring") UtsusemiGetNeunetHistogram::~UtsusemiGetNeunetHistogram "UtsusemiGetNeunetHistogram::~UtsusemiGetNeunetHistogram()
==========================================================
    Destructor. 

";
%feature("docstring") UtsusemiGetNeunetHistogram::SetElementContainerMatrix "bool UtsusemiGetNeunetHistogram::SetElementContainerMatrix(ElementContainerMatrix *ecm, vector< UInt4 > runNos, string wfile, string dfile, bool withPH=false, string dataPath=\"/data\", string t0dataPath=\"\")
==================================================================================================================================================================================================================
    sets Histogram into ElementContainerMatrix using saved temporal wiring info file
    bool SetElementContainerMatrix( ElementContainerMatrix *ecm, string dataPath=\"/data\", string t0dataPath=\"\" ) bool SetElementContainerMatrix( ElementContainerMatrix *ecm, vector<UInt4> runNos, string wfile, string dfile, bool withPH=false, string dataPath=\"/data\", string t0dataPath=\"\" )

    Args:
        ecm (ElementContainerMatrix*) data container for histogram
        dataPath (string) top path of event data (\"/data\")
        t0dataPath (string) path of T0Index event data (\"\")
        runNos (vector<UInt4>) run numbers list
        wfile (string) wiring info file name
        dfile (string) detector info file name
        withPH (bool) adding of pulse height info

    Returns:
        true : succeeded
        false : failed 

    
bool UtsusemiGetNeunetHistogram::SetElementContainerMatrix(ElementContainerMatrix *ecm, UInt4 caseId=1) 
";
%feature("docstring") UtsusemiGetNeunetHistogram::LoadEventDataFiles "bool UtsusemiGetNeunetHistogram::LoadEventDataFiles(string dataPath=\"/data\", string t0dataPath=\"\") 

";
%feature("docstring") UtsusemiGetNeunetHistogram::PutListOfCases "vector< UInt4 > UtsusemiGetNeunetHistogram::PutListOfCases() 

";
%feature("docstring") UtsusemiGetNeunetHistogram::SetFlagOfPulseIdCheck "void UtsusemiGetNeunetHistogram::SetFlagOfPulseIdCheck(bool flag) 

";
%feature("docstring") UtsusemiGetNeunetHistogram::SetFlagToAddTofBin "void UtsusemiGetNeunetHistogram::SetFlagToAddTofBin(bool flag) 

";
%feature("docstring") UtsusemiGetNeunetHistogram::PutEventDataConverterNeunet "UtsusemiEventDataConverterNeunet* UtsusemiGetNeunetHistogram::PutEventDataConverterNeunet() 

";
%feature("docstring") UtsusemiGetNeunetHistogram::PutEventDataConverterNeunetWithPH "UtsusemiEventDataConverterNeunetWithPH* UtsusemiGetNeunetHistogram::PutEventDataConverterNeunetWithPH() 

";
// File: classUtsusemiGetRPMTHistogram.xml

%feature("docstring") UtsusemiGetRPMTHistogram "

    Creates Histogram from Neunet event data.
    read WiringInfo
    Set runNo and read suitable WiringInfo
    Set Histgram conversion parameter
    Set many parameters for the condition of histogram
    rewrite WiringInfo by given parameters
    create histogram from rewritten WiringInfo and DetectorInfo
    C++ includes: UtsusemiGetRPMTHistogram.hh 

";
%feature("docstring") UtsusemiGetRPMTHistogram::UtsusemiGetRPMTHistogram "UtsusemiGetRPMTHistogram::UtsusemiGetRPMTHistogram()
=====================================================
    Constructor. 

";
%feature("docstring") UtsusemiGetRPMTHistogram::~UtsusemiGetRPMTHistogram "UtsusemiGetRPMTHistogram::~UtsusemiGetRPMTHistogram()
======================================================
    Destructor. 

";
%feature("docstring") UtsusemiGetRPMTHistogram::SetElementContainerMatrix "bool UtsusemiGetRPMTHistogram::SetElementContainerMatrix(ElementContainerMatrix *ecm, string dataPath=\"/data\", string t0dataPath=\"\") 

    
bool UtsusemiGetRPMTHistogram::SetElementContainerMatrix(ElementContainerMatrix *ecm, vector< UInt4 > runNos, string wfile, string dfile, string dataPath=\"/data\", string t0dataPath=\"\")
=============================================================================================================================================================================================
    sets Histogram into ElementContainerMatrix using saved temporal wiring info file
    bool SetElementContainerMatrix( ElementContainerMatrix *ecm, string dataPath=\"/data\", string t0dataPath=\"\" ) bool SetElementContainerMatrix( ElementContainerMatrix *ecm, vector<UInt4> runNos, string wfile, string dfile, bool withPH=false, string dataPath=\"/data\", string t0dataPath=\"\" )

    Args:
        ecm (ElementContainerMatrix*) data container for histogram
        dataPath (string) top path of event data (\"/data\")
        t0dataPath (string) path of T0Index event data (\"\")

    Returns:
        true : succeeded
        false : failed 
";
// File: classUtsusemiLogger.xml

%feature("docstring") UtsusemiLogger "

    Logger of Ustusemi.
    stores any messages This executes as Singlton.
    C++ includes: UtsusemiHeader.hh 

";
%feature("docstring") UtsusemiLogger::_convT "string UtsusemiLogger::_convT(const time_t *timer) 

";
%feature("docstring") UtsusemiLogger::Add "void UtsusemiLogger::Add(const Int4 level, const string msg, const bool isForce=false)
=======================================================================================
    Adds message.

    Args:
        level (Int4) 0:normal message, 1:worning message, 2:error message
        msg (string) message
        isForce (bool) shows message in spite of _isQuiet flag

    Returns:
        None 

    
void UtsusemiLogger::Add(const vector< Int4 > levels, const vector< string > msgs)
===================================================================================
    Adds many messages in a time.

    Args:
        levels (vector<Int4>) 0:normal message, 1:warning message, 2:error message
        msgs (vector<string>) messages

    Returns:
        None 
    
void UtsusemiLogger::Add(const vector< Int4 > levels, const vector< string > msgs, const vector< string > timer)
=================================================================================================================
    Adds many messages in a time.

    Args:
        levels (vector<Int4>) 0:normal message, 1:warning message, 2:error message
        msgs (vector<string>) messages
        timer (vector<string>) timers string

    Returns:
        None 
";
%feature("docstring") UtsusemiLogger::Clear "void UtsusemiLogger::Clear()
=============================
    Clear stored messages.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiLogger::CheckLogQuiet "void UtsusemiLogger::CheckLogQuiet()
=====================================
    Update the flag from the current UTSUSEMI_LOG_QUIET environment value.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiLogger::SetLoggingOn "void UtsusemiLogger::SetLoggingOn()
====================================
    Set the logging on.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiLogger::SetLoggingOff "void UtsusemiLogger::SetLoggingOff()
=====================================
    Set the logging off.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiLogger::LoggingStatus "bool UtsusemiLogger::LoggingStatus()
=====================================
    Return the logging status.

    Args:
        None

    Returns:
        true
        false 

";
%feature("docstring") UtsusemiLogger::PutLevels "vector<Int4> UtsusemiLogger::PutLevels()
=========================================
    Puts Levels.

    Returns:
        _Levels (vector<Int4>) 

";
%feature("docstring") UtsusemiLogger::PutMessages "vector< string > UtsusemiLogger::PutMessages(const Int4 level=-1)
==================================================================
    Puts Messages.

    Args:
        level (Int4) -1: all messages, 0:normal, 1:warning, 2:error

    Returns:
        _Messages (vector<string>) 

";
%feature("docstring") UtsusemiLogger::Dump "void UtsusemiLogger::Dump(const string filename=\"\")
======================================================
    Dumps to file.

    Args:
        filename (string) filename including path

    Returns:
        None 

";
// File: classUtsusemiModInfo.xml

%feature("docstring") UtsusemiModInfo "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") UtsusemiModInfo::UtsusemiModInfo "UtsusemiModInfo::UtsusemiModInfo()
===================================
    Constructor. 

    
UtsusemiModInfo::UtsusemiModInfo(const UtsusemiModInfo &obj)
=============================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiModInfo::~UtsusemiModInfo "UtsusemiModInfo::~UtsusemiModInfo()
====================================
    Destructor. 

";
%feature("docstring") UtsusemiModInfo::ClearList "void UtsusemiModInfo::ClearList() 

";
%feature("docstring") UtsusemiModInfo::PutAliveList "vector< UInt4 > UtsusemiModInfo::PutAliveList()
================================================
    Puts list of DetList index alived.

    Args:
        None

    Returns:
        vector of index 

";
// File: classUtsusemiNeunetEventDecoderBase.xml

%feature("docstring") UtsusemiNeunetEventDecoderBase "

    Decode Event Data of NEUNET for Utsusemi.
    C++ includes: UtsusemiNeunetEventDecoderBase.hh 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::UtsusemiNeunetEventDecoderBase "UtsusemiNeunetEventDecoderBase::UtsusemiNeunetEventDecoderBase()
=================================================================
    Constructor. 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::~UtsusemiNeunetEventDecoderBase "UtsusemiNeunetEventDecoderBase::~UtsusemiNeunetEventDecoderBase()
==================================================================
    Destructor. 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::SetParametersFromFiles "Int4 UtsusemiNeunetEventDecoderBase::SetParametersFromFiles(std::string wiring_file, std::string detector_file)
================================================================================================================
    set parameters from files

    Args:
        wiring_file (string) Wiring Info xml file
        detector_file (string) DetectorInfo xml file

    Returns:
        0 no error
        -1 Troubles happened 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::ClearPrevT0Event "void UtsusemiNeunetEventDecoderBase::ClearPrevT0Event(UInt4 ThNum)
===================================================================
    Clear Previous T0 Event.

    Args:
        ThNum (UInt4) Thread number

    Returns:
        None 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::DecodeEventData "UInt4 UtsusemiNeunetEventDecoderBase::DecodeEventData(UInt4 daqId, UInt4 moduleNo, const UChar *data, UInt4 *pixel_id, double *tof, vector< Double > *Clock, UInt4 ThNum)
==========================================================================================================================================================================
    decode Event data
    This decodes any one event data and return type of event. If a given event is neutron, this sets pixel_id and tof and return 1 (_isNeutronEvent) If T0 event, this event is stored and return 2 (_isT0Event) If clock event, return 3 If any other event, return 0

    Args:
        daqId (UInt4) daq ID
        moduleNo (UInt4) module number
        data (UChar) one event data
        pixel_id (UInt4) Pixel ID calculated by given event
        tof (double) TOF calculated by given event
        Clock (vector<Double>)
        ThNum (UInt4) Thread number

    Returns:
        _isNeutronEvent if neutron event
        _isT0Event if T0 event
        _isClockEvent if clock event
        0 if any other event 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::ConvertPixelIdToInnerId "UInt4 UtsusemiNeunetEventDecoderBase::ConvertPixelIdToInnerId(UInt4 pixel_id)
==============================================================================
    convert outer PixelID to inner( memory allocated ) ID
    This is used for conversion from outer PixelID to inner id for allocated vectors

    Args:
        pixel_id (UInt4) pixel ID

    Returns:
        inner ID (UInt4) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::ConvertPixelIdToDetId "UInt4 UtsusemiNeunetEventDecoderBase::ConvertPixelIdToDetId(UInt4 pixel_id)
============================================================================
    convert outer PixelID to outer DetID
    This is used to get det Id from outer PixelID to

    Args:
        pixel_id (UInt4) pixel ID

    Returns:
        detID (UInt4) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutPixelIdList "vector< UInt4 > UtsusemiNeunetEventDecoderBase::PutPixelIdList(bool isInner)
=============================================================================
    return vector of existed id from conversion table
    Conversion table( PixelID <-> inner ID ) is made by WiringFile. If isInner is true, this puts list of existed inner ID if false, list of existed pixel ID

    Args:
        isInner (bool) parameter to toggle type of return values.

    Returns:
        list of Id (vector<UInt4>) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutHistBin "vector< Double > UtsusemiNeunetEventDecoderBase::PutHistBin(UInt4 outerPixelId)
================================================================================
    put binning calculated by Efix
    For direct convertion from tof to phisical values, calculated binning(tof) is required to construct histograms.

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        binning vector 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutNumOfInnerPixels "UInt4 UtsusemiNeunetEventDecoderBase::PutNumOfInnerPixels()
============================================================
    put the number of inner pixels

    Returns:
        the number of pixels (UInt4) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutPixelPosition "vector< Double > UtsusemiNeunetEventDecoderBase::PutPixelPosition(UInt4 outerPixelId)
======================================================================================
    put pixel position from given outerPixelId

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        vector of pixel position 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutXLabel "pair< string, string > UtsusemiNeunetEventDecoderBase::PutXLabel(Int4 convtype) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutYLabel "pair< string, string > UtsusemiNeunetEventDecoderBase::PutYLabel(Int4 convtype) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutELabel "pair< string, string > UtsusemiNeunetEventDecoderBase::PutELabel(Int4 convtype) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::SetMaskOnError "void UtsusemiNeunetEventDecoderBase::SetMaskOnError(UInt4 _outerPixelId, vector< Double > &_bin, vector< Double > &_err) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutMaxOfPixelId "UInt4 UtsusemiNeunetEventDecoderBase::PutMaxOfPixelId()
========================================================
    put maximum number of pixel id

    Returns:
        maximum number (UInt4) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::CalcPixelPosition "void UtsusemiNeunetEventDecoderBase::CalcPixelPosition()
=========================================================
    calculate the position of each pixel
    This calculates the position of pixel from stored information. Potisions are stored to _pixelPositionVect.

    Returns:
        None 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutTofBinType "Int4 UtsusemiNeunetEventDecoderBase::PutTofBinType(UInt4 outerPixelId)
=======================================================================
    put Tof Bin Type of given outerPixelId
    Tof Bin Type comes from Wiring File

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        tof bin type 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutXaxis "vector< Double > UtsusemiNeunetEventDecoderBase::PutXaxis()
============================================================
    put x axis values
    When TofBinType is for direct conversion from event data to energy, this returns calculated x-axis values.

    Args:
        None

    Returns:
        vector for values on calculated x-axis 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::isReverseAxis "bool UtsusemiNeunetEventDecoderBase::isReverseAxis(Int4 convtype) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::isValidConvType "bool UtsusemiNeunetEventDecoderBase::isValidConvType(Int4 convtype) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::SetTofOriginShift "bool UtsusemiNeunetEventDecoderBase::SetTofOriginShift(UInt4 cType)
====================================================================
    < set fixed Energy value for direct or indirect geometry
    < fixed Energy values are required to calculate tof array for direct unit convertion from tof If single Double efix is given, this value is used to calculate unit conversion for direct geometry analysis. The vector<Double> efix is used for inverted one.

    Args:
        efix (vector<Double> or Double) each fixed Energy ( index of vector is PixelId )

    Returns:
        None < imports Time focusing parameters to TofBinPattern from DetInfo  <

    Args:
        None

    Returns:
        None 

    
bool UtsusemiNeunetEventDecoderBase::SetTofOriginShift(UInt4 cType, vector< Double > params)
=============================================================================================
    Sets type and calculation parameter for Tof origin shift.
    This shift is defined by the lamda-depend function given in codes

    Args:
        cType (UInt4) pattern Id for function
        params (vector<Double>) parameters of cType function

    Returns:
        true succeeded
        false failed 
";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutLambda "vector< Double > UtsusemiNeunetEventDecoderBase::PutLambda(UInt4 pixel_id)
===========================================================================
    Puts lambda axis from data container of pixel_id.

    Args:
        pixel_id (UInt4) pixel id

    Returns:
        vector<Double> lambda axis 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutTimeDependBackGroundInfo "vector< double > * UtsusemiNeunetEventDecoderBase::PutTimeDependBackGroundInfo(UInt4 _outerPixelId) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutDetIdPixNoFromEvent "bool UtsusemiNeunetEventDecoderBase::PutDetIdPixNoFromEvent(UInt4 daqId, UInt4 moduleNo, const UChar *data, UInt4 *detId, UInt4 *pixNo, UInt4 ThNum)
=====================================================================================================================================================
    < Puts tof range of time depend background for each pixel_id
    <

    Args:
        pixel_id (UInt4) pixel id

    Returns:
        vector<Double>* Tof range of Time Depend Back Ground 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutNumOfPixelForDet "UInt4 UtsusemiNeunetEventDecoderBase::PutNumOfPixelForDet(UInt4 _detId=0) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutL1 "Double UtsusemiNeunetEventDecoderBase::PutL1() 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutTypicalL2 "Double UtsusemiNeunetEventDecoderBase::PutTypicalL2() 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutTypicalDS "Double UtsusemiNeunetEventDecoderBase::PutTypicalDS() 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::PutTypicalPixelSize "vector< Double > UtsusemiNeunetEventDecoderBase::PutTypicalPixelSize(UInt4 _detId=0) 

";
%feature("docstring") UtsusemiNeunetEventDecoderBase::SetSimpleMode "void UtsusemiNeunetEventDecoderBase::SetSimpleMode(bool _isSimple=false) 

";
// File: classUtsusemiNeutronEventDecoderBase.xml

%feature("docstring") UtsusemiNeutronEventDecoderBase "

    Base class Decode Event Data.
    with UtsusemiEventDataConverterTemplate
    C++ includes: UtsusemiNeutronEventDecoderBase.hh 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::UtsusemiNeutronEventDecoderBase "UtsusemiNeutronEventDecoderBase::UtsusemiNeutronEventDecoderBase()
===================================================================
    Constructor. 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::~UtsusemiNeutronEventDecoderBase "UtsusemiNeutronEventDecoderBase::~UtsusemiNeutronEventDecoderBase()
====================================================================
    Destructor. 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::SetParametersFromFiles "Int4 UtsusemiNeutronEventDecoderBase::SetParametersFromFiles(string wiring_file, string detector_file)
=======================================================================================================
    set parameters from files

    Args:
        wiring_file (string) Wiring Info xml file
        detector_file (string) DetectorInfo xml file

    Returns:
        0 no error
        -1 Troubles happened 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::decodeEventDataPy "vector< Double > UtsusemiNeutronEventDecoderBase::decodeEventDataPy(UInt4 daqId, string data)
==============================================================================================
    call decodeEventData from python
    This call decodeEventData and return pixel_id and tof.

    Args:
        daqId (UInt4) daq ID
        data (string) a event data

    Returns:
        vector<Double> [0]=pixel ID [1]=tof 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::SetFramePeriod "void UtsusemiNeutronEventDecoderBase::SetFramePeriod(Double _time) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::ClearPrevT0Event "void UtsusemiNeutronEventDecoderBase::ClearPrevT0Event(UInt4 ThNum)
====================================================================
    Clear Previous T0 Event.

    Args:
        ThNum (UInt4) Thread number

    Returns:
        None 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::DecodeEventData "UInt4 UtsusemiNeutronEventDecoderBase::DecodeEventData(UInt4 daqId, UInt4 moduleNo, const UChar *data, UInt4 *pixel_id, double *tof, vector< Double > *Clock, UInt4 ThNum=1)
=============================================================================================================================================================================
    decode Event data
    This decodes any one event data and return type of event. If a given event is neutron, this sets pixel_id and tof and return 1 (_isNeutronEvent) If T0 event, this event is stored and return 2 (_isT0Event) If clock event, return 3 If any other event, return 0

    Args:
        daqId (UInt4) daq ID
        moduleNo (UInt4) module number
        data (UChar) one event data
        pixel_id (UInt4) Pixel ID calculated by given event
        tof (double) TOF calculated by given event
        Clock (vector<Double>)
        ThNum (UInt4) Thread number

    Returns:
        _isNeutronEvent if neutron event
        _isT0Event if T0 event
        _isClockEvent if clock event
        0 if any other event 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::ConvertPixelIdToInnerId "UInt4 UtsusemiNeutronEventDecoderBase::ConvertPixelIdToInnerId(UInt4 pixel_id)
===============================================================================
    convert outer PixelID to inner( memory allocated ) ID
    This is used for conversion from outer PixelID to inner id for allocated vectors

    Args:
        pixel_id (UInt4) pixel ID

    Returns:
        inner ID (UInt4) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutPixelIdList "vector< UInt4 > UtsusemiNeutronEventDecoderBase::PutPixelIdList(bool isInner)
==============================================================================
    return vector of existed id from conversion table
    Conversion table( PixelID <-> inner ID ) is made by WiringFile. If isInner is true, this puts list of existed inner ID if false, list of existed pixel ID

    Args:
        isInner (bool) parameter to toggle type of return values.

    Returns:
        list of Id (vector<UInt4>) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutHistBin "vector< Double > UtsusemiNeutronEventDecoderBase::PutHistBin(UInt4 outerPixelId)
=================================================================================
    put binning calculated by Efix
    For direct convertion from tof to phisical values, calculated binning(tof) is required to construct histograms.

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        binning vector 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutXaxis "vector< Double > UtsusemiNeutronEventDecoderBase::PutXaxis()
=============================================================
    put X axis binning calculated from Tof bin type
    For direct convertion from tof to phisical values, calculated X-axis is required to construct histograms.

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        X-axis vector 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::IsNeutronEvent "bool UtsusemiNeutronEventDecoderBase::IsNeutronEvent(UInt4 type)
=================================================================
    return true when type is neutron
    type is return value from _EventDecoder->DecodeEventData

    Args:
        data (UInt) type

    Returns:
        bool 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::IsT0Event "bool UtsusemiNeutronEventDecoderBase::IsT0Event(UInt4 type)
============================================================
    return true when type is t0 event
    type is return value from _EventDecoder->DecodeEventData

    Args:
        data (UInt) type

    Returns:
        bool 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::IsInstClockEvent "bool UtsusemiNeutronEventDecoderBase::IsInstClockEvent(UInt4 type)
===================================================================
    return true when type is inst clock
    type is return value from _EventDecoder->DecodeEventData

    Args:
        data (UInt) type

    Returns:
        bool 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::CalcIncrementVal "Double UtsusemiNeutronEventDecoderBase::CalcIncrementVal(Double *tof, UInt4 *pixelId)
======================================================================================
    Calculation increment value (intensity shift)
    If incremented value (default=1) shifts by case id and tof, use this function. This is used in original Increment function.

    Args:
        tof (Double*) given tof
        pixelId (UInt4*) given pixel id

    Returns:
        value (Double) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutNumOfInnerPixels "virtual UInt4 UtsusemiNeutronEventDecoderBase::PutNumOfInnerPixels()
=====================================================================
    put the number of inner pixels

    Returns:
        the number of pixels (UInt4) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutPixelPosition "vector< Double > UtsusemiNeutronEventDecoderBase::PutPixelPosition(UInt4 outerPixelId)
=======================================================================================
    put pixel position from given outerPixelId

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        vector of pixel position 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutTofBinType "Int4 UtsusemiNeutronEventDecoderBase::PutTofBinType(UInt4 outerPixelId)
========================================================================
    put type of tof binning

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        binning type 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutXLabel "pair< string, string > UtsusemiNeutronEventDecoderBase::PutXLabel(Int4 convtype) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutYLabel "pair< string, string > UtsusemiNeutronEventDecoderBase::PutYLabel(Int4 convtype) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutELabel "pair< string, string > UtsusemiNeutronEventDecoderBase::PutELabel(Int4 convtype) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::isReverseAxis "bool UtsusemiNeutronEventDecoderBase::isReverseAxis(Int4 convtype) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::isValidConvType "bool UtsusemiNeutronEventDecoderBase::isValidConvType(Int4 convtype) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::SetMaskOnError "void UtsusemiNeutronEventDecoderBase::SetMaskOnError(UInt4 _outerPixelId, vector< Double > &_bin, vector< Double > &_err) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutTimeDependBackGroundInfo "vector< double > * UtsusemiNeutronEventDecoderBase::PutTimeDependBackGroundInfo(UInt4 _outerPixelId) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutNumOfPixelForDet "virtual UInt4 UtsusemiNeutronEventDecoderBase::PutNumOfPixelForDet(UInt4 _detId=0) 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutL1 "virtual Double UtsusemiNeutronEventDecoderBase::PutL1() 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutTypicalL2 "virtual Double UtsusemiNeutronEventDecoderBase::PutTypicalL2() 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutTypicalDS "virtual Double UtsusemiNeutronEventDecoderBase::PutTypicalDS() 

";
%feature("docstring") UtsusemiNeutronEventDecoderBase::PutTypicalPixelSize "vector< Double > UtsusemiNeutronEventDecoderBase::PutTypicalPixelSize(UInt4 _detId=0) 

";
// File: classUtsusemiOneCase.xml

%feature("docstring") UtsusemiOneCase "C++ includes: UtsusemiOneTrignetStorage.hh 

";
%feature("docstring") UtsusemiOneCase::UtsusemiOneCase "UtsusemiOneCase::UtsusemiOneCase() 

    
UtsusemiOneCase::UtsusemiOneCase(UInt4 _tof, vector< UInt4 > *_cases) 
    
UtsusemiOneCase::UtsusemiOneCase(const UtsusemiOneCase &obj) 
";
%feature("docstring") UtsusemiOneCase::~UtsusemiOneCase "UtsusemiOneCase::~UtsusemiOneCase() 

";
%feature("docstring") UtsusemiOneCase::SetCases "void UtsusemiOneCase::SetCases(vector< UInt4 > _cases) 

";
// File: classUtsusemiOneTrignetStorage.xml

%feature("docstring") UtsusemiOneTrignetStorage "

    Class to storage the case table for TrigNET.
    C++ includes: UtsusemiOneTrignetStorage.hh 

";
%feature("docstring") UtsusemiOneTrignetStorage::UtsusemiOneTrignetStorage "UtsusemiOneTrignetStorage::UtsusemiOneTrignetStorage(UInt4 _num_of_multh=2, UInt4 _dio=0, UInt4 _adc1=0, UInt4 _adc2=0, UInt4 _count=0)
========================================================================================================================================
    Constructor. 

";
%feature("docstring") UtsusemiOneTrignetStorage::~UtsusemiOneTrignetStorage "UtsusemiOneTrignetStorage::~UtsusemiOneTrignetStorage()
========================================================
    Destructor. 

";
%feature("docstring") UtsusemiOneTrignetStorage::SetDebugMode "void UtsusemiOneTrignetStorage::SetDebugMode(bool isDebug=false)
=================================================================
    Sets Debug mode on.

    Args:
        isDebug (bool)

    Returns:
        None 

";
%feature("docstring") UtsusemiOneTrignetStorage::StartFrame "void UtsusemiOneTrignetStorage::StartFrame()
=============================================
    Reset all inner tables for the beginning of analysis trignet data.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiOneTrignetStorage::StartAFrame "void UtsusemiOneTrignetStorage::StartAFrame(UInt4 _multh)
==========================================================
    Reset all inner tables for one frame to analysis trignet data.

    Args:
        _multh (UInt4) the openMP thread number

    Returns:
        None 

";
%feature("docstring") UtsusemiOneTrignetStorage::AddFilterCaseSort "bool UtsusemiOneTrignetStorage::AddFilterCaseSort(UInt4 _multh, UInt4 _sid2, UInt4 _tof, vector< UInt4 > _cases)
=================================================================================================================
    Adds caseID calclated from analysis trignet filter data.

    Args:
        _multh (UInt4) the openMP thread number
        _sid2 (UInt4) SID2 of an analyzed TrigNET event
        _tof (UInt4) TOF of an analyzed TrigNET event
        _cases (vector<UInt4>) cases of an analyzed TrigNET event

    Returns:
        true : succeeded

    Returns:
        false : failed 

";
%feature("docstring") UtsusemiOneTrignetStorage::AddCounterCaseSort "bool UtsusemiOneTrignetStorage::AddCounterCaseSort(UInt4 _multh, UInt4 _tof, UInt4 _case)
==========================================================================================
    Adds caseID calclated from analysis trignet counter data.

    Args:
        _multh (UInt4) the openMP thread number
        _tof (UInt4) TOF of an analyzed TrigNET event
        _case (UInt4) case of an analyzed TrigNET event

    Returns:
        true : succeeded

    Returns:
        false : failed 

";
%feature("docstring") UtsusemiOneTrignetStorage::AddPulseId "bool UtsusemiOneTrignetStorage::AddPulseId(UInt4 _multh, UInt4 _pulseId, Double _instClock=0.)
===============================================================================================
    Adds Pulse ID encoded from trignet event data.

    Args:
        _multh (UInt4) the openMP thread number
        _pulseId (UInt4) Pulse ID of TrigNET event
        _instClock (Double) Instrument Clock of TrigNET event

    Returns:
        true : succeeded

    Returns:
        false : failed 

";
%feature("docstring") UtsusemiOneTrignetStorage::MergeOnMulTh "bool UtsusemiOneTrignetStorage::MergeOnMulTh()
===============================================
    Merges inner case tables for each thread into one table.

    Args:
        None

    Returns:
        true : succeeded

    Returns:
        false : failed 

";
%feature("docstring") UtsusemiOneTrignetStorage::Merge "bool UtsusemiOneTrignetStorage::Merge(vector< vector< UInt4 > * > *_mergedTable, vector< bool > isAndFilter, UInt4 _numOfCounterCase, UInt4 _preCase=0)
========================================================================================================================================================
    Merges three Filter cases tables and one Counter cases table into one tables.

    Args:
        _mergedTable (vector<vector<UInt4>*>*) results of this merge
        isAndFilter (vector<bool>) And/Or condition between trignet cases in a filter
        _numOfCounterCase (UInt4) total number of counter case

    Returns:
        true : succeeded

    Returns:
        false : failed 

";
%feature("docstring") UtsusemiOneTrignetStorage::PutMergedTable "vector< UInt4 > UtsusemiOneTrignetStorage::PutMergedTable(UInt4 frm, vector< bool > isAndFilter, UInt4 _numOfCounterCase)
==========================================================================================================================
    Puts the result of Merge method.

    Args:
        frm (UInt4) frame NO
        isAndFilter (vector<bool>) And/Or condition between trignet cases in a filter
        _numOfCounterCase (UInt4) total number of counter case

    Returns:
        vector<UInt4> 

";
// File: classUtsusemiPsdBinInfo.xml

%feature("docstring") UtsusemiPsdBinInfo "C++ includes: WiringInfoEditorNeunet.hh 

";
%feature("docstring") UtsusemiPsdBinInfo::UtsusemiPsdBinInfo "UtsusemiPsdBinInfo::UtsusemiPsdBinInfo()
=========================================
    Constructor. 

    
UtsusemiPsdBinInfo::UtsusemiPsdBinInfo(const UtsusemiPsdBinInfo &obj)
======================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiPsdBinInfo::~UtsusemiPsdBinInfo "UtsusemiPsdBinInfo::~UtsusemiPsdBinInfo()
==========================================
    Destructor. 

";
%feature("docstring") UtsusemiPsdBinInfo::SetConts "bool UtsusemiPsdBinInfo::SetConts(string conts)
================================================
    Destructor. 

";
%feature("docstring") UtsusemiPsdBinInfo::SetNewNumOfPixel "bool UtsusemiPsdBinInfo::SetNewNumOfPixel(UInt4 num_of_pixel) 

";
%feature("docstring") UtsusemiPsdBinInfo::PutContsAsString "string UtsusemiPsdBinInfo::PutContsAsString() 

";
// File: classUtsusemiPsdParam.xml

%feature("docstring") UtsusemiPsdParam "C++ includes: WiringInfoEditorNeunet.hh 

";
%feature("docstring") UtsusemiPsdParam::UtsusemiPsdParam "UtsusemiPsdParam::UtsusemiPsdParam() 

    
UtsusemiPsdParam::UtsusemiPsdParam(const UtsusemiPsdParam &obj) 
";
%feature("docstring") UtsusemiPsdParam::~UtsusemiPsdParam "UtsusemiPsdParam::~UtsusemiPsdParam() 

";
// File: classUtsusemiReadoutEventDecoderTemplate.xml

%feature("docstring") UtsusemiReadoutEventDecoderTemplate "

    Decode Event Data of Readout (2D) for Utsusemi.
    C++ includes: UtsusemiReadoutEventDecoderTemplate.hh 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::UtsusemiReadoutEventDecoderTemplate "UtsusemiReadoutEventDecoderTemplate< T1, T2 >::UtsusemiReadoutEventDecoderTemplate()
=====================================================================================
    Constructor. 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::~UtsusemiReadoutEventDecoderTemplate "UtsusemiReadoutEventDecoderTemplate< T1, T2 >::~UtsusemiReadoutEventDecoderTemplate()
======================================================================================
    Destructor. 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::SetParametersFromFiles "Int4 UtsusemiReadoutEventDecoderTemplate< T1, T2 >::SetParametersFromFiles(std::string wiring_file, std::string detector_file)
===============================================================================================================================
    set parameters from files

    Args:
        wiring_file (string) Wiring Info xml file
        detector_file (string) DetectorInfo xml file

    Returns:
        0 no error
        -1 Troubles happened 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::ClearPrevT0Event "void UtsusemiReadoutEventDecoderTemplate< T1, T2 >::ClearPrevT0Event(UInt4 ThNum)
==================================================================================
    Clear Previous T0 Event.

    Args:
        ThNum (UInt4) Thread number

    Returns:
        None 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::DecodeEventData "virtual UInt4 UtsusemiReadoutEventDecoderTemplate< T1, T2 >::DecodeEventData(UInt4 daqId, UInt4 modNo, const UChar *data, UInt4 *pixel_id, double *tof, vector< Double > *Clock, UInt4 ThNum)=0
================================================================================================================================================================================================
    decode Event data
    This decodes any one event data and return type of event. If a given event is neutron, this sets pixel_id and tof and return 1 (_isNeutronEvent) If T0 event, this event is stored and return 2 (_isT0Event) If clock event, return 3 If any other event, return 0

    Args:
        daqId (UInt4) daq ID
        modNo (UInt4) module No
        data (UChar) one event data
        pixel_id (UInt4) Pixel ID calculated by given event
        tof (double) TOF calculated by given event
        Clock (vector<Double>)
        ThNum (UInt4) Thread number

    Returns:
        _isNeutronEvent if neutron event
        _isT0Event if T0 event
        _isClockEvent if clock event
        0 if any other event 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::ConvertPixelIdToInnerId "UInt4 UtsusemiReadoutEventDecoderTemplate< T1, T2 >::ConvertPixelIdToInnerId(UInt4 pixel_id)
=============================================================================================
    convert outer PixelID to inner( memory allocated ) ID
    This is used for conversion from outer PixelID to inner id for allocated vectors

    Args:
        pixel_id (UInt4) pixel ID

    Returns:
        inner ID (UInt4) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::ConvertPixelIdToDetId "UInt4 UtsusemiReadoutEventDecoderTemplate< T1, T2 >::ConvertPixelIdToDetId(UInt4 pixel_id)
===========================================================================================
    convert outer PixelID to outer DetID
    This is used to get det Id from outer PixelID to

    Args:
        pixel_id (UInt4) pixel ID

    Returns:
        detID (UInt4) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutPixelIdList "vector< UInt4 > UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutPixelIdList(bool isInner)
============================================================================================
    return vector of existed id from conversion table
    Conversion table( PixelID <-> inner ID ) is made by WiringFile. If isInner is true, this puts list of existed inner ID if false, list of existed pixel ID

    Args:
        isInner (bool) parameter to toggle type of return values.

    Returns:
        list of Id (vector<UInt4>) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutHistBin "vector< Double > UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutHistBin(UInt4 outerPixelId)
===============================================================================================
    put binning calculated by Efix
    For direct convertion from tof to phisical values, calculated binning(tof) is required to construct histograms.

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        binning vector 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutNumOfInnerPixels "UInt4 UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutNumOfInnerPixels()
===========================================================================
    put the number of inner pixels

    Returns:
        the number of pixels (UInt4) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutPixelPosition "vector< Double > UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutPixelPosition(UInt4 outerPixelId)
=====================================================================================================
    put pixel position from given outerPixelId

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        vector of pixel position 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutXLabel "pair< string, string > UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutXLabel(Int4 convtype) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutYLabel "pair< string, string > UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutYLabel(Int4 convtype) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutELabel "pair< string, string > UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutELabel(Int4 convtype) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::SetMaskOnError "void UtsusemiReadoutEventDecoderTemplate< T1, T2 >::SetMaskOnError(UInt4 _outerPixelId, vector< Double > &_bin, vector< Double > &_err) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::CalcPixelPosition "virtual void UtsusemiReadoutEventDecoderTemplate< T1, T2 >::CalcPixelPosition()
================================================================================
    calculate the position of each pixel
    This calculates the position of pixel from stored information. Potisions are stored to _pixelPositionVect.

    Returns:
        None 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutMaxOfPixelId "UInt4 UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutMaxOfPixelId()
=======================================================================
    put maximum number of pixel id

    Returns:
        maximum number (UInt4) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutTofBinType "Int4 UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutTofBinType(UInt4 outerPixelId)
======================================================================================
    put Tof Bin Type of given outerPixelId
    Tof Bin Type comes from Wiring File

    Args:
        outerPixelId (UInt4) pixel id

    Returns:
        tof bin type 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutXaxis "vector< Double > UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutXaxis()
===========================================================================
    put x axis values
    When TofBinType is for direct conversion from event data to energy, this returns calculated x-axis values.

    Args:
        None

    Returns:
        vector for values on calculated x-axis 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::isReverseAxis "bool UtsusemiReadoutEventDecoderTemplate< T1, T2 >::isReverseAxis(Int4 convtype) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::isValidConvType "bool UtsusemiReadoutEventDecoderTemplate< T1, T2 >::isValidConvType(Int4 convtype) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::SetTofOriginShift "bool UtsusemiReadoutEventDecoderTemplate< T1, T2 >::SetTofOriginShift(UInt4 cType) 

    
bool UtsusemiReadoutEventDecoderTemplate< T1, T2 >::SetTofOriginShift(UInt4 cType, vector< Double > params) 
";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutLambda "vector< Double > UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutLambda(UInt4 pixel_id) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutNumOfPixelForDet "UInt4 UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutNumOfPixelForDet(UInt4 _detId=0) 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutL1 "Double UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutL1() 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutTypicalL2 "Double UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutTypicalL2() 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutTypicalDS "Double UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutTypicalDS() 

";
%feature("docstring") UtsusemiReadoutEventDecoderTemplate::PutTypicalPixelSize "vector< Double > UtsusemiReadoutEventDecoderTemplate< T1, T2 >::PutTypicalPixelSize(UInt4 _detId=0) 

";
// File: classUtsusemiReadoutGateInfo.xml

%feature("docstring") UtsusemiReadoutGateInfo "C++ includes: WiringInfoEditorReadout.hh 

";
%feature("docstring") UtsusemiReadoutGateInfo::UtsusemiReadoutGateInfo "UtsusemiReadoutGateInfo::UtsusemiReadoutGateInfo() 

    
UtsusemiReadoutGateInfo::UtsusemiReadoutGateInfo(const UtsusemiReadoutGateInfo &obj) 
";
%feature("docstring") UtsusemiReadoutGateInfo::~UtsusemiReadoutGateInfo "UtsusemiReadoutGateInfo::~UtsusemiReadoutGateInfo() 

";
// File: classUtsusemiReadoutMWPCEventDecoder.xml

%feature("docstring") UtsusemiReadoutMWPCEventDecoder "

    Decode Event Data of Readout for Utsusemi.
    C++ includes: UtsusemiReadoutMWPCEventDecoder.hh 

";
%feature("docstring") UtsusemiReadoutMWPCEventDecoder::UtsusemiReadoutMWPCEventDecoder "UtsusemiReadoutMWPCEventDecoder::UtsusemiReadoutMWPCEventDecoder()
===================================================================
    Constructor. 

";
%feature("docstring") UtsusemiReadoutMWPCEventDecoder::~UtsusemiReadoutMWPCEventDecoder "UtsusemiReadoutMWPCEventDecoder::~UtsusemiReadoutMWPCEventDecoder()
====================================================================
    Destructor. 

";
%feature("docstring") UtsusemiReadoutMWPCEventDecoder::DecodeEventData "UInt4 UtsusemiReadoutMWPCEventDecoder::DecodeEventData(UInt4 daqId, UInt4 modNo, const UChar *data, UInt4 *pixel_id, double *tof, vector< Double > *Clock, UInt4 ThNum)
========================================================================================================================================================================
    decode Event data
    This decodes any one event data and return type of event. If a given event is neutron, this sets pixel_id and tof and return 1 (_isNeutronEvent) If T0 event, this event is stored and return 2 (_isT0Event) If clock event, return 3 If any other event, return 0

    Args:
        daqId (UInt4) daq ID
        modNo (UInt4) module No
        data (UChar) one event data
        pixel_id (UInt4) Pixel ID calculated by given event
        tof (double) TOF calculated by given event
        Clock (vector<Double>)
        ThNum (UInt4) Thread number

    Returns:
        _isNeutronEvent if neutron event
        _isT0Event if T0 event
        _isClockEvent if clock event
        0 if any other event 

";
%feature("docstring") UtsusemiReadoutMWPCEventDecoder::CalcPixelPosition "void UtsusemiReadoutMWPCEventDecoder::CalcPixelPosition()
==========================================================
    calculate the position of each pixel
    This calculates the position of pixel from stored information. Potisions are stored to _pixelPositionVect.

    Returns:
        None 

";
// File: classUtsusemiReadoutRPMTEventDecoder.xml

%feature("docstring") UtsusemiReadoutRPMTEventDecoder "

    Decode Event Data of Readout for Utsusemi.
    C++ includes: UtsusemiReadoutRPMTEventDecoder.hh 

";
%feature("docstring") UtsusemiReadoutRPMTEventDecoder::UtsusemiReadoutRPMTEventDecoder "UtsusemiReadoutRPMTEventDecoder::UtsusemiReadoutRPMTEventDecoder()
===================================================================
    Constructor. 

";
%feature("docstring") UtsusemiReadoutRPMTEventDecoder::~UtsusemiReadoutRPMTEventDecoder "UtsusemiReadoutRPMTEventDecoder::~UtsusemiReadoutRPMTEventDecoder()
====================================================================
    Destructor. 

";
%feature("docstring") UtsusemiReadoutRPMTEventDecoder::DecodeEventData "UInt4 UtsusemiReadoutRPMTEventDecoder::DecodeEventData(UInt4 daqId, UInt4 modNo, const UChar *data, UInt4 *pixel_id, double *tof, vector< Double > *Clock, UInt4 ThNum)
========================================================================================================================================================================
    decode Event data
    This decodes any one event data and return type of event. If a given event is neutron, this sets pixel_id and tof and return 1 (_isNeutronEvent) If T0 event, this event is stored and return 2 (_isT0Event) If clock event, return 3 If any other event, return 0

    Args:
        daqId (UInt4) daq ID
        modNo (UInt4) module No
        data (UChar) one event data
        pixel_id (UInt4) Pixel ID calculated by given event
        tof (double) TOF calculated by given event
        Clock (vector<Double>)
        ThNum (UInt4) Thread number

    Returns:
        _isNeutronEvent if neutron event
        _isT0Event if T0 event
        _isClockEvent if clock event
        0 if any other event 

";
%feature("docstring") UtsusemiReadoutRPMTEventDecoder::CalcPixelPosition "void UtsusemiReadoutRPMTEventDecoder::CalcPixelPosition()
==========================================================
    calculate the position of each pixel
    This calculates the position of pixel from stored information. Potisions are stored to _pixelPositionVect.

    Returns:
        None 

";
// File: classUtsusemiReadoutWLSF32EventDecoder.xml

%feature("docstring") UtsusemiReadoutWLSF32EventDecoder "

    Decode Event Data of Readout 32bit for Utsusemi.
    C++ includes: UtsusemiReadoutWLSF32EventDecoder.hh 

";
%feature("docstring") UtsusemiReadoutWLSF32EventDecoder::UtsusemiReadoutWLSF32EventDecoder "UtsusemiReadoutWLSF32EventDecoder::UtsusemiReadoutWLSF32EventDecoder()
=======================================================================
    Constructor. 

";
%feature("docstring") UtsusemiReadoutWLSF32EventDecoder::~UtsusemiReadoutWLSF32EventDecoder "UtsusemiReadoutWLSF32EventDecoder::~UtsusemiReadoutWLSF32EventDecoder()
========================================================================
    Destructor. 

";
%feature("docstring") UtsusemiReadoutWLSF32EventDecoder::DecodeEventData "UInt4 UtsusemiReadoutWLSF32EventDecoder::DecodeEventData(UInt4 daqId, UInt4 modNo, const UChar *data, UInt4 *pixel_id, double *tof, vector< Double > *Clock, UInt4 ThNum)
==========================================================================================================================================================================
    decode Event data
    This decodes any one event data and return type of event. If a given event is neutron, this sets pixel_id and tof and return 1 (_isNeutronEvent) If T0 event, this event is stored and return 2 (_isT0Event) If clock event, return 3 If any other event, return 0

    Args:
        daqId (UInt4) daq ID
        modNo (UInt4) module No
        data (UChar) one event data
        pixel_id (UInt4) Pixel ID calculated by given event
        tof (double) TOF calculated by given event
        Clock (vector<Double>)
        ThNum (UInt4) Thread number

    Returns:
        _isNeutronEvent if neutron event
        _isT0Event if T0 event
        _isClockEvent if clock event
        0 if any other event 

";
%feature("docstring") UtsusemiReadoutWLSF32EventDecoder::CalcPixelPosition "void UtsusemiReadoutWLSF32EventDecoder::CalcPixelPosition()
============================================================
    calculate the position of each pixel
    This calculates the position of pixel from stored information. Potisions are stored to _pixelPositionVect.

    Returns:
        None 

";
%feature("docstring") UtsusemiReadoutWLSF32EventDecoder::SetAnaModeReadout32 "bool UtsusemiReadoutWLSF32EventDecoder::SetAnaModeReadout32(Int4 anamode=-1) 

";
// File: classUtsusemiReductionCommon.xml

%feature("docstring") UtsusemiReductionCommon "

    Functions to do data correction.
    calculate Phi from Pixel position
    normalized by bin width
    C++ includes: UtsusemiReductionCommon.hh 

";
%feature("docstring") UtsusemiReductionCommon::UtsusemiReductionCommon "UtsusemiReductionCommon::UtsusemiReductionCommon()
===================================================
    Constructor. 

    
UtsusemiReductionCommon::UtsusemiReductionCommon(ElementContainerMatrix *ecm)
==============================================================================
    Constructor.

    Args:
        ecm ElementContainerMatrix for the target 
";
%feature("docstring") UtsusemiReductionCommon::~UtsusemiReductionCommon "UtsusemiReductionCommon::~UtsusemiReductionCommon()
====================================================
    Destructor. 

";
%feature("docstring") UtsusemiReductionCommon::CalcPhi "bool UtsusemiReductionCommon::CalcPhi(ElementContainerMatrix *ecm, double d_px=0, double d_py=0, double d_pz=0)
================================================================================================================
    executes calclulation of Phi to store in header

    Args:
        ecm (ElementContainerMatrix*) Target data
        d_px (Double) delta-x of volume of a pixel
        d_py (Double) delta-y of volume of a pixel
        d_pz (Double) delta-z of volume of a pixel

    Returns:
        true suceeded
        false failed 

    
bool UtsusemiReductionCommon::CalcPhi(double d_px=0, double d_py=0, double d_pz=0)
===================================================================================
    executes calclulation of Phi

    Args:
        d_px (Double) delta-x of volume of a pixel
        d_py (Double) delta-y of volume of a pixel
        d_pz (Double) delta-z of volume of a pixel

    Returns:
        true suceeded
        false failed 
";
%feature("docstring") UtsusemiReductionCommon::NormByBinWidth "bool UtsusemiReductionCommon::NormByBinWidth(ElementContainerMatrix *ecm, string key=\"\") 

    
bool UtsusemiReductionCommon::NormByBinWidth(string key=\"\")
==============================================================
    Intensity normalized by binning width.

    Returns:
        true : suceeded
        false failed 
";
%feature("docstring") UtsusemiReductionCommon::NormBySolidAngle "bool UtsusemiReductionCommon::NormBySolidAngle(ElementContainerMatrix *ecm, Double L2=0.0, Double dS=0.0) 

    
bool UtsusemiReductionCommon::NormBySolidAngle(Double L2=0.0, Double dS=0.0) 
";
%feature("docstring") UtsusemiReductionCommon::SolidAngleCorrect "bool UtsusemiReductionCommon::SolidAngleCorrect(ElementContainerMatrix *ecm=NULL) 

";
%feature("docstring") UtsusemiReductionCommon::NormByKickers "bool UtsusemiReductionCommon::NormByKickers(ElementContainerMatrix *ecm=NULL, Double normFactor=1.0) 

    
bool UtsusemiReductionCommon::NormByKickers(Double normFactor) 
";
// File: classUtsusemiReductionInEla.xml

%feature("docstring") UtsusemiReductionInEla "

    Function to do corrections for inelastic scattering.
    ki/kf term
    1/dhw
    ToPowder
    C++ includes: UtsusemiReductionInEla.hh 

";
%feature("docstring") UtsusemiReductionInEla::UtsusemiReductionInEla "UtsusemiReductionInEla::UtsusemiReductionInEla() 

    
UtsusemiReductionInEla::UtsusemiReductionInEla(ElementContainerMatrix *ecm)
============================================================================
    Constructor.

    Args:
        ecm ElementContainerMatrix for the target 
";
%feature("docstring") UtsusemiReductionInEla::~UtsusemiReductionInEla "UtsusemiReductionInEla::~UtsusemiReductionInEla()
==================================================
    Destructor. 

";
%feature("docstring") UtsusemiReductionInEla::KiKfCorrect "bool UtsusemiReductionInEla::KiKfCorrect(ElementContainerMatrix *ecm=NULL)
===========================================================================
    executes correction.

    Returns:
        None 

";
%feature("docstring") UtsusemiReductionInEla::dHWCorrect "bool UtsusemiReductionInEla::dHWCorrect(ElementContainerMatrix *ecm=NULL) 

";
%feature("docstring") UtsusemiReductionInEla::ToPowder "bool UtsusemiReductionInEla::ToPowder(ElementContainerMatrix *ret_ecm, Double deltaQ, Double startQ=-1.0, Double endQ=-1.0) 

    
bool UtsusemiReductionInEla::ToPowder(ElementContainerMatrix *ecm, ElementContainerMatrix *ret_ecm, Double deltaQ, Double startQ=-1.0, Double endQ=-1.0) 
";
%feature("docstring") UtsusemiReductionInEla::BoseFactorCorrect "bool UtsusemiReductionInEla::BoseFactorCorrect(ElementContainerMatrix *ecm, Double T) 

    
bool UtsusemiReductionInEla::BoseFactorCorrect(Double T) 
";
%feature("docstring") UtsusemiReductionInEla::BoseFactorCorrectEC "bool UtsusemiReductionInEla::BoseFactorCorrectEC(ElementContainer *ec, Double T) 

";
// File: classUtsusemiRunDataPathDict.xml

%feature("docstring") UtsusemiRunDataPathDict "

    Dictionary for Run data path.
    stores the found run data folders This is executed as a Singlton.
    C++ includes: UtsusemiHeader.hh 

";
%feature("docstring") UtsusemiRunDataPathDict::Add "void UtsusemiRunDataPathDict::Add(const string runNo, const vector< string > runFolders)
=========================================================================================
    Adds path informations.

    Args:
        runNo (string) XXXnnnnnn like SIK012345
        runFolders (vector<string>) /data/SIK/SIK012345_20181218

    Returns:
        None 

";
%feature("docstring") UtsusemiRunDataPathDict::Put "vector< string > UtsusemiRunDataPathDict::Put(const string runNo)
==================================================================
    Puts path informations.

    Args:
        runNo (string) XXXnnnnnn like SIK012345

    Returns:
        vector<string> folders for runNo 

";
%feature("docstring") UtsusemiRunDataPathDict::Dump "void UtsusemiRunDataPathDict::Dump()
=====================================
    Dumps of dictionary.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiRunDataPathDict::Clear "void UtsusemiRunDataPathDict::Clear()
======================================
    Clears dictionary.

    Args:
        None

    Returns:
        None 

";
// File: classUtsusemiSetMask.xml

%feature("docstring") UtsusemiSetMask "

    Sets mask flag at data container on Utsusemi environment.
    Mask flags is under the mask rule of Manyo-Library when the HeaderBase of container includes \"MASKED\" with (Int4) 1
    when the error value is minus
    This UtsusemiSetMask can set mask to ElementContainerMatrix using Mask File. Mask File format1 Ignores line which first charactor is #
    text format with space separator <detId> or <detId>.<pixNo> detId is value of key \"DETID\" in HeaderBase of ElementContainerArray pixNo is the index number of ElementContainer stored in ElementContainerArray
    Example of mask.txt
    | # INSTRUMENT SIK
    | # DATATYPE ELEMENTCONTAINERMATRIX
    | # TIME 2014 3 10
    | 0.0 0.99
    | 1.0 1.99
    | 10
    | 11.0 11.1
    Mask File format2 xml format Example of mask.xml
    | <maskInfo>
    |   <masklist n=\"2\">
    |     <mask i=\"0\">
    |       <pixelid> 100-200 </pixelid>
    |       <detector/>
    |       <pixelno/>
    |       <axis key=\"\"/>
    |     </mask>
    |     <mask i=\"1\">
    |       <pixelid/>
    |       <detector> 32-223 </detector>
    |       <pixelno>All</pixelno>
    |       <axis key=\"TOF\">0:500,1000:1250</axis>
    |     </mask>
    |   </masklist>
    | </maskInfo>
    Mask files must be placed in ${UTSUSEMI_BASE_DIR}/${UTSUSEMI_INST_CODE}/ana/xml
    ${UTSUSEMI_USR_DIR}/ana/xml
    C++ includes: UtsusemiSetMask.hh 

";
%feature("docstring") UtsusemiSetMask::UtsusemiSetMask "UtsusemiSetMask::UtsusemiSetMask()
===================================
    Constructor. 

    
UtsusemiSetMask::UtsusemiSetMask(ElementContainerMatrix *ecm)
==============================================================
    Constructor.

    Args:
        ecm (ElementContainerMatrix*) target data container 
    
UtsusemiSetMask::UtsusemiSetMask(ElementContainerMatrix *ecm, string filename)
===============================================================================
    Constructor.

    Args:
        ecm (ElementContainerMatrix*) target data container
        filename (string) Maskfile format1: xxx.txt, format2: xxx.xml 
    
UtsusemiSetMask::UtsusemiSetMask(ElementContainerMatrix *ecm, string filename, string key)
===========================================================================================
    Constructor.

    Args:
        ecm (ElementContainerMatrix*) target data container
        filename (string) Maskfile format1: xxx.txt, format2: xxx.xml
        key (string) key of axis in data container on using format2 
";
%feature("docstring") UtsusemiSetMask::~UtsusemiSetMask "UtsusemiSetMask::~UtsusemiSetMask()
====================================
    Destructor. 

";
%feature("docstring") UtsusemiSetMask::ReadFile "bool UtsusemiSetMask::ReadFile(string filename)
================================================
    Reads Mask File.
    bool ReadFile( string filename )

    Args:
        filename (string) full path to mask file

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiSetMask::SetAxisKey "void UtsusemiSetMask::SetAxisKey(string a_key)
===============================================
    Sets Axis key in data container on using format2.
    void SetAxisKey( string a_key )

    Args:
        key (string) key

    Returns:
        None 

";
%feature("docstring") UtsusemiSetMask::Execute "bool UtsusemiSetMask::Execute()
================================
    Executes Set Mask flags.
    bool Execute()

    Args:
        None

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiSetMask::MaskRange "void UtsusemiSetMask::MaskRange(ElementContainer *ec, string key, vector< Double > axrange)
============================================================================================
    Masks given axis range.
    void MaskRange( ElementContainer* ec, string key, vector<Double> axrange )

    Args:
        ec (ElementContainer*) target data container
        key (string) key of axis to be masked
        axrange (vector<Double>) [mask1_start,mask1_end,mask2_start,mask2_end,...]

    Returns:
        None 

";
%feature("docstring") UtsusemiSetMask::UnmaskAll "void UtsusemiSetMask::UnmaskAll()
==================================
    Deletes all masked flag.
    void UnmaskAll()

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiSetMask::PutListOfTxtMask "bool UtsusemiSetMask::PutListOfTxtMask(vector< vector< vector< Double > * > * > *list) 

";
// File: classUtsusemiSqeCalc.xml

%feature("docstring") UtsusemiSqeCalc "

    Class for supporting functions to treat Q value.
    This includes some methods to replace functions in VisualCont2 (VisualContCommon.py)
    C++ includes: UtsusemiSqeCalc.hh 

";
%feature("docstring") UtsusemiSqeCalc::UtsusemiSqeCalc "UtsusemiSqeCalc::UtsusemiSqeCalc()
===================================
    Constructor. 

    
UtsusemiSqeCalc::UtsusemiSqeCalc(bool isDebug)
===============================================
    Constructor.

    Args:
        isDebug when debug mode, set true 
    
UtsusemiSqeCalc::UtsusemiSqeCalc(string instType)
==================================================
    Constructor.

    Args:
        instType Direct:direct geometry, Inverted:inverted geometry 
";
%feature("docstring") UtsusemiSqeCalc::~UtsusemiSqeCalc "UtsusemiSqeCalc::~UtsusemiSqeCalc()
====================================
    Destructor. 

";
%feature("docstring") UtsusemiSqeCalc::SetInstGeometry "void UtsusemiSqeCalc::SetInstGeometry(string instType=\"Direct\")
==================================================================
    Sets the instrument geometry.

    Args:
        instType Direct:direct geometry, Inverted:inverted geometry 

";
%feature("docstring") UtsusemiSqeCalc::CalcReciproLattice "vector< Double > UtsusemiSqeCalc::CalcReciproLattice(vector< Double > latticeConst, vector< Double > Uvec, vector< Double > Vvec, Double phi)
==============================================================================================================================================
    Calculates reciprocal lattice from parameters.

    Args:
        latticeConst Lattice Constants a,b,c,alpha,beta,gamma
        Uvec U vector
        Vvec V vector
        phi angle around W axis

    Returns:
        Reciprocal Lattice vector 

";
%feature("docstring") UtsusemiSqeCalc::Make4DVect "vector< Double > UtsusemiSqeCalc::Make4DVect(vector< Double > vaxis, vector< Double > lc)
==========================================================================================
    Makes 4 dimension vector on Q-E space from 3-D vector on Q-space.

    Args:
        vaxis view axes
        lc Reciprocal vector infor (returned from CalcReciproLattice)

    Returns:
        None 

";
%feature("docstring") UtsusemiSqeCalc::Projection "vector< Double > UtsusemiSqeCalc::Projection(vector< Double > vaxis)
=====================================================================
    Calculates projction of ElementContainerMatrix.

    Args:
        vaxis view axes

    Returns:
        Reciprocal Lattice vector 

    
bool UtsusemiSqeCalc::Projection(PyObject *arg_ax1, PyObject *arg_ax2, PyObject *arg_ax3, PyObject *arg_ax4) 
    
bool UtsusemiSqeCalc::Projection() 
";
%feature("docstring") UtsusemiSqeCalc::Projection_QxQyQz "vector< Double > UtsusemiSqeCalc::Projection_QxQyQz(vector< Double > vaxis)
============================================================================
    Calculates projction of ElementContainerMatrix.

    Args:
        vaxis view axes

    Returns:
        Reciprocal Lattice vector 

";
%feature("docstring") UtsusemiSqeCalc::Slice "Int4 UtsusemiSqeCalc::Slice(vector< Double > Ax1range, vector< Double > Ax2range, vector< Double > Ax3range, vector< Double > Ax4range, vector< string > AxesType, vector< Double > Folding, bool isAverageMode=true)
======================================================================================================================================================================================================================
    Slice.

    Args:
        Ax1range first view axis vector
        Ax2range second view axis vector
        Ax3range third view axis vector
        Ax4range forth view axis vector
        AxesType set how to treat each axis. can use only \"X\",\"Y\" or \"T\".
        Folding [0]to[3] are for along-axis-folding 0..off, 1..on, [4]to[6] are parameters for diagonal folding, [4] is type 0..no, 1..1st-3rd quadrant, 2..2nd-4th quadrant, [5]and[6] are axes-id to be used.
        isAverageMode

    Returns:
        -1 Something wrong
        0 No trouble 

    
bool UtsusemiSqeCalc::Slice(PyObject *Ax1, PyObject *Ax2, PyObject *Ax3, PyObject *Ax4, PyObject *DiagFolding, bool isAverageMode=true) 
    
bool UtsusemiSqeCalc::Slice(bool isAverageMode=true) 
";
%feature("docstring") UtsusemiSqeCalc::PutXArray "vector<Double> UtsusemiSqeCalc::PutXArray()
============================================
    Puts XArray (X-axis values) calculated at Slice method.

    Returns:
        < XArray > 

";
%feature("docstring") UtsusemiSqeCalc::PutYArray "vector<Double> UtsusemiSqeCalc::PutYArray()
============================================
    Puts YArray (Y-axis values) calculated at Slice method.

    Returns:
        < YArray > 

";
%feature("docstring") UtsusemiSqeCalc::PutDArray "vector< Double > UtsusemiSqeCalc::PutDArray()
==============================================
    Puts DArray (Intensity values) calculated at Slice method.

    Returns:
        < DArray > 

";
%feature("docstring") UtsusemiSqeCalc::PutEArray "vector< Double > UtsusemiSqeCalc::PutEArray()
==============================================
    Puts EArray (Error values) calculated at Slice method.

    Returns:
        < EArray > 

";
%feature("docstring") UtsusemiSqeCalc::GetAxLimit "vector< Double > UtsusemiSqeCalc::GetAxLimit()
===============================================
    returns Q1,Q2,Q3,hw ranges

    Returns:
        < Q1 min, Q1 max, Q2 min, Q2 max, Q3 min, Q3 max, Q4 min, Q4 max > 

";
%feature("docstring") UtsusemiSqeCalc::PutQRange "PyObject* UtsusemiSqeCalc::PutQRange()
=======================================
    Puts axes ranges of D4Mat.

    Args:
        None

    Returns:
        python list object [ax1_min, ax1_max, ax2_min, ... , ax4_max] 

";
%feature("docstring") UtsusemiSqeCalc::ConvertToD4Mat "Int4 UtsusemiSqeCalc::ConvertToD4Mat(string filepath, vector< Double > ax1, vector< Double > ax2, vector< Double > ax3, vector< Double > ax4, vector< Double > foldings, bool isAverageMode=true)
==================================================================================================================================================================================================
    Convert and save data using format which D4MatSlicer can load.

    Args:
        filepath Path/to/file
        ax1 first view axis information < min, max, step >
        ax2 second view axis information < min, max, step >
        ax3 third view axis information < min, max, step >
        ax4 forth view axis information < min, max, step >
        foldings folding 0..off, 1..on
        isAverageMode true: average calculation of intensity, false: summation

    Returns:
        -1 Something wrong
        0 No trouble 

    
Int4 UtsusemiSqeCalc::ConvertToD4Mat(string filepath, bool isAverageMode=true)
===============================================================================
    Convert and save data using format which D4MatSlicer can load.

    Args:
        filepath Path/to/file
        isAverageMode true: average calculation of intensity, false: summation

    Returns:
        -1 Something wrong
        0 No trouble 
";
%feature("docstring") UtsusemiSqeCalc::Test "void UtsusemiSqeCalc::Test() 

";
%feature("docstring") UtsusemiSqeCalc::QConvFromReciprocalToRealSpace "vector< Double > UtsusemiSqeCalc::QConvFromReciprocalToRealSpace(vector< Double > Qvec, vector< Double > LC, vector< Double > Uv, vector< Double > Vv, vector< Double > RS, vector< Double > VA)
=================================================================================================================================================================================================
    Convert list of Qx,Qy,Qz in Qvec to real space using sample information.

    Args:
        Qvec list of Qx,Qy,Qz : Qx0,Qy0,Qz0,Qx1,Qy1,Qz1,Qx2,...,Qxn,Qyn,Qzn
        LC Latice constants
        Uv U vector
        Vv V vector
        RS Rotation info
        VA View axes info

    Returns:
        list of x,y,z in real space, its size is same as Qvec 

";
%feature("docstring") UtsusemiSqeCalc::MakeProjectionMatrix "vector< Double > UtsusemiSqeCalc::MakeProjectionMatrix(vector< Double > latticeConst, vector< Double > Uvec, vector< Double > Vvec, vector< Double > rotateSteps, vector< Double > viewAxes)
=============================================================================================================================================================================================
    Makes the 4d Matrix for projection from (Qa,Qb,Qc,hw) -> (Vx,Vy,Vz,Vx)
    Vx = Qz*A[0] + Qx*A[1] + Qy*A[2] + hw*A[3]; Vy = Qz*A[4] + Qx*A[5] + Qy*A[6] + hw*A[7]; Vz = Qz*A[8] + Qx*A[9] + Qy*A[10] + hw*A[11]; Vw = Qz*A[12] + Qx*A[13] + Qy*A[14] + hw*A[15];

    Args:
        laticeConst (vector<double>) a,b,c,alpha,beta,gamma
        Uvec (vector<double>) U vector
        Vvec (vector<double>) V vector
        rotateSteps (vector<double>) axis1, rot1[, axis2, rot2[, axis3, rot3] ] axisX is the number of rotation axis (\"X\":0,\"Y\":1,\"Z\":2) and the rotation value
        viewAxes (vector<Double>) View Axes

    Returns:
        vector<Double> Matrix A with size of 16 

";
%feature("docstring") UtsusemiSqeCalc::SetSlicedElementContainerArray "bool UtsusemiSqeCalc::SetSlicedElementContainerArray(ElementContainerArray *_eca, string _bin_key=\"X\", string _xval_key=\"XVAL\", string _xrange_key=UTSUSEMI_KEY_HEAD_XRANGE) 

";
%feature("docstring") UtsusemiSqeCalc::LoadXtalParam "bool UtsusemiSqeCalc::LoadXtalParam(string file) 

";
%feature("docstring") UtsusemiSqeCalc::SaveXtalParam "bool UtsusemiSqeCalc::SaveXtalParam(string file) 

";
%feature("docstring") UtsusemiSqeCalc::SetLatticeConstants "bool UtsusemiSqeCalc::SetLatticeConstants(PyObject *LC) 

";
%feature("docstring") UtsusemiSqeCalc::SetUVvector "bool UtsusemiSqeCalc::SetUVvector(PyObject *UV, PyObject *VV) 

";
%feature("docstring") UtsusemiSqeCalc::SetRotationSteps "bool UtsusemiSqeCalc::SetRotationSteps(string steps) 

";
%feature("docstring") UtsusemiSqeCalc::SetDebugMode "void UtsusemiSqeCalc::SetDebugMode(bool _isDebugMode=true) 

";
// File: classUtsusemiSqeCalc2.xml

%feature("docstring") UtsusemiSqeCalc2 "

    Class for supporting functions to treat Q value.
    This includes some methods to replace functions in VisualCont2 (VisualContCommon.py)
    C++ includes: UtsusemiSqeCalc2.hh 

";
%feature("docstring") UtsusemiSqeCalc2::UtsusemiSqeCalc2 "UtsusemiSqeCalc2::UtsusemiSqeCalc2()
=====================================
    Constructor. 

    
UtsusemiSqeCalc2::UtsusemiSqeCalc2(bool isDebug)
=================================================
    Constructor.

    Args:
        isDebug when debug mode, set true 
    
UtsusemiSqeCalc2::UtsusemiSqeCalc2(string instType)
====================================================
    Constructor.

    Args:
        instType Direct:direct geometry, Inverted:inverted geometry 
";
%feature("docstring") UtsusemiSqeCalc2::~UtsusemiSqeCalc2 "UtsusemiSqeCalc2::~UtsusemiSqeCalc2()
======================================
    Destructor. 

";
%feature("docstring") UtsusemiSqeCalc2::MakeProjectionMatrix "vector< Double > UtsusemiSqeCalc2::MakeProjectionMatrix(vector< Double > latticeConst, vector< Double > Uvec, vector< Double > Vvec, vector< Double > rotateSteps, vector< Double > viewAxes) 

    
vector< Double > UtsusemiSqeCalc2::MakeProjectionMatrix(vector< Double > UBmat, vector< Double > rotateSteps, vector< Double > viewAxes)
=========================================================================================================================================
    Makes the 4d Matrix for projection from (Qa,Qb,Qc,hw) -> (Vx,Vy,Vz,Vx)
    Vx = Qx*A[0] + Qy*A[1] + Qz*A[2] + hw*A[3]; Vy = Qx*A[4] + Qy*A[5] + Qz*A[6] + hw*A[7]; Vz = Qx*A[8] + Qy*A[9] + Qz*A[10] + hw*A[11]; Vw = Qx*A[12] + Qy*A[13] + Qz*A[14] + hw*A[15];

    Args:
        laticeConst (vector<double>) a,b,c,alpha,beta,gamma
        Uvec (vector<double>) U vector
        Vvec (vector<double>) V vector
        rotateSteps (vector<double>) axis1, rot1[, axis2, rot2[, axis3, rot3] ] axisX is the number of rotation axis (\"X\":0,\"Y\":1,\"Z\":2) and the rotation value
        viewAxes (vector<Double>) View Axes

    Returns:
        vector<Double> Matrix A with size of 16 
";
%feature("docstring") UtsusemiSqeCalc2::SetInstGeometry "void UtsusemiSqeCalc2::SetInstGeometry(string instType=\"Direct\")
===================================================================
    Sets the instrument geometry.

    Args:
        instType Direct:direct geometry, Inverted:inverted geometry 

";
%feature("docstring") UtsusemiSqeCalc2::Projection "vector< Double > UtsusemiSqeCalc2::Projection(vector< Double > vaxis)
======================================================================
    Calculates projction of ElementContainerMatrix.

    Args:
        vaxis view axes

    Returns:
        Reciprocal Lattice vector 

    
bool UtsusemiSqeCalc2::Projection(PyObject *arg_ax1, PyObject *arg_ax2, PyObject *arg_ax3, PyObject *arg_ax4) 
    
bool UtsusemiSqeCalc2::Projection() 
";
%feature("docstring") UtsusemiSqeCalc2::Projection_QxQyQz "vector< Double > UtsusemiSqeCalc2::Projection_QxQyQz(vector< Double > vaxis)
=============================================================================
    Calculates projction of ElementContainerMatrix.

    Args:
        vaxis view axes

    Returns:
        Reciprocal Lattice vector 

";
%feature("docstring") UtsusemiSqeCalc2::Slice "Int4 UtsusemiSqeCalc2::Slice(vector< Double > Ax1range, vector< Double > Ax2range, vector< Double > Ax3range, vector< Double > Ax4range, vector< string > AxesType, vector< Double > Folding, bool isAverageMode=true)
=======================================================================================================================================================================================================================
    Slice.

    Args:
        Ax1range first view axis vector
        Ax2range second view axis vector
        Ax3range third view axis vector
        Ax4range forth view axis vector
        AxesType set how to treat each axis. can use only \"X\",\"Y\" or \"T\".
        Folding [0]to[3] are for along-axis-folding 0..off, 1..on, [4]to[6] are parameters for diagonal folding, [4] is type 0..no, 1..1st-3rd quadrant, 2..2nd-4th quadrant, [5]and[6] are axes-id to be used.
        isAverageMode

    Returns:
        -1 Something wrong
        0 No trouble 

    
bool UtsusemiSqeCalc2::Slice(PyObject *Ax1, PyObject *Ax2, PyObject *Ax3, PyObject *Ax4, PyObject *DiagFolding, bool isAverageMode=true) 
    
bool UtsusemiSqeCalc2::Slice(bool isAverageMode=true) 
";
%feature("docstring") UtsusemiSqeCalc2::PutXArray "vector<Double> UtsusemiSqeCalc2::PutXArray()
=============================================
    Puts XArray (X-axis values) calculated at Slice method.

    Returns:
        < XArray > 

";
%feature("docstring") UtsusemiSqeCalc2::PutYArray "vector<Double> UtsusemiSqeCalc2::PutYArray()
=============================================
    Puts YArray (Y-axis values) calculated at Slice method.

    Returns:
        < YArray > 

";
%feature("docstring") UtsusemiSqeCalc2::PutDArray "vector< Double > UtsusemiSqeCalc2::PutDArray()
===============================================
    Puts DArray (Intensity values) calculated at Slice method.

    Returns:
        < DArray > 

";
%feature("docstring") UtsusemiSqeCalc2::PutEArray "vector< Double > UtsusemiSqeCalc2::PutEArray()
===============================================
    Puts EArray (Error values) calculated at Slice method.

    Returns:
        < EArray > 

";
%feature("docstring") UtsusemiSqeCalc2::GetAxLimit "vector< Double > UtsusemiSqeCalc2::GetAxLimit()
================================================
    returns Q1,Q2,Q3,hw ranges

    Returns:
        < Q1 min, Q1 max, Q2 min, Q2 max, Q3 min, Q3 max, Q4 min, Q4 max > 

";
%feature("docstring") UtsusemiSqeCalc2::PutQRange "PyObject* UtsusemiSqeCalc2::PutQRange()
========================================
    Puts axes ranges of D4Mat.

    Args:
        None

    Returns:
        python list object [ax1_min, ax1_max, ax2_min, ... , ax4_max] 

";
%feature("docstring") UtsusemiSqeCalc2::ConvertToD4Mat "Int4 UtsusemiSqeCalc2::ConvertToD4Mat(string filepath, vector< Double > ax1, vector< Double > ax2, vector< Double > ax3, vector< Double > ax4, vector< Double > foldings, bool isAverageMode=true)
===================================================================================================================================================================================================
    Convert and save data using format which D4MatSlicer can load.

    Args:
        filepath Path/to/file
        ax1 first view axis information < min, max, step >
        ax2 second view axis information < min, max, step >
        ax3 third view axis information < min, max, step >
        ax4 forth view axis information < min, max, step >
        foldings folding 0..off, 1..on
        isAverageMode true: average calculation of intensity, false: summation

    Returns:
        -1 Something wrong
        0 No trouble 

    
Int4 UtsusemiSqeCalc2::ConvertToD4Mat(string filepath, bool isAverageMode=true)
================================================================================
    Convert and save data using format which D4MatSlicer can load.

    Args:
        filepath Path/to/file
        isAverageMode true: average calculation of intensity, false: summation

    Returns:
        -1 Something wrong
        0 No trouble 
";
%feature("docstring") UtsusemiSqeCalc2::Test "void UtsusemiSqeCalc2::Test() 

";
%feature("docstring") UtsusemiSqeCalc2::QConvFromReciprocalToRealSpace "vector< Double > UtsusemiSqeCalc2::QConvFromReciprocalToRealSpace(vector< Double > Qvec, vector< Double > LC, vector< Double > Uv, vector< Double > Vv, vector< Double > RS, vector< Double > VA)
==================================================================================================================================================================================================
    Convert list of Qx,Qy,Qz in Qvec to real space using sample information.

    Args:
        Qvec list of Qx,Qy,Qz : Qx0,Qy0,Qz0,Qx1,Qy1,Qz1,Qx2,...,Qxn,Qyn,Qzn
        LC Latice constants
        Uv U vector
        Vv V vector
        RS Rotation info
        VA View axes info

    Returns:
        list of x,y,z in real space, its size is same as Qvec 

";
%feature("docstring") UtsusemiSqeCalc2::SetSlicedElementContainerArray "bool UtsusemiSqeCalc2::SetSlicedElementContainerArray(ElementContainerArray *_eca, string _bin_key=\"X\", string _xval_key=\"XVAL\", string _bin_unit=\"\", string _xval_unit=\"\", string _xrange_key=UTSUSEMI_KEY_HEAD_XRANGE) 

";
%feature("docstring") UtsusemiSqeCalc2::LoadXtalParam "bool UtsusemiSqeCalc2::LoadXtalParam(string file) 

";
%feature("docstring") UtsusemiSqeCalc2::SaveXtalParam "bool UtsusemiSqeCalc2::SaveXtalParam(string file) 

";
%feature("docstring") UtsusemiSqeCalc2::SetLatticeConstants "bool UtsusemiSqeCalc2::SetLatticeConstants(PyObject *LC) 

";
%feature("docstring") UtsusemiSqeCalc2::SetUVvector "bool UtsusemiSqeCalc2::SetUVvector(PyObject *UV, PyObject *VV) 

";
%feature("docstring") UtsusemiSqeCalc2::SetUBMatrix "bool UtsusemiSqeCalc2::SetUBMatrix(PyObject *UBM) 

";
%feature("docstring") UtsusemiSqeCalc2::SetRotationSteps "bool UtsusemiSqeCalc2::SetRotationSteps(string steps) 

";
%feature("docstring") UtsusemiSqeCalc2::ConvToUBMatrix "vector< Double > UtsusemiSqeCalc2::ConvToUBMatrix(PyObject *LC, PyObject *UV, PyObject *VV, bool flagRound=true) 

";
%feature("docstring") UtsusemiSqeCalc2::ConvToUVvector "vector< Double > UtsusemiSqeCalc2::ConvToUVvector(PyObject *LC, PyObject *UB, bool flagRound=true) 

";
%feature("docstring") UtsusemiSqeCalc2::InverseMatrix "vector< Double > UtsusemiSqeCalc2::InverseMatrix(vector< Double > a) 

";
%feature("docstring") UtsusemiSqeCalc2::TEST_InverseMatrix "void UtsusemiSqeCalc2::TEST_InverseMatrix(vector< Double > a) 

";
%feature("docstring") UtsusemiSqeCalc2::SetDebugMode "void UtsusemiSqeCalc2::SetDebugMode(bool _isDebugMode=true) 

";
%feature("docstring") UtsusemiSqeCalc2::PutInnerMatrix "vector< Double > UtsusemiSqeCalc2::PutInnerMatrix(string M)
============================================================
    Puts the inner matrix for LatticeConst , U and V, Rotation, View axes and all.
    argument string : \"L\" Matrix of a* b* c* \"U\" Matrix of U and V vectors \"R\" Matrix of rotation \"V\" Matrix of view axes \"A\" A = [V] [L] [U] [R]

    Args:
        M (string) \"L\",\"U\",\"R\",\"V\" and \"A\"

    Returns:
        vector of matrix. 

";
// File: classUtsusemiSqeCalcXtalParams.xml

%feature("docstring") UtsusemiSqeCalcXtalParams "C++ includes: UtsusemiSqeCalcXtalParams.hh 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::UtsusemiSqeCalcXtalParams "UtsusemiSqeCalcXtalParams::UtsusemiSqeCalcXtalParams(string filepath=\"\")
===========================================================================
    Constructor.

    Returns:
        None 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::~UtsusemiSqeCalcXtalParams "UtsusemiSqeCalcXtalParams::~UtsusemiSqeCalcXtalParams()
========================================================
    Destructor.

    Returns:
        None 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetLatticeConstants "bool UtsusemiSqeCalcXtalParams::SetLatticeConstants(Double a, Double b, Double c, Double alpha, Double beta, Double gamma)
===========================================================================================================================
    Sets crystal lattice parameters.
    This sets crystal lattice consts with individual

    Args:
        a (double) Lattice constants a
        b (double) Lattice constants a
        c (double) Lattice constants a
        alpha (double) Lattice constants alpha
        beta (double) Lattice constants beta
        gamma (double) Lattice constants gamma

    Returns:
        true no trouble
        false trouble happened. 

    
bool UtsusemiSqeCalcXtalParams::SetLatticeConstants(PyObject *LC)
==================================================================
    Sets crystal lattice parameters.
    This sets crystal lattice consts by python list object

    Args:
        LC (list of float) Lattice constants [, , ,<alpha>,<beta>,<gamma>]

    Returns:
        true    no trouble
        false    trouble happened. 
";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetUVvector "bool UtsusemiSqeCalcXtalParams::SetUVvector(Double ux, Double uy, Double uz, Double vx, Double vy, Double vz, bool isPriority=true)
====================================================================================================================================
    Sets crystal orientation.

    Args:
        ux (double) U-vector Uh
        uy (double) U-vector Uk
        uz (double) U-vector Ul
        wx (double) V-vector Vh
        wy (double) V-vector Vk
        wz (double) V-vector Vl
        isPriority (bool) true: UV-vector is used to calculate projection instead of UBmatrix

    Returns:
        true no trouble
        false trouble happened. 

    
bool UtsusemiSqeCalcXtalParams::SetUVvector(PyObject *UV, PyObject *VV, bool isPriority=true)
==============================================================================================
    Sets crystal orientation.

    Args:
        UV (list of float) U-vector [<Uh>,<Uk>,
        VV (list of float) V-vector [<Vh>,<Vk>,<Vl>]
        isPriority (bool) true: UV-vector is used to calculate projection instead of UBmatrix

    Returns:
        true no trouble
        false trouble happened. 
";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetUBMatrix "bool UtsusemiSqeCalcXtalParams::SetUBMatrix(PyObject *UB, bool isPriority=true)
================================================================================
    Sets UB matrix.

    Args:
        UB (list of float) U-vector [<UB11>,<UB12>,<UB13>,<UB21>,<UB22>,<UB23>,<UB31>,<UB32>,<UB33>,]
        isPriority (bool) true: UBmatrix is used to calculate projection instead of UV-vectors

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::AddRotationStep "bool UtsusemiSqeCalcXtalParams::AddRotationStep(string axis, double degree)
============================================================================
    Sets Rotation angle.

    Args:
        axis (string) \"Y\" or \"X\" or \"Z\"
        degree (double) angle [degree]

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetRotationSteps "bool UtsusemiSqeCalcXtalParams::SetRotationSteps(string steps)
===============================================================
    Sets Rotation angle.

    Args:
        steps (string) format \"<Axis>:<degree>[,<Axis>:<degree>,...]\"

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetSampleInfoToData "bool UtsusemiSqeCalcXtalParams::SetSampleInfoToData(ElementContainerMatrix *ecm)
=================================================================================
    Sets Sample information to header in ElementContainerMatrix.

    Args:
        ecm (ElementContainerMatrix)

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::ClearRotationStep "bool UtsusemiSqeCalcXtalParams::ClearRotationStep()
====================================================
    Clears Rotation steps.

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetProjectionAxis "bool UtsusemiSqeCalcXtalParams::SetProjectionAxis(string _id, double va, double vb, double vc, double ve, string title, string unit)
=====================================================================================================================================
    Sets Projection information for a axis.

    Args:
        _id (string) id of Ax
        va (double) a* value of corrdinate axis for projection
        vb (double) b* value of corrdinate axis for projection
        vc (double) c* value of corrdinate axis for projection
        ve (double) Energy value of corrdinate axis for projection
        title (string) label of corrdinate axis
        unit (string) unit of corrdinate axis

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetProjectionAxes "bool UtsusemiSqeCalcXtalParams::SetProjectionAxes(PyObject *arg_ax1, PyObject *arg_ax2, PyObject *arg_ax3, PyObject *arg_ax4)
==============================================================================================================================
    Sets Projection information for a axis.
    Given list is like [1.0,0.0,0.0,0.0,\"Qh\",\"rlu\"]

    Args:
        arg_ax1 (list) [<a* value>,<b* value>,<c* value>,<energy value>,\"<label>\",\"<unit>\"]
        arg_ax2 (list) [<a* value>,<b* value>,<c* value>,<energy value>,\"<label>\",\"<unit>\"]
        arg_ax3 (list) [<a* value>,<b* value>,<c* value>,<energy value>,\"<label>\",\"<unit>\"]
        arg_ax4 (list) [<a* value>,<b* value>,<c* value>,<energy value>,\"<label>\",\"<unit>\"]

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetSliceAxis "bool UtsusemiSqeCalcXtalParams::SetSliceAxis(string _id, string _type, double _min, double _max, double _width, double _folding)
=================================================================================================================================
    Sets slicing information for a axis.

    Args:
        _id (string) id of Ax
        _type (string) type of Ax : \"X\",\"Y\" or \"T\"
        _min (double) minimum value of Ax
        _max (double) maximum value of Ax
        _width (double) width value of Ax
        _folding (double) folding info of Ax

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetSliceAxes "bool UtsusemiSqeCalcXtalParams::SetSliceAxes(PyObject *Ax1, PyObject *Ax2, PyObject *Ax3, PyObject *Ax4, bool isForced=false)
==============================================================================================================================
    Sets slicing information.
    \"X\" and \"Y\" axis : [\"X\",<min>,<max>,<width>] \"T\" axis : [\"T\",<min>,<max>]

    Args:
        Ax1 (list) List for Ax1
        Ax2 (list) List for Ax2
        Ax3 (list) List for Ax3
        Ax4 (list) List for Ax4
        isForced (bool) true: ignore the number of axis types (\"X\",\"Y\" and \"T\")

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetDiagFolding "bool UtsusemiSqeCalcXtalParams::SetDiagFolding(string _type, UInt4 ax1, UInt4 ax2)
===================================================================================
    Sets folding information for a axix.

    Args:
        type (string)
        ax1 (UInt4)
        ax2 (UInt4)

    Returns:
        true no trouble
        false trouble happened. 

    
bool UtsusemiSqeCalcXtalParams::SetDiagFolding(PyObject *Dfold) 
";
%feature("docstring") UtsusemiSqeCalcXtalParams::LoadFile "bool UtsusemiSqeCalcXtalParams::LoadFile(string filepath, UInt4 flags=TOXML_ALL)
=================================================================================
    Loads XtalParams.

    Args:
        filepath (string) full path to XtalParam.xml
        flags (UInt4) information to read parameters pertially

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SaveFile "bool UtsusemiSqeCalcXtalParams::SaveFile(string filepath, UInt4 flags=TOXML_ALL)
=================================================================================
    Save XtalParams.

    Args:
        filepath (string) full path to XtalParam.xml
        flags (UInt4) information to save parameters pertially

    Returns:
        true no trouble
        false trouble happened. 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::DecodeFromXml "bool UtsusemiSqeCalcXtalParams::DecodeFromXml(string conts, UInt4 flags) 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::EncodeToXml "bool UtsusemiSqeCalcXtalParams::EncodeToXml(UInt4 flags) 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutXmlString "string UtsusemiSqeCalcXtalParams::PutXmlString(UInt4 flags=TOXML_ALL)
======================================================================
    Put XtalParams info as string.

    Args:
        flags (UInt4) information to save parameters pertially

    Returns:
        string XtalParam string 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::Dump "void UtsusemiSqeCalcXtalParams::Dump() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::SetExampleParams "void UtsusemiSqeCalcXtalParams::SetExampleParams() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutLatticeConsts "vector<Double> UtsusemiSqeCalcXtalParams::PutLatticeConsts() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutUVector "vector<Double> UtsusemiSqeCalcXtalParams::PutUVector() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutVVector "vector<Double> UtsusemiSqeCalcXtalParams::PutVVector() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutUBMatrix "vector<Double> UtsusemiSqeCalcXtalParams::PutUBMatrix() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutPriorigy "bool UtsusemiSqeCalcXtalParams::PutPriorigy() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutRotateSteps "vector< Double > UtsusemiSqeCalcXtalParams::PutRotateSteps() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutViewAxes "vector< Double > UtsusemiSqeCalcXtalParams::PutViewAxes() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutViewAxesLabels "vector< string > UtsusemiSqeCalcXtalParams::PutViewAxesLabels() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutViewAxesUnits "vector< string > UtsusemiSqeCalcXtalParams::PutViewAxesUnits() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutAxRange "vector< Double > UtsusemiSqeCalcXtalParams::PutAxRange(UInt4 ind, bool useAxTypeInfo=false) 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutAxType "vector< string > UtsusemiSqeCalcXtalParams::PutAxType() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutAxLabels "vector< string > UtsusemiSqeCalcXtalParams::PutAxLabels()
==========================================================
    Returns axes labels for slicing.
    vector of 4 labels, [0]:Label for \"X\" axis, [1]:Label for \"Y\" axis, [2],[3]:labels for \"T\"

    Returns:
        vector<string> 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutAxUnits "vector< string > UtsusemiSqeCalcXtalParams::PutAxUnits()
=========================================================
    Returns axes units for slicing.
    vector of 4 units, [0]:unit for \"X\" axis, [1]:unit for \"Y\" axis, [2],[3]:units for \"T\"

    Returns:
        vector<string> 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutFolding "vector< Double > UtsusemiSqeCalcXtalParams::PutFolding() 

";
%feature("docstring") UtsusemiSqeCalcXtalParams::PutDiagFolding "vector< UInt4 > UtsusemiSqeCalcXtalParams::PutDiagFolding() 

";
// File: classUtsusemiSubtractDarkBackground.xml

%feature("docstring") UtsusemiSubtractDarkBackground "C++ includes: UtsusemiSubtractDarkBackground.hh 

";
%feature("docstring") UtsusemiSubtractDarkBackground::UtsusemiSubtractDarkBackground "UtsusemiSubtractDarkBackground::UtsusemiSubtractDarkBackground()
=================================================================
    Constructor.

    Returns:
        None 

";
%feature("docstring") UtsusemiSubtractDarkBackground::~UtsusemiSubtractDarkBackground "UtsusemiSubtractDarkBackground::~UtsusemiSubtractDarkBackground()
==================================================================
    Destructor. 

";
%feature("docstring") UtsusemiSubtractDarkBackground::Execute "bool UtsusemiSubtractDarkBackground::Execute(ElementContainerMatrix *sam, ElementContainerMatrix *bak)
=======================================================================================================
    Executes subtraction.
    bool Execute(ElementContainerMatrix *sam, ElementContainerMatrix *bak)

    Args:
        sam (ElementContainermatrix) Sample data
        bak (ElementContainermatrix) Background data
        normFact_ecm (Double) normalize factor for ecm
        normFact_bk (Double) normalize factor for bk

    Returns:
        true : succeeded
        false : failed 

";
// File: classUtsusemiTimeDependBackGround.xml

%feature("docstring") UtsusemiTimeDependBackGround "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") UtsusemiTimeDependBackGround::UtsusemiTimeDependBackGround "UtsusemiTimeDependBackGround::UtsusemiTimeDependBackGround() 

    
UtsusemiTimeDependBackGround::UtsusemiTimeDependBackGround(const UtsusemiTimeDependBackGround &obj) 
";
%feature("docstring") UtsusemiTimeDependBackGround::~UtsusemiTimeDependBackGround "UtsusemiTimeDependBackGround::~UtsusemiTimeDependBackGround() 

";
// File: classUtsusemiTofBinInfo.xml

%feature("docstring") UtsusemiTofBinInfo "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") UtsusemiTofBinInfo::UtsusemiTofBinInfo "UtsusemiTofBinInfo::UtsusemiTofBinInfo()
=========================================
    Constructor. 

    
UtsusemiTofBinInfo::UtsusemiTofBinInfo(const UtsusemiTofBinInfo &obj)
======================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiTofBinInfo::~UtsusemiTofBinInfo "UtsusemiTofBinInfo::~UtsusemiTofBinInfo()
==========================================
    Destructor. 

";
// File: classUtsusemiTofBinPattern.xml

%feature("docstring") UtsusemiTofBinPattern "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") UtsusemiTofBinPattern::UtsusemiTofBinPattern "UtsusemiTofBinPattern::UtsusemiTofBinPattern() 

    
UtsusemiTofBinPattern::UtsusemiTofBinPattern(const UtsusemiTofBinPattern &obj) 
";
%feature("docstring") UtsusemiTofBinPattern::~UtsusemiTofBinPattern "UtsusemiTofBinPattern::~UtsusemiTofBinPattern() 

";
// File: classUtsusemiTofMaskPattern.xml

%feature("docstring") UtsusemiTofMaskPattern "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") UtsusemiTofMaskPattern::UtsusemiTofMaskPattern "UtsusemiTofMaskPattern::UtsusemiTofMaskPattern() 

    
UtsusemiTofMaskPattern::UtsusemiTofMaskPattern(const UtsusemiTofMaskPattern &obj) 
";
%feature("docstring") UtsusemiTofMaskPattern::~UtsusemiTofMaskPattern "UtsusemiTofMaskPattern::~UtsusemiTofMaskPattern() 

";
// File: classUtsusemiTofOriginCorrection.xml

%feature("docstring") UtsusemiTofOriginCorrection "

    Calculation of TOF origin Correction.
    C++ includes: UtsusemiTofOriginCorrection.hh 

";
%feature("docstring") UtsusemiTofOriginCorrection::UtsusemiTofOriginCorrection "UtsusemiTofOriginCorrection::UtsusemiTofOriginCorrection()
===========================================================
    Constructor. 

";
%feature("docstring") UtsusemiTofOriginCorrection::~UtsusemiTofOriginCorrection "UtsusemiTofOriginCorrection::~UtsusemiTofOriginCorrection()
============================================================
    Destructor. 

";
%feature("docstring") UtsusemiTofOriginCorrection::SetTofOriginCorrectionType "bool UtsusemiTofOriginCorrection::SetTofOriginCorrectionType(UInt4 cType) 

    
bool UtsusemiTofOriginCorrection::SetTofOriginCorrectionType(UInt4 cType, vector< Double > params)
===================================================================================================
    Sets type of Tof Origin Correction Function.

    Args:
        type (UInt4) type number for a type of direct conversion

    Returns:
        true
        fales 
";
%feature("docstring") UtsusemiTofOriginCorrection::TofOriginShiftByLambda "Double UtsusemiTofOriginCorrection::TofOriginShiftByLambda(Double lambda) 

    
vector< Double > UtsusemiTofOriginCorrection::TofOriginShiftByLambda(vector< Double > vlambda) 
";
%feature("docstring") UtsusemiTofOriginCorrection::SetDiscreteData "bool UtsusemiTofOriginCorrection::SetDiscreteData(vector< Double > lambda_list, vector< Double > tofshift_list) 

";
%feature("docstring") UtsusemiTofOriginCorrection::PutNumOfParam "UInt4 UtsusemiTofOriginCorrection::PutNumOfParam() 

";
// File: classUtsusemiTrignetCondGroup.xml

%feature("docstring") UtsusemiTrignetCondGroup "

    Group of Conditions for TrigNet.
    This stores several conditions for TrigNET.
    C++ includes: UtsusemiTrignetDictionary.hh 

";
%feature("docstring") UtsusemiTrignetCondGroup::UtsusemiTrignetCondGroup "UtsusemiTrignetCondGroup::UtsusemiTrignetCondGroup()
=====================================================
    Constructor. 

    
UtsusemiTrignetCondGroup::UtsusemiTrignetCondGroup(const UtsusemiTrignetCondGroup &obj)
========================================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiTrignetCondGroup::~UtsusemiTrignetCondGroup "UtsusemiTrignetCondGroup::~UtsusemiTrignetCondGroup()
======================================================
    Destructor. 

";
%feature("docstring") UtsusemiTrignetCondGroup::AppendTofRangeCond "void UtsusemiTrignetCondGroup::AppendTofRangeCond(pair< Double, Double > tofrange)
===================================================================================
    Appends TOF range condition.

    Args:
        tofrange (pair<Double,Double>) start tof and end tof

    Returns:
        None 

";
%feature("docstring") UtsusemiTrignetCondGroup::AppendTimeRangeCond "void UtsusemiTrignetCondGroup::AppendTimeRangeCond(string type, vector< Double > timerange)
============================================================================================
    Appends Time range condition.
    type=\"PASS\" : start time is zero, end time is passed time type=\"MLF\" : start time and end time are given MLF clock type=\"DATE\" : start time and end time are given DATE format \"YYYY\",\"MM\",\"DD\",\"hh\",\"mm\",\"ss\",\"sub-sec\"

    Args:
        type (string)
        tofrange (vector<Double>) start tof and end tof

    Returns:
        None 

";
%feature("docstring") UtsusemiTrignetCondGroup::AppendTrigCond "void UtsusemiTrignetCondGroup::AppendTrigCond(UtsusemiTrignetCondition trigcond)
=================================================================================
    Appends TrigNET condition.

    Args:
        trigcond ( UtsusemiTrignetCondition)

    Returns:
        None 

";
%feature("docstring") UtsusemiTrignetCondGroup::TrigFilter "Int4 UtsusemiTrignetCondGroup::TrigFilter(UInt4 index, UInt4 trig, UInt4 type, const vector< UInt4 > *cond)
============================================================================================================
    Checks TrigNET parameters are sutiffied condition(s)

    Args:
        index (UInt4)
        trig (UInt4)
        type (UInt4)
        cond (const vector<UInt4>*)

    Returns:
        1 satisfied condition
        -1 not satisfied
        0 ignored 

";
%feature("docstring") UtsusemiTrignetCondGroup::TimeFilter "Int4 UtsusemiTrignetCondGroup::TimeFilter(Double time_in, Double first_clock)
==============================================================================
    Checks Time parameters are sutiffied condition(s)

    Args:
        time_in (Double) target clock [MLF clock]
        first_clock (Double) first clock of the measurement [MLF clock]

    Returns:
        1 satisfied condition
        -1 not satisfied
        0 ignored 

";
%feature("docstring") UtsusemiTrignetCondGroup::TofFilter "Int4 UtsusemiTrignetCondGroup::TofFilter(Double tof_in)
========================================================
    Checks Tof parameters are sutiffied condition(s)

    Args:
        time_in (Double) clock [MLF clock]

    Returns:
        1 satisfied condition
        -1 not satisfied
        0 ignored 

";
%feature("docstring") UtsusemiTrignetCondGroup::MakeCondArrayAndList "void UtsusemiTrignetCondGroup::MakeCondArrayAndList()
======================================================
    Makes list of TrigNET indexes under AND condition.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") UtsusemiTrignetCondGroup::Dump "void UtsusemiTrignetCondGroup::Dump() 

";
// File: classUtsusemiTrignetCondition.xml

%feature("docstring") UtsusemiTrignetCondition "

    TrigNET filter Condition.
    This stores one filter condition for TrigNET.
    C++ includes: UtsusemiTrignetDictionary.hh 

";
%feature("docstring") UtsusemiTrignetCondition::UtsusemiTrignetCondition "UtsusemiTrignetCondition::UtsusemiTrignetCondition()
=====================================================
    Constructor. 

    
UtsusemiTrignetCondition::UtsusemiTrignetCondition(const UtsusemiTrignetCondition &obj)
========================================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiTrignetCondition::~UtsusemiTrignetCondition "UtsusemiTrignetCondition::~UtsusemiTrignetCondition()
======================================================
    Destructor. 

";
%feature("docstring") UtsusemiTrignetCondition::SetIndex "Int4 UtsusemiTrignetCondition::SetIndex(Int4 ind)
==================================================
    Sets Index.

    Args:
        ind (Int4)

    Returns:
        -1 given ind is invalid
        0 

";
%feature("docstring") UtsusemiTrignetCondition::SetTrig "Int4 UtsusemiTrignetCondition::SetTrig(string trig)
====================================================
    Sets trigger.

    Args:
        trig (string)

    Returns:
        -1 given trig is invalid
        0 

";
%feature("docstring") UtsusemiTrignetCondition::SetType "Int4 UtsusemiTrignetCondition::SetType(string type)
====================================================
    Sets type.

    Args:
        type (string)

    Returns:
        -1 given argument is invalid
        0 

";
%feature("docstring") UtsusemiTrignetCondition::SetTitle "Int4 UtsusemiTrignetCondition::SetTitle(string title)
======================================================
    Sets title.

    Args:
        title (string)

    Returns:
        0 

";
%feature("docstring") UtsusemiTrignetCondition::SetAttr "Int4 UtsusemiTrignetCondition::SetAttr(string attr)
====================================================
    Sets attribute.

    Args:
        attr (string)

    Returns:
        0 

";
%feature("docstring") UtsusemiTrignetCondition::SetCont "Int4 UtsusemiTrignetCondition::SetCont(vector< UInt4 > cont)
=============================================================
    Sets contents.

    Args:
        cont (vector<string>)

    Returns:
        -1 if Trigger/Type is not set
        0 

";
%feature("docstring") UtsusemiTrignetCondition::SetAnd "Int4 UtsusemiTrignetCondition::SetAnd(bool is_and)
===================================================
    Sets AND condition.

    Args:
        is_and (bool)

    Returns:
        0 

";
%feature("docstring") UtsusemiTrignetCondition::Check "Int4 UtsusemiTrignetCondition::Check(UInt4 index, UInt4 trig, UInt4 type, const vector< UInt4 > *cond, string title=\"\")
==========================================================================================================================
    Checks parameters sutisfies given conditions.

    Args:
        index (UInt4)
        trig (UInt4)
        type (UInt4)
        cond (const vector<UInt4>*)
        title (string)

    Returns:
        1 satisfied condition
        -1 not satisfied
        0 ignored 

";
%feature("docstring") UtsusemiTrignetCondition::Dump "void UtsusemiTrignetCondition::Dump()
======================================
    Shows all conditions.

    Args:
        None

    Returns:
        None 

";
// File: classUtsusemiTrignetCounter.xml

%feature("docstring") UtsusemiTrignetCounter "

    TrigNET counter Conditions.
    This stores TrigNET counter conditions.
    type : 0=Encoder ABphase, 1=1DIO, 2=2DIOs ABphases : < DIO Number of A phase, that of B phase >
    Val = OrgVal + ConvVal*(Counts) [Unit] ConditionType : 1: condition range with two values for each case 2: start, end ,step [ caseId = int(( end-start )/step ) ]
    C++ includes: UtsusemiTrignetDictionary.hh 

";
%feature("docstring") UtsusemiTrignetCounter::UtsusemiTrignetCounter "UtsusemiTrignetCounter::UtsusemiTrignetCounter()
=================================================
    Constructor. 

    
UtsusemiTrignetCounter::UtsusemiTrignetCounter(const UtsusemiTrignetCounter &obj)
==================================================================================
    Copy Constructor. 
";
%feature("docstring") UtsusemiTrignetCounter::~UtsusemiTrignetCounter "UtsusemiTrignetCounter::~UtsusemiTrignetCounter()
==================================================
    Destructor. 

";
%feature("docstring") UtsusemiTrignetCounter::SetType "Int4 UtsusemiTrignetCounter::SetType(string type)
==================================================
    Sets type of condition format.

    Args:
        type (string)

    Returns:
        condition type 

";
%feature("docstring") UtsusemiTrignetCounter::AddAsABphase "Int4 UtsusemiTrignetCounter::AddAsABphase(UtsusemiTrignetCondition trig)
=========================================================================
    Sets AB-phases triggers by by UtsusemiTrignetCondition.
    Using attribute of UtsusemiTrignetCondition, A or B is set.

    Args:
        trig ( UtsusemiTrignetCondition) trigger event

    Returns:
        -1 invalid trigger event @rerval 0 OK 

";
%feature("docstring") UtsusemiTrignetCounter::AddTriggers "Int4 UtsusemiTrignetCounter::AddTriggers(UtsusemiTrignetCondition trig)
========================================================================
    Adds Trigger condition as a trigger for the counter.

    Args:
        trig ( UtsusemiTrignetCondition)

    Returns:
        condition type 

";
%feature("docstring") UtsusemiTrignetCounter::SetConvVal "Int4 UtsusemiTrignetCounter::SetConvVal(string convval)
========================================================
    Sets ConvVal.

    Args:
        ConvVal (string)

    Returns:
        0 

";
%feature("docstring") UtsusemiTrignetCounter::SetOrgVal "Int4 UtsusemiTrignetCounter::SetOrgVal(string orgval, string unit_in)
======================================================================
    Sets OrgVal.

    Args:
        OrgVal (string)
        unit_in (string) unit of OrgVal

    Returns:
        0 

";
%feature("docstring") UtsusemiTrignetCounter::SetVirtualKickerPriority "Int4 UtsusemiTrignetCounter::SetVirtualKickerPriority(string val)
==================================================================
    Sets which has the priority on choosing case ID for virtual kicker mode.

    Args:
        val (string) \"case\" or \"signal\"

    Returns:
        0 

";
%feature("docstring") UtsusemiTrignetCounter::SetConditionType "Int4 UtsusemiTrignetCounter::SetConditionType(string val)
==========================================================
    Sets type of condition.

    Args:
        val (string)

    Returns:
        ConditionType 

";
%feature("docstring") UtsusemiTrignetCounter::SetConditionList "Int4 UtsusemiTrignetCounter::SetConditionList(UInt4 caseId, string conts)
==========================================================================
    Sets contents of condition.

    Args:
        caseId (UInt4)
        conts (string)

    Returns:
        -1 ConditionType is invalid
        0 OK 

";
%feature("docstring") UtsusemiTrignetCounter::SetCyclicRegion "Int4 UtsusemiTrignetCounter::SetCyclicRegion(string begin, string end) 

";
%feature("docstring") UtsusemiTrignetCounter::SetClock "UInt4 UtsusemiTrignetCounter::SetClock(Double clock)
=====================================================
    Sets clock for cyclic time slicing with trignet signal used as start point for time slicing.
    This returns the caseId calculated from given clock

    Args:
        clock (Double)

    Returns:
        0 to (UTSUSEMIMASKVALUEUINT4-1) :Decided CaseId (last caseId)
        UTSUSEMIMASKVALUEUINT4 :This condition should be ignored. 

";
%feature("docstring") UtsusemiTrignetCounter::CountEvent "UInt4 UtsusemiTrignetCounter::CountEvent(UInt4 index, UInt4 trig, UInt4 type, const vector< UInt4 > *cond, double clock=0.0) 

    
UInt4 UtsusemiTrignetCounter::CountEvent(vector< UInt4 > index, vector< UInt4 > trig, vector< UInt4 > type, const vector< vector< UInt4 > * > &cond)
=====================================================================================================================================================
    Sets parameters decoded from TrigNET event(s) to count up.
    This returns the caseId calculated from given conditions

    Args:
        index (UInt4 or vector<UInt4>)
        trig (UInt4 or vector<UInt4>)
        type (UInt4 or vector<UInt4>)
        cond (vector<UInt4>* or vector< vector<UInt4> >)
        clock (Double)

    Returns:
        0 to (UTSUSEMIMASKVALUEUINT4-1) :Decided CaseId (last caseId)
        UTSUSEMIMASKVALUEUINT4 :This condition should be ignored. 
";
%feature("docstring") UtsusemiTrignetCounter::Dump "void UtsusemiTrignetCounter::Dump()
====================================
    Shows counter conditions.

    Args:
        None

    Returns:
        None 

";
// File: classUtsusemiTrignetDictionary.xml

%feature("docstring") UtsusemiTrignetDictionary "

    Dictionary for TrigNet and Make Case Table.
    C++ includes: UtsusemiTrignetDictionary.hh 

";
%feature("docstring") UtsusemiTrignetDictionary::UtsusemiTrignetDictionary "UtsusemiTrignetDictionary::UtsusemiTrignetDictionary()
=======================================================
    Constructor. 

";
%feature("docstring") UtsusemiTrignetDictionary::~UtsusemiTrignetDictionary "UtsusemiTrignetDictionary::~UtsusemiTrignetDictionary()
========================================================
    Destructor. 

";
%feature("docstring") UtsusemiTrignetDictionary::PutTrigString "string UtsusemiTrignetDictionary::PutTrigString(UInt4 sid1)
============================================================
    Puts charactors code defined for SID1 in TrigDic.

    Args:
        sid1 (UInt4) SID1 number @retrun code (string) 

";
%feature("docstring") UtsusemiTrignetDictionary::PutTypeString "string UtsusemiTrignetDictionary::PutTypeString(UInt4 sid2)
============================================================
    Puts charactors code defined for Type in TypeDic.
    This Type is used to analyze last 3 bites in TrinNET event

    Args:
        sid2 (UInt4) SID2 number @retrun code (string) 

";
%feature("docstring") UtsusemiTrignetDictionary::PutTrigIndex "Int4 UtsusemiTrignetDictionary::PutTrigIndex(string trig)
==========================================================
    Puts index number defined for trig code in TrigDic.

    Args:
        trig (string) trigger code

    Returns:
        >=0 index number
        -1 invalid trigger code 

";
%feature("docstring") UtsusemiTrignetDictionary::PutTypeIndex "Int4 UtsusemiTrignetDictionary::PutTypeIndex(string type)
==========================================================
    Puts index number defined for type code in TypeDic.

    Args:
        type (string) type code

    Returns:
        >=0 index number
        -1 invalid trigger code 

";
// File: classUtsusemiTrignetEventDecoderBase.xml

%feature("docstring") UtsusemiTrignetEventDecoderBase "

    Decode Event Data of TrigNet and Store their information.
    C++ includes: UtsusemiTrignetEventDecoderBase.hh 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::UtsusemiTrignetEventDecoderBase "UtsusemiTrignetEventDecoderBase::UtsusemiTrignetEventDecoderBase()
===================================================================
    Constructor. 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::~UtsusemiTrignetEventDecoderBase "UtsusemiTrignetEventDecoderBase::~UtsusemiTrignetEventDecoderBase()
====================================================================
    Destructor. 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::_decodePulseIdEvent "UInt8 UtsusemiTrignetEventDecoderBase::_decodePulseIdEvent(UChar buf[]) 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::decodePulseIdEvent "UInt8 UtsusemiTrignetEventDecoderBase::decodePulseIdEvent(const UChar *buf)
============================================================================
    Decods PulseId Event in TrigNET event.

    Args:
        buf (UChar []) TrigNET event

    Returns:
        PulseId (UInt8) 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::_decodeInstClockEvent "Double UtsusemiTrignetEventDecoderBase::_decodeInstClockEvent(UChar buf[]) 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::decodeInstClockEvent "Double UtsusemiTrignetEventDecoderBase::decodeInstClockEvent(const UChar *buf)
===============================================================================
    Decods InstClock Event in TrigNET event.

    Args:
        buf (UChar []) TrigNET event

    Returns:
        clock (double) 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::isHeaderT0 "bool UtsusemiTrignetEventDecoderBase::isHeaderT0(UChar aByte)
==============================================================
    Checks whether given UChar is the header of T0 event.

    Args:
        aByte (UChar)

    Returns:
        true
        false 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::isHeaderClock "bool UtsusemiTrignetEventDecoderBase::isHeaderClock(UChar aByte)
=================================================================
    Checks whether given UChar is the header of Instrument Clock event.

    Args:
        aByte (UChar)

    Returns:
        true
        false 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::isTrigEvent "bool UtsusemiTrignetEventDecoderBase::isTrigEvent(UChar buf)
=============================================================
    Checks whether given UChar is the header of TrigNET event.

    Args:
        buf (UChar)

    Returns:
        true
        false 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::DecodeTrigEvent "Int4 UtsusemiTrignetEventDecoderBase::DecodeTrigEvent(const UChar *data, vector< UInt4 > *values, UInt4 index=0)
=================================================================================================================
    Decodes an Event of TrigNET.
    Returned values: values[0] = tof [clock(25nano-sec)] values[1] = index values[2] = SID1 (trigger) values[3] = SID2 (type) values[4-11] = contents depends on SID2

    Args:
        data (UChar*) an event with 8bytes
        values (vector<UInt4>*) values decoded from an event
        index (UInt4) index of TrigNETs

    Returns:
        -1 given event is not for TrigNET or other errors
        -2 size of given values vector is invalid
        0 successfull 

";
%feature("docstring") UtsusemiTrignetEventDecoderBase::DumpTrigEvent "vector< string > UtsusemiTrignetEventDecoderBase::DumpTrigEvent(vector< UInt4 > evt, bool debug=true)
======================================================================================================
    Dumps decoded TrigNET event given as vector<UInt4>

    Args:
        evt (vector<UInt4>) TrigNET event
        debug (bool) true if debug mode is on

    Returns:
        decoded event 

";
// File: classUtsusemiUnitConverter.xml

%feature("docstring") UtsusemiUnitConverter "

    Function for offering some constant values and converting units.
    Unit Conversion e=1.602187653e-19 [J]->1meV=1.602187653e-22[J] [J]=[kg(m/2)^2] mn=1.67495e-27 [kg] Basical Units length [meter] time [micro-second] Energy [milli-electron-volt] verocity [meter/micro-second] Wave length [Ang] Wave vector [1/Ang]
    C++ includes: UtsusemiUnitConverter.hh 

";
%feature("docstring") UtsusemiUnitConverter::UtsusemiUnitConverter "UtsusemiUnitConverter::UtsusemiUnitConverter()
===============================================
    Constructor.
    used before 0.3.3.0
    Use MlfPhyisicalConstants (0.3.3.1) 

";
%feature("docstring") UtsusemiUnitConverter::~UtsusemiUnitConverter "UtsusemiUnitConverter::~UtsusemiUnitConverter()
================================================
    Destructor. 

";
%feature("docstring") UtsusemiUnitConverter::LEtoT "double UtsusemiUnitConverter::LEtoT()
======================================
    Puts conversion parameter from L[m], E[meV] to TOF[micro-sec].

    Returns:
        cLEtoT 

    
double UtsusemiUnitConverter::LEtoT(double L, double E)
========================================================
    Puts Tof[micro-sec] converted from given L[m] and E[meV].

    Args:
        L flight path length [meter]
        E energy [meV]

    Returns:
        TOF [micro-sec] 
";
%feature("docstring") UtsusemiUnitConverter::VtoE "double UtsusemiUnitConverter::VtoE()
=====================================
    Puts conversion parameter from V[meter/micro-sec] to E[meV].

    Returns:
        cVtoE 

    
double UtsusemiUnitConverter::VtoE(double V)
=============================================
    Puts Energy[meV] converted from given verocity[meter/micro-sec].

    Args:
        V verocity of neutron [meter/micro-sec]

    Returns:
        energy [meV] 
";
%feature("docstring") UtsusemiUnitConverter::VtoK "double UtsusemiUnitConverter::VtoK(double V)
=============================================
    Puts wave vector converted from given verocity.

    Args:
        V verocity of neutron [m/s]

    Returns:
        wave vector [(1/Ang)] 

";
%feature("docstring") UtsusemiUnitConverter::Vmm_msToK "double UtsusemiUnitConverter::Vmm_msToK()
==========================================
    Puts wave vector converted from given verocity.

    Args:
        V verocity of neutron [mm/micro-sec]

    Returns:
        constant to convert from V[mm/micro-sec] to K [(1/Ang)] 

    
double UtsusemiUnitConverter::Vmm_msToK(double V)
==================================================
    Puts wave vector converted from given verocity.

    Args:
        V verocity of neutron [mm/micro-sec]

    Returns:
        wave vector [(1/Ang)] 
";
%feature("docstring") UtsusemiUnitConverter::EtoV "double UtsusemiUnitConverter::EtoV()
=====================================
    Puts conversion parameter from E[meV] to V[meter/micro-sec].

    Returns:
        cEtoV 

    
double UtsusemiUnitConverter::EtoV(double E)
=============================================
    Puts verocity[meter/micro-sec] converted from given energy of neutron [meV].

    Args:
        E energy of neutron [meV]

    Returns:
        verocity [meter/micro-sec] 
";
%feature("docstring") UtsusemiUnitConverter::Mn "double UtsusemiUnitConverter::Mn()
===================================
    Puts constant value about mass of a neutron [kg].

    Returns:
        mass of neutron [kg] 

";
%feature("docstring") UtsusemiUnitConverter::KtoE "double UtsusemiUnitConverter::KtoE(double K)
=============================================
    Puts Energy[meV] converted from given wave vector [1/Ang].

    Args:
        K wave vector length [1/Ang]

    Returns:
        energy [meV] 

";
%feature("docstring") UtsusemiUnitConverter::K2toE "double UtsusemiUnitConverter::K2toE()
======================================
    Puts conversion parameter from sqare( K[1/Ang] ) to Energy [meV].

    Returns:
        cK2toE 

";
%feature("docstring") UtsusemiUnitConverter::EtoK2 "double UtsusemiUnitConverter::EtoK2(double E)
==============================================
    Puts square of wave vector[1/Ang] converted from given energy[meV].

    Args:
        E energy of neutron [meV]

    Returns:
        square of wave vector [1/Ang] 

";
%feature("docstring") UtsusemiUnitConverter::J2meV "double UtsusemiUnitConverter::J2meV()
======================================
    Puts unit conversion parameter from Joule to meV.

    Returns:
        cnvJ2E 

";
%feature("docstring") UtsusemiUnitConverter::TLtoLambda "double UtsusemiUnitConverter::TLtoLambda(double _tof, double _L)
=================================================================
    Puts lambda [Angs.] from TOF[micro-sec] and L1+L2[m].

    Args:
        _tof time of flight [micro-sec]
        _L length between modelator and detector [m]

    Returns:
        lambda (double) 

";
%feature("docstring") UtsusemiUnitConverter::VtoLambda "double UtsusemiUnitConverter::VtoLambda()
==========================================
    Puts conversion parameter from 1/v[meter/micro-sec] to lambda [Angs.].

    Returns:
        ccVtoLambda 

    
double UtsusemiUnitConverter::VtoLambda(double V)
==================================================
    Puts lambda [Ang] from v[meter/micro-sec].

    Args:
        V (double) verosity [meter/micro-sec]

    Returns:
        lambda (double) 
";
%feature("docstring") UtsusemiUnitConverter::EtoLambda "double UtsusemiUnitConverter::EtoLambda(double E)
==================================================
    Puts lambda [Ang] from E[meV].

    Args:
        E (double) energy [meV]

    Returns:
        lambda (double) 

";
%feature("docstring") UtsusemiUnitConverter::KtoLambda "double UtsusemiUnitConverter::KtoLambda(double K)
==================================================
    Puts lambda [Ang] from K[1/Ang].

    Args:
        K (double) wave length [1/Ang]

    Returns:
        lambda (double) 

";
// File: classUtsusemiWiringInfoEditorBase.xml

%feature("docstring") UtsusemiWiringInfoEditorBase "C++ includes: UtsusemiWiringInfoEditorBase.hh 

";
%feature("docstring") UtsusemiWiringInfoEditorBase::UtsusemiWiringInfoEditorBase "UtsusemiWiringInfoEditorBase::UtsusemiWiringInfoEditorBase()
=============================================================
    Constructor. 

";
%feature("docstring") UtsusemiWiringInfoEditorBase::~UtsusemiWiringInfoEditorBase "UtsusemiWiringInfoEditorBase::~UtsusemiWiringInfoEditorBase()
==============================================================
    Destructor. 

";
// File: classUtsusemiWiringInfoEditorNeunet.xml

%feature("docstring") UtsusemiWiringInfoEditorNeunet "C++ includes: UtsusemiWiringInfoEditorNeunet.hh 

";
%feature("docstring") UtsusemiWiringInfoEditorNeunet::UtsusemiWiringInfoEditorNeunet "UtsusemiWiringInfoEditorNeunet::UtsusemiWiringInfoEditorNeunet()
=================================================================
    Constructor. 

";
%feature("docstring") UtsusemiWiringInfoEditorNeunet::~UtsusemiWiringInfoEditorNeunet "UtsusemiWiringInfoEditorNeunet::~UtsusemiWiringInfoEditorNeunet()
==================================================================
    Destructor. 

";
%feature("docstring") UtsusemiWiringInfoEditorNeunet::SetDetParam "bool UtsusemiWiringInfoEditorNeunet::SetDetParam(string params=\"psd\")
========================================================================
    sets detector parameter to use for histogram creations
    bool SetDetParam( string params=\"psd\" ) Format of params \"<detType>[,<LLD_min> [-<LLD_max>] ]\" detType in {\"psd\",\"n2mon\",\"psd-ph\",\"n2mon-ph\"}
    \"-PH\" means that Pulse Height is calculated at the same time
    default values for LLD are min=0, max=10000

    Args:
        params (string) detector parameters for histogram ceration

    Returns:
        true : succeeded
        false : failed 

";
// File: classUtsusemiWiringInfoEditorTemplate.xml

%feature("docstring") UtsusemiWiringInfoEditorTemplate "C++ includes: UtsusemiWiringInfoEditorTemplate.hh 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::UtsusemiWiringInfoEditorTemplate "UtsusemiWiringInfoEditorTemplate< T1 >::UtsusemiWiringInfoEditorTemplate()
===========================================================================
    Constructor. 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::~UtsusemiWiringInfoEditorTemplate "UtsusemiWiringInfoEditorTemplate< T1 >::~UtsusemiWiringInfoEditorTemplate()
============================================================================
    Destructor. 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::SetRunNo "bool UtsusemiWiringInfoEditorTemplate< T1 >::SetRunNo(UInt4 runNo, UInt4 mode_no=0, std::string env_file=\"\") 

    
bool UtsusemiWiringInfoEditorTemplate< T1 >::SetRunNo(std::string runNos, std::string mode_no=\"0\", std::string env_file=\"\") 
    
bool UtsusemiWiringInfoEditorTemplate< T1 >::SetRunNo(UInt4 runNo, string wfile)
=================================================================================
    sets run No and environ_ana.xml
    This set run number and read environ_ana.xml to select WiringInfo and DetecorInfo suitable for the run number. If evn_file is empty(), this uses ${UTSUSEMI_BASE_DIR}/${UTSUSEMI_INST_CODE}/ana/xml(_UtsusemiUserXmlPath)/environ_ana.xml. If evn_file is set, the path of env_file is used as _UtsusemiUserXmlPath. bool SetRunNo( UInt4 runNo, string env_file=\"\" ) bool SetRunNo( string runNos, string env_file=\"\" )

    Args:
        runNo (UInt4) run number
        runNos (string) run numbers. format : \"1234,1235\"
        env_file (string) environ_ana.xml which includes several WiringInfo and DetectorInfo for each run number.
        wfile (string) set directly WiringInfo file

    Returns:
        true : succeeded
        false : failed 
";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::SetRunNoWithWiringInfo "bool UtsusemiWiringInfoEditorTemplate< T1 >::SetRunNoWithWiringInfo(std::string runNos, std::string wfile) 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::SetConversionParameter "bool UtsusemiWiringInfoEditorTemplate< T1 >::SetConversionParameter(std::string params, UInt4 _ptnId=0)
========================================================================================================
    sets conversion parameter for histogram creations
    bool SetConversionParameter( string params, UInt4 _ptnId=0 ) Format of params TOF delta-TOF const : tof,<min_tof>,<max_tof>,<delta_tof> d-TOF/TOF const : rtof,<min_tof>,<max_tof>,<racio>
    TOF with time forcusing delta-TOF const : tf-tof,<min_tof>,<max_tof>,<delta_tof> d-TOF/TOF const : tf-rtof,<min_tof>,<max_tof>,<racio>
    Lambda delta-lambda const : lambda,<min_lambda>,<max_lambda>,<delta_lambda> delta-lambda/lambda const : rlambda,<min_lambda>,<max_lambda>,<racio>
    Energy energy,<min_energy>,<max_energy>,<delta_energy>
    Momentum Transfer q,<min_Q>,<max_Q>,<delta_Q>[,<ki_x>,<ki_y>,<ki_z>]
    Energy Transfer hw,<Ei>,<min_hw>,<max_hw>,<delta_hw>[,<t0_shift>]
    d-value d,<min_d-val>,<max_d-val>,<delta_d-val>

    Args:
        params (string) parameters for histogram ceration
        _ptnId (UInt4) ID of this parameters in WiringInfo

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::SetDetRange "bool UtsusemiWiringInfoEditorTemplate< T1 >::SetDetRange(std::string params=\"All\")
=====================================================================================
    sets detector range for histogram creations
    bool SetDetRange( string params=\"All\" ) Format of params \"All[:<number_of_pixels>]\" : use all detectors \"<startDetId>-<endDetId>[:<number_of_pixels>]\" : use detectors from <startDetId> to <endDetId> ( \"X-Y:Z,A-B:C,D-E:F...\" can be used for more settings in my plan )

    Args:
        params (string) parameters for histogram ceration

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::SetFrameInfo "bool UtsusemiWiringInfoEditorTemplate< T1 >::SetFrameInfo(std::string params=\"None\")
=======================================================================================
    sets Frame Info for histogram creations
    bool SetFrameInfo( string params ) Format of params

    Args:
        params (string) parameters for histogram ceration

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::SetMaskInfo "bool UtsusemiWiringInfoEditorTemplate< T1 >::SetMaskInfo(std::string params=\"NoFile\", UInt4 _ptnId=0)
========================================================================================================
    sets MASK histogram creations
    bool SetMaskInfo( string params=\"NoFile\", UInt4 _ptnId=0 ) Format of params \"<Mask.xml>[,<TOF-Mask from>-< to > [,<TOF-Mask from>-<to>] ]\" Mask.xml = \"NoFile\" if no mask.

    Args:
        params (string) detector parameters for histogram ceration
        _ptnId (UInt4) ID of this parameters in WiringInfo

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::SetTimeDependBackGroundInfo "bool UtsusemiWiringInfoEditorTemplate< T1 >::SetTimeDependBackGroundInfo(string params=\"None\")
=================================================================================================
    sets Tof region to be used for TimeDependBackground correction
    bool SetTimeDependBackGroundInfo( string params=\"None\" ) Format of params \"None\" : not used this background correction \"tof0-tof1\" : tof0 is start tof of region, tof1 is last of region

    Args:
        params (string) TimeDepend BackGroundRegion

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::MakeTempWiringInfo "std::string UtsusemiWiringInfoEditorTemplate< T1 >::MakeTempWiringInfo(std::string _path=\"\", bool asFile=false)
==================================================================================================================
    make and save the temporal wiring info to create histogram
    this returns a path of the saved temporal wiring info file string MakeTempWiringInfo()

    Args:
        None

    Returns:
        (string) : the path of output wiring info file 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::SetDetParam "bool UtsusemiWiringInfoEditorTemplate< T1 >::SetDetParam(std::string params=\"psd\")
=====================================================================================
    sets detector type
    bool SetDetParam( string params=\"psd\" ) Format of params \"<detType>\" detType in {\"psd\",\"n2mon\",\"psd-ph\",\"n2mon-ph\"}

    Args:
        params (string) detector type for histogram creation

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") UtsusemiWiringInfoEditorTemplate::PutNumOfPixelForDet "UInt4 UtsusemiWiringInfoEditorTemplate< T1 >::PutNumOfPixelForDet(UInt4 _detId=0) 

";
// File: classVanadiumToolsChoppers.xml

%feature("docstring") VanadiumToolsChoppers "

    Methods to correct data by Vanadium measurements.
    C++ includes: VanadiumToolsChoppers.hh 

";
%feature("docstring") VanadiumToolsChoppers::VanadiumToolsChoppers "VanadiumToolsChoppers::VanadiumToolsChoppers()
===============================================
    Constructor. 

";
%feature("docstring") VanadiumToolsChoppers::~VanadiumToolsChoppers "VanadiumToolsChoppers::~VanadiumToolsChoppers()
================================================
    Destructor. 

";
%feature("docstring") VanadiumToolsChoppers::MakeWhiteVanData "ElementContainer VanadiumToolsChoppers::MakeWhiteVanData(ElementContainerMatrix *ecm, double Emin, double Emax, double tof_offset)
===================================================================================================================================
    makes temporary data for white vanadium correction

    Args:
        ecm Target ElementContainerMatrix
        Emin minimum energy in summation region [meV]
        Emax maximum energy in summation region [meV]
        tof_offset T0 offset value ( has dependency on Energy..)

    Returns:
        ElementContainer for temporary data for white van correction 

    
ElementContainer VanadiumToolsChoppers::MakeWhiteVanData(ElementContainerMatrix *ecm, double Emin, double Emax)
================================================================================================================
    makes temporary data for white vanadium correction
    This execute MakeWhiteVanData with tof_offset = 0.0

    Args:
        ecm Target ElementContainerMatrix
        Emin minimum energy in summation region [meV]
        Emax maximum energy in summation region [meV]

    Returns:
        ElementContainer for temporary data for white van correction 
";
%feature("docstring") VanadiumToolsChoppers::MakeMonoVanData "ElementContainer VanadiumToolsChoppers::MakeMonoVanData(ElementContainerMatrix *ecm, double Ei, double deltaEi, double tof_offset)
===================================================================================================================================
    makes temporary data for monochromatic vanadium correction

    Args:
        ecm Target ElementContainerMatrix
        Ei Incident energy [meV]
        deltaEi width of integration region around Ei [meV]
        tof_offset T0 offset value ( has dependency on Energy..)

    Returns:
        ElementContainer for temporary data for white van correction 

    
ElementContainer VanadiumToolsChoppers::MakeMonoVanData(ElementContainerMatrix *ecm, double deltaEi)
=====================================================================================================
    makes temporary data for monochromatic vanadium correction
    This execute MakeMonoVanData with Ei imported from Header of Target ECM and tof_offset=0.0

    Args:
        ecm Target ElementContainerMatrix
        deltaEi width of integration region around Ei [meV]

    Returns:
        ElementContainer for temporary data for white van correction 
";
%feature("docstring") VanadiumToolsChoppers::CorrectWhiteVan "void VanadiumToolsChoppers::CorrectWhiteVan(ElementContainerMatrix *data, ElementContainer wvdata)
===================================================================================================
    executes correction by white van temporary data
    This divides sample data by white van data

    Args:
        data Target ElementContainerMatrix
        wvdata white vanadium temporary data

    Returns:
        None 

";
%feature("docstring") VanadiumToolsChoppers::CorrectMonVan "ElementContainerMatrix VanadiumToolsChoppers::CorrectMonVan(ElementContainerMatrix data, ElementContainer mvdata)
==================================================================================================================
    executes correction by mono van temporary data
    This divides sample data by mono van data

    Args:
        data Target ElementContainerMatrix
        mvdata monochromatic vanadium temporary data

    Returns:
        corrected ElementContainerMarix 

";
%feature("docstring") VanadiumToolsChoppers::CorrectAllVan "ElementContainerMatrix VanadiumToolsChoppers::CorrectAllVan(ElementContainerMatrix data, ElementContainer wvdata, ElementContainer mvdata, ElementContainer wmvdata)
=====================================================================================================================================================================
    executes correction by both mono and white van temporary data
    This divides sample data by both van temporary data

    Args:
        data Target ElementContainerMatrix
        wvdata white vanadium temporary data
        mvdata monochromatic vanadium temporary data
        wmvdata white vanadium at measurement for monochromatic vanaium

    Returns:
        corrected ElementContainerMarix 

";
%feature("docstring") VanadiumToolsChoppers::MakeVanECM "ElementContainerMatrix VanadiumToolsChoppers::MakeVanECM(ElementContainer ec)
==============================================================================
    Puts temporary vanadium data as a format of ElementContainerMatrix.
    This is used to check how is temporary vanadium data Before executing this, you must do MakeWhiteVanData or MakeMonoVanData.

    Args:
        ec white or mono vanadium temporary data

    Returns:
        None 

    
ElementContainerMatrix VanadiumToolsChoppers::MakeVanECM(ElementContainer ec, ElementContainerMatrix ecm)
==========================================================================================================
    Puts temporary vanadium data as a format of ElementContainerMatrix.
    This makes ElementContainerMatrix of temporary vanaium data by using given ElementContainer as a base format.

    Args:
        ec white or mono vanadium temporary data
        ecm ElementContainerMatrix as a base format

    Returns:
        None 
";
// File: classWiringInfoConversionDictionary.xml

%feature("docstring") WiringInfoConversionDictionary "

    Methods for unit conversion on histogram creation.
    puts X-axis bin for direct conversion from event to histogram
    puts TOF bin for histogram according to given conversion
    puts lambda values for each X axis tt = WiringInfoConversionDictionary() tt.SetParams( conv_type, params ) x=tt.PutXaxis() tof_bin = tt.PutTofBin( pixel_id )
    C++ includes: WiringInfoConversionDictionary.hh 

";
%feature("docstring") WiringInfoConversionDictionary::WiringInfoConversionDictionary "WiringInfoConversionDictionary::WiringInfoConversionDictionary()
=================================================================
    Constructor. 

";
%feature("docstring") WiringInfoConversionDictionary::~WiringInfoConversionDictionary "WiringInfoConversionDictionary::~WiringInfoConversionDictionary()
==================================================================
    Destructor. 

";
%feature("docstring") WiringInfoConversionDictionary::isValidConvType "bool WiringInfoConversionDictionary::isValidConvType(Int4 convtype) 

";
%feature("docstring") WiringInfoConversionDictionary::PutConvType "Int4 WiringInfoConversionDictionary::PutConvType(string keycode)
=================================================================
    Puts ConvType Number from key code.

    Args:
        keycode (string) key code for a type of direct conversion

    Returns:
        ConvType (Int4) 

";
%feature("docstring") WiringInfoConversionDictionary::PutKeyCode "string WiringInfoConversionDictionary::PutKeyCode(Int4 convtype)
=================================================================
    Puts Key code from ConvType Number.

    Args:
        convtype (Int4) conversion type number

    Returns:
        KeyCode (string) 

";
%feature("docstring") WiringInfoConversionDictionary::CheckParams "bool WiringInfoConversionDictionary::CheckParams(Int4 convtype, vector< Double > params) 

";
%feature("docstring") WiringInfoConversionDictionary::PutNumOfParams "vector< UInt4 > WiringInfoConversionDictionary::PutNumOfParams(string keycode) 

    
vector< UInt4 > WiringInfoConversionDictionary::PutNumOfParams(Int4 convtype)
==============================================================================
    Puts the number of parameters for given conv type.
    PutNumOfParams( string keycode ); PutNumOfParams( Int4 convtype );

    Args:
        keycode (string)
        convtyep (Int4)

    Returns:
        the number of parameters (vector<UInt4>) 
";
%feature("docstring") WiringInfoConversionDictionary::PutMemo "string WiringInfoConversionDictionary::PutMemo(string keycode)
===============================================================
    Puts Memo for given ConvType.

    Args:
        keycode (string) key code for a type of direct conversion

    Returns:
        Memo (string) 

";
%feature("docstring") WiringInfoConversionDictionary::isReverseXaxis "bool WiringInfoConversionDictionary::isReverseXaxis(string keycode) 

    
bool WiringInfoConversionDictionary::isReverseXaxis(Int4 convtype)
===================================================================
    Returns whether converted tof is required to reverse.
    isReverseXaxis( string keycode ); isReverseXaxis( Int4 convtype );

    Args:
        keycode (string)
        convtyep (Int4)

    Returns:
        (bool) 
";
%feature("docstring") WiringInfoConversionDictionary::SetParams "bool WiringInfoConversionDictionary::SetParams(string keycode, vector< Double > *params) 

    
bool WiringInfoConversionDictionary::SetParams(Int4 convtype, vector< Double > *params)
========================================================================================
    Sets conv type and its parameters.
    SetParams( string keycode ); SetParams( Int4 convtype );

    Args:
        keycode (string)
        convtyep (Int4)
        params (vector<Double>*)

    Returns:
        true : succeed setting
        false : fail setting 
";
%feature("docstring") WiringInfoConversionDictionary::PutParams "vector< Double > WiringInfoConversionDictionary::PutParams(Int4 convtype)
==========================================================================
    Puts parametes for given conv type.
    PutParams( Int4 convtype );

    Args:
        convtyep (Int4)

    Returns:
        params (vector<Double>*) 

";
%feature("docstring") WiringInfoConversionDictionary::PutXaxis "vector< Double > WiringInfoConversionDictionary::PutXaxis(Double tof_offset=0.0)
=================================================================================
    Puts X axis for given conv type.
    PutXaxis();

    Args:
        tof_offset (Double)

    Returns:
        X axis (vector<Double>) 

";
%feature("docstring") WiringInfoConversionDictionary::PutTofBin "vector< Double > WiringInfoConversionDictionary::PutTofBin(UInt4 pixelId) 

    
vector< Double > WiringInfoConversionDictionary::PutTofBin(UInt4 pixelId, Int4 convtype, vector< Double > *params)
===================================================================================================================
    Puts Tof Binning for given conv type.
    (1) PutTofBin( UInt4 pixelId ) (2) PutTofBin( UInt4 pixelId, Int4 convtype, vector<Double> *params ) Both return TOF binning of given pixel ID. (1) requires SetParams(...) before. (2) includes SetParams(...), so you must give convtype and params.

    Args:
        pixelId (UInt4)
        convtype (Int4)
        params (vector<Double>*)

    Returns:
        TOF binning (vector<Double>) 
";
%feature("docstring") WiringInfoConversionDictionary::PutLambda "vector< Double > WiringInfoConversionDictionary::PutLambda(UInt4 pixelId)
==========================================================================
    Puts Lambda values for given pixel ID and its X axis values.
    PutLambda( UInt4 pixelId );

    Args:
        pixelId (UInt4)

    Returns:
        Lambda values (vector<Double>) 

";
%feature("docstring") WiringInfoConversionDictionary::SetPixelPosition "void WiringInfoConversionDictionary::SetPixelPosition(vector< vector< Double > * > pixelPositionVect) 

";
%feature("docstring") WiringInfoConversionDictionary::SetTimeFocusingParam "void WiringInfoConversionDictionary::SetTimeFocusingParam(vector< vector< Double > > *timeFocusParam) 

";
%feature("docstring") WiringInfoConversionDictionary::SetL1 "void WiringInfoConversionDictionary::SetL1(Double L1) 

";
%feature("docstring") WiringInfoConversionDictionary::SetSamplePosition "void WiringInfoConversionDictionary::SetSamplePosition(Double px, Double py, Double pz) 

";
%feature("docstring") WiringInfoConversionDictionary::PutXLabel "pair< string, string > WiringInfoConversionDictionary::PutXLabel(Int4 convtype=-1) 

";
%feature("docstring") WiringInfoConversionDictionary::PutYLabel "pair< string, string > WiringInfoConversionDictionary::PutYLabel(Int4 convtype=-1) 

";
%feature("docstring") WiringInfoConversionDictionary::PutELabel "pair< string, string > WiringInfoConversionDictionary::PutELabel(Int4 convtype=-1) 

";
%feature("docstring") WiringInfoConversionDictionary::SetTofShift "bool WiringInfoConversionDictionary::SetTofShift(UInt4 cType) 

    
bool WiringInfoConversionDictionary::SetTofShift(UInt4 cType, vector< Double > params) 
";
%feature("docstring") WiringInfoConversionDictionary::SetTimeDependBackGroundRegion "void WiringInfoConversionDictionary::SetTimeDependBackGroundRegion(Double tof0=0., Double tof1=0.) 

";
%feature("docstring") WiringInfoConversionDictionary::SetFrameBoundaryInfoList "bool WiringInfoConversionDictionary::SetFrameBoundaryInfoList(UInt4 frameNo, Double boundary, string unit) 

";
// File: classWiringInfoConversionTemplate.xml

%feature("docstring") WiringInfoConversionTemplate "

    Template for methods to convert from TOF.
    C++ includes: WiringInfoConversionDictionary.hh 

";
%feature("docstring") WiringInfoConversionTemplate::WiringInfoConversionTemplate "WiringInfoConversionTemplate::WiringInfoConversionTemplate()
=============================================================
    Constructor. 

    
WiringInfoConversionTemplate::WiringInfoConversionTemplate(const WiringInfoConversionTemplate &obj)
====================================================================================================
    Copy Constructor. 
";
%feature("docstring") WiringInfoConversionTemplate::~WiringInfoConversionTemplate "WiringInfoConversionTemplate::~WiringInfoConversionTemplate()
==============================================================
    Destructor. 

";
%feature("docstring") WiringInfoConversionTemplate::CheckParams "bool WiringInfoConversionTemplate::CheckParams(vector< Double > params) 

";
%feature("docstring") WiringInfoConversionTemplate::PutTofBin "vector< Double > WiringInfoConversionTemplate::PutTofBin(vector< Double > *xaxis, vector< Double > *params, vector< Double > *pv, vector< Double > *oparams) 

";
%feature("docstring") WiringInfoConversionTemplate::PutXaxisVect "vector< Double > WiringInfoConversionTemplate::PutXaxisVect(vector< Double > params, Double tof_offset=0.0) 

";
%feature("docstring") WiringInfoConversionTemplate::PutLambdaVec "vector< Double > WiringInfoConversionTemplate::PutLambdaVec(vector< Double > *xaxis, vector< Double > *params, vector< Double > *pv, vector< Double > *oparams) 

";
// File: classWiringInfoDefineNeunet.xml

%feature("docstring") WiringInfoDefineNeunet "C++ includes: WiringInfoEditorNeunet.hh 

";
%feature("docstring") WiringInfoDefineNeunet::WiringInfoDefineNeunet "WiringInfoDefineNeunet::WiringInfoDefineNeunet() 

";
%feature("docstring") WiringInfoDefineNeunet::~WiringInfoDefineNeunet "WiringInfoDefineNeunet::~WiringInfoDefineNeunet() 

";
// File: classWiringInfoEditorBase.xml

%feature("docstring") WiringInfoEditorBase "

    Codes to treat WiringInfo.
    Reads WiringInfo to be read from histogram creation methods
    Reads WiringInfo to change its contents
    Saves changed WiringInfo
    C++ includes: WiringInfoEditorBase.hh 

";
%feature("docstring") WiringInfoEditorBase::WiringInfoEditorBase "WiringInfoEditorBase::WiringInfoEditorBase()
=============================================
    Constructor. 

    
WiringInfoEditorBase::WiringInfoEditorBase(string _wFile, bool workAsReader=true)
==================================================================================
    Constructor.

    Args:
        _wFile (string)
        workAsReader (bool) 
";
%feature("docstring") WiringInfoEditorBase::~WiringInfoEditorBase "WiringInfoEditorBase::~WiringInfoEditorBase()
==============================================
    Destructor. 

";
%feature("docstring") WiringInfoEditorBase::Clear "void WiringInfoEditorBase::Clear(UInt4 index=0)
================================================
    Clears stored parameters.
    This deletes information by given index. index = 0 : all (default) index = 1 : PixelInfo ( and DetInfoList ) index = 2 : TofBinPtnInfo index = 3 : TofBinInfo index = 4 : FrameBoundaryInfo

    Args:
        index (UInt4)

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::Read "bool WiringInfoEditorBase::Read(string arg)
============================================
    Reads WiringInfo.xml and import information.

    Args:
        arg (string) path/to/DetectorInfo.xml or DetectorInfo as string

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::Write "bool WiringInfoEditorBase::Write(string filepath)
==================================================
    Writes WiringInfo.xml.

    Args:
        filepath (string)

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::OutXml "string WiringInfoEditorBase::OutXml(bool withIndent=false)
===========================================================
    Returns WiringInfo as string.

    Args:
        withIndent(bool) false : output xml without an indent format

    Returns:
        string 

";
%feature("docstring") WiringInfoEditorBase::ImportPixelInfo "void WiringInfoEditorBase::ImportPixelInfo()
=============================================
    Analyzes xml descriptions for PixelInfo.
    This analyzes read xml descriptions

    Args:
        None

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::ImportTofBinPattern "void WiringInfoEditorBase::ImportTofBinPattern()
=================================================
    Analyzes xml descriptions for TOF bin patterns.
    This analyzes read xml descriptions

    Args:
        None

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::ImportTofMaskPattern "void WiringInfoEditorBase::ImportTofMaskPattern()
==================================================
    Analyzes xml descriptions for TOF mask pattern.
    This analyzes read xml descriptions

    Args:
        None

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::ImportTofBinInfo "void WiringInfoEditorBase::ImportTofBinInfo()
==============================================
    Analyzes xml descriptions for TOF bin info.
    This analyzes read xml descriptions

    Args:
        None

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::ImportFrameInfo "void WiringInfoEditorBase::ImportFrameInfo()
=============================================
    Analyzes xml descriptions for frame info.
    This analyzes read xml descriptions

    Args:
        None

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::Dump "void WiringInfoEditorBase::Dump(Int4 index=DUMP_ALL)
=====================================================
    Shows imported information.

    Args:
        index (Int4)

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::ResetHeadPixelId "void WiringInfoEditorBase::ResetHeadPixelId(Int4 first_detId=0, Int4 last_detId=-1, Int4 headPixelId=0)
========================================================================================================
    Re-calculates each headPixelId by numPixel.
    ResetHeadPixelId(Int4 first_detId=0, Int4 last_detId=-1, Int4 headPixelId=0 )

    Args:
        first_detId range of detId to apply
        last_detId range of detId to apply
        headPixelId if set, headPixelId starts from this value

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::SetInstInfo "bool WiringInfoEditorBase::SetInstInfo(string instCode=\"\", string update=\"\", string ver=\"\")
==================================================================================================
    Set InstCode and other information.
    SetInstInfo( string instCode, string ver=\"1.5\", string update=\"\" );

    Args:
        instCode instrument code
        update date format \"YYYYMMDDhhmmss\"
        ver version

    Returns:
        true : success
        false : false 

";
%feature("docstring") WiringInfoEditorBase::SetPixelInfo "bool WiringInfoEditorBase::SetPixelInfo(UInt4 daqId, UInt4 modNo, UInt4 detId, Int4 headPixelId, UInt4 numPixel, string type, UInt4 numAxis=1) 

    
bool WiringInfoEditorBase::SetPixelInfo(UInt4 daqId, UInt4 modNo) 
    
bool WiringInfoEditorBase::SetPixelInfo(UInt4 daqId)
=====================================================
    Sets Pixel info.
    This changes or makes pixel information by given parameters
    SetPixelInfo( UInt4 daqId, UInt4 modNo, UInt4 detId, UInt4 headPixelId, UInt4 numPixel, string type, UInt4 axis=0 ) SetPixelInfo( UInt4 daqId, UInt4 modNo ) SetPixelInfo( UInt4 daqId )

    Args:
        daqId
        modNo
        detId
        headPixelid
        numPixel
        type
        numAxis

    Returns:
        true : success
        false : false 
";
%feature("docstring") WiringInfoEditorBase::SetAllPixelInfo "bool WiringInfoEditorBase::SetAllPixelInfo(UInt4 numPixel, string type=UTSUSEMI_KEY_HEAD_DETTYPE_PSD, UInt4 numAxis=1, Int4 daqId=-1, Int4 modNo=-1)
=====================================================================================================================================================
    Sets Pixel info for all or given range.
    This changes or makes pixel information by given parameters After changed parameter all, this executes ReSetHeadPixelId
    SetAllPixelInfo( UInt4 numPixel, string type=\"PSD\", UInt4 axis=0, Int4 daqId=-1, Int4 modNo=-1);

    Args:
        numPixel
        type
        numAxis
        daqId
        modNo

    Returns:
        true : success
        false : false 

";
%feature("docstring") WiringInfoEditorBase::DeleteDetector "bool WiringInfoEditorBase::DeleteDetector(UInt4 detId)
=======================================================
    Deletes detector element in Pixel info.
    This delete detector information
    RemoveDetector( UInt4 detId )

    Args:
        daqId

    Returns:
        true : success
        false : false 

";
%feature("docstring") WiringInfoEditorBase::DeleteModule "bool WiringInfoEditorBase::DeleteModule(UInt4 daqId, UInt4 modNo)
==================================================================
    Deletes module element in Pixel info.
    This delete module element ( also deletes included detectors )
    DeleteModule( UInt4 daqId, UInt4 modNo )

    Args:
        daqId
        modNo

    Returns:
        true : success
        false : false 

";
%feature("docstring") WiringInfoEditorBase::DeleteDaq "bool WiringInfoEditorBase::DeleteDaq(UInt4 daqId)
==================================================
    Deletes daq elements in Pixel info.
    This deletes daq element ( also deletes included modules and detectors )
    DeleteDaq( UInt4 daqId )

    Args:
        daqId

    Returns:
        true : success
        false : false 

";
%feature("docstring") WiringInfoEditorBase::SetDaqAlive "void WiringInfoEditorBase::SetDaqAlive(bool isAlive, UInt4 first_daqId, UInt4 last_daqId=999999999)
====================================================================================================
    Sets DAQ components status use or not.
    isAlive info is used when output to xml.
    SetDaqAlive( bool isAlive, UInt4 first_daqId, UInt4 last_daqId=999999999 );

    Args:
        isAlive (bool) true: use, false: not use
        first_daqId (UInt4) first daqId to be set
        last_daqId (UInt4) last daqId to be set, if not set, only first_daqId is set.

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::SetModAlive "void WiringInfoEditorBase::SetModAlive(bool isAlive, UInt4 daqId, UInt4 first_modNo, UInt4 last_modNo=999999999)
=================================================================================================================
    Sets Module components status use or not.
    isAlive info is used when output to xml.
    SetModAlive( bool isAlive, UInt4 daqId, UInt4 first_modNo, UInt4 last_modNo=999999999 )

    Args:
        isAlive (bool) true: use, false: not use
        daqId (UInt4) DAQ ID including target modules
        first_modNo (UInt4) first module No to be set
        last_modNo (UInt4) last module No to be set, if not set, only first_modNo is set.

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::SetDetAlive "void WiringInfoEditorBase::SetDetAlive(bool isAlive, UInt4 first_detId, UInt4 last_detId=999999999)
====================================================================================================
    Sets detector components status use or not.
    isAlive info is used when output to xml.
    SetDetAlive( bool isAlive, UInt4 first_detId, UInt4 last_detId=999999999 )

    Args:
        isAlive (bool) true: use, false: not use
        first_detId (UInt4) first detId to be set
        last_detId (UInt4) last detId to be set, if not set, only first_detId is set.

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::SetTofBinPattern "bool WiringInfoEditorBase::SetTofBinPattern(UInt4 patternId, UInt4 type, vector< Double > params)
==================================================================================================
    Sets Tof binning pattern.
    SetTofBinPattern( UInt4 patternId, UInt4 type, vector<Double> params )

    Args:
        patternId (UInt4) patternId, if already patternId exists, overwrites
        type (UInt4) TofBin type
        params (vector<Double>) parameters for TofBin type)

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::DeleteTofBinPattern "bool WiringInfoEditorBase::DeleteTofBinPattern(UInt4 patternId)
================================================================
    Deletes Tof binning pattern.
    DeleteTofBinPattern( UInt4 patternId )

    Args:
        patternId (UInt4) patternId, if already patternId exists, overwrites

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::DeleteAllTofBinPattern "void WiringInfoEditorBase::DeleteAllTofBinPattern()
====================================================
    Deletes all Tof binning pattern.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::SetTofBinInfo "bool WiringInfoEditorBase::SetTofBinInfo(UInt4 patternId, Double offsetBin=0.0, Int4 maskPtnId=-1) 

    
bool WiringInfoEditorBase::SetTofBinInfo(UInt4 start_detId, UInt4 end_detId, UInt4 patternId, Double offsetBin=0.0, Int4 maskPtnId=-1) 
    
bool WiringInfoEditorBase::SetTofBinInfo(vector< UInt4 > range, UInt4 patternId, Double offsetBin=0.0, Int4 maskPtnId=-1)
==========================================================================================================================
    Sets Tof binning info.
    SetTofBinInfo( UInt4 patternId, UInt4 offsetBin=0 ) this applys all detectors. SetTofBinInfo( UInt4 start_detId, UInt4 end_detId, UInt4 patternId, UInt4 offsetBin=0 ); this applys detectors between start_detid and end_detId SetTofBinInfo( vector<UInt4> range, UInt4 patternId, UInt4 offsetBin=0 ); this applys individual, example [0,12,15,16,20,0,25,29] => 0-12,15-16,20,25-29

    Args:
        start_detId (UInt4) detId range
        end_detId (UInt4) detId range
        range (vector<UInt4>)
        patternId (UInt4) patternId
        offsetBin (Double) offset value
        maskPtnId (Int4) mask pattern Id

    Returns:
        true succeded
        false failed 
";
%feature("docstring") WiringInfoEditorBase::DeleteAllTofBinInfo "void WiringInfoEditorBase::DeleteAllTofBinInfo()
=================================================
    Deletes all Tof binning info.

    Args:
        None

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorBase::SetFrameInfo "bool WiringInfoEditorBase::SetFrameInfo(UInt4 frameNo, Double boundary, string type=\"tof\")
=============================================================================================
    Sets Tof frame boundary parameters.
    SetFrameInfo( UInt4 frameNo, Double boundary )

    Args:
        frameNo (UInt4) Frame Number
        boundary (Double) TOF boundary
        type (string)

    Returns:
        true succeded
        false failed 

    
bool WiringInfoEditorBase::SetFrameInfo(string params)
=======================================================
    Sets tof frame treating information.
    This params can include frame number and boundary tof. [\"None\" or <frameNo>,<boundaryTof> or \"<type>:<boundary>\" where type in (\"tof\",\"lambda\",\"energy\",\"ei\") ]

    Args:
        params (string) frame info parameter

    Returns:
        true succeded
        false failed 
";
%feature("docstring") WiringInfoEditorBase::SetUseDetectorType "bool WiringInfoEditorBase::SetUseDetectorType(std::string _detType)
====================================================================
    Makes detectors alive by given detector type.

    Args:
        _detType (string) <detType1>[,<detType2>,...]

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::SetTofMaskPattern "bool WiringInfoEditorBase::SetTofMaskPattern(UInt4 patternId, vector< Double > params)
=======================================================================================
    Sets Tof mask Pattern with pattern Id.

    Args:
        patterinId (UInt4) pattern Id for given params
        params (vector<Double>) tof ranges list to be masked, [m1,m2,m3,m4,...,] means region of [m1:m2], [m3:m4] ... are masked.

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::SetDetectorRange "bool WiringInfoEditorBase::SetDetectorRange(vector< UInt4 > list_of_num_pixels, vector< pair< Int4, Int4 > > list_of_det_range, string det_type)
=================================================================================================================================================
    Makes the staus of given detectors alive or not.

    Args:
        list_of_num_pixels (vector<UInt4>) the number of pixels of each detector ranges
        list_of_det_range (vector< pair<Int4,Int4> >) detector ranges
        det_type (string) type of all given detectors

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::SetConversionParameter "bool WiringInfoEditorBase::SetConversionParameter(string params, UInt4 _ptnId=0)
=================================================================================
    Sets conversion parameters for histogram creation from event data.
    This params are checked by WiringConversionDictionary class and used to calculate tof_bin_pattern.

    Args:
        params (string) parameters to create histogram in string format
        _ptnId (UInt4) given pattern id for this parameter ( normally 1 )

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::SetDetParam "bool WiringInfoEditorBase::SetDetParam(string params)
======================================================
    Sets detector parameters.
    This method will be overrided by WiringInfoEditorNeunet to treat Pulse Height. In this class, this methods set only detector type in [\"PSD\",\"uPSD\",\"MON\",\"SCIN1D\",\"RPMT\",\"MWPC\",\"WLSF32\"]

    Args:
        params (string) detector type

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::SetDetRange "bool WiringInfoEditorBase::SetDetRange(string params)
======================================================
    Sets detector ranges to be used for histogram creation.
    This params can include \"All\", range of detector ID, the number of pixels in a detector. [\"All\", <detId>-<detId>, <detId>-<detId>:num,...]

    Args:
        params (string) detector range parameter(s)

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorBase::SetMaskInfo "bool WiringInfoEditorBase::SetMaskInfo(string params, UInt4 _ptnId)
====================================================================
    sets MASK histogram creations
    bool SetMaskInfo( string params=\"NoFile\", UInt4 _ptnId=0 ) Format of params \"<Mask.xml>[,<TOF-Mask from>-< to > [,<TOF-Mask from>-<to>] ]\" Mask.xml = \"NoFile\" if no mask.

    Args:
        params (string) detector parameters for histogram ceration
        _ptnId (UInt4) ID of this parameters in WiringInfo

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") WiringInfoEditorBase::SetTimeDependBackGroundInfo "bool WiringInfoEditorBase::SetTimeDependBackGroundInfo(string params)
======================================================================
    sets Tof region to be used for TimeDependBackground correction
    bool SetTimeDependBackGroundInfo( string params=\"None\" ) Format of params \"None\" : not used this background correction \"tof0-tof1\" : tof0 is start tof of region, tof1 is last of region

    Args:
        params (string) TimeDepend BackGroundRegion

    Returns:
        true : succeeded
        false : failed 

";
%feature("docstring") WiringInfoEditorBase::ImportTimeDependBackGroundInfo "void WiringInfoEditorBase::ImportTimeDependBackGroundInfo() 

";
%feature("docstring") WiringInfoEditorBase::PutTimeDependBackGroundList "vector< vector<Double>* >* WiringInfoEditorBase::PutTimeDependBackGroundList() 

";
%feature("docstring") WiringInfoEditorBase::ClearReader "void WiringInfoEditorBase::ClearReader(UInt4 index=0) 

";
%feature("docstring") WiringInfoEditorBase::SetInfoAsReader "bool WiringInfoEditorBase::SetInfoAsReader() 

";
%feature("docstring") WiringInfoEditorBase::PutConversionDictionary "WiringInfoConversionDictionary* WiringInfoEditorBase::PutConversionDictionary() 

";
%feature("docstring") WiringInfoEditorBase::SetIgnoreModuleType "void WiringInfoEditorBase::SetIgnoreModuleType(string tmp) 

";
%feature("docstring") WiringInfoEditorBase::PutDaqList "vector< UInt4 > WiringInfoEditorBase::PutDaqList()
===================================================
    Returns list of DAQ ID described in WiringInfo.

    Returns:
        vector<UInt4> 

";
%feature("docstring") WiringInfoEditorBase::PutModuleList "vector< UInt4 > WiringInfoEditorBase::PutModuleList(UInt4 daqId)
=================================================================
    Returns list of module No in given daqId described in WiringInfo.

    Args:
        daqId (UInt4) DAQ Id

    Returns:
        vector<UInt4> 

";
%feature("docstring") WiringInfoEditorBase::PutDetectorList "vector< UInt4 > WiringInfoEditorBase::PutDetectorList(UInt4 daqId, UInt4 modNo)
================================================================================
    Returns list of detId in given daqId and module No described in WiringInfo.

    Args:
        daqId (UInt4) DAQ Id
        modNo (UInt4) module No

    Returns:
        vector<UInt4> 

";
%feature("docstring") WiringInfoEditorBase::PutDetInfo "UtsusemiDetInfo * WiringInfoEditorBase::PutDetInfo(UInt4 daqId, UInt4 modNo, UInt4 detId) 

";
%feature("docstring") WiringInfoEditorBase::PutNumOfPixelForDet "UInt4 WiringInfoEditorBase::PutNumOfPixelForDet(UInt4 _detId=0) 

";
%feature("docstring") WiringInfoEditorBase::PutPixelInfoStore "vector< Int4 > WiringInfoEditorBase::PutPixelInfoStore(UInt4 daqId, UInt4 modeNo, UInt4 detNo) 

";
%feature("docstring") WiringInfoEditorBase::IgnoredXml "void WiringInfoEditorBase::IgnoredXml(bool isIgnoredXml=true) 

";
%feature("docstring") WiringInfoEditorBase::FixHeadPixelId "void WiringInfoEditorBase::FixHeadPixelId(bool isFixed=true) 

";
// File: classWiringInfoEditorNeunet.xml

%feature("docstring") WiringInfoEditorNeunet "C++ includes: WiringInfoEditorNeunet.hh 

";
%feature("docstring") WiringInfoEditorNeunet::WiringInfoEditorNeunet "WiringInfoEditorNeunet::WiringInfoEditorNeunet()
=================================================
    Constructor. 

    
WiringInfoEditorNeunet::WiringInfoEditorNeunet(string wfile, bool workAsReader=true)
=====================================================================================
    Constructor.
    @params wfile (string) wiring file path

    Args:
        workAsReader (bool) 
";
%feature("docstring") WiringInfoEditorNeunet::~WiringInfoEditorNeunet "WiringInfoEditorNeunet::~WiringInfoEditorNeunet()
==================================================
    Destructor. 

";
%feature("docstring") WiringInfoEditorNeunet::Clear "void WiringInfoEditorNeunet::Clear(UInt4 index=0)
==================================================
    Clears stored parameters.
    This deletes information by given index. index = 0 : all (default) index = 1 : PixelInfo ( and DetInfoList ) index = 2 : TofBinPtnInfo index = 3 : TofBinInfo index = 4 : FrameBoundaryInfo index = 5 : TrigInfoStore index = 6 : TofMaskPtn index = 7 : PsdParams index = 8 : PsdBinInfo

    Args:
        index (UInt4)

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorNeunet::ClearReader "void WiringInfoEditorNeunet::ClearReader(UInt4 index=0) 

";
%feature("docstring") WiringInfoEditorNeunet::Read "bool WiringInfoEditorNeunet::Read(std::string arg)
===================================================
    Reads WiringInfo.xml and import information.

    Args:
        arg (string) path/to/DetectorInfo.xml or DetectorInfo as string

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") WiringInfoEditorNeunet::Write "bool WiringInfoEditorNeunet::Write(std::string filepath)
=========================================================
    Writes WiringInfo.xml.

    Args:
        filepath (string)

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") WiringInfoEditorNeunet::OutXml "string WiringInfoEditorNeunet::OutXml(bool withIndent=false)
=============================================================
    Returns WiringInfo as string.

    Args:
        withIndent(bool) false : output xml without an indent format

    Returns:
        string 

";
%feature("docstring") WiringInfoEditorNeunet::ImportPsdParams "void WiringInfoEditorNeunet::ImportPsdParams()
===============================================
    Analyzes xml descriptions for psd params (A,B,C,LDD)
    This analyzes read xml descriptions

    Args:
        None

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorNeunet::ImportPsdInfo "void WiringInfoEditorNeunet::ImportPsdInfo()
=============================================
    Analyzes xml descriptions for PsdBinInfo.
    This analyzes read xml descriptions

    Args:
        None

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorNeunet::PutPsdParams "vector< Double > WiringInfoEditorNeunet::PutPsdParams(UInt4 detId)
===================================================================
    Puts PSD parameters for given detector ID.
    PutPsdParams( UInt4 detId )

    Args:
        detId (UInt4) detId

    Returns:
        vector<Double> with size=0 : no PSD info
        vector<Double> with size=5 : [, , , <Lower limit PH>, <Upper limit PH>] 

";
%feature("docstring") WiringInfoEditorNeunet::SetPsdParams "bool WiringInfoEditorNeunet::SetPsdParams(UInt4 detId, Double Aval, Double Bval, Double Cval, Double PHlow, Double PHup) 

    
bool WiringInfoEditorNeunet::SetPsdParams(UInt4 detId, string tag, Double val)
===============================================================================
    Sets PSD parameters for each detector.
    SetPsdParams( UInt4 detId, Double Aval, Double Bval, Double Cval, Double PHlow, Double PHup ) SetPsdParams( UInt4 detId, string tag, Double val )

    Args:
        detId (UInt4) detId
        Aval (Double) A value of PSD
        Bval (Double) B value of PSD
        Cval (Double) C value of PSD
        PHlow (Double) lower limit of pulse height value of PSD
        PHup (Double) upper limit of pulse heignt value of PSD
        tag (string) Key of parameters which must be \"A\",\"B\",\"C\",\"LLD\",\"HLD\"
        val (Double) value for given Key

    Returns:
        true succeded
        false failed 
";
%feature("docstring") WiringInfoEditorNeunet::SetAllPsdParams "bool WiringInfoEditorNeunet::SetAllPsdParams(string tag, Double val)
=====================================================================
    Sets PSD parameters to all.
    SetAllPsdParams( string tag, Double val )

    Args:
        tag (string) Key of parameters which must be \"A\",\"B\",\"C\",\"LLD\",\"HLD\"
        val (Double) value for given Key

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorNeunet::DeletePsdParams "bool WiringInfoEditorNeunet::DeletePsdParams(UInt4 start_detId=0, UInt4 end_detId=0)
=====================================================================================
    Deletes PSD parameters.
    DeletePsdParams( UInt4 start_detId=0, UInt4 end_detId=0 )

    Args:
        start_detId (UInt4) range of detId
        end_detId (UInt4) range of detId

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorNeunet::MakePsdInfo "void WiringInfoEditorNeunet::MakePsdInfo(UInt4 numPixel, Double deltaX, Double offsetX)
========================================================================================
    Makes PSD bin Info.
    This collects detId which has same numPixel as given numPixel and makes PsdInfo MakePsdInfo( UInt4 numPixel, UInt4 deltaX, UInt4 offsetX )

    Args:
        numPixel (UInt4) number of pixels in a PSD
        deltaX (Double) width on X axis for each pixel
        offsetX (Double) offset value on X axis

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorNeunet::SetPsdInfo "bool WiringInfoEditorNeunet::SetPsdInfo(UInt4 numPixel, Double deltaX, Double offsetX, string conts) 

    
bool WiringInfoEditorNeunet::SetPsdInfo(Double deltaX, Double offsetX, UInt4 start_detId=0, UInt4 end_detId=0)
===============================================================================================================
    Sets PSD bin Info.
    This makes PSD info tag by given parameters without checking. SetPsdInfo( UInt4 numPixel, Double deltaX, Double offsetX, string conts ) SetPsdInfo( Double deltaX, Double offsetX, UInt4 start_detId=0, UInt4 end_detId=0 )

    Args:
        numPixel (UInt4) number of pixels in a PSD
        deltaX (Double) width on X axis for each pixel
        offsetX (Double) offset value on X axis
        conts (string) contents of this tag
        start_detId (UInt4) range of detId
        end_detId (UInt4) range of detId

    Returns:
        true succeded
        false failed 
";
%feature("docstring") WiringInfoEditorNeunet::DeletePsdInfo "bool WiringInfoEditorNeunet::DeletePsdInfo(UInt4 index=999999999)
==================================================================
    Deletes Psd bin info.
    DeletePsdInfo( UInt4 index=999999999 )

    Args:
        index (UInt4) index for PsdBinInfo to be deleted

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorNeunet::Dump "void WiringInfoEditorNeunet::Dump(Int4 index=DUMP_ALL) 

";
%feature("docstring") WiringInfoEditorNeunet::SetNumPixelOfPsdBin "bool WiringInfoEditorNeunet::SetNumPixelOfPsdBin(UInt4 num_of_pixel, Int4 start_id=-1, Int4 end_id=-1) 

";
%feature("docstring") WiringInfoEditorNeunet::SetDetectorRange "bool WiringInfoEditorNeunet::SetDetectorRange(vector< UInt4 > list_of_num_pixels, vector< pair< Int4, Int4 > > list_of_det_range, string det_type)
===================================================================================================================================================
    Makes the staus of given detectors alive or not.

    Args:
        list_of_num_pixels (vector<UInt4>) the number of pixels of each detector ranges
        list_of_det_range (vector< pair<Int4,Int4> >) detector ranges
        det_type (string) type of all given detectors

    Returns:
        true succeded
        false failed 

";
%feature("docstring") WiringInfoEditorNeunet::SetDetParam "bool WiringInfoEditorNeunet::SetDetParam(string params=\"psd\") 

";
%feature("docstring") WiringInfoEditorNeunet::SetInfoAsReader "bool WiringInfoEditorNeunet::SetInfoAsReader() 

";
// File: classWiringInfoEditorReadout.xml

%feature("docstring") WiringInfoEditorReadout "C++ includes: WiringInfoEditorReadout.hh 

";
%feature("docstring") WiringInfoEditorReadout::WiringInfoEditorReadout "WiringInfoEditorReadout::WiringInfoEditorReadout()
===================================================
    Constructor. 

    
WiringInfoEditorReadout::WiringInfoEditorReadout(string wfile, bool workAsReader=true)
=======================================================================================
    Constructor.
    @params wfile (string) wiring file path

    Args:
        workAsReader (bool) 
";
%feature("docstring") WiringInfoEditorReadout::~WiringInfoEditorReadout "WiringInfoEditorReadout::~WiringInfoEditorReadout()
====================================================
    Destructor. 

";
%feature("docstring") WiringInfoEditorReadout::Clear "void WiringInfoEditorReadout::Clear(UInt4 index=0)
===================================================
    Clears stored parameters.
    This deletes information by given index. index = 0 : all (default) index = 1 : PixelInfo ( and DetInfoList ) index = 2 : TofBinPtnInfo index = 3 : TofBinInfo index = 4 : FrameBoundaryInfo index = 5 : TrigInfoStore index = 6 : TofMaskPtn index = 7 : PsdParams index = 8 : PsdBinInfo index = 9 : ReadoutGateInfo

    Args:
        index (UInt4)

    Returns:
        None 

";
%feature("docstring") WiringInfoEditorReadout::Read "bool WiringInfoEditorReadout::Read(std::string arg)
====================================================
    Reads WiringInfo.xml and import information.

    Args:
        arg (string) path/to/DetectorInfo.xml or DetectorInfo as string

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") WiringInfoEditorReadout::Write "bool WiringInfoEditorReadout::Write(std::string filepath)
==========================================================
    Writes WiringInfo.xml.

    Args:
        filepath (string)

    Returns:
        true : succeeded
        false failed 

";
%feature("docstring") WiringInfoEditorReadout::OutXml "string WiringInfoEditorReadout::OutXml(bool withIndent=false)
==============================================================
    Returns WiringInfo as string.

    Args:
        withIndent(bool) false : output xml without an indent format

    Returns:
        string 

";
%feature("docstring") WiringInfoEditorReadout::ImportReadoutGateInfo "void WiringInfoEditorReadout::ImportReadoutGateInfo() 

";
%feature("docstring") WiringInfoEditorReadout::Dump "void WiringInfoEditorReadout::Dump(Int4 index=DUMP_ALL) 

";
%feature("docstring") WiringInfoEditorReadout::SetInfoAsReader "bool WiringInfoEditorReadout::SetInfoAsReader() 

";
// File: classWiringInfoTagDefineBase.xml

%feature("docstring") WiringInfoTagDefineBase "C++ includes: WiringInfoDataBase.hh 

";
%feature("docstring") WiringInfoTagDefineBase::WiringInfoTagDefineBase "WiringInfoTagDefineBase::WiringInfoTagDefineBase()
===================================================
    Constructor. 

";
%feature("docstring") WiringInfoTagDefineBase::~WiringInfoTagDefineBase "WiringInfoTagDefineBase::~WiringInfoTagDefineBase()
====================================================
    Destructor. 

";
