%module  Levmar
%include "carrays.i"
%include "std_string.i"
%include "std_vector.i"
%include "std_pair.i"
%include "VectorDef.i"

%{
#include "Header.hh"

#include "ThreadBase.hh"
#include "AdvMessage.hh"
#include "AdvVectorComplexTool.hh"
#include "AdvVectorArrayConv.hh"
#include "AdvVectorGSLVectorConv.hh"
#include "AdvMatrixUtil.hh"
#include "AdvGslFFTComplex.hh"
#include "AdvFuncBase.hh"
#include "AdvFuncConv.hh"
#include "AdvConstant.hh"
#include "AdvConstantConv.hh"
#include "AdvPolynomial1.hh"
#include "AdvPolynomial1Conv.hh"
#include "AdvPolynomial2.hh"
#include "AdvPolynomial2Conv.hh"
#include "AdvPolynomial3.hh"
#include "AdvPolynomial3Conv.hh"
#include "AdvExponential.hh"
#include "AdvGaussian.hh"
#include "AdvDeltaConv.hh"
#include "AdvGaussianConv.hh"
#include "AdvLorentzian.hh"
#include "AdvLorentzianConv.hh"
#include "AdvAugmentedLorentzian.hh"
#include "AdvAugmentedLorentzianConv.hh"
#include "AdvPseudoVoigt1.hh"
#include "AdvPseudoVoigt2.hh"
#include "AdvPseudoVoigt1Conv.hh"
#include "AdvPseudoVoigt2Conv.hh"
#include "AdvDampedHarmonicOscillator.hh"
#include "AdvDampedHarmonicOscillatorConv.hh"
#include "AdvErrorFunction.hh"
#include "AdvTriangle.hh"
#include "AdvTrapezoid.hh"
#include "AdvFuncParser.hh"
#include "AdvFuncComb.hh"
#include "AdvFuncCombToElementContainer.hh"
#include "AdvDomain.hh"
#include "AdvPeakType.hh"
#include "AdvPeak.hh"
#include "AdvPeakData.hh"
#include "AdvParamSet.hh"
#include "AdvMethod.hh"
#include "AdvBSpline.hh"
#include "AdvMovingAverage.hh"
#include "AdvLevmarConsts.hh"
#include "AdvLevmarFunc.hh"
#include "AdvLevmarImmutables.hh"
#include "AdvLevmarControl.hh"
#include "AdvLevmarArgs.hh"
#include "AdvAdditionalData.hh"
#include "AdvLevmarFit.hh"
#include "AdvFitCommand.hh"
#include "AdvConvergenceStat.hh"
#include "AdvReportConvergenceProcess.hh"
#include "AdvNewLevmar.hh"
#include "AdvMultiDataMethod.hh"
#include "AdvMultiDataLevmar.hh"
#include "AdvConvolutionConsts.hh"
#include "AdvEqualSpacing.hh"
#include "AdvConvolutionBase.hh"
#include "AdvConvolutionByFFT.hh"
#include "AdvDeconvolutionByFFT.hh"
#include "AdvMethodType.hh"
#include "AdvMethodFactory.hh"
#include "AdvMultiDataMethodFactory.hh"
#include "AdvOperationBase.hh"
#include "AdvSmoothing.hh"
#include "AdvPeakSearch.hh"
#include "AdvPeakFit.hh"
#include "AdvMultiDataOperationBase.hh"
#include "AdvMultiDataPeakFit.hh"
#include "AdvConvDeconv.hh"
#include "AdvConvDeconvPre.hh"
#include "AdvInsMEM.hh"
#include "AdvSimulatedAnnealingConsts.hh"
#include "AdvSimulatedAnnealing.hh"
#include "AdvSimulatedAnnealingArgs.hh"
#include "AdvModel.hh"
#include "AdvModelLayer.hh"
#include "AdvModelParam.hh"
#include "AdvModelParamSet.hh"
#include "AdvModelSpecular.hh"
#include "AdvModelParticle.hh"
#include "AdvModelDistribution.hh"
#include "AdvModelParticleType.hh"
#include "AdvModelSmallAngle.hh"
#include "AdvModelSpecularMul.hh"

%}

%include "DoxySwig.i"

%include "TemplateDef.i"
%include "Header.hh"
%include "ThreadBase.hh"

%include "AdvMessage.hh"
%include "AdvVectorComplexTool.hh"
%include "AdvVectorArrayConv.hh"
%include "AdvVectorGSLVectorConv.hh"
%include "AdvMatrixUtil.hh"
%include "AdvGslFFTComplex.hh"
%include "AdvFuncBase.hh"
%include "AdvFuncConv.hh"
%include "AdvConstant.hh"
%include "AdvConstantConv.hh"
%include "AdvPolynomial1.hh"
%include "AdvPolynomial1Conv.hh"
%include "AdvPolynomial2.hh"
%include "AdvPolynomial2Conv.hh"
%include "AdvPolynomial3.hh"
%include "AdvPolynomial3Conv.hh"
%include "AdvExponential.hh"
%include "AdvGaussian.hh"
%include "AdvDeltaConv.hh"
%include "AdvGaussianConv.hh"
%include "AdvLorentzian.hh"
%include "AdvLorentzianConv.hh"
%include "AdvAugmentedLorentzian.hh"
%include "AdvAugmentedLorentzianConv.hh"
%include "AdvPseudoVoigt1.hh"
%include "AdvPseudoVoigt2.hh"
%include "AdvPseudoVoigt1Conv.hh"
%include "AdvPseudoVoigt2Conv.hh"
%include "AdvDampedHarmonicOscillator.hh"
%include "AdvDampedHarmonicOscillatorConv.hh"
%include "AdvErrorFunction.hh"
%include "AdvTriangle.hh"
%include "AdvTrapezoid.hh"
%include "AdvFuncParser.hh"
%include "AdvFuncComb.hh"
%include "AdvFuncCombToElementContainer.hh"
%include "AdvDomain.hh"
%include "AdvPeakType.hh"
%include "AdvPeak.hh"
%include "AdvPeakData.hh"
%include "AdvParamSet.hh"
%include "AdvMethod.hh"
%include "AdvBSpline.hh"
%include "AdvMovingAverage.hh"
%include "AdvLevmarConsts.hh"
%include "AdvLevmarFunc.hh"
%include "AdvLevmarImmutables.hh"
%include "AdvLevmarControl.hh"
%include "AdvLevmarArgs.hh"
%include "AdvAdditionalData.hh"
%include "AdvLevmarFit.hh"
%include "AdvFitCommand.hh"
%include "AdvConvergenceStat.hh"
%include "AdvReportConvergenceProcess.hh"
%include "AdvNewLevmar.hh"
%include "AdvMultiDataMethod.hh"
%include "AdvMultiDataLevmar.hh"
%include "AdvConvolutionConsts.hh"
%include "AdvEqualSpacing.hh"
%include "AdvConvolutionBase.hh"
%include "AdvConvolutionByFFT.hh"
%include "AdvDeconvolutionByFFT.hh"
%include "AdvMethodType.hh"
%include "AdvMethodFactory.hh"
%include "AdvMultiDataMethodFactory.hh"
%include "AdvOperationBase.hh"
%include "AdvSmoothing.hh"
%include "AdvPeakSearch.hh"
%include "AdvPeakFit.hh"
%include "AdvMultiDataOperationBase.hh"
%include "AdvMultiDataPeakFit.hh"
%include "AdvConvDeconv.hh"
%include "AdvConvDeconvPre.hh"
%include "AdvInsMEM.hh"
%include "AdvSimulatedAnnealingConsts.hh"
%include "AdvSimulatedAnnealing.hh"
%include "AdvSimulatedAnnealingArgs.hh"
%include "AdvModel.hh"
%include "AdvModelLayer.hh"
%include "AdvModelParam.hh"
%include "AdvModelParamSet.hh"
%include "AdvModelSpecular.hh"
%include "AdvModelParticle.hh"
%include "AdvModelDistribution.hh"
%include "AdvModelParticleType.hh"
%include "AdvModelSmallAngle.hh"
%include "AdvModelSpecularMul.hh"

