#include "AdvConvDeconvPre.hh"

const string AdvConvDeconvPre::className = string("AdvConvDeconvPre");

AdvConvDeconvPre::AdvConvDeconvPre() {
};


AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src) : AdvMultiDataOperationBase(src) {
}

#ifndef SWIGPYTHON
AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src, AdvMultiDataMethod *method ) : AdvMultiDataOperationBase(src, method) {
}
#endif

AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src, const AdvMethodType &methodType) : AdvMultiDataOperationBase(src, methodType) {
}

AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src, const string &methodName    ) : AdvMultiDataOperationBase(src, methodName) {
}

#ifndef SWIGPYTHON
AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src, AdvMultiDataMethod *method,     const Double xLower, const Double xUpper) : AdvMultiDataOperationBase(src, method,     xLower, xUpper) {
}
#endif

AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src, const AdvMethodType &methodType, const Double xLower, const Double xUpper) : AdvMultiDataOperationBase(src, methodType, xLower, xUpper) {
}

AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src, const string     &methodName, const Double xLower, const Double xUpper) : AdvMultiDataOperationBase(src, methodName, xLower, xUpper) {
}

#ifndef SWIGPYTHON
AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src, AdvMultiDataMethod *method,     const UInt4 lower, const UInt4 upper) : AdvMultiDataOperationBase(src, method,     lower, upper) {
}
#endif

AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src, const AdvMethodType &methodType, const UInt4 lower, const UInt4 upper) : AdvMultiDataOperationBase(src, methodType, lower, upper) {
}

AdvConvDeconvPre::AdvConvDeconvPre(ElementContainerArray *src, const string     &methodName, const UInt4 lower, const UInt4 upper) : AdvMultiDataOperationBase(src, methodName, lower, upper) {
}

AdvConvDeconvPre::~AdvConvDeconvPre() {
};


void AdvConvDeconvPre::execute() {

    if ( ! this->method->checkParam(*(this->source), this->domains, this->param) ) {
        return;
    }

    this->method->toInnerForm(*(this->source), this->domains, this->param);
    this->method->fit();
    if ( this->method->isMultiThreaded() ) {
        while (this->method->isFitting()) {
            sleep(1);
        }
    }

    this->method->eval();

    //vector< vector<Double> > trend = this->method->getTrend();

}

ElementContainer AdvConvDeconvPre::getResult(UInt4 i) {
    ElementContainer *ec=new ElementContainer(this->source->PutHeader());
    this->method->toElementContainer(*(this->source), i, *ec);
    return *ec;
}

ElementContainerArray AdvConvDeconvPre::getResult() {

    ElementContainerArray *eca=new ElementContainerArray(this->source->PutHeader());
    this->method->toElementContainerArray(*(this->source), *eca);
    return *eca;
}

