#ifndef SCATABSOBODYMONITOR
#define SCATABSOBODYMONITOR

#include <vector>
#include <algorithm>

#include "Header.hh"
#include "ElementContainer.hh"
#include "ElementContainerArray.hh"

//#include "AdvScatAbsoBodyManagerDNA.hh"
#include "AdvScatAbsoBodyManagerMLF.hh"

/**
 */
//class AdvNeutronMonitorDNA : public AdvScatAbsoBodyManagerDNA {
class AdvNeutronMonitorDNA : public AdvScatAbsoBodyManagerMLF {
  private:
    string filename;
    string filepath;

    struct ScatAbsoInfo monitorInfo;
    struct ScatAbsoInfo wallInfo;
    Double LengthFromSource;
    vector <Double> time;
    vector <Double> energy;
    vector <Double> observedAtMonitor;
    vector <Double> observedAtMonitorErr; // 
    vector <Double> intensityAtMonitor;
    vector <Double> intensityAtMonitorErr;
    vector <Double> intensityAtSample;
    vector <Double> intensityAtSampleErr;
  
    Double monitorEfficiency;
    Double wallEfficiency;
    Double sigmaNitroAbs;
    Double sigmaMonitorTotal;
    Double sigmaWallEffAbs;

    ElementContainer* monitorCount;
    ElementContainer* sampleIntensity;

  private:
    void vectorReverse(vector<Double>& v);
  public:
    AdvNeutronMonitorDNA(void);
    AdvNeutronMonitorDNA(string);
    ~AdvNeutronMonitorDNA(void);

    void TranslateFromTToE(void);
    ElementContainer& TranslateFromTToE(ElementContainer& ec);
    void SetLengthFromSource(Double);
    Double GetMonitorEfficiency(Double);
    Double GetWallEfficiency(Double);
    void SetIntensityAtSource(void);
    void SetIntensityAtSource(ElementContainer& monitorCount);
    void GetIntensityAtSample(void);
    void GetIntensityAtSample(ElementContainer& monitorCount, ElementContainerArray& eca);
    void GetIntensityAtSample(ElementContainer& monitorCount, ElementContainer& ec);
    void GetProfileUseMonAtSample(ElementContainer& monitorCount, ElementContainer& result);
    void outputResult(string& fileName);
    void toContainer(ElementContainerArray& eca);
    void toContainer(ElementContainer& ec);
    ElementContainer GetIntensityAtSample(ElementContainer monitorCount);
    ElementContainerArray getCorrection();

};

#endif

    
