#ifndef UTSUSEMICHOPCONDINFOREADERTRIGNET
#define UTSUSEMICHOPCONDINFOREADERTRIGNET
#include "UtsusemiCaseInfoReaderTrignet.hh"

#include "BoostXmlParser.hh"
class UtsusemiChopCondInfoReaderTrignet:
    public UtsusemiCaseInfoReaderTrignet{


private:
    StringTools *stools;
    string _CF_KEY;
    BoostXmlParser *_parserDetInfo;                  /**< XML parser  */
    BoostXmlParser *_parserWirInfo;                  /**< XML parser  */

public:
    UtsusemiChopCondInfoReaderTrignet();
        //!< Constructor
        /*!<
         */
    UtsusemiChopCondInfoReaderTrignet( string filename );
        //!< Constructor
        /*!<
         *   @param filename (string) path to CaseInfo.xml
         */
    ~UtsusemiChopCondInfoReaderTrignet();
        //!< Destructor
        /*!<
         */

    Double PutFastChopperFrequency();

    UInt4 PutNumOfFastChopperSlit();

    vector<Double> PutFastChopperSlitWidth();

    vector<Double> PutFastChopperSlitAngle();

    UInt4 PutFastChopperMode();

    Double PutL1();
    Double PutLChopper();
    Double PutLBandChopper();

    Double PutLambdaCenter();
    Double PutDeltaLambda();
    Double PutTOFoffset();

    Double PutTOFResolver1();
    Double PutTOFResolver2();

    Double PutTOFSourceMin();
    Double PutTOFSourceMax();

    Int4 PutTOFbintype();

    Int4 ImportDetectorInfo(string filepath);

    Int4 ImportWiringInfo(string filepath);


};
#endif
