#ifndef UTSUSEMIFILTERTRIGNETCONDITIONDNA
#define UTSUSEMIFILTERTRIGNETCONDITIONDNA
#include "Header.hh"
#include <algorithm>
//////////////////////////////////
// UtsusemiFilterTrignetConditionDNA
/////////////////////////////////
class UtsusemiFilterTrignetConditionDNA
{
protected:
    Double fastChopperFrequency;

    UInt4 fastChopperNumOfSlit;

    vector<Double> fastChopperSlitWidths;

    vector<Double> fastChopperSlitAngles;

    UInt4 fastChopperMode;

    Double LChopper;

    Double LBand;

    Double L1;

    Double TOFminSource;

    Double TOFmaxSource;

    Double LambdaCenter;

    Double DeltaLambda;

    Double LambdaMin;

    Double LambdaMax;

    Double TOFoffset;

    Double TOFresolver1;

    Double TOFresolver2;

    vector<Double> _CalcTOFSlit();

    vector<vector<Double> > _CalcTOFSlit(vector<vector<UInt4> >, vector<Double>);

    vector<vector<Double> > _CalcTOFSlit(vector<vector<UInt4> >,vector<vector<UInt4> >, vector<Double>);


    vector<Double> _eiRange;

    vector<Double> _tofRange;

    vector<Double> _tofSlit;

public:
    UtsusemiFilterTrignetConditionDNA();

    ~UtsusemiFilterTrignetConditionDNA();

    vector<Double> CalcBandRange();

    vector<vector<Double> > CalcTOFRange(vector<vector<Double> > ChopperCaseTablesIn); // --old

    vector<vector<Double> > CalcTOFRange(vector<vector<UInt4> >, vector<Double>);

    vector<vector<Double> > CalcTOFRange(vector<vector<UInt4> >,vector<vector<UInt4> >, vector<Double>);

    vector<Double> CalcTOFRange();

    vector<Double> CalcEiRange();

    vector<vector<Double> > CalcTOFRangeDebug(vector<vector<Double> > ChopperCaseTablesIn);

    vector<vector<Double> > CalcTOFSlit(vector<vector<UInt4> >, vector<Double>);

    vector<vector<Double> > CalcTOFSlit(vector<vector<UInt4> >,vector<vector<UInt4> >, vector<Double>);

    vector<Double> CalcTOFSlit();

    vector<Double> GetTOFRange();

    vector<Double> GetEiRange();

    vector<Double> GetTOFSlit();

    vector<Double> CalcEiShift();

    void Clear();
};

#endif
